.ds T1 NIST POSIX Testing Policy\(em
.ds T2 Certificate of Validation Requirements for FIPS 151-2
.\"	
.\"	The following included file defines the common macros for the documents
.\"		General Information,
.\"		Installation and Testing Guide, and
.\"		Certificate of Validation Requirements for FIPS 151-2
.\" and generates the title page based on the previous macros defines.
.\"
.so ../macros
.rs
.\"  Generate blank back page.
.PH "'\s10NIST POSIX Testing Policy''\*(Dt\s0'"
.bp
.\"
.\"	Start of Document
.\"
.rs
.EF "''Page \\\\n%''"
.OF "''Page \\\\n%''"
.nr % 1
.sp |10P
.H 1 Introduction
.SP 2P
General information on the NIST POSIX testing policy is provided
in a separate document, \f2NIST POSIX Testing Policy General Information\fP.
Information on Accredited POSIX Testing Laboratories
is provided in the \f2NIST POSIX Testing Policy General
Information\fP and in the \f2National Voluntary Laboratory Accreditation
Program\(em Program Handbook\(em Computer Applications Testing\(em
POSIX Conformance Testing\fP.
.P
This document presents information specific to conformance testing
and \*(Cv requirements for the
Federal Information Processing Standards Publication 151-2.
All functions of the Certification Authority, as defined in the
\f2NIST POSIX Testing Policy General Information\fP, are
conducted by the Computer Systems Laboratory of the
National Institute of Standards and Technology.
.SK
.rs
.sp |10P
.H 1 Terminology
.SP 2P
.H 2 Terms
.BL 4
.LI "Certification Authority"
.br
The Director of \*(Nl provides the overall
direction for organizing, managing, directing, and administering the
NIST POSIX testing program.
.LI client
.br
Organization or person who employs an APTL for NIST POSIX testing.
.LI "conformance to \*(Fp"
.br
The state of an implementation satisfying the
requirements and specifications of \*(Fp as tested by the
Official \*(N2.
.LI "cooperating-hosted system"
.br
A single computer system that
provides the functionality of both the \f2development system\fP and the
\f2host implementation\fP with a single operating system, and provides
the \*(Fp conforming implementation with another operating system.
.LI "cooperating system"
.br
The combination of the \f2development system\fP and the \f2target system\fP.
.LI "development system"
.br
The computer system used to compile and configure a \*(Ps.
[IEEE Std 1003.3-1991, 2.2.2.6]
.LI "host implementation"
.br
Provides the operating system kernel services needed
by a \f2hosted implementation\fP.
.LI "hosted implementation"
.br
Implementation of \*(P1 that is accomplished through
interfaces from the \*(P1 services to some alternate form of operating
system kernel services.
[ISO/IEC 9945-1:1990, B.2.2.2]
.LI "implementation under test"
.br
The software that implements \*(Fp.
.LI "native implementation"
.br
Implementation of \*(P1 that interfaces directly
to an operating system kernel.
[ISO/IEC 9945-1:1990, B.2.2.2]
.LI "NIST/CSL FIPS 151 Certification Body"
.br
The group designated to perform the
tasks designated by the Certification Authority.
.LI "\*(N2"
.br
Conformance Test Suite for \*(Fp
.LI "Official \*(N2"
.br
\*(N2 distributed by NTIS in conjunction with the latest
FIXES Patch distributed by \*(Nl.
.LI "system under test"
.br
The computer system hardware and software on
which the \f2implementation under test\fP operates.
[IEEE P2003/D3.0, March 1, 1994]
.LI "target system"
.br
The combination of the computer system on which the \*(Ps is executed and the
parts of the development system that are used to generate the executable
code of a \*(Ps.
[IEEE Std 1003.3-1991, 2.2.2.13]
.LE
.H 2 Abbreviations
.VL 10
.LI APTL
Accredited POSIX Testing Laboratory
.LI CSL
Computer System Laboratory (within NIST)
.LI "\*(Fp"
Federal Information Processing Standards Publication 151-2,
\f2Portable Operating System Interface (POSIX)\(em
System Application Interface [C Language]\fP
.LI "FIPS 160"
Federal Information Processing Standards Publication 160,
\f7`\fPC\f7'\fP, March 13, 1991 with change #1, August 24, 1992.
.LI GTI
General Terminal Interface
.LI IUT
implementation under test
.LI NIST
National Institute of Standards and Technology
.LI "\*(Pd"
POSIX Conforming Document for \*(P1
.LI PCTP
POSIX Conforming Test Procedure
.LI PCTS
POSIX Conformance Test Suite
.LI POSIX
The colloquial name for the collection of IEEE 1003 Standards, the
first of which was IEEE Standard Portable Operating System Interface for
Computer Environments, IEEE Std 1003.1-1988.
.LI POSIX.1
\&\*(S1 (IEEE Std 1003.1-1990)
.LI POSIX.3.1
\&\*(I3
.LI SUT
system under test
.LE
.SK
.rs
.sp |10P
.H 1 "FIPS 151-2"
.SP 2P
.H 2 "FIPS 151-2 and \*(P1"
\&\*(Fp adopts ISO/IEC 9945-1:1990 and in addition requires
a number of the optional features defined in \*(P1 to promote application
portability among conforming implementations.
An implementation that conforms to \*(Fp also conforms to \*(P1.
.H 2 Chronicle
.BL 4
FIPS 151
.BL 2
.BL 2
.LI
FIPS 151 approved, September 12, 1988.
.LE
.LE
.P
FIPS 151-1
.BL 2
.BL 2
.LI
FIPS 151-1 approved, March 28, 1992.
.LI
NIST POSIX Testing Program for FIPS 151-1 established, May 1, 1991.
.LE
.LE
.P
FIPS 151-2
.BL 2
.BL 2
.LI
FIPS 151-2 approved, April 15, 1993.
.LI
FIPS 151-2 issued, May 12, 1993.
.LI
NIST POSIX Testing Program for FIPS 151-2 established, May 12, 1993.
.LI
FIPS 151-2 effective, October 15, 1993.
.LE
.LE
.LE
.SK
.rs
.sp |10P
.H 1 "\*(N2"
.SP 2P
.H 2 Availability
The \*(N2 is designed to test conformance to \*(Fp
based on the test method specifications of POSIX.3.1-1992
and the additional specific requirements ``a - p'' of \*(Fp.
The \*(N2 only tests the \*(P3 assertions that are applicable to \*(Fp.
.P
The Official \*(N2 is distributed by \*(Nl.
\*(Nl also provides to \*(N2 owners, which have e-mail accessibility, any
additional updates which occur.
.H 2 "Testing Resources"
The following resources are required to perform \*(Fp conformance testing:
.BL 4
.BL 1
.LI
IUT
.LI
Implementation's \*(Pd (allows the tester to accurately configure
the implementation).
.LI
POSIX.3.1 to provide a reference for the \*(Pd.
.LI
Method to load \*(N2.
.LI
Disk space to load, compile, and run the PCTS.
Amount of space needed will vary from one system to another
(120MB was required to install and execute on an IUT).
Required disk space can be considerably reduced by compiling
and runing the PCTS a section at a time.
.LI
FIPS 160 conforming compiler.
.LI
Time to install and execute the PCTS.
For estimating time required, installation required less than three
hours and execution less than two hours on a 25 SPECmark system.
.LE
.LE
.P
The following resources are optional, but when provided by the IUT
must be tested:
.BL 4
.BL 1
.LI
Mountable file system for performing [EROFS] and [ENOSPC] testing.
.LI
Two general interface devices interfaced to 
terminal ports connected closed-loop for testing assertions related to
the GTI.
.LE
.LE
.H 2 "Reports Provided"
Four reports are provided by the \*(N2.
.BL 4
.BL 4
.LI
Installation Report:
.br
Captures all the commands that are used
to generate the utilities and test modules and all output results
reported by the implementations utilities used.
.LI
Raw Journal Report:
.br
Provides a step-by-step log of what test is
to be performed, the preparations taken, and the results of each test.
.LI
Output Report:
.br
The Output Report consists of a test result code for every assertion of
each element (see \*(Ig, Appendix F).
.LI
Validation Report:
.br
Compares the result codes in the Output Report with the expected test
result codes and lists all discrepancies.
.LE
.SK
.rs
.sp |10P
.H 1 "Conformance Testing"
.SP 2P
.H 2 Requirements
The current Official \*(N2 must be used whenever
conformance testing for \*(Fp is to be performed (\(sc6.4.2).
The Official \*(N2 is the latest \*(N2 distributed
in conjunction with its latest distributed FIXES Patch.
The purchaser may utilize the \*(N2 as they wish,
modifying or enhancing it to provide added value.
However, when a test for conformance is to be performed the
UNEDITED version of the Official \*(N2 must be used.
.H 2 "\*(N2
The \*(Ig
provides the documentation required to install,
configure and execute the \*(N2.
The tester must use the implementation's \*(Pd to configure this \*(Ps.
\*(Ps configuration files
will reference specific sections of the \*(Pd 
when information on the behavior of the SUT is needed.
.P
The \*(Ig provides the \*(Fp acceptable test result code for each \*(P3
assertion.
The Output Journal test result codes must match the \*(Fp
required test result codes.
If report analysis verifies the implementation is non-conforming,
these errors must be
corrected in the SUT and the \*(N2 rerun in its
entirety.
If report analysis shows that an installation file
was not configured correctly, the configuration must be corrected and the
\*(N2 must be rerun in its entirety.
.H 3 Reports
The Installation Report is generated by the \*(N2 in the
user's test directory with a filename of \f7journal\fP.
.P
The Raw Journal Report provides
sufficient detail such that most failures can be identified
with a specific line or block of the actual source code where the test failed.
This report is produced for each element tested and is placed 
in \f7./STD/POSIX.1_Section/adm/.element\fP (where: \f2element\fP is the
name of the \f2element\fP tested).
.P
The Output Report provides the \*(Ps generated test result codes.
The complete list of these codes are listed below as 
acceptable or unacceptable test result codes.
.P
.BL 3
The acceptable test result codes are:
.BL 4
.BL 22
.LI "PASS \(em"
Successful test of a base assertion.
.LI "PASS_EXTENDED \(em"
Successful test of an extended assertion.
.LI "UNTESTED \(em"
Extended assertion for which a test has not been written.
.LI "UNSUPPORTED \(em"
Conditional feature not implemented.
.LI "NOT_TESTABLE \(em"
\*(P3 assertions containing a testing constraint which is not supported
by the IUT.
Examples illustrating when this test result code is reported are:
.BL 1
.LI
GTI devices are not provided.
.LI
{PCTS_NAME_MAX} \(<= {NAME_MAX}.
.LE
.LI "NOT_APPLICABLE \(em"
\*(P3 assertion contains a conditional feature which is contradictory
to the requirements of \*(Fp.
Eamples illustrating when this test result code is reported are:
.BL 1
.LI
{_POSIX_JOB_CONTROL} is not supported.
.LI
{_POSIX_SAVED_IDS} is not supported.
.LE
.LI "UNUSED \(em"
This assertion test was changed by a POSIX.3.1 interpretation and the
assertion is no longer valid.
.LE
.LE
.P
Unacceptable test result codes must be resolved to an acceptable test code
or an APTL resolved test code before
a successful conformance statement can be issued.
The unacceptable test result codes are:
.BL 4
.BL 22
.LI "FAIL \(em"
Unsuccessful test of a base assertion.
.LI "FAIL_EXTENDED \(em"
Unsuccessful test of an extended assertion.
.LI "UNRESOLVED \(em"
Assertion test could not be completed.
(Refer to Raw Journal Report for details on
why this test result code was generated.)
.LI "NOT_INITIATED \(em"
No test was initiated for this assertion number.
This code results when an earlier failure causes
this assertion test to be skipped.
.LE
.LE
.LE
.P
The Validation Report results are directed to \f7stdout\fP.
.H 2 "\*(Fp Conformance Document Audit"
The requirement for an audit of the PCD.1 for \*(Fp validation
was dropped (see 7.6).
.P
The \*(Pd, for the SUT, must provide the documentation requirements of \*(P3
and the additional requirement ``p'' of \*(Fp.
.H 3 "Additional \*(Fp Documentation Requirements"
The APTL must ensure that the additional documentation requirement
as specified in \*(Fp Item ``p'' is met.
.in +0.8i
.ll -0.8i
Implementations claiming conformance to \*(Fp shall document,
in the POSIX Conformance Document, the \*(Fp conditional features implemented.
(The term conditional features are the features or behaviors referred to
in \*(Fp that need not be present on all conforming implementations.
\*(I3 lists the documentation assertions for POSIX.1)
.in -0.8i
.ll +0.8i
.P
This requirement provides two necessary features:
.BL 4
.BL 1
.LI
Ensures conditional features supported by the SUT are documented.
.LI
Ensures that the information needed to set up the
\*(N2 is present in the SUT's \*(Pd.
.LE
.LE
.H 3 "Example of a \*(Pd Audit Procedure"
When the implementation Certified by the APTL provides
additional text based on an updated \*(S1
standard or to an approved IEEE standard that updates \*(S1,
Section 7.5 provides the \*(Pd requirements for \*(Fp.
.P
To provide some guidance for \*(Pd audits based on POSIX.3.1, 
a checklist is provided (see Appendix A).
Each entry of the checklist corresponds to a \*(P3 (sub)clause and
documentation assertion number.
This information must be presented in the \*(Pd in the (sub)clause as
stated by the checklist.
.P
The \f2Allowable Resolution\fP, of the checklist for each entry, is determined
by the category of the assertion, the text of the assertion, the text of
\*(P1, and the additional requirements of \*(Fp.\*F
.FS
The assumption used in the creation of this checklist is that the \*(I3
has properly specified all the documentation assertions.
Errors in documentation assertions must be rectified via the
IEEE Interpretation process.
.FE
The \f2Audit\fP column of Appendix A is completed by the APTL and
must contain, for each entry,
a \f4'\fPd\f4'\fP, \f4'\fPD\f7'\fP, or \f4'\fPN\f4'\fP.
Which identifier is used for an Audit entry
is determined by the following rules.
.BL 4
.LI d
Specifies documentation is provided that states the conditional feature
is NOT supported.
The use of \f4'\fPd\f4'\fP is restricted to those conditional documentation
assertion entries where the \*(N2 needs to know when support for the feature
documented is provided.
.LI D
Documentation is provided.
.LI N
Documentation is NOT provided.
.LE
.P
The following rules provide the rationale on the \f2Allowable Resolution\fP
column for each entry.
.BL 4
.LI
A documentation assertion with an \f4'\fPA\f4'\fP classification
requires the \*(Pd provide documentation.
Therefore, the \f2Allowable Resolution\fP entry and
the \f2Audit\fP entry is \f4'\fPD\f4'\fP.
.LI
A documentation assertion with a \f4'\fPC\f4'\fP classification that
specifies whether the feature is supported and this feature is required by
\*(Fp need not be documented.
The \f2Allowable Resolution\fP entry for this type of assertion is 
depicted as RD,N.
This syntax specifies the feature is required to be supported by \*(Fp
and documentation need not be provided.
Therefore, the \f2Audit\fP entry is either \f4'\fPD\f4'\fP or \f4'\fPN\f4'\fP.
.LI
A documentation assertion with a \f4'\&\fPC\f7\&'\fP classification that
is implied by a \*(Fp additional requirement must be documented.
The \f2Allowable Resolution\fP entry for this type of assertion is 
depicted as RD.
This syntax specifies the feature is required to be supported by \*(Fp
and documentation is required, since the documentation is an integral part
of the support for the \*(Fp additional requirement.
The \f2Audit\fP entry is \f4'\fPD\f4'\fP.
.LI
A documentation assertion with a \f4'\&\fPC\f7\&'\fP classification that
specifies that a feature is supported,
which \*(Fp does not mandate, and
which the implementation supports,
must be documented\*F.
.FS
\*(Fp specifications 'Item p' requires that conditional features implemented
be documented in the POSIX Conformance Document.
.FE
The \f2Allowable Resolution\fP entry for this type of assertion is 
depicted as either S\(->D,N or S\(->D,N,d.
The initial syntax specifies that when the feature is supported it
must be documented and when unsupported it is not documented.
The later syntax is used when documentation for nonsupport is also
acceptable to the documentation assertion.
The \f2Audit\fP entry is either a \f4'\fPD\f4'\fP or an \f4'\fPN\f4'\fP and
when applicable can be a \f4'\fPd\f4'\fP.
.LI
A documentation assertion with a \f4'\fPC\f4'\fP classification that
is based on additional specifications, behavior, or documentation being
provided need not be documented.
The \f2Allowable Resolution\fP entry and the \f2Audit\fP entry for
this type of assertion is depicted as D,N.
The \f2Audit\fP entry is either \f4'\fPD\f4'\fP or \f4'\fPN\f4'\fP.
.LI
A documentation assertion which is not applicable to \*(Fp requirements 
must not be documented.
The \f2Allowable Resolution\fP entry for
this type of assertion is depicted as NA\(->N.
The \f2Audit\fP entry is \f4'\fPN\f4'\fP.
.LE
.P
The parameters specified by the APTL for the configuration file
<config> in the \*(N2 must be consistent with the
specifications of the \*(Pd.
.H 2 "\*(Fp Conformance"
A claim of conformance to \*(Fp asserts that the SUT
test result codes match the required \*(Fp test result codes
(or possible in some cases the APTL resolved test codes)
and complies fully with the \*(Fp documentation requirements. 
Statements claiming conformance to \*(Fp should state
the version of the Official \*(N2 that was used.
.P
A \*(Cv for \*(Fp is
issued only by \*(Nl through APTLs.
.SK
.rs
.sp |10P
.H 1 "\*(Nl \*(Cv"
.SP 2P
This section specifies the procedures to be followed, when
a \*(Cv from \*(Nl is desired.
.H 2 "APTL for FIPS 151-2"
An Accredited POSIX Testing Laboratory (APTL) is a testing laboratory that
has been accredited for POSIX testing
by NVLAP.
APTLs for \*(Fp have demonstrated the proficiency required to use
the \*(N2 and may submit test results for a \*(Fp \*(Cv.
.P
Arrangements for conformance testing are between clients and APTLs.
Arrangements for evaluation of the test results, for the purpose
of issuing a \*(Cv, are between the APTLs and \*(Nl.
.P
The Official \*(N2 is provided by the APTL.
.P
The Official \*(N2 must be used whenever the goal of the testing is to
obtain a \*(Cv with the test results.
The APTL will cause the generation of all required output reports for the IUT.
\*(Nl will accept \*(Fp Certification Reports only from APTLS.
APTLs shall not use results from BETA Patches in certification reports
submitted to \*(Nl for validation.
An APTL may
reference the BETA Patch as the required documentation to support
the argument that a bug exists in the \*(N2 for a
specific assertion.
.P
Test results submitted to \*(Nl for validation
must be the results of testing conducted by the
APTL after it formally received notification of accreditation from NVLAP
(see \f2NVLAP Handbook\fP, Appendix E).
\*(Nl schedule reviews of certification reports in the order in
which they are received from APTLs.
\*(Nl issues a \*(Cv
upon successful  completion of the validation procedure.
.H 2 "APTL Resolved Test Codes"
APTL resolved test codes allow a test result code of an unacceptable
type to be resolved to one that is acceptable for obtaining a
\*(Cv from \*(Nl.
To obtain a \*(Cv
when the test result codes reported do not match the acceptable \*(Fp
test result codes and the APTL deems that the reason for
the discrepancy is not the fault of the SUT,
the APTL must resolve each discrepancy to an APTL resolved test result code.
Supporting documentation must be provided
to justify the selected APTL resolved test code.
This policy is not designed to \f2waive\fP or ignore
actual errors, but rather to permit acceptance
of implementations which meet the
intent of the standard, but through some set of errors or
discrepancies fails to meet a specific encoding of a test (i.e.,
resolve false negatives).
.P
When test failures occur due to hardware malfunctioning, the APTL is expected
to rerun the \*(N2 in its entirety on properly functioning hardware.
No APTL resolved test code exists to cover the failure of a test
due to hardware malfunction.
The inherent assumption of a \*(Cv is that the hardware functioned properly.  
.P
APTL provided Certification Reports must consist of unmodified test results.
.P
Each submission of an APTL resolved test code will be examined
by \*(Nl on its individual merits.
When \*(Nl accepts the
APTL resolved test code, the actual test result code will not be an
impediment to the issuance of a \*(Cv.
If \*(Nl does not accept the APTL resolved test code, the actual test
result code applies and a \*(Cv will
not be issued.
An APTL shall NEVER alter the reports generated by an
Official \*(N2 run that is to be used for requesting a
\*(Cv from \*(Nl.
.P
The complete list of APTL resolved test codes are defined below:
.P
POSIX.1_EXTENSION:
.BL 4
An APTL resolved test code of POSIX.1_EXTENSION specifies that
the SUT provided a POSIX.1 allowable extension that was not handled
properly by the \*(N2 and
this extension has been properly documented in the SUT's \*(Pd.
The APTL;
shall provide supportive documentation that clearly and accurately
describes the problem with the Official \*(N2,
should suggest corrective code that allows the test to perform
successfully on the SUT, and
shall quote from the \*(Pd the statements that apply.
.LE
.P
PCD_DOCUMENTED:
.BL 4
An APTL resolved test code of PCD_DOCUMENTED states that:
the unsuccessful result was caused by the \*(Ps improperly handling
an implementation defined condition,
the APTL verified that the required documentation is provided in the
appropriate place in the \*(Pd,
the unsuccessful result reported by the \*(Ps is consistent with
the documentation provided,
and supporting documentation for these requirements is provided by the APTL
in the Certification Report.
.LE
.P
PCTS_FAILURE:
.BL 4
An APTL resolved test code of PCTS_FAILURE specifies the
Official \*(N2 has a "bug" that impeded the SUT
from properly performing the required test.
For acceptance of an APTL resolved test code of PCTS_FAILURE,
the APTL generated documentation required must contain:
.BL 4
.BL 1
.LI
The complete output results from the raw journal for the assertion test or
test case that failed.
.LI
A clear and accurate description of the problem encountered.
.LI
Code changes or PCTP required to obtain a successful test result code.
For an \f2extended assertion\fP, this requirement is optional.
.LI
Affirmation from the APTL that successful results were obtained when
the documented changes were performed.
For an \f2extended assertion\fP, this requirement is optional.
.LE
.LE
.LE
.P
POSIX.1_FAILURE:
.BL 4
An APTL resolved test code of POSIX.1_FAILURE specifies that the \*(S1
has an error or inconsistency that was resolved
by an IEEE interpretation or an official update to \*(S1.
The documentation required to use this code is a complete reference
to the interpretation.
.LE
.P
POSIX.3_FAILURE:
.BL 4
An APTL resolved test code of POSIX.3_FAILURE specifies that the
\*(I3 has an error or inconsistency that was resolved
by an IEEE interpretation or an official update to the POSIX.3.1 standard.
The documentation required to use this code is a complete reference
to the interpretation.
.LE
.P
POSIX_VERSION_UPDATE
.BL 4
The value of {_POSIX_VERSION} provided by the implementation
corresponds either to an updated version of \*(S1
or to an approved IEEE standard that updates \*(S1.
POSIX_VERSION_UPDATE is an APTL resolved test code that can be
used ONLY for assertion
.At sym_const 05 .
.P
The value of {_POSIX_VERSION} used by the IUT must be
provided with the supporting documentation.
.LE
.H 2 "APTL Report Checklist"
When the \*(N2 reports comply with the requirements below,
the APTL is ready to request \*(Nl validation.
.BL 4
.BL 1
.LI
Installation has been completed and no errors or warnings
implying errors are reported in the Installation Report.
.LI
The \*(N2 procedures have been adhered to as documented in the
\*(N2 Installation Guide.
.LI
All Output Report results match those specified
in \*(Ig (\(sc12.2) except for any test
result codes of FAIL, FAIL_EXTENDED, UNRESOLVED, and NOT_INITIATED
each of which has been resolved to an APTL resolved test code of
POSIX.1_EXTENSION,
PCD_DOCUMENTED,
PCTS_FAILURE,
POSIX.1_FAILURE, or
POSIX.3_FAILURE.
.LI
No APTL resolved test codes are dependent on a yet to be determined IEEE
interpretation.
.LE
.LE
.H 2 "APTL Certification Report"
.H 3 "Certificate of Validation Application Form"
The application form provides information that will appear
on the \*(Cv (Appendix C).
A sample \*(Ca
is provided as Appendix B and a template for this form is provided
by the \*(N2 as file \f7./CERT_data/NPTP_appendixB\fP.
This template must be fully and accurately completed.
.br
.H 4 "Validated FIPS 151-2 Product"
The APTL must provide the name of the supplier of the software product tested
and must accurately identify the product.
When a trademark or a registered trademark symbol is required, the APTL
will specify the requirement in ASCII text on the \*(Ca.
If a trademark symbol is expected on the \*(Cv, the APTL
must state this.
The \*(Cv will have the option of the use of a symbol for trademarks.
.P
The identification must include the name of the product and any other
product designations needed to uniquely define the tested product.
The product identified represents the IUT.
This product must contain, if needed, automated procedures
for configuration control during installation.
Implementations requiring that the IUT be manually
\f2patched\fP, cannot be identified as required and will not be validated.
(i.e., An operating system that requires a type
definition of \f2typedef int ssize t;\fP be added
to \f7/usr/include/sys/types.h\fP
to PASS all \*(N2 testing is not a conforming implementation.
This code must be provided by the operating system during installation.)
.P
Products need not automate configuration details required for
providing FIPS 151-2 optional features nor for performing FIPS 151-2
validation testing.
.H 4 "Configuration of SUT for FIPS 151-2 Conformance"
The APTL must specify the installation procedures required to configure
the software product identified in 6.4.1.1 for FIPS 151-2 conformance.
This specification is to be retained in
file \f7./CERT_data/config_SUT\fP and is limited
only to those procedures needed to obtain FIPS 151-2 conformance.
References to specific sections in the SUT's associated system documentation
is acceptable.
When the SUT is such that FIPS 151-2 conformance is not
dependent on installation procedures, then the APTL shall state:
.BL 8
Operating system is not dependent on installation procedures for
FIPS 151-2 conformance.
.LE
as the data for \f7./CERT_data/config_SUT\fP.
.br
.H 4 "Test Environment"
Four types of \*(P1 implementations have been identified:
\f2native\fP, \f2hosted\fP, \f2cooperating\fP, and \f2cooperating-hosted\fP.
The type of the implementation tested must be stated.
.P
The hardware implementation employed to test the product must be identified.
The identification must include the name of the implementation
and any other designations needed to uniquely define it
(i.e., Name, Model, Release).
If the product tested was on a \f2cooperating\fP implementation, then both
the target and the development implementations must be identified.
Other required details are:
.BL 4
.BL 1
.LI
model number (if applicable),
.LI
random access memory available, and
.LI
number of central processing units available.
.LE
.LE
.P
The complete hardware configuration is required.
This includes memory provided, cpu's available,
controllers installed, and the number and types of disk drives.
.P
The APTL must also provide the
name and supplier of the FIPS 160 conforming compiler and
the identification scheme to uniquely identify it (Name, Release, etc).
.P
These specifications should follow the
format as shown by the following example.
.P
.nf
.in +0.5i
.ta 0.3i 1.0i
Implementation Tested
	Supplier:	POSIX Products, Inc.
	Product:	PROD_456, Version 1.3, August 1993
	PCD:	POSIX Conformance Document, August 1993
.SP 2
System Tested
.ta 0.3i 1.0i
	Type:	Native
.ta 0.3i 2.4i
	Computer Hardware Supplier:	Hardware Inc.
	Computer Hardware Product:	TRUE_blue, Model Red_White_Blue, 48MB, 1cpu
.ta 1.1i
	1 - Graphics box, Model See_It_Quick
.ta 0.3i 0.5i 1.8i
		Disk Controller:	Integrated SCSI controller
.ta 1.1i
	1 - 665MB disk drive, Model RWB_1
	2 - 1.2GB disk drive, Model RWB_3
.ta 0.3i 0.5i 1.8i
		Terminal Controller:	Never_a_Miss, Model RWB,

.ta 0.5i 2.4i
	C Compiler Supplier:	POSIX Products, Inc.
	C Compiler Product:	PROD C Compiler, Version 1.0, August 1993
.in -0.5i
.fi

\*(Nl will attempt to automate the generation of the \*(Cv based on the input
provided by the APTL and the Output Report from the \*(N2.
APTLs should make every effort to retain the designated format when
preparing the application form file \f7./CERT_data/NPTP_appendixB\fP.
.H 3 "Timely Dispatch of Certification Reports"
APTLs may submit certification reports from the prior
Official \*(N2 for up to thirty days from the date of the latest
release of the Official \*(N2.
Certification reports from a prior version received
more than thirty days after the official date of the updated
\*(N2 will not be validated.
.P
For example: An APTL that initiates testing on 1/1/95
with the Official \*(N2 and
continues testing with this PCTS even though an updated Official \*(N2
is released on 3/1/95 must submit the Certification Report to \*(Nl
on or before 3/31/95.
This Certification Report received beyond 3/31/95 will not be accepted.
The APTL will have to rerun the testing with the Official \*(N2.
.H 3 "Validation Review"
\*(Nl will strive to process a problem-free Certification Report
and provide to the APTL a \*(Cv
within three weeks after the report and its associated \*(Ca are received.
.P
A Certification Report which requires an update to the supporting material 
provided with the PCTS must be resubmitted in its entirety.
If the \*(Ca is found to be in
error, it must be resubmitted along with the updated Certification Report.
\*(Nl will not retain Certification Reports that require additional updates.
These reports will be destroyed.
The APTL must adhere to \(sc6.4.2 in order to avoid having to rerun and
repay for a \*(Cv.
.P
When a resolution of a test result code is determined to be dependent on
a not-yet-completed IEEE interpretation and/or a follow up \*(Ny decision
(see FIPS PUB 29-2),
the APTL will be informed of this matter and the report will be destroyed.
Once the required procedures are completed and the outcome is now in compliance
with the results obtained from the SUT, the APTL can update the report
to include the decisions rendered.
The APTL must adhere to \(sc6.4.2 in order to avoid having to rerun and
repay for a \*(Cv.
.P
An APTL should if possible avoid testing an implementation, for obtaining
a \*(Cv, when interpretations are known to be required.
When this condition arises, the APTL should attempt to get the interpretation
problem favorably resolved prior to submitting the Certification Report to
\*(Nl.
.H 3  "Collection and Submission of Certification Report"
To request a \*(Cv for \*(Fp an
APTL must provide to \*(Nl the following items:
.BL 4
.AL 1 3
.LI
Certification Fee
.LI
File \f7CV_report\fP which is generated by \f7./bin/gen_cert_rept\fP.
.LE
.LE
.P
The file \f7CV_report\fP contains the \*(N2 configuration files and the
required APTL generated reports.
The APTL reports are:
.BL 4
.AL 1 3
.LI
Completed \*(Ca (\(scAppendix B)
.LI
A statement on altered \f7*/*/src/*/svcomp\fP files.
When no \f7svcomp\fP files have been altered, the statement shall state
this fact.
.LI
Documentation for any APTL resolved test codes used.
When no APTL resolved test codes are needed because all tests were successful,
the document shall state this fact.
.LI
Documentation specifying additional installation
procedures performed or installation options selected to obtain
the environment for testing the implementation for FIPS 151-2 conformance.
When system documentation is referenced
(e.g., Technical Notes, manual pages, etc.),
either a copy of this documentation must be provided or a summary of the
referenced document must be contained within this report
(file \f7./CERT_data/config_SUT\fP).
When copies of system documents are provided, these will be
returned when validation procedures are completed.
.LE
.LE
.P
Section 13 in the \*(Ig documents the file names to use
for the required APTL reports and the procedures available for
generating \f7CV_report\fP.
The file \f7./NIST-PCTS/CERT_data/LIST_FILES\fP lists all the files to be
included in the Certification Report.
The APTL must as a minimum collect, from the IUT,
all the required files via the
extended \f7cpio\fP format creating utility once testing is completed.
Once this data is collected, only the files:
.in +1.0i
.nf
\&\f7./CERT_data/NPTP_appendixA
\&./CERT_data/NPTP_appendixB
\&./CERT_data/alt_svcomp
\&./CERT_data/resolved_trc
\&./CERT_data/config_SUT\fP
.br
.in -1.0i
.fi
may be altered by the APTL.
The APTL must assure that the status times obtained for the other
files collected at the IUT site are not altered in the Certification Report
submitted to \*(Nl.
.P
The Certification Report
as obtained from the execution
of \f7./bin/gen_cert_rept\fP
must be submitted to the NIST POSIX Cerification
Authority in machine-readable form.
The medium must be acceptable to \*(Nl.
E-mail sent to \*(Em is the prefered machine-readable medium.
.P
The certification fee and a printed copy of the \*(Ca
containing the NVLAP approved signatory shall be submitted to:
.P
.BL 4
.nf
NIST POSIX Certification Authority
National Institute of Standards and Technology
Bldg 225 Room B266
Gaithersburg, MD 20899
.fi
.LE
.P
The \*(N2 provides templates of Appendices A, B, and C
in directory \f7./CERT_data\fP.
Templates B and C must be used when submitting a Certification Report.
Certification Reports which improvise on the format of these templates
will not be accepted.
.P
The APTL must be able to reproduce paper copies of the Certification Report
if requested by the NIST POSIX Certification Authority.
.H 2 "Certificate of Validation"
A \*(Cv is issued by \*(Nl based on the
Official \*(N2.
Samples of a \*(Cv are provided in Appendix C.
Many of the items on the \*(Cv are those
specified by the APTL in
the \*(Ca.
.P
Additional \*(Cv information is available from
\*(Nl on:
.BL 4
.BL 1
.LI
Hardware configuration including the types and models of
the controllers used for the devices tested.
.LI
List of assertions (element, assertion number, corresponding
test result code, and APTL resolved test result code) for those
assertions where the Output Report test result code was FAIL,
UNRESOLVED, NOT_INITIATED, or FAIL_EXTENDED.
.LE
.LE
.P
\*(Nl maintains a register called the \f2NIST POSIX Testing Laboratories
and Validated Products\fP which lists current APTLs and POSIX products.
As additional products are validated, they are added to the register.
.P
\*(Nl also provides an e-mail file service.
You can receive the most recent information on the NIST POSIX
Testing Program by sending e-mail messages to
\f2posix@nist.gov\fP.
An e-mail message with a body consisting of ``send 151-2reg'' will return
the register of validated prodocts for \*(Fp.
The automatic mail file server will read the message and return the requested
document as the body of one or more e-mail messages.
.H 3 "Reference File Number"
Each \*(Cv is assigned a Reference File Number.
The Reference File Number is determined by the concatenation of; the text
``151-2'',
a unique three letter mnemonic for each operating system supplier,
and a three digit number which starts at 001 for each operating system
supplier and incremented for each \*(Cv issued.
A Reference File Number of 151-2DCC001 would be assigned to
the initial \*(Cv for the fictitious ``Data Computer Company''.
.SK
.H 1 "Testing Policy Decisions"
.SP 2P
This section specifies the policy decisions that have been made pertaining to
the testing for conformance to \*(Fp.
These existing policy decisions are subject to change and if additional policy
decisions are needed they will be placed in this section.
.H 2 "FIPS 151-2 Testing"
This PCTS is testing \*(Fp not an updated \*(P1-1990 standard.
No testing requirement, as determined by \*(Fp (and its associated
\*(I3 testing standard), will be altered because an update of the 
\*(P1-1990 standard, deleted or made optional a requirement of \*(P1-1990.
.H 2 "\*(P1 Extensions"
The issue of conformance testing for implementations
providing POSIX.1 extensions, using the \*(N2 is a problem area.
As products
are being prepared, vendors, users, and testers are concerned about how
\*(Nl will resolve conformance testing problems involved by \*(P1 extensions.
.P
Until we determine and document what action to take for an extensively
documented and acceptable \*(P1 extension,
we will not validate systems that require resolved test codes of
PCTS_FAILURE based on inadequately specified issues as related to
\*(P1.
.H 2 "\*(P1 Unspecified Features"
ISO/IEC 9945-1:1990 allows conforming implementations
to contain unspecified features.
Unspecified features provided in implementations under \*(P1 umbrellas
such as those introduced in Sections 2.2.2.4, 2.3.1, and 2.3.2 - which
allow implementation-defined, alternate, or extended behavior while
completely omitting the details for this behavior - may cause unacceptable
test results when tested.
.P
The \*(N2 tests conformance to \*(Fp based on the assertions
(modified as needed to adhere to the additional requirements of \*(Fp)
in the latest \*(P3 document available when \*(Fp was approved.
Implementations with unacceptable test results, because the implementation
incorporated unspecified features when tested, will not be issued a \*(Cv.
.P
Vendors requiring a \*(Cv for implementations that
provide unspecified features must ensure these features do not cause the
PCTS to become errant.
APTLs must ensure that the implementation tested
is the unaltered implementation identified on the \*(Ca.
The APTL should capture any installation
setup details outside the scope of the \*(Ps that are needed to ensure the
successful run of the \*(Ps.
These details will be needed if a rerun of
the conformance testing is required in the future.
.br
.H 2 "FIPS 151-1 and FIPS 151-2 Certificates of Validation"
An implementation that attains a \*(Fp \*(Cv
is conforming to both \*(Fp and \f1FIPS 151-1\fP.
The \*(S1 was defined by P1003.1 as the update to
IEEE Std 1003.1-1988 which contained only corrections and additional text
to explain the intended meaning of the 1988 standard.
The tests of the \*(N2 therefore, can be used as the tests for FIPS 151-1.
.P
\*(Fp became effective on October 15, 1993.
\*(Nl no longer processes FIPS 151-1 Certification Reports.
.P
The Official \*(N2 (based on the test methods of \*(I3)
is available for purchase from NIST/CSL (see Appendix D).
\*(Nl will validate \*(Fp Certification Reports from
\*(Fp NVLAP Accredited POSIX Testing Laboratories.
.H 2 \*(Pd 
To harmonize the \*(Pd requirements of FIPS 151-2 with that of \*(S1
and its official updates, the \*(Fp \*(Pd requirements are:
.BL
.LI
The \*(Pd must meet all the requirements as specified by the actual
documentation assertions of \*(I3 and additional requirement ``p'' of \*(Fp.
.LI
The \*(Pd must not delete or change any requirements of \*(Fp and
its associated test method standard, \*(I3.
.LI
The \*(Pd must contain all the documentation requirements as
specified by both \*(Fp and \*(I3.
.LI
The \*(Pd may contain additional text related to vendor
determined requirements for an official update of \*(S1 or
for an approved IEEE standard that updates \*(S1
when a test method standard is not available to specify the
actual requirements of the updated standard.
The APTL is not required to certify that the text provided
is consistent with the perceived documentation requirements of
the updated standard.
.LE
.H 2 "\*(Pd Requirement Dropped"
IEEE Interpretations has stated that a conflict exists between
the requirements of IEEE Std 1003.1-1990 and the documentation
assertions as stated in \*(I3.
On August 30, 1994, the audit of the \*(Pd was no longer required
to obtain a \*(Cv for \*(Fp from \*(Nl.
.P
The two unchanged requirements associated with the \*(Pd for \*(Fp
certification will be the documentation of its identification
in the \*(Ca, and the
retention of the \*(Pd as part of the APTL's official test results file.
Specification of the \*(Pd identification is confirmation by
the APTL that the \*(Pd was utilized when testing was performed.
.SK
.rs
.nr Hc 2				\" Center chapter titles and HUs (level 2 and less)
.HU "APPENDIX A"

.ce 1
.S 14
\*(Fp Documentation Audit
.ce 0
.SP 2P
.S 12
Documentation Audit Tables Symbols:
.BL 3
.nf
.ta 1.0i
,	\(em Separation notation used for listing of acceptable symbols. 
S	\(em \*(P1 conditional feature is supported.
d	\(em Documentation provided specifies conditional feature NOT supported.
D	\(em Documentation provided.
N	\(em Documentation NOT provided.
NA	\(em Documentation assertion is not applicable to FIPS 151-2 requirements.
S\(->D	\(em If conditional feature is supported, then documentation is required.
RD	\(em Implied required FIPS 151-2 conditional feature, documentation required.
RD,N	\(em Required FIPS 151-2 conditional feature, documentation need not be provided.
NA\(->N	\(em Documentation shall not be provided.
.fi
.LE
.SK
.S \\n(XS
.SP 2P
.TS
tab (|) center,box;
c | l | c | c | c
c | l | c | c | c
l | l | l | l | c.
POSIX.3.1|#|Allowable|PCTS|Audit
(Sub)clause|\&|Resolution|Conditional Feature|D,N,d
=
1.3.1.1|1|D|\*(P1 environment|.|
1.3.1.2|2|D|name, number, and date of applicable \*(P1 standard|.|
1.3.1.2|3|D,N|international software standards|.|
1.3.3|4|NA\(->N|C-language differences from C Standard|.|
1.3.3.2|5|D|version of the C Standard supported|.|
1.3.3.3|GA1|NA\(->N|interface differences from C Standard|.|
1.3.3.3|6|NA\(->N|language binding differences from C Standard|.|
2.2.2.4|1|D,d|associating appropriate privileges with a process|.|
2.2.2.9|2|RD,N|character special files other than terminal device files|.|
2.2.2.9|3|D,N|structures of character special files|.|
2.2.2.27|4|RD,N|other file types|.|
2.2.2.30|5|D,N|additional criteria to assign process to file group class|.|
2.2.2.55|6|D|parent process ID assigned after parent ended|.|
2.2.2.57|7|D|interpretation of pathname that begins with two slashes|.|
2.2.2.68|8|D,N|resources returned when process terminates|.|
2.2.2.69|9|D|restrictions of interfaces on read-only file systems|.|
2.2.2.83|10|RD,N|effective GID returned by \f2getgroups\fP(\^)|.|
2.3.1|1|RD,N|extended security controls|.|
2.3.2|2|RD,N|additional and alternate file access controls|.|
2.3.2|3|D,N|disabling alternate mechanism and \f2chmod\fP(\^)|.|
2.3.5|4|D,N|additional time-related update specifications|.|
2.3.5|5|D,N|additional time-related update specifications|.|
2.3.5|6|D,N|updating time-related fields|.|
2.4|1|RD,N|additional errors|.|
2.4|2|D|reliable detection of [EFAULT]|.|
2.4|3|D|maximum file size allowed|.|
2.5|1|RD,N|additional type symbols ending in ``_t''|.|
2.6|1|RD,N|other characters used for environment variable names|.|
2.7.2|1|RD,N|additional feature test macros|.|
2.8.3|1|D|limit for {NGROUPS_MAX} in <limits.h>|.|
2.8.4|2|D|run-time invariant values in <limits.h>|.|
2.8.5|3|D|changeable values in <limits.h>|.|
2.9|1|D|values {_POSIX_JOB_CONTROL}, {_POSIX_SAVED_IDS}|.|
2.9|2|RD,N|value of {_POSIX_CHOWN_RESTRICTED} in <unistd.h>|.|
2.9|3|RD,N|value of {_POSIX_NO_TRUNC} in <unistd.h>|.|
2.9|4|RD,N|value of {_POSIX_VDISABLE} in <unistd.h>|.|
.TE
.SK
.TS
tab (|) center,box;
c | l | c | c | c
c | l | c | c | c
l | l | l | l | c.
POSIX.3.1|#|Allowable|PCTS|Audit
(Sub)clause|\&|Resolution|Conditional Feature|D,N,d
=
2.9.4|5|RD|{_POSIX_CHOWN_RESTRICTED} value in <unistd.h>|.|
2.9.4|6|RD|{_POSIX_NO_TRUNC} value in <unistd.h>|.|
2.9.4|7|RD|{_POSIX_VDISABLE} value in <unistd.h>|.|
3.1.1.2|1|RD,N|sharing open directory streams between parent and child|.|
3.1.1.2|2|D,N|inheritance of process characteristics for \f2fork\fP(\^)|.|
3.1.1.4|3|RD,N|[ENOMEM] detection for \f2fork\fP(\^)|.|
3.1.2.2|1|D|\f2execlp\fP(\^) or \f2execvp\fP(\^) results on search without PATH|.|
3.1.2.2|2|D,N| inheritance of process characteristics for \f7exec\fP elements|.|
3.1.2.2|3|D,N|\f2st_atime\fP marked for update when \f7exec\fP fails|.|
3.1.2.4|4|RD,N|execution of irregular files|.|
3.1.2.4|5|RD,N|[ENOMEM] detection \f7exec\fP|.|
3.2.1.1.2|1|D,N|order reporting status for two or more child processes|.|
3.2.1.1.3|2|D,N|additional circumstances for reporting status|.|
3.2.1.1.4|3|D,N|status value provided by \f2wait\fP(\^) or \f2waitpid\fP(\^) is [EINTR]|.|
3.2.2.1|1|NA\(->N|result type for function \f7_exit\fP(\^)|.|
3.2.2.2|2|D|parent process ID assigned to child of terminated process|.|
3.3.1.1|1|NA\(->N|support of {_POSIX_JOB_CONTROL} signals|.|
3.3.1.1|2|RD,N|additional signals supported|.|
3.3.1.2|3|D,N|action taken on blocked signal when action is SIG_IGN|.|
3.3.1.2|4|D|signal delivered more than once if another signal is pending|.|
3.3.1.2|5|D,N|delivery of multiple pending signals to process|.|
3.3.1.2|6|D|details outside of POSIX.1 on generating signals|.|
3.3.1.3|7|D,N|SIGFPE, SIGILL, or SIGSEGV signal ignored|.|
3.3.1.3|8|D,N|action taken for SIGCHLD to SIG_IGN|.|
3.3.1.3|9|D,N|action SIGFPE/SIGILL/SIGSEGV not from \f7kill\fP(\^)/\f7raise\fP(\^)|.|
3.3.1.3|10|D,N|caught SIGCHLD signal and unwaited terminated child process|.|
3.3.1.3|11|D,N|interrupted unsafe function calls an unsafe function|.|
3.3.2.2|1|RD,N|send signals to processes of another user ID|.|
3.3.2.2|2|D,N|excluded set of system processes when \f2pid\fP is 0|.|
3.3.2.2|3|D,N|behavior of \f2kill\fP(\^) when \f2pid\fP is -1|.|
3.3.2.2|4|D,N|excluded set of system processes when \f2pid\fP is negative but not -1|.|
3.3.2.2|5|D,N|restrictions on sending of non-\*(P1 signals|.|
3.3.3.1.2|1|D,N|object of type \f2sigset_t\fP not initialized but pointer to object supplied|.|
3.3.3.3.4|1|RD,N|[EINVAL] detection for \f2sigaddset\fP(\^)|.|
3.3.3.4.4|1|RD,N|[EINVAL] detection for \f2sigdelset\fP(\^)|.|
3.3.3.5.4|1|RD,N|[EINVAL] detection for \f2sigismember\fP(\^)|.|
3.3.4.2|1|D,N|action taken by \f2sigaction\fP(\^) when established by \f2signal\fP(\^)|.|
3.3.4.2|2|D,N|setting action to SIG_DFL for signal that cannot be ignored|.|
3.3.5.2|1|D,N|SIGFPE, SIGILL, or SIGSEGV generated while blocked|.|
3.3.6.4|1|RD,N|error conditions detected for \f2sigpending\fP(\^)|.|
3.4.3.2|1|D,N|SIGALRM generated during \f2sleep\fP(\^) is ignored or blocked|.|
3.4.3.2|2|D,N|SIGALRM is blocked from delivery|.|
3.4.3.2|3|D,N|SIGALRM is not blocked or ignored|.|
3.4.3.2|4|D,N|details (time, action, signal mask) SIGALARM interrupting \f2sleep\fP(\^)|.|
3.4.3.2|5|D,N|\f2sleep\fP(\^) interrupted and \f2siglongjmp\fP(\^) or \f2longjmp\fP(\^) called|.|
.TE
.SK
.TS
tab (|) center,box;
c | l | c | c | c
c | l | c | c | c
l | l | l | l | c.
POSIX.3.1|#|Allowable|PCTS|Audit
(Sub)clause|\&|Resolution|Conditional Feature|D,N,d
=
4.2.2.1.2|1|RD|appropriate privileges to change real, effective, saved setuids|.|
4.2.2.2.2|1|RD|appropriate privileges to change real and effective group IDs|.|
4.2.3.2|1|D,N|array entries and returned value from \f2getgroups\fP(\^)|.|
4.2.4.3|1|D,N|return value from \f2getlogin\fP(\^) possibly overwritten|.|
4.2.4.4|2|S\(->D,N,d|error conditions detected for \f2getlogin\fP(\^)|.|
4.3.3.2|1|NA\(->N|support for \f2setpgid\fP(\^)|.|
4.4.1.2|1|D|format of \f2struct utsname\fP members|.|
4.4.1.4|2|RD,N|error conditions detected for \f2uname\fP(\^)|.|
4.5.1.4|1|RD,N,d|error conditions detected for \f2time\fP(\^)|.|
4.5.2.3|1|D,N|return value from \f2times\fP(\^) overflow range of type \f2clock_t\fP|.|
4.5.2.4|2|RD,N,d|error conditions detected for \f2times\fP(\^)|.|
4.6.1.3|1|D,N|return value from \f2getenv\fP(\^) possibly overwritten|.|
4.6.1.4|2|RD,N,d|error conditions detected for \f2getenv\fP(\^)|.|
4.7.1.3|1|D,N|return value from \f2ctermid\fP(\^) possibly overwritten|.|
4.7.1.4|2|RD,N,d|error conditions detected for \f2ctermid\fP(\^)|.|
4.7.2.1.2|1|D,N|return value from \f2ttyname\fP(\^) possibly overwritten|.|
4.7.2.1.4|2|RD,N,d|error conditions detected for \f2ttyname\fP(\^)|.|
4.7.2.2.4|1|RD,N,d|error conditions detected for \f2isatty\fP(\^)|.|
4.8.1.2|1|D,N|additional configuration system variables|.|
5.1.1|1|D,N|internal format of directories|.|
5.1.1|2|D,N|size of array \f2d_name\fP|.|
5.1.2.1.2|1|D,N|file removed or added after \f2opendir\fP(\^)|.|
5.1.2.1.4|2|RD,N|[EMFILE] detection for \f2opendir\fP(\^)|.|
5.1.2.1.4|3|RD,N|[ENFILE] detection for \f2opendir\fP(\^)|.|
5.1.2.2.2|1|D,N|return value from \f2readdir\fP(\^) possibly overwritten|.|
5.1.2.2.2|2|D,N|\f2readdir\fP(\^) buffers directory entries per read operation|.|
5.1.2.2.2|3|D,N|using directory stream after \f7exec\fP type function call|.|
5.1.2.2.2|4|D,N|parent and child call \f2readdir\fP(\^)|.|
5.1.2.2.4|5|D,N|passing a closed \f2dirp\fP argument to \f2readdir\fP(\^)|.|
5.1.2.2.4|6|RD,N|[EBADF] detection for \f2readdir\fP(\^)|.|
5.1.2.3.1|1|NA\(->N|result type for \f2readdir\fP(\^)|.|
5.1.2.3.2|2|D,N|removing and adding entries to a directory|.|
5.1.2.3.2|3|D,N|passing a closed \f2dirp\fP argument to \f2rewinddir\fP(\^)|.|
5.1.2.4.2|4|D,N|child and parent processes both using \f2readdir\fP(\^) and \f2rewinddir\fP(\^)|.|
5.1.2.4.2|1|D,N|accessibility of object type DIR after call to \f2closedir\fP(\^)|.|
5.1.2.4.2|2|D,N|passing a closed \f2dirp\fP argument to \f2closedir\fP(\^)|.|
5.1.2.4.4|3|RD,N|[EBADF] detection for \f2closedir\fP(\^)|.|
.TE
.SK
.TS
tab (|) center,box;
c | l | c | c | c
c | l | c | c | c
l | l | l | l | c.
POSIX.3.1|#|Allowable|PCTS|Audit
(Sub)clause|\&|Resolution|Conditional Feature|D,N,d
=
5.2.2.2|1|D,N|behavior of \f2getcwd\fP(\^) when \f2buf\fP is a NULL pointer|.|
5.2.2.3|2|D,N|contents of buffer passed to \f2getcwd\fP(\^) after an error|.|
5.2.2.4|3|RD,N|[EACCES] detection for \f2getcwd\fP(\^)|.|
5.3.1.2|1|D,N|call to \f2open\fP(\^) on a FIFO with O_RDWR set|.|
5.3.1.2|2|D|group ID of new file set to group ID of its directory|.|
5.3.1.2|3|D,N|\f2open\fP(\^) with O_CREAT and bits other than mode bits are set|.|
5.3.1.2|4|D,N|\f2open\fP(\^) with O_EXCL and O_CREAT not set|.|
5.3.1.2|5|D,N|block or character supporting nonblocking and O_NONBLOCK set|.|
5.3.1.2|6|D,N|\f2path\fP not a block, character, or FIFO file and supports nonblocking|.|
5.3.1.2|7|D|O_TRUNC on file types other than regular, FIFO, or terminal files|.|
5.3.1.2|8|D,N|\f2open\fP(\^) with O_TRUNC and O_RDONLY set|.|
5.3.3.2|1|D|bits other than file permission bits in \f2umask\fP(\^) argument|.|
5.3.4.2|1|RD,N,d|\f2link\fP(\^) across file systems|.|
5.3.4.2|2|RD,N|appropriate privileges to link to a directory|.|
5.3.4.2|3|RD,N,d|\f2link\fP(\^) to directory|.|
5.3.4.2|4|RD,N|access permission to access existing file for \f2link\fP(\^) to succeed|.|
5.4.1.2|1|D|effect of \f2mkdir\fP(\^) of bits other than permission bits set in \f2mode\fP|.|
5.4.1.2|2|D|group ID of new file set to group ID of its directory|.|
5.4.2.2|1|D|effect of \f2mkfifo\fP(\^) of bits other than permission bits set in \f2mode\fP|.|
5.4.2.2|2|D|group ID of new file set to group ID of its directory|.|
5.5.1.2|1|D|appropriate privileges for unlinking directories|.|
5.5.1.2|2|RD,N|support for \f2unlink\fP(\^) on directories|.|
5.5.1.4|3|RD,N|[EBUSY] detection for \f2unlink\fP(\^)|.|
5.5.2.2|1|RD,N|\f2rmdir\fP(path) succeeds and \f2path\fP is root or current directory |.|
5.5.2.2|2|RD,N|\f2rmdir\fP(path) fails and \f2path\fP is root or current directory |.|
5.5.2.4|3|RD,N|[EBUSY] detection for \f2rmdir\fP(\^)|.|
5.5.3.2|1|RD,N,d|requires write permission to rename directory|.|
5.5.3.4|2|RD,N|[EBUSY] detection for \f2rename\fP(\^)|.|
5.6.1|1|D,N|usage of field \f2st_size\fP in structure returned by \f2stat\fP(\^) and \f2fstat\fP(\^)|.|
5.6.1.2|2|D,N|ORs bits other than those specified into the \f2st_mode\fP field ...|.|
5.6.2.1.2|1|D,N|additional/alternate file access control mechanisms cause \f2stat\fP(\^) fail|.|
5.6.2.2.2|1|D,N|additional/alternate file access control mechanisms cause \f2fstat\fP(\^) fail|.|
5.6.3.2|1|RD,N|appropriate privileges to override file access control mechanism|.|
5.6.3.2|2|D,N|appropriate privileges ... none of the execute bits for \f2path\fP are set|.|
5.6.3.4|3|RD,N|[EINVAL] detection for \f2access\fP(\^)|.|
5.6.4.2|1|RD,N|appropriate privileges to change file mode|.|
5.6.4.2|2|RD,N|ignore S_ISUID or S_ISGID bits|.|
5.6.4.2|3|D|effect of file descriptors for files open at \f2chmod\fP(\^) time|.|
5.6.5.2|1|RD,N|appropriate privileges to change file owner|.|
5.6.5.2|2|RD,N|effect of S_ISUID and S_ISGID bits on the file|.|
5.6.5.4|3|RD,N|[EINVAL] detection for \f2chown\fP(\^)|.|
5.6.6.2|1|D,N|additional members of \f2utimbuf\fP structure|.|
.TE
.SK
.TS
tab (|) center,box;
c | l | c | c | c
c | l | c | c | c
l | l | l | l | c.
POSIX.3.1|#|Allowable|PCTS|Audit
(Sub)clause|\&|Resolution|Conditional Feature|D,N,d
=
5.7.1.1.2|1|D,N|additional configurable pathname variables|.|
5.7.1.1.2|2|D,N|association of ... with other than a terminal file|.|
5.7.1.1.2|3|D,N|association of ... with file types other than a directory|.|
5.7.1.1.2|4|D,N|association of ... with file types other than pipe, FIFO, directory|.|
5.7.1.1.4|5|RD,N|[EINVAL] detection for \f2pathconf\fP(\^)|.|
5.7.1.1.4|6|RD,N|[EACCESS] detection for \f2pathconf\fP(\^)|.|
5.7.1.1.4|7|RD,N|[ENAMETOOLONG] detection for \f2pathconf\fP(\^)|.|
5.7.1.1.4|8|RD,N|[ENOENT] detection for \f2pathconf\fP(\^)|.|
5.7.1.1.4|9|RD,N|[ENOTDIR] detection for \f2pathconf\fP(\^)|.|
5.7.1.2.2|1|D,N|association of ... with other than a terminal file|.|
5.7.1.2.2|2|D,N|association of ... with file types other than a directory|.|
5.7.1.2.2|3|D,N|association of ... with file types other than pipe, FIFO, directory|.|
5.7.1.2.4|4|RD,N|[EBADF] detection for \f2fpathconf\fP(\^)|.|
5.7.1.2.4|5|RD,N|[EINVAL] detection for \f2fpathconf\fP(\^)|.|
6.3.1.2|1|D,N|when \f2close\fP(\^) is interrupted by a signal|.|
6.4.1.2|1|D,N|value of file offset after \f2read\fP(\^) on file not capable of seeking|.|
6.4.1.2|2|D|\f2read\fP(\^) interrupted after reading some data|.|
6.4.1.2|3|D|result of subsequent reads after \f2read\fP(\^) returns end-of-file|.|
6.4.1.2|4|D|\f2read\fP(\^) with value greater than {SSIZE_MAX}|.|
6.4.1.4|5|D,N|additional conditions for detecting [EIO] for \f2read\fP(\^)|.|
6.4.2.2|1|D,N|\f2write\fP(\^) when \f2nbyte\fP is zero and not a regular file|.|
6.4.2.2|2|D,N|value of file offset after \f2write\fP(\^) on file not capable of seeking|.|
6.4.2.2|3|D|\f2write\fP(\^) interrupted after writing some data|.|
6.4.2.2|4|D|\f2write\fP(\^) with value greater than {SSIZE_MAX}|.|
6.4.2.4|5|D,N|additional conditions for detecting [EIO] for \f2write\fP(\^)|.|
6.5.2.2|1|D,N|additional file status flags for F_SETFL for \f2fcntl\fP(\^)|.|
6.5.2.2|2|D,N,d|advisory record locking for files other than regular files|.|
6.5.2.2|3|D,N|\f2fcntl\fP(\^) for file locking when \f2l_len\fP is negative|.|
6.5.2.4|4|RD,N|[EDEADLK] detected for \f2fcntl\fP(\^)|.|
6.5.3.2|1|D|behavior of \f2lseek\fP(\^) on devices incapable of seeking|.|
.TE
.SK
.TS
tab (|) center,box;
c | l | c | c | c
c | l | c | c | c
l | l | l | l | c.
POSIX.3.1|#|Allowable|PCTS|Audit
(Sub)clause|\&|Resolution|Conditional Feature|D,N,d
=
7.1|1|D|device types supported by the general terminal interface ...|.|
7.1.1.2|2|D,N|terminal has foreground process group when ...|.|
7.1.1.3|3|D|session leader without a controlling terminal ...|.|
7.1.1.3|4|D,N|close of last file descriptor associated with controlling terminal ...|.|
7.1.1.3|5|D,N|session leader can reacquire a controlling terminal after ...|.|
7.1.1.3|6|D,N,d|after controlling process terminates access ...|.|
7.1.1.3|7|D|how controlling terminal for a session is allocated by session leader|.|
7.1.1.5|8|D,N|{MAX_INPUT} limit|.|
7.1.1.6|9|D,N|{MAX_CANON} limit|.|
7.1.1.7|10|D,N|\f2read\fP(\^) response when MIN is greater than {MAX_INPUT}|.|
7.1.1.8|11|RD,N,d|buffers write output to terminal device|.|
7.1.1.9|12|RD,N,d|START and STOP special characters can be changed|.|
7.1.1.9|13|D,N|two or more special characters received which have same value|.|
7.1.1.9|14|D,N|single bytes other than ... or multibytes have special meaning|.|
7.1.1.10|15|D,N|EOF is returned or [EIO] is detected when modem disconnects|.|
7.1.2.1|1|D,N|additional members of \f2termios\fP structure|.|
7.1.2.2|2|D|break condition for non-asynchronous data transmissions|.|
7.1.2.2|3|D|conditions under which START and STOP are transmitted|.|
7.1.2.2|4|D|initial input control value after \f2open\fP(\^) is specified|.|
7.1.2.3|5|D|processing of output data by OPOST|.|
7.1.2.3|6|D|initial output control value after \f2open\fP(\^) is specified|.|
7.1.2.4|7|D,N|non-asynchronous serial connection ignoring hardware modes|.|
7.1.2.4|8|D|initial hardware control value after \f2open\fP(\^) is specified|.|
7.1.2.5|9|D,N|echoing details when no character exists to erase|.|
7.1.2.5|10|D,N|details on erasing a line when ECHOK and ICANON are set|.|
7.1.2.5|11|D,N,d|details on operation when IEXTEN is set|.|
7.1.2.5|12|D|interaction of IEXTEN set with ICANON, ISIG, IXON, or IXOFF|.|
7.1.2.5|13|D|initial local control value after \f2open\fP(\^) is specified|.|
7.1.2.6|14|NA\(->N|implementation ignores ...|.|
7.1.2.6|15|D,N|value of NCCS|.|
7.1.2.6|16|D,N,d|character values in \f2c_cc\fP indexed by START and STOP are ignored|.|
7.1.2.6|17|D|initial values of all control characters|.|
7.1.3.1.4|1|RD,N|error detection \f2cfgetospeed\fP(\^)|.|
7.1.3.2.2|1|RD,N|\f2cfsetospeed\fP(\^) details on attempting to set unsupported baud rate|.|
7.1.3.2.4|2|RD,N|error conditions  detected for \f2cfsetospeed\fP(\^)|.|
7.1.3.2.4|1|RD,N|error conditions  detected for \f2cfgetispeed\fP(\^)|.|
7.1.3.4.2|1|RD,N|\f2cfsetispeed\fP(\^) returns error for unsupported baud rate|.|
7.1.3.4.4|2|RD,N|error conditions detected for \f2cfsetispeed\fP(\^)|.|
7.2.1.1.2|1|RD,N,d|input and output baud rates that differ|.|
7.2.2.1.2|1|D|period of time break signal is sent when \f2tcsendbreak\fP(\^) ...|.|
7.2.2.1.2|2|D,N|details on non-asynchronous data transmission and \f2tcsendbreak\fP(\^)|.|
7.2.3.2|1|NA\(->N|support for \f2tcgetpgrp\fP(\^)|.|
7.2.4.2|1|NA\(->N|support for \f2tcsetpgrp\fP(\^)|.|
.TE
.SK
.TS
tab (|) center,box;
c | l | c | c | c
c | l | c | c | c
l | l | l | l | c.
POSIX.3.1|#|Allowable|PCTS|Audit
(Sub)clause|\&|Resolution|Conditional Feature|D,N,d
=
8.1|1|NA\(->N|differences from C Standard|.|
8.1.3.2|1|RD,N|other locales other than ``C''|.|
8.1.3.2|2|D,N|string returned from \f2setlocale\fP(\^) when \f2locale\fP is a NULL pointer|.|
8.1.3.2|3|D,N|additional categories supported for \f2setlocale\fP(\^)|.|
8.1.3.2|4|D|LC_ALL not set or set to the empty string ...|.|
8.1.6.1|1|NA\(->N|result type for \f2longjmp\fP(\^)|.|
8.1.7.1|1|NA\(->N|result type for \f2clearerr\fP(\^)|.|
8.1.36.1|1|NA\(->N|result type for \f2rewind\fP(\^)|.|
8.1.40.1|1|NA\(->N|result type for \f2setbuf\fP(\^)|.|
8.1.47.1|1|NA\(->N|result type for \f2srand\fP(\^)|.|
8.1.48.1|1|NA\(->N|result type for \f2calloc\fP(\^), \f2free\fP(\^), \f2malloc\fP(\^), and \f2realloc\fP(\^)|.|
8.1.49.1|1|NA\(->N|result type for \f2abort\fP(\^)|.|
8.1.50.1|1|NA\(->N|result type for \f2exit\fP(\^)|.|
8.1.52.1|1|NA\(->N|result type for \f2bsearch\fP(\^) and \f2qsort\fP(\^)|.|
8.1.56.1|1|D|details of TZ environment variable beginning with a colon|.|
8.1.56.1|2|D,N|meanings of any characters except ...|.|
8.1.56.1|3|D,N|behavior of \f2offset\fP field of TZ environment variable ...|.|
8.2.1.4|1|RD,N|error conditions detected for \f2fileno\fP(\^)|.|
8.2.2.2|1|D,N|additional values for the \f2fdopen\fP(\^) \f2type\fP argument|.|
8.2.2.4|2|RD,N|error conditions detected for \f2fdopen\fP(\^)|.|
8.2.3|1|D,N|details involving two or more handles|.|
8.2.3|2|D,N|state of open file description when active handle not accessible ...|.|
8.2.3|3|D,N|details on rules when file handles are not followed|.|
8.2.3|4|D|conditions when applications will see all input exactly once|.|
8.2.3|5|D,N|\f2ftell\fP(\^) result when stream oppened in append mode ...|.|
8.3.1.2.1|1|NA\(->N|result type for \f2siglongjmp\fP(\^)|.|
8.3.2.1|1|NA\(->N|result type for \f2tzset\fP(\^)|.|
8.3.2.2|2|D|TZ absent, default time-zone information used by \f2tzset\fP(\^)|.|
.TE
.SK
.TS
tab (|) center,box;
c | l | c | c | c
c | l | c | c | c
l | l | l | l | c.
POSIX.3.1|#|Allowable|PCTS|Audit
(Sub)clause|\&|Resolution|Conditional Feature|D,N,d
=
9.1|1|D|interpretation of null initial working directory field in user database|.|
9.1|2|D|system default value for null initial user program field|.|
9.2.1.1.3|1|D,N|return pointer from \f2getgrgid\fP(\^) possibly overwritten|.|
9.2.1.1.4|2|RD,N|error conditions detected for \f2getgrgid\fP(\^)|.|
9.2.1.2.3|1|D,N|return pointer from \f2getgrnam\fP(\^) possibly overwritten|.|
9.2.1.2.4|2|RD,N|error conditions detected for \f2getgrnam\fP(\^)|.|
9.2.2.1.3|1|D,N|return pointer from \f2getpwuid\fP(\^) possibly overwritten|.|
9.2.2.1.4|2|RD,N|error conditions detected for \f2getpwuid\fP(\^)|.|
9.2.2.2.3|1|D,N|return pointer from \f2getpwnam\fP(\^) possibly overwritten|.|
9.2.2.2.4|2|RD,N|error conditions detected for \f2getpwnam\fP(\^)|.|
10.1|1|D|interface to format-creating and format-reading utilities|.|
10.1|2|D,N|media format and frames on the media in which the data appears|.|
10.1.1|1|D,N|tape contents after two zero-filled end-of-archive indicator blocks|.|
10.1.1|2|D,N|encoding used for names outside the portable filename character set|.|
10.1.1|3|D|details on procedures for handling input of invalid file names|.|
10.1.1|4|D,N|format-reading utility details on mode bits not in \*(P1|.|
10.1.1|5|D,N|\f2typeflag\fP field settings of CHARTYPE, BLKTYPE, or FIFOTYPE|.|
10.1.1|6|D,N|\f2devmajor\fP and \f2devminor\fP fields|.|
10.1.2.1|1|D,N|values for the \f2c_dev\fP and \f2c_ino\fP fields|.|
10.1.2.1|2|D|character or block special files contained in \f2c_rdev\fP|.|
10.1.2.2|3|D|details on procedures for handling input of invalid file names|.|
10.1.2.4|4|D,N|value of \f2c_filesize\fP for special files other than FIFO, directory, trailer|.|
10.1.2.4|5|D,N|contents of bytes in last block following ``TRAILER!!!''|.|
10.1.2.5|6|D,N|store/extract file types other than C_ISDIR, C_ISFIFO, C_ISREG|.|
10.1.3|7|D|file to read as next file after end-of-file or end-of-media condition|.|
.TE
.SK
.rs
.nr Hc 2				\" Center chapter titles and HUs (level 2 and less)
.HU "APPENDIX B"

.ce 1
.S 14
Certificate of Validation Application Form\*F
.ce 0
.S \\n(XS
.FS
This Appendix represents a sample of the actual form.
The actual form is provided in \f7./CERT_data/NPTP_appendixB\fP
of the \*(N2.
The discussion of the items in this form are specified in \(sc6.4.1.* of
this document.
.FE
.SP 2P
.nf
.ta 0.3i 1.0i
\s14\f3Client\f1\s0
	Name:	____________________________________
	Address:	____________________________________
.SP 2
.ta 0.3i 1.0i
\s14\f3Implementation\ Tested\f1\s0
	Supplier:	Vendor's name who supplied the tested operating system
	Product:	Identification of operating system tested
	PCD:	\*(P1 Conformance Document identification
.SP 2
\s14\f3System\ Tested\f1\s0
.ta 0.3i 1.0i
	Type:	Native, Hosted, Cooperating-Hosted, or Cooperating

.ta 0.3i 2.0i
	Native, Host, or Target Computer System:
.ta 0.5i 1.1i
	Supplier:	Vendor's name
	Product:	Identification    RAM    CPUs
.ta 0.3i 0.5i 0.8i 2.0i
			Disk Controller:\ \ Identification
.ta 1.1i
	Identification of devices on disk controller
.ta 0.3i 0.5i 0.8i 2.0i
			Terminal Controller:\ \ Identification
.ta 1.1i
	Identification of devices on terminal controller

.mk
.S 28
.ti 3.75i
\&\f3\(rk\fP
.S \\n(XS
.rt
.ta 0.3i 2.0i
	Host and/or Development Operating System
.ta 0.5i 1.1i 4.0i
	Supplier:	Vendor's name	\f2When applicable\fP
	Product:	Identification

.mk
.S 28
.ti 3.75i
\&\f3\(rk\fP
.S \\n(XS
.rt
.ta 0.3i 2.0i
	Development Computer System
.ta 0.5i 1.1i 4.0i
	Supplier:	Vendor's name	\f2When applicable\fP
	Product:	Identification

.ta 0.3i 2.0i
	Compiler Information
.ta 0.5i 2.0i
	C Compiler Supplier:	Vendor's name
	C Compiler Product:	Identification

.SP 2P
.ta 1.5i
APTL Name & Number:\ ____

NVLAP Signatory:\ _____________________________\ \ \ \ Date:\ ________
.fi
.SK
.HU "APPENDIX C"
\X'ps: exec gsave'
\X'ps: exec 1.25 -1.25 scale'
\X'ps: exec 50 -135 translate'
\X'ps: file ./nist_cert.ps'
\X'ps: exec grestore'
.SP 5P
.ce 1
.S 16
\f3CERTIFICATE OF VALIDATION\f1
.S \\n(XS
.P
.nh
\f2This \*(Cv verifies that the product identified below has been tested
using the Official National Institute of Standards and Technology POSIX
Conformance Test Suite for the Federal Information Processing Standards
Publication 151-2 (NIST-PCTS:151-2, mm/dd/yr) and that the test results
obtained have been validated by NIST.
The Accredited POSIX Testing Laboratory was Name_of_Lab (NVLAP 100XYZ).\f1
.hy
.SP 2P
.nf
.ta 0.3i 1.0i
\s14\f3IMPLEMENTATION\ TESTED\f1\s0
	Supplier:	Vendor's name who supplied the validated software product
	Product:	Identification of system tested
	PCD:	\*(P1 Conformance Document Identification
.SP 1
.ta 0.3i 0.5i 3.5i
	Primary Conditional Features:
		General Terminal Interface Devices	\(em NOT Provided by Product
		Mountable File System	\(em Supported by Product
		Modem Control	\(em NOT Provided by Product
		Appropriate Privileges	\(em Supported by Product
.ta 0.3i 1.0i
.SP 2
\s14\f3SYSTEM TESTED:\f1\s0
.ta 0.3i 3.5i
	Computer Hardware Supplier:	Vendor's name
	Computer Hardware Product:	Identification of native implementation
.ta 0.3i 0.5i 3.5i
		Disk Controller:	Identification
		Terminal Controller:	Identification


	C Compiler Supplier:	Vendor's name
	C Compiler Product:	Identification

.SP 4P
.ta 0.5i 4.0i
	____________________________	______
	NIST POSIX Certification Authority	Date
.SP 3P
.fi
Additional information is available from \*(Nl on conditional features,
configuration details, and resolved test codes (if appropriate).
Reference file: 151-2DCC001
.SK
.HU "APPENDIX D"
.SP 2P
.S 14
.ce 1
Sources of Documents
.S \\n(XS
.SP 2P
American National
Standards Institute (ANSI), 1430 Broadway, New York, NY 10018,
telephone 212/354-3300, order FAX 212/302-1286, information FAX 212/398-0023.
.BL 4
.BL 1
.LI
ISO/IEC 9899:1990 Information Technology\(emProgramming Language \(em C
.LE
.LE
.SP 2P
Institute of Electrical
and Electronics Engineers (IEEE), 345 East 47th Street, New York,
NY 10017-2394, telephone 212/705-7900, Standards Orders 800/678-4333.
.BL 4
.BL 1
.LI
International Standard \*(S1,
Information Technology\(em Portable Operating System Interface (POSIX)\(em
Part 1: System Application Program Interface (API) [C Language]
.LI
IEEE Standard for Information Technology\(emTest Methods for
Measuring Conformance to POSIX, IEEE Std 1003.3-1991
.LI
IEEE Standard for Information Technology\(emTest Methods for
Measuring Conformance to POSIX.1, \*(I3
.LE
.LE
.SP 2P
National Institute of Standards and Technology (NIST),
Computer Systems Laboratory,
NIST POSIX Certification Authority,
Bldg 225 Room B266,
Gaithersburg, MD 20899,
301/975-3295, FAX 301/590-0932.
.BL 4
.BL 1
.LI
\&\*(Gt.
.LI
\&\*(Ft.
.LI
\*(N2 Distribution, contains:
(1) \*(Gt,
(2) \*(Ft,
(3) \*(Ig, and
(4) \*(N2.
.LE
.LE
.SP 2P
National Technical Information Service (NTIS), 5285 Port Royal Road,
Springfield, VA
22161, telephone 703/487-4650, FAX 703/321-8547.
.BL 4
.BL 1
.LI
Federal Information Processing Standards Publication 151-2 (FIPS PUB 151-2),
Portable Operating System Interface (POSIX)\(em System Application Program
Interface [C Language], 1993 May 12.
(Supersedes FIPS PUB 151-1 \(em 1990, March 28)
.LI
Federal Information Processing Standards Publication 160 (FIPS PUB 160),
\&\f7'\fPC\f7'\fP, March 13, 1991 with change #1, August 24, 1992.
.br
.LI
\*(Nl Validated Processor List, NISTIR XXXX (published quarterly),
Order number PB91-937300.
.LE
.LE
.SK
National Voluntary Laboratory Accreditation Program (NVLAP),
National Institute of
Standards and Technology, Bldg 411 Room A124, Gaithersburg, MD
20899, telephone 301/975-4016, FAX 301/975-3839.
.BL 4
.BL 1
.LI
NVLAP Program Handbook\(em Computer Applications Testing\(em
POSIX Conformance Testing, 1991.
.LE
.LE
.PH "''''"
.\".OP
.TC 1 1 5 0
