#include	<pcts.h>

#include	<Zunistd.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<termios.h>
#include	<pcts_timer.h>

struct baud_table	{
  						const	char name[8];
						const	speed_t speed;
					} baud[] = {
	"B50",		B50,
	"B75",		B75,
	"B110",		B110,
	"B134",		B134,
	"B150",		B150,
	"B200",		B200,
	"B300",		B300,
	"B600",		B600,
	"B1200",	B1200,
	"B1800",	B1800,
	"B2400",	B2400,
	"B4800",	B4800,
	"B9600",	B9600,
	"B19200",	B19200,
	"B38400",	B38400,
};

#define SPEEDS (sizeof(baud)/sizeof(struct baud_table))

int main(void)
{
	int		tty_fildes, loop_fildes;
	struct	termios tty_termios, *tty_termios_p = &tty_termios,
					loop_termios, *loop_termios_p = &loop_termios;
	int		i;
	speed_t	ispeed;

	setup(E_CFGETISPEED);
	funct(E_CFGETISPEED);

	assertion(4, BASE);
	start
		if(GTI_PROVIDED) {
			prep("Establish PORT_TTY as the control terminal and PORT_LOOP.");
			start
				exit_on(ERROR);

				termios_prep(&tty_fildes, tty_termios_p, &loop_fildes,
								loop_termios_p);
			finis
		}

		testing("Call to cfgetispeed() returns the input baud rate stored");
		testing("in the \"termios\" structure pointed to by the termios_p");
		testing("parameter.");
		start
			for(i=0; i<SPEEDS; ++i) {
										/* Test only configured baud rates.	*/
				if(baud_rate(baud[i].speed) == FALSE)
					continue;
						/*	Error conditions are undefined for cfgetispeed().
							Set same speed for INPUT and OUTPUT.

							NOTE: Same test as cfsetispeed[5].
						*/
				if(GTI_PROVIDED)
					cfsetospeed(tty_termios_p, baud[i].speed);
				if(cfsetispeed(tty_termios_p, baud[i].speed) != 0) {
										/* Value stated in include/config. */
					error("%s%s.\n%s\n%s", 
							"Call to cfsetispeed() failed for baud rate ",
							baud[i].name,
							"This baud rate specified in ./include/config ",
							"\tfor parameter GTI_BAUD_RATES.");
					continue;
				}
				if(GTI_PROVIDED) {
					if(tcsetattr(tty_fildes, TCSANOW, tty_termios_p) == -1) {
						error("%s%s.\n%s\n%s", 
								"Call to tcsetattr() failed for baud rate ",
								baud[i].name,
								"This baud rate specified in ./include/config ",
								"\tfor parameter GTI_BAUD_RATES.");
						continue;
					}
					Ztcgetattr(tty_fildes, tty_termios_p);
				}
				if((ispeed = cfgetispeed(tty_termios_p)) != baud[i].speed){
					error("%s%lu.\n%s%lu.", 
							"Call to cfsetispeed() specified ",
							(unsigned long) baud[i].speed,
							"Call to cfgetispeed() returned ",
							(unsigned long) ispeed);
				}

			}
		finis

		if(GTI_PROVIDED) {
			cleanup("Close terminal devices.");
			start
				SIGNAL(SIGHUP, SIG_IGN);
				Zclose(tty_fildes);
				Zclose(loop_fildes);
				SLEEP(GTI_LINE_CLOSE_DELAY)
			finis
		}
	finis

	done();
}
