#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<termios.h>
#include	<pcts_timer.h>

char string[] = "Yes Sir, that's my baby. No Sir, I don't mean maybe.\n";
#define Strlen	(sizeof(string)-1)


int main(void)
{
	int		tty_fildes, loop_fildes;
	struct	termios tty_termios, *tty_termios_p = &tty_termios,
					loop_termios, *loop_termios_p = &loop_termios;
	char inbuf[_POSIX_MAX_INPUT];
	size_t	n_read;

	setup(E_INTERFACE);
	funct(E_INTERFACE);

	if(GTI_NOT_PROVIDED) {
		GTI_NOT_PROVIDED_RESULT(27, BASE)
		GTI_NOT_PROVIDED_RESULT(28, BASE)
		done();
	}

	continue_on(ERROR);

						/*  Noncanonical Mode Input Processing */
						/*  line assembly */
	assertion(27, BASE);
	start
		prep("Establish PORT_TTY as the control terminal, and PORT_LOOP.");
		prep("Setup PORT_TTY in non-canonical mode.");
		start
			exit_on(ERROR);
			termios_prep(&tty_fildes, tty_termios_p, &loop_fildes,
							loop_termios_p);

								/* Set for non-canonical mode. */
			tty_termios_p->c_lflag &= ~(ICANON | ECHO);
			Ztcsetattr(tty_fildes, TCSANOW, tty_termios_p);
		finis

		testing("Characters input from a terminal are not assembled");
		testing("into lines.");
		start
			SET_TIMEOUT
				expecting(Strlen);
				Zwrite(loop_fildes, string, Strlen);
				expecting(Strlen);
				Zwrite(loop_fildes, string, Strlen);
				Ztcdrain(loop_fildes);

				for(n_read=0; n_read != 2*Strlen;)
					n_read += Zread(tty_fildes, inbuf, _POSIX_MAX_INPUT);
			CLEAR_ALARM
		finis
	finis

							/* line editing */
	assertion(28, BASE);
	start
										/* ERASE processing */
		prep("Clear queues of PORTS.");
		start
			Ztcflush(tty_fildes, TCIOFLUSH);
			Ztcflush(loop_fildes, TCIOFLUSH);
		finis

		testing("ERASE.");
		start
			SET_TIMEOUT
				expecting(Strlen);
				Zwrite(loop_fildes, string, Strlen);
				WRITE_TTY_SCC(loop_fildes, tty_termios_p->c_cc[VERASE]);
				Ztcdrain(loop_fildes);
				dt_secs(TIME_ACQUIRE_XMITTED_DATA);

				for(n_read=0; n_read != Strlen +sizeof(char);)
					n_read += Zread(tty_fildes, inbuf +n_read,_POSIX_MAX_INPUT);
			CLEAR_ALARM

			if((cc_t)inbuf[Strlen] != tty_termios_p->c_cc[VERASE])
				error("ERASE character not placed in input queue.");
		finis

										/* KILL processing */
		prep("Clear queues of PORTS.");
		start
			Ztcflush(tty_fildes, TCIOFLUSH);
			Ztcflush(loop_fildes, TCIOFLUSH);
		finis

		testing("KILL.");
		start
			SET_TIMEOUT
				expecting(Strlen);
				Zwrite(loop_fildes, string, Strlen);
				WRITE_TTY_SCC(loop_fildes, tty_termios_p->c_cc[VKILL]);
				Ztcdrain(loop_fildes);
				dt_secs(TIME_ACQUIRE_XMITTED_DATA);

				for(n_read=0; n_read != Strlen +sizeof(char);)
					n_read += Zread(tty_fildes, inbuf +n_read,_POSIX_MAX_INPUT);
			CLEAR_ALARM

			if((cc_t)inbuf[Strlen] != tty_termios_p->c_cc[VKILL])
				error("KILL character not placed in input queue.");
		finis
	finis

	cleanup("Close terminal devices.");
	start
		SIGNAL(SIGHUP, SIG_IGN);
		Zclose(tty_fildes);
		Zclose(loop_fildes);
		SLEEP(GTI_LINE_CLOSE_DELAY)
	finis

	done();
}
