#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<termios.h>
#include	<pcts_timer.h>

char String1[]	= "yes indeed";
#define Strlen1	(sizeof(String1)-1)
char String2[]	= "No no";
#define Strlen2	(sizeof(String2)-1)

unsigned char NL	= '\n';


int main(void)
{
	int		tty_fildes, loop_fildes;
	struct	termios tty_termios, *tty_termios_p = &tty_termios,
					loop_termios, *loop_termios_p = &loop_termios;
	char inbuf[_POSIX_MAX_INPUT];
	int	i;


	setup(E_INTERFACE);
	funct(E_INTERFACE);

	if(GTI_NOT_PROVIDED) {
		GTI_NOT_PROVIDED_RESULT(52, BASE)
		GTI_NOT_PROVIDED_RESULT(53, BASE)
		GTI_NOT_PROVIDED_RESULT(54, BASE)
		GTI_NOT_PROVIDED_RESULT(55, BASE)
		GTI_NOT_PROVIDED_RESULT(56, BASE)
		done();
	}

	continue_on(ERROR);

	setup(E_INTERFACE);
	funct(E_INTERFACE);

	continue_on(ERROR);

				/* Erase control character */
	assertion(52, BASE);
	start
		prep("Establish PORT_TTY as the control terminal and PORT_LOOP.");
		start
			exit_on(ERROR);
			termios_prep(&tty_fildes, tty_termios_p, &loop_fildes,
							loop_termios_p);
		finis

		testing("When ICANON is set and ERASE is received, the last character");
		testing("of the current line is removed from the input queue,");
		testing("line delimiter NL is nor removed, and the erase");
		testing("character is discarded.");
		start
			SET_TIMEOUT
				expecting(Strlen1);
				Zwrite(loop_fildes, String1, Strlen1);

				WRITE_TTY_SCC(loop_fildes, tty_termios_p->c_cc[VERASE]);

				expecting(sizeof(NL));
				Zwrite(loop_fildes, (char *)&NL, sizeof(NL));

				expecting(Strlen1 -1 +1);
				Zread(tty_fildes, inbuf, _POSIX_MAX_INPUT);

				expecting(Strlen1);
				Zwrite(loop_fildes, String1, Strlen1);

				expecting(sizeof(NL));
				Zwrite(loop_fildes, (char *)&NL, sizeof(NL));

				expecting(Strlen1);
				Zwrite(loop_fildes, String1, Strlen1);

				for(i = 0; i < Strlen1 * 2; ++i) {
					WRITE_TTY_SCC(loop_fildes, tty_termios_p->c_cc[VERASE]);
				}

				expecting(sizeof(NL));
				Zwrite(loop_fildes, (char *)&NL, sizeof(NL));

				expecting(Strlen1 +sizeof(char));
				Zread(tty_fildes, inbuf, _POSIX_MAX_INPUT);

				expecting(sizeof(char));
				Zread(tty_fildes, inbuf, _POSIX_MAX_INPUT);
			CLEAR_ALARM
		finis

		testing("When ICANON is set and ERASE is received, the last character");
		testing("of the current line is removed from the input queue,");
		testing("line delimiter EOF is not removed, and the erase");
		testing("character is discarded.");
		start
			SET_TIMEOUT
				expecting(Strlen1);
				Zwrite(loop_fildes, String1, Strlen1);

				WRITE_TTY_SCC(loop_fildes, tty_termios_p->c_cc[VERASE]);
				WRITE_TTY_SCC(loop_fildes, tty_termios_p->c_cc[VEOF]);
				Ztcdrain(loop_fildes);

				expecting(Strlen1 -sizeof(char));
				Zread(tty_fildes, inbuf, _POSIX_MAX_INPUT);

				expecting(Strlen1);
				Zwrite(loop_fildes, String1, Strlen1);

				WRITE_TTY_SCC(loop_fildes, tty_termios_p->c_cc[VEOF]);

				expecting(Strlen1);
				Zwrite(loop_fildes, String1, Strlen1);

				for(i = 0; i < Strlen1 * 2; ++i) {
					WRITE_TTY_SCC(loop_fildes, tty_termios_p->c_cc[VERASE]);
				}

				WRITE_TTY_SCC(loop_fildes, tty_termios_p->c_cc[VEOF]);
				Ztcdrain(loop_fildes);

				expecting(Strlen1);
				Zread(tty_fildes, inbuf, _POSIX_MAX_INPUT);

				expecting(0);
				Zread(tty_fildes, inbuf, _POSIX_MAX_INPUT);
			CLEAR_ALARM
		finis

		testing("When ICANON is set and ERASE is received, the last character");
		testing("of the current line is removed from the input queue,");
		testing("line delimiter EOL is not removed, and the erase");
		testing("character is discarded.");
		start
			SET_TIMEOUT
				expecting(Strlen1);
				Zwrite(loop_fildes, String1, Strlen1);

				WRITE_TTY_SCC(loop_fildes, tty_termios_p->c_cc[VERASE]);
				WRITE_TTY_SCC(loop_fildes, tty_termios_p->c_cc[VEOL]);
				Ztcdrain(loop_fildes);

				expecting(Strlen1 +1 -1);
				Zread(tty_fildes, inbuf, _POSIX_MAX_INPUT);

				expecting(Strlen1);
				Zwrite(loop_fildes, String1, Strlen1);

				WRITE_TTY_SCC(loop_fildes, tty_termios_p->c_cc[VEOL]);

				expecting(Strlen1);
				Zwrite(loop_fildes, String1, Strlen1);

				for(i = 0; i < Strlen1  * 2; ++i) {
					WRITE_TTY_SCC(loop_fildes, tty_termios_p->c_cc[VERASE]);
				}

				WRITE_TTY_SCC(loop_fildes, tty_termios_p->c_cc[VEOL]);
				Ztcdrain(loop_fildes);

				expecting(Strlen1 +sizeof(char));
				Zread(tty_fildes, inbuf, _POSIX_MAX_INPUT);

				expecting(sizeof(char));
				Zread(tty_fildes, inbuf, _POSIX_MAX_INPUT);
			CLEAR_ALARM
		finis
	finis

					/* Kill control character */
	assertion(53, BASE);
	start
		testing("When the ICANON flag is set and the special character KILL");
		testing("is input from a terminal, all characters in the current");
		testing("line are removed from the input queue up to but not");
		testing("including the line delimiter (NL), and the KILL character");
		testing("is discarded.");
		start
			Ztcflush(tty_fildes, TCIOFLUSH);
			Ztcflush(loop_fildes, TCIOFLUSH);

			SET_TIMEOUT
				expecting(Strlen1);
				Zwrite(loop_fildes, String1, Strlen1);

				expecting(sizeof(NL));
				Zwrite(loop_fildes, (char *)&NL, sizeof(NL));

				expecting(Strlen2);
				Zwrite(loop_fildes, String2, Strlen2);

				WRITE_TTY_SCC(loop_fildes, tty_termios_p->c_cc[VKILL]);
				expecting(sizeof(NL));
				Zwrite(loop_fildes, (char *)&NL, sizeof(NL));
				Ztcdrain(loop_fildes);

				expecting(Strlen1 +sizeof(NL));
				Zread(tty_fildes, inbuf, _POSIX_MAX_INPUT);

				expecting(sizeof(NL));
				Zread(tty_fildes, inbuf, _POSIX_MAX_INPUT);

				if(inbuf[0] != NL)
					error("NL character has been discarded.");
			CLEAR_ALARM
		finis

						/* Kill control character and EOF */
		testing("When ICANON flag is set and the special character KILL");
		testing("is input from a terminal, all characters in the current");
		testing("line are removed from the input queue up to but not");
		testing("including the line delimiter (EOF), and the KILL character");
		testing("is discarded.");
		start
			Ztcflush(tty_fildes, TCIOFLUSH);
			Ztcflush(loop_fildes, TCIOFLUSH);

			SET_TIMEOUT
				expecting(Strlen1);
				Zwrite(loop_fildes, String1, Strlen1);

				WRITE_TTY_SCC(loop_fildes, tty_termios_p->c_cc[VEOF]);

				expecting(Strlen2);
				Zwrite(loop_fildes, String2, Strlen2);

				WRITE_TTY_SCC(loop_fildes, tty_termios_p->c_cc[VKILL]);
				expecting(sizeof(NL));
				Zwrite(loop_fildes, (char *)&NL, sizeof(NL));
				Ztcdrain(loop_fildes);

				expecting(Strlen1);
				Zread(tty_fildes, inbuf, _POSIX_MAX_INPUT);
				expecting(sizeof(NL));
				Zread(tty_fildes, inbuf, _POSIX_MAX_INPUT);
			CLEAR_ALARM
		finis

					/* Kill control character and EOL */
		testing("When ICANON flag is set and the special character KILL");
		testing("is input from a terminal, all characters in the current");
		testing("line are removed from the input queue up to but not");
		testing("including the line delimiter (EOL), and the KILL character");
		testing("is discarded.");
		start
			Ztcflush(tty_fildes, TCIOFLUSH);
			Ztcflush(loop_fildes, TCIOFLUSH);

			SET_TIMEOUT
				expecting(Strlen1);
				Zwrite(loop_fildes, String1, Strlen1);

				WRITE_TTY_SCC(loop_fildes, tty_termios_p->c_cc[VEOL]);

				expecting(Strlen2);
				Zwrite(loop_fildes, String2, Strlen2);

				WRITE_TTY_SCC(loop_fildes, tty_termios_p->c_cc[VKILL]);
				WRITE_TTY_SCC(loop_fildes, tty_termios_p->c_cc[VEOL]);
				Ztcdrain(loop_fildes);

				expecting(Strlen1 +sizeof(char));
				Zread(tty_fildes, inbuf, _POSIX_MAX_INPUT);
				expecting(sizeof(NL));
				Zread(tty_fildes, inbuf, _POSIX_MAX_INPUT);

				if(inbuf[0] != tty_termios_p->c_cc[VEOL])
					error("EOL character has been discarded.");
			CLEAR_ALARM
		finis
	finis

					/* EOF control character */
	assertion(54, BASE);
	start
		testing("When ICANON is set, and EOF is received as input data and");
		testing("fewer bytes of input data are received prior to an EOF than");
		testing("those requested by the read(), then the read returns the");
		testing("input data prior to the EOF and the EOF character is");
		testing("discarded");
		start
			Ztcflush(loop_fildes, TCIOFLUSH);
			Ztcflush(tty_fildes, TCIOFLUSH);

					/* Bytes requested is N and bytes in input queue is N-1. */
			SET_TIMEOUT
				expecting(Strlen1);
				Zwrite(loop_fildes, String1, Strlen1);

				WRITE_TTY_SCC(loop_fildes, tty_termios_p->c_cc[VEOF]);
				Ztcdrain(loop_fildes);

				expecting(Strlen1);
				Zread(tty_fildes, inbuf, Strlen1 +1);
			CLEAR_ALARM

												/* EOF is discarded. */
			expecting(sizeof(NL));
			Zwrite(loop_fildes, (char *)&NL, sizeof(NL));
			Ztcdrain(loop_fildes);
			Zread(tty_fildes, inbuf, _POSIX_MAX_INPUT);
			if(inbuf[0] != NL)
				if(inbuf[0] == tty_termios_p->c_cc[VEOF])
					error("EOF character has not been discarded.");
				else
					error("Unexpected data (%s) detected in input queue.",
								inbuf);

					/* Bytes requested is N and bytes in input queue is 0. */
			SET_TIMEOUT
				WRITE_TTY_SCC(loop_fildes, tty_termios_p->c_cc[VEOF]);
				Ztcdrain(loop_fildes);

				expecting(0);
				Zread(tty_fildes, inbuf, Strlen1);
			CLEAR_ALARM

												/* EOF is discarded. */
			expecting(sizeof(NL));
			Zwrite(loop_fildes, (char *)&NL, sizeof(NL));
			Ztcdrain(loop_fildes);
			Zread(tty_fildes, inbuf, _POSIX_MAX_INPUT);
			if(inbuf[0] != NL)
				if(inbuf[0] == tty_termios_p->c_cc[VEOF])
					error("EOF character has not been discarded.");
				else
					error("Unexpected data (%s) detected in input queue.",
								inbuf);
		finis
	finis

	assertion(55, BASE);
	start
		testing("When ICANON is set, and EOF is received as input data and");
		testing("more bytes of input data are received prior to an EOF than");
		testing("those requested by the read(), then the read returns the");
		testing("input data requested and the remaining bytes and the EOF");
		testing("are retained in the input stream.");
		start
			Ztcflush(loop_fildes, TCIOFLUSH);
			Ztcflush(tty_fildes, TCIOFLUSH);

			SET_TIMEOUT
				expecting(Strlen1);
				Zwrite(loop_fildes, String1, Strlen1);

				WRITE_TTY_SCC(loop_fildes, tty_termios_p->c_cc[VEOF]);
				Ztcdrain(loop_fildes);

				expecting(Strlen1 -1);
				Zread(tty_fildes, inbuf, Strlen1 -1);
			CLEAR_ALARM

								/* Unread data byte and EOF are retained. */
			SET_TIMEOUT
				expecting(2);
				Zwrite(loop_fildes, String1, 2);
				expecting(sizeof(NL));
				Zwrite(loop_fildes, (char *)&NL, sizeof(NL));
				Ztcdrain(loop_fildes);

								/* Only the prior unread byte is returned. */
				expecting(1);
				Zread(tty_fildes, inbuf, _POSIX_MAX_INPUT);
			CLEAR_ALARM
		finis
	finis

	assertion(56, BASE);
	start
		testing("When ICANON is set, and EOF is received as input data and");
		testing("the bytes of input data received prior to an EOF is");
		testing("the number of bytes requested by the read(), then the read");
		testing("returns the input data requested.");
		start
			Ztcflush(loop_fildes, TCIOFLUSH);
			dt_secs(TIME_ACQUIRE_XMITTED_DATA);
			Ztcflush(tty_fildes, TCIOFLUSH);

			SET_TIMEOUT
				expecting(Strlen1);
				Zwrite(loop_fildes, String1, Strlen1);

				WRITE_TTY_SCC(loop_fildes, tty_termios_p->c_cc[VEOF]);
				Ztcdrain(loop_fildes);
				dt_secs(TIME_ACQUIRE_XMITTED_DATA);

				expecting(Strlen1);
				Zread(tty_fildes, inbuf, Strlen1);
			CLEAR_ALARM
		finis
	finis

	cleanup("Close terminal devices.");
	start
		SIGNAL(SIGHUP, SIG_IGN);
		Zclose(tty_fildes);
		Zclose(loop_fildes);
		SLEEP(GTI_LINE_CLOSE_DELAY)
	finis

	done();
}
