#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zfcntl.h>
#include	<math.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<termios.h>
#include	<pcts_timer.h>

char String[] = "yes indeed";
#define Strlen	(sizeof(String)-1)

const cc_t NEW_CC =	'A';				/* new control char value			*/
const cc_t STOP =	'\023';				/* ASCII DC3						*/
const cc_t START =	'\021';				/* ASCII DC1						*/
unsigned char NL = '\n';


int main(void)
{
	int		tty_fildes, loop_fildes;
	struct	termios tty_termios, *tty_termios_p = &tty_termios,
					loop_termios, *loop_termios_p = &loop_termios;
	struct	termios tty_origin;
	unsigned	char inbuf[_POSIX_MAX_INPUT];
	unsigned	char outbuf[_POSIX_MAX_INPUT];
	cc_t	posix_vdisable;


	setup(E_INTERFACE);
	funct(E_INTERFACE);

	if(GTI_NOT_PROVIDED) {
		GTI_NOT_PROVIDED_RESULT(57, BASE)
		GTI_NOT_PROVIDED_RESULT(58, BASE)
		GTI_NOT_PROVIDED_RESULT(59, BASE)
		GTI_NOT_PROVIDED_RESULT(60, BASE)
		GTI_NOT_PROVIDED_RESULT(61, BASE)
		GTI_NOT_PROVIDED_RESULT(62, BASE)
		GTI_NOT_PROVIDED_RESULT(63, BASE)
		done();
	}

	setup(E_INTERFACE);
	funct(E_INTERFACE);

	assertion(57, BASE);
	start
		prep("Establish PORT_TTY as the control terminal and PORT_LOOP.");
		prep("Set ISIG on PORT_TTY.");
		start
			exit_on(ERROR);
			termios_prep(&tty_fildes, tty_termios_p, &loop_fildes,
							loop_termios_p);
			tty_termios_p->c_lflag |= ISIG;
			tty_termios_p->c_iflag &= ~ISTRIP;
			Ztcsetattr(tty_fildes, TCSANOW, tty_termios_p);
			Ztcgetattr(tty_fildes, &tty_origin);
		finis

														/* INTR */
		testing("The value for INTR can be changed.");
		start
			tty_termios_p->c_cc[VINTR] = NEW_CC;
			Ztcsetattr(tty_fildes, TCSANOW, tty_termios_p);
			sig_rcvd = 0;
			SIGNAL(SIGINT, sig_int);

			SET_TIMEOUT
				WRITE_TTY_SCC(loop_fildes, NEW_CC);
				tcdrain(loop_fildes);		/* Allow for interrupt to occur. */
			CLEAR_ALARM

			if(sig_rcvd == 0)
				sleep(1);			/* Allow for interrupt to occur. */
			if(sig_rcvd == 0)
				error("New interrupt character failed.");
		finis

		testing("The value for QUIT can be changed.");
		start
			tty_termios_p->c_cc[VINTR] = tty_origin.c_cc[VINTR];
			tty_termios_p->c_cc[VQUIT] = NEW_CC;
			Ztcsetattr(tty_fildes, TCSANOW, tty_termios_p);
			sig_rcvd = 0;
			SIGNAL(SIGQUIT, sig_int);
			SET_TIMEOUT
				WRITE_TTY_SCC(loop_fildes, NEW_CC);
				tcdrain(loop_fildes);		/* Allow for interrupt to occur. */
			CLEAR_ALARM

			if(sig_rcvd == 0)
				sleep(1);				/* Allow for interrupt to occur. */
			if(sig_rcvd == 0)
				error("New quit character failed.");
		finis

														/* ERASE */
		testing("The value for ERASE can be changed.");
		start
			tty_termios_p->c_cc[VQUIT] = tty_origin.c_cc[VQUIT];
			tty_termios_p->c_cc[VERASE] = NEW_CC;
			Ztcsetattr(tty_fildes, TCSAFLUSH, tty_termios_p);

			SET_TIMEOUT
				expecting(Strlen);
				Zwrite(loop_fildes, String, Strlen);
				WRITE_TTY_SCC(loop_fildes, NEW_CC);
				expecting(sizeof(char));
				Zwrite(loop_fildes, (char *)&NL, sizeof(char));
				Ztcdrain(loop_fildes);

				expecting(Strlen);
				Zread(tty_fildes, inbuf, _POSIX_MAX_INPUT);
			CLEAR_ALARM
		finis

														/* KILL */
		testing("The value for KILL can be changed.");
		start
			tty_termios_p->c_cc[VERASE] = tty_origin.c_cc[VERASE];
			tty_termios_p->c_cc[VKILL] = NEW_CC;
			Ztcsetattr(tty_fildes, TCSAFLUSH, tty_termios_p);

			SET_TIMEOUT
				expecting(Strlen);
				Zwrite(loop_fildes, String, Strlen);
				WRITE_TTY_SCC(loop_fildes, NEW_CC);
				expecting(sizeof(char));
				Zwrite(loop_fildes, (char *)&NL, sizeof(char));
				Ztcdrain(loop_fildes);

				expecting(sizeof(char));
				Zread(tty_fildes, inbuf, _POSIX_MAX_INPUT);
			CLEAR_ALARM
		finis

														/* EOF */
		testing("The value for EOF can be changed.");
		start
			tty_termios_p->c_cc[VKILL] = tty_origin.c_cc[VKILL];
			tty_termios_p->c_cc[VEOF] = NEW_CC;
			Ztcsetattr(tty_fildes, TCSAFLUSH, tty_termios_p);

			SET_TIMEOUT
				expecting(Strlen);
				Zwrite(loop_fildes, String, Strlen);
				WRITE_TTY_SCC(loop_fildes, NEW_CC);
				Ztcdrain(loop_fildes);

				expecting(Strlen);
				Zread(tty_fildes, inbuf, _POSIX_MAX_INPUT);
			CLEAR_ALARM
		finis

														/* EOL */
		testing("The value for EOL can be changed.");
		start
			tty_termios_p->c_cc[VEOF] = tty_origin.c_cc[VEOF];
			tty_termios_p->c_cc[VEOL] = NEW_CC;
			Ztcsetattr(tty_fildes, TCSAFLUSH, tty_termios_p);

			SET_TIMEOUT
				expecting(Strlen);
				Zwrite(loop_fildes, String, Strlen);
				WRITE_TTY_SCC(loop_fildes, NEW_CC);
				Ztcdrain(loop_fildes);

				expecting(Strlen +sizeof(cc_t));
				Zread(tty_fildes, inbuf, _POSIX_MAX_INPUT);
			CLEAR_ALARM
		finis
	finis

							/* New SUSP character */
	assertion(58, BASE);
	start
		testing("The value for SUSP can be changed.");
		start
			tty_termios_p->c_cc[VEOL] = tty_origin.c_cc[VEOL];
			tty_termios_p->c_cc[VSUSP] = NEW_CC;
			Ztcsetattr(tty_fildes, TCSAFLUSH, tty_termios_p);

			sig_rcvd = 0;
			SIGNAL(SIGTSTP, sig_int);

			SET_TIMEOUT
				WRITE_TTY_SCC(loop_fildes, NEW_CC);
				tcdrain(loop_fildes);		/* Allow for interrupt to occur. */
			CLEAR_ALARM

			if(sig_rcvd == 0)
				sleep(1);			/* Allow for interrupt to occur. */

			if(sig_rcvd == 0)
				error("New suspense character failed.");
		finis
	finis

							/* START and STOP may be changed */
	assertion(59, BASE);
	start
		if(GTI_START_STOP == 1) {
											/* STOP */
			testing("The STOP special character can be changed.");
			start
				tty_termios_p->c_cc[VSUSP] = tty_origin.c_cc[VSUSP];
				tty_termios_p->c_cc[VSTOP] = NEW_CC;
				tty_termios_p->c_iflag |= IXON;
				Ztcsetattr(tty_fildes, TCSANOW, tty_termios_p);
				Ztcflush(loop_fildes, TCIOFLUSH);
				Ztcflush(tty_fildes, TCIOFLUSH);

				Ztcgetattr(tty_fildes, tty_termios_p);
				if(tty_termios_p->c_cc[VSTOP] != NEW_CC)
					error("STOP was not changed.");
				memset(outbuf, 'B', sizeof(outbuf));

				SET_TIMEOUT
											/* Stop output from PORT_TTY */
					WRITE_TTY_SCC(loop_fildes, NEW_CC);
					Ztcdrain(loop_fildes);
				CLEAR_ALARM

				SLEEP(1);

				if(PCTS_GTI_BUFFERS_OUTPUT) {
					SET_ALARM(WAIT_FOR_TIME)
						write(tty_fildes, String, Strlen);	/* Data */
						Ztcdrain(tty_fildes);	/* Does not complete. */
					EXPECT_ALARM

					SET_TIMEOUT
						expecting(0);
						Zread(loop_fildes, inbuf, _POSIX_MAX_INPUT);
					CLEAR_ALARM
				}
				else {
					SET_ALARM(WAIT_FOR_TIME)
												/* Does not complete. */
						write(tty_fildes, String, Strlen);
					EXPECT_ALARM
				}
			finis

											/* START */
			testing("The START special character can be changed.");
			start
				tty_termios_p->c_cc[VSTOP] = tty_origin.c_cc[VSTOP];
				tty_termios_p->c_cc[VSTART] = NEW_CC;
				Ztcsetattr(tty_fildes, TCSANOW, tty_termios_p);

				Ztcgetattr(tty_fildes, tty_termios_p);
				if(tty_termios_p->c_cc[VSTART] != NEW_CC)
					error("START was not changed.");

				SET_TIMEOUT
					WRITE_TTY_SCC(loop_fildes, NEW_CC);		/* Send START */
					Ztcdrain(loop_fildes);
				CLEAR_ALARM
				SLEEP(1);

				if(PCTS_GTI_BUFFERS_OUTPUT) {
					SET_TIMEOUT
						expecting(Strlen);
						Zread(loop_fildes, inbuf, _POSIX_MAX_INPUT);  /* Data */
					CLEAR_ALARM
				}
				else {
						SET_TIMEOUT
							write(tty_fildes, String, Strlen);	/* Data */
							Ztcdrain(tty_fildes);

							expecting(Strlen);
							Zread(loop_fildes, inbuf, _POSIX_MAX_INPUT);
						CLEAR_ALARM
				}
			finis
		}
		else
			not_implemented("changing START and STOP characters");
	finis

	assertion(60, BASE);
	start
		int	i, j, k, n_count;

		testing("When the IEXTERN flag is not set, then all characters except");
		testing("the special characters are received without interpretation.");
		start
			tty_termios_p->c_lflag &= ~IEXTEN;
			loop_termios_p->c_lflag &= ~IEXTEN;
			tty_termios_p->c_lflag &= ~ICANON;
			tty_termios_p->c_cc[VTIME] = 10;
			tty_termios_p->c_cc[VMIN] = _POSIX_MAX_INPUT;
			Ztcsetattr(tty_fildes, TCSAFLUSH, tty_termios_p);
			dt_secs(TIME_ACQUIRE_XMITTED_DATA);
			Ztcsetattr(loop_fildes, TCSAFLUSH, loop_termios_p);

										/* Distinct values in character. */
			n_count = (sizeof(char) == 1) ? 256 : 65536;
			for(i=0, j=0; i<n_count; i++) {
				outbuf[j] = i;
				if(	i == (int)tty_termios_p->c_cc[VINTR]  ||
					i == (int)tty_termios_p->c_cc[VQUIT]  ||
					i == (int)tty_termios_p->c_cc[VSUSP]  ||
					i == (int)tty_termios_p->c_cc[VERASE] ||
					i == (int)tty_termios_p->c_cc[VKILL]  ||
					i == (int)tty_termios_p->c_cc[VEOF]   ||
					i == (int)tty_termios_p->c_cc[VEOL]   ||
					i == (int)tty_termios_p->c_cc[VSTART] ||
					i == (int)tty_termios_p->c_cc[VSTOP]  ||

					i == (int)loop_termios_p->c_cc[VINTR]  ||
					i == (int)loop_termios_p->c_cc[VQUIT]  ||
					i == (int)loop_termios_p->c_cc[VSUSP]  ||
					i == (int)loop_termios_p->c_cc[VERASE] ||
					i == (int)loop_termios_p->c_cc[VKILL]  ||
					i == (int)loop_termios_p->c_cc[VEOF]   ||
					i == (int)loop_termios_p->c_cc[VEOL]   ||
					i == (int)loop_termios_p->c_cc[VSTART] ||
					i == (int)loop_termios_p->c_cc[VSTOP]	)
						continue;
				if(++j == _POSIX_MAX_INPUT) {
					SET_ALARM(2 * MAX_TIME_TO_RUN)
						expecting(_POSIX_MAX_INPUT);
						Zwrite(loop_fildes, outbuf, _POSIX_MAX_INPUT);
						Ztcdrain(loop_fildes);
						dt_secs(TIME_ACQUIRE_XMITTED_DATA);

						expecting(_POSIX_MAX_INPUT);
						Zread(tty_fildes, inbuf, _POSIX_MAX_INPUT);
	
						for(k=0; k<_POSIX_MAX_INPUT; k++) {
							if(inbuf[k] != outbuf[k])
								error("%s\n%s%x(hex)\n%s%x(hex)",
									"Transmitted char different than received.",
									"Transmitted: ",
									outbuf[k],
									"Received: ",
									inbuf[k]);
						}
					CLEAR_ALARM
					j = 0;
				}
			}

			if(j > 0) {
				SET_ALARM(2 * MAX_TIME_TO_RUN)
					expecting(j);
					Zwrite(loop_fildes, outbuf, (size_t)j);
					Ztcdrain(loop_fildes);
					dt_secs(TIME_ACQUIRE_XMITTED_DATA);

					expecting(j);
					Zread(tty_fildes, inbuf, (size_t)j);
	
					for(k=0; k<j; k++) {
						if(inbuf[k] != outbuf[k])
							error("%s\n%s%x(hex)\n%s%x(hex)",
									"Transmitted char different than received.",
									"Transmitted: ",
									outbuf[k],
									"Received: ",
									inbuf[k]);
					}
				CLEAR_ALARM
			}
		finis
	finis

						/* Disable special characters */
	assertion(61, BASE);
	start
		prep("Determine value of _POSIX_VDISABLE.");
		start
			posix_vdisable = (cc_t) fpathconf(tty_fildes, _PC_VDISABLE);
		finis
															/* INTR */
		testing("The function of INTR can be disabled");
		testing("individually by setting the value of INTR");
		testing("to _POSIX_V_DISABLE.");
		start
			tty_termios_p->c_lflag |= ICANON;
			tty_termios_p->c_cc[VSTART] = tty_origin.c_cc[VSTART];
			tty_termios_p->c_cc[VINTR] = posix_vdisable;
			Ztcsetattr(tty_fildes, TCSAFLUSH, tty_termios_p);
			Ztcflush(loop_fildes, TCIOFLUSH);
			dt_secs(TIME_ACQUIRE_XMITTED_DATA);
			Ztcflush(tty_fildes, TCIOFLUSH);

			sig_rcvd = 0;
			SIGNAL(SIGINT, sig_int);

			SET_TIMEOUT
								/*	Neither the old INTR character nor the
									disable character generates INTR. */
				WRITE_TTY_SCC(loop_fildes, tty_origin.c_cc[VINTR]);
				WRITE_TTY_SCC(loop_fildes, posix_vdisable);
				Ztcdrain(loop_fildes);
			CLEAR_ALARM

			if(sig_rcvd != 0)
				error("Interrupt character was not disabled.");
		finis

														/* QUIT */
		testing("The function of QUIT can be disabled");
		testing("individually by setting the value of the character");
		testing("to _POSIX_V_DISABLE.");
		start
			tty_termios_p->c_cc[VQUIT] = posix_vdisable;
			Ztcsetattr(tty_fildes, TCSAFLUSH, tty_termios_p);

			sig_rcvd = 0;
			SIGNAL(SIGQUIT, sig_int);

			SET_TIMEOUT
								/*	Neither the old QUIT character nor the
									disable character enables QUIT. */
				WRITE_TTY_SCC(loop_fildes, tty_origin.c_cc[VQUIT]);
				WRITE_TTY_SCC(loop_fildes, posix_vdisable);
				Ztcdrain(loop_fildes);
			CLEAR_ALARM

			if(sig_rcvd != 0)
				error("Quit character was not disabled.");
		finis

														/* ERASE */
		testing("The function of ERASE can be disabled");
		testing("individually by setting the value of the character");
		testing("to _POSIX_V_DISABLE.");
		start
			tty_termios_p->c_cc[VERASE] = posix_vdisable;
			Ztcsetattr(tty_fildes, TCSAFLUSH, tty_termios_p);
			Ztcflush(loop_fildes, TCIOFLUSH);
			dt_secs(TIME_ACQUIRE_XMITTED_DATA);
			Ztcflush(tty_fildes, TCIOFLUSH);

			SET_TIMEOUT
				expecting(Strlen);
				Zwrite(loop_fildes, String, Strlen);
								/*	Neither the old ERASE character nor the
									disable character enables ERASE. */
				WRITE_TTY_SCC(loop_fildes, tty_origin.c_cc[VERASE]);
				WRITE_TTY_SCC(loop_fildes, posix_vdisable);

				expecting(sizeof(char));
				Zwrite(loop_fildes, (char *)&NL, sizeof(char));
				Ztcdrain(loop_fildes);
				dt_secs(TIME_ACQUIRE_XMITTED_DATA);

				expecting(Strlen +2*(sizeof(cc_t)) +sizeof(char));
				Zread(tty_fildes, inbuf, _POSIX_MAX_INPUT);
			CLEAR_ALARM
		finis

															/* KILL */
		testing("The function of KILL can be disabled");
		testing("individually by setting the value of the character");
		testing("to _POSIX_V_DISABLE.");
		start
			tty_termios_p->c_cc[VKILL] = posix_vdisable;
			Ztcsetattr(tty_fildes, TCSAFLUSH, tty_termios_p);

			SET_TIMEOUT
				expecting(Strlen);
				Zwrite(loop_fildes, String, Strlen);
								/*	Neither the old KILL character nor the
									disable character enables KILL. */
				WRITE_TTY_SCC(loop_fildes, tty_origin.c_cc[VKILL]);
				WRITE_TTY_SCC(loop_fildes, posix_vdisable);
				expecting(sizeof(char));
				Zwrite(loop_fildes, (char *)&NL, sizeof(char));
				Ztcdrain(loop_fildes);

				expecting(Strlen +2*(sizeof(cc_t)) +sizeof(char));
				Zread(tty_fildes, inbuf, _POSIX_MAX_INPUT);
			CLEAR_ALARM
		finis

														/* EOF */
		testing("The function of EOF can be disabled");
		testing("individually by setting the value of the character");
		testing("to _POSIX_V_DISABLE.");
		start
			tty_termios_p->c_cc[VEOF] = posix_vdisable;
			Ztcsetattr(tty_fildes, TCSANOW, tty_termios_p);

			SET_TIMEOUT
				expecting(Strlen);
				Zwrite(loop_fildes, String, Strlen);
								/*	Neither the old EOF character nor the
									disable character enables EOF. */
				WRITE_TTY_SCC(loop_fildes, tty_origin.c_cc[VEOF]);
				WRITE_TTY_SCC(loop_fildes, posix_vdisable);
				expecting(sizeof(char));
				Zwrite(loop_fildes, (char *)&NL, sizeof(char));
				Ztcdrain(loop_fildes);

				expecting(Strlen +2*(sizeof(cc_t)) +sizeof(char));
				Zread(tty_fildes, inbuf, _POSIX_MAX_INPUT);
			CLEAR_ALARM
		finis

														/* EOL */
		testing("The function of EOL can be disabled");
		testing("individually by setting the value of the character");
		testing("to _POSIX_V_DISABLE.");
		start
			tty_termios_p->c_cc[VEOL] = posix_vdisable;
			Ztcsetattr(tty_fildes, TCSAFLUSH, tty_termios_p);

			SET_TIMEOUT
				expecting(Strlen);
				Zwrite(loop_fildes, String, Strlen);
								/*	Neither the old EOL character nor the
									disable character enables EOL. */
				WRITE_TTY_SCC(loop_fildes, tty_origin.c_cc[VEOL]);
				WRITE_TTY_SCC(loop_fildes, posix_vdisable);
				expecting(sizeof(char));
				Zwrite(loop_fildes, (char *)&NL, sizeof(char));
				Ztcdrain(loop_fildes);

				expecting(Strlen +2*(sizeof(cc_t)) +sizeof(char));
				Zread(tty_fildes, inbuf, _POSIX_MAX_INPUT);
			CLEAR_ALARM
		finis
	finis

							/* Disable SUSP character */
	assertion(62, BASE);
	start
		testing("The function of the special character SUSP can be");
		testing("disabled individually by setting the value of the");
		testing("special character to _POSIX_VDISABLE.");
		start
			tty_termios_p->c_cc[VSUSP] = posix_vdisable;
			Ztcsetattr(tty_fildes, TCSANOW, tty_termios_p);

			sig_rcvd = 0;
			SIGNAL(SIGTSTP, sig_int);

			SET_TIMEOUT
								/*	Neither the old SUSP character nor the
									disable character enables SUSP. */
				WRITE_TTY_SCC(loop_fildes, tty_origin.c_cc[VSUSP]);
				WRITE_TTY_SCC(loop_fildes, posix_vdisable);
				Ztcdrain(loop_fildes);
			CLEAR_ALARM

			if(sig_rcvd != 0)
				error("Suspense character was not disabled.");
		finis
	finis

									/* Disable START and STOP characters */
	assertion(63, BASE);
	start
		if(GTI_START_STOP == 1) {
															/* STOP */
			testing("The function of STOP can be disabled by setting the");
			testing("value of the character to _POSIX_V_DISABLE.");
			start
				tty_termios_p->c_cc[VSTOP] = posix_vdisable;
				tty_termios_p->c_iflag &= IXON;
				Ztcflush(loop_fildes, TCIOFLUSH);
				dt_secs(TIME_ACQUIRE_XMITTED_DATA);
				Ztcsetattr(tty_fildes, TCSAFLUSH, tty_termios_p);

				SET_TIMEOUT
								/*	Neither the old STOP character nor the
									disable character enables STOP. */
					WRITE_TTY_SCC(loop_fildes, tty_origin.c_cc[VSTOP]);
					WRITE_TTY_SCC(loop_fildes, posix_vdisable);
					expecting(sizeof(char));
					Zwrite(loop_fildes, (char *)&NL, sizeof(char));
					Ztcdrain(loop_fildes);
					dt_secs(TIME_ACQUIRE_XMITTED_DATA);

					expecting(2*sizeof(cc_t) +sizeof(char));
					Zread(tty_fildes, inbuf, _POSIX_MAX_INPUT);
				CLEAR_ALARM

				if((cc_t) inbuf[1] != posix_vdisable)
					error("STOP character was not disabled.");
			finis

															/* START */
			testing("The function of START can be disabled by setting");
			testing("the value of the character to _POSIX_V_DISABLE.");
			start
				tty_termios_p->c_cc[VSTART] = posix_vdisable;
				Ztcsetattr(tty_fildes, TCSANOW, tty_termios_p);

				SET_TIMEOUT
								/*	Neither the old START character nor the
									disable character enables START. */
					WRITE_TTY_SCC(loop_fildes, tty_origin.c_cc[VSTART]);
					WRITE_TTY_SCC(loop_fildes, posix_vdisable);
					expecting(sizeof(char));
					Zwrite(loop_fildes, (char *)&NL, sizeof(char));
					Ztcdrain(loop_fildes);

					expecting(2*sizeof(cc_t) +sizeof(char));
					Zread(tty_fildes, inbuf, _POSIX_MAX_INPUT);
				CLEAR_ALARM

				if((cc_t) inbuf[1] != posix_vdisable)
					error("START character was not disabled.");
			finis
		}
		else
			not_implemented("changing START and STOP characters");
	finis

	cleanup("Close terminal devices.");
	start
		SIGNAL(SIGHUP, SIG_IGN);
		Zclose(tty_fildes);
		Zclose(loop_fildes);
		SLEEP(GTI_LINE_CLOSE_DELAY)
	finis

	done();
}
