#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<termios.h>
#include	<pcts_timer.h>

char String[] = "This is standard output.\n";
#define Strlen	(sizeof(String)-1)


int main(void)
{
	int		tty_fildes, loop_fildes;
	struct	termios tty_termios, *tty_termios_p = &tty_termios,
					loop_termios, *loop_termios_p = &loop_termios;
	pid_t	pid;
	char	inbuf[_POSIX_MAX_INPUT];

	setup(E_INTERFACE);
	funct(E_INTERFACE);

	if(GTI_NOT_PROVIDED) {
		GTI_NOT_PROVIDED_RESULT(67, BASE)
		GTI_NOT_PROVIDED_RESULT(68, BASE)
		done();
	}

	exit_on(ERROR);

	assertion(68, EXTENDED);

						/* Closing a Terminal Device File */
	assertion(67, BASE);
	start
		FORK
		ENABLE_PSYNC
			prep("Fork a child  process.");
			start
				sv_flush();
				pid = Zfork();
			finis
	
			if(pid == (pid_t)0) {
				prep("Open PORT_LOOP, send data to ensure connection");
				prep("has been properly established.");
				start 
					loop_prep(&loop_fildes, loop_termios_p);
					loop_termios_p->c_cflag |= CLOCAL;
					Ztcsetattr(loop_fildes, TCSANOW, loop_termios_p);

					SET_TIMEOUT
										/* Wait for PORT_TTY to complete. */
						WAIT_PSYNC

						expecting(Strlen);
						Zwrite(loop_fildes, String, Strlen);
						Ztcdrain(loop_fildes);
					CLEAR_ALARM

				finis
	
				testing("Write to terminal, then close device.");
				start
					SET_TIMEOUT
						WAIT_PSYNC
						expecting(Strlen);
						Zwrite(loop_fildes, String, Strlen);
						Zclose(loop_fildes);
					CLEAR_ALARM

					SLEEP(GTI_LINE_CLOSE_DELAY)
											/* close() completed. */
					SEND_PSYNCA
					SET_TIMEOUT
											/* Wait for testing to complete. */
						WAIT_PSYNC
					CLEAR_ALARM
				finis
	
				done();
			}

			prep("Open PORT_TTY and process initial data message.");
			prep("Wait for child to close PORT_LOOP.");
			start
				tty_prep(&tty_fildes, tty_termios_p);
						/*	Ensure disconnect is not detected, which if detected
							would cause data in input queue to be discarded.
						*/
				tty_termios_p->c_cflag |= CLOCAL;		
				Ztcsetattr(tty_fildes, TCSANOW, tty_termios_p);
				SEND_PSYNC

				SET_TIMEOUT
					expecting(Strlen);
					Zread(tty_fildes, inbuf, _POSIX_MAX_INPUT);
					SEND_PSYNC
				CLEAR_ALARM

				SET_TIMEOUT
					WAIT_PSYNCA
				CLEAR_ALARM
			finis
	
			testing("The last process to close a terminal device file causes");
			testing("any data in the output queue to be sent to the device.");
			start
				dt_secs(TIME_ACQUIRE_XMITTED_DATA);

				SET_TIMEOUT
					expecting(Strlen);
					Zread(tty_fildes, inbuf, sizeof(inbuf));
				CLEAR_ALARM

				SEND_PSYNC
			finis

			WAIT_FOR_PID(pid);
		DISABLE_PSYNC
		KROF
		SLEEP(GTI_LINE_CLOSE_DELAY)
	finis

	done();
}
