#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<termios.h>
#include	<pcts_timer.h>

char String[] = "Test THIS";
#define Strlen	(sizeof(String)-1)
unsigned char NL = '\n';


int main(void)
{
	int		tty_fildes, loop_fildes;
	struct	termios tty_termios, *tty_termios_p = &tty_termios,
					loop_termios, *loop_termios_p = &loop_termios;
	char	inbuf[_POSIX_MAX_INPUT];
	pid_t	pid;

	setup(E_SETTABLE);
	funct(E_SETTABLE);

	if(GTI_NOT_PROVIDED) {
		GTI_NOT_PROVIDED_RESULT(8, BASE)
		GTI_NOT_PROVIDED_RESULT(9, BASE)
		GTI_NOT_PROVIDED_RESULT(10, BASE)
		done();
	}

									/* IGNBRK, BRKINT */
	assertion(8, BASE);
	start
		prep("Establish PORT_TTY as the control terminal and PORT_LOOP.");
		start
			exit_on(ERROR);
			termios_prep(&tty_fildes, tty_termios_p, &loop_fildes,
							loop_termios_p);
			tty_termios_p->c_iflag |=(IGNBRK|BRKINT);
			Ztcsetattr(tty_fildes, TCSAFLUSH, tty_termios_p);
		finis

		testing("If IGNBRK is set, a break condition detected on input");
		testing("is ignored and does not affect the read by any process).");
		start
			sig_rcvd = 0;
			SIGNAL(SIGINT, sig_int);
			SET_TIMEOUT
				Ztcsendbreak(loop_fildes, 0);
			CLEAR_ALARM

			if(sig_rcvd != 0)
				error("SIGINT generated when break was received.");

						/* No additional data generated by tcsendbreak()? */
			SET_TIMEOUT
				expecting(Strlen);
				Zwrite(loop_fildes, String, Strlen);
				expecting(sizeof(NL));
				Zwrite(loop_fildes, (char *)&NL, sizeof(NL));
				Ztcdrain(loop_fildes);
				expecting(Strlen +sizeof(NL));
				Zread(tty_fildes, inbuf, _POSIX_MAX_INPUT);
			CLEAR_ALARM
		finis
	finis

							/* ~IGNBRK, BRKINT, controlling terminal
								of foreground process group.
							*/
	assertion(10, BASE);
	start
		testing("IGNBRK clear and BRKINT set");
		start
			tty_termios_p->c_iflag &= ~IGNBRK;
			tty_termios_p->c_iflag |= BRKINT;
			Ztcsetattr(tty_fildes, TCSAFLUSH, tty_termios_p);
			sig_rcvd = 0;
			SIGNAL(SIGINT, sig_int);

			SET_TIMEOUT
				expecting(Strlen);
							/* Send data to PORT_TTY input queue. */
				Zwrite(loop_fildes, String, Strlen);
				Ztcdrain(loop_fildes);

				if(PCTS_GTI_BUFFERS_OUTPUT) {
							/* Send data to PORT_TTY output queue. */
					Ztcflow(tty_fildes, TCOOFF);
					expecting(Strlen);
					Zwrite(tty_fildes, String, Strlen);
				}
			CLEAR_ALARM

			SLEEP(1); /*	Allow time for write() to complete. */

					/*	Avoid being interruped while generating SIGINT
						to the process in the foreground process group.
					*/
			pid = Zfork();
			if(pid == (pid_t)0) {
				Zsetpgid((pid_t)0, (pid_t)0);
				SET_TIMEOUT
					Ztcsendbreak(loop_fildes, 0);
					Ztcdrain(loop_fildes);
					dt_secs(TIME_ACQUIRE_XMITTED_DATA);
				CLEAR_ALARM
				done();
			}
			sleep(2);	/*	Allow time for expected SIGINT to occur.	*/
			WAIT_FOR_PID(pid);

			if(sig_rcvd == 0)
				error("SIGINT not generated.");

			SET_ALARM(TIMEOUT +TIMEOUT +WAIT_FOR_TIME)
				Ztcflow(tty_fildes, TCOON);
								/* Check queues were flushed. */
				expecting(sizeof(char));
				Zwrite(loop_fildes, (char *)&NL, sizeof(NL));
				Zwrite(tty_fildes, (char *)&NL, sizeof(NL));
				Ztcdrain(loop_fildes);
				Ztcdrain(tty_fildes);

				dt_secs(TIME_ACQUIRE_XMITTED_DATA);

				expecting(sizeof(NL));
				Zread(loop_fildes, inbuf, _POSIX_MAX_INPUT);
				expecting(sizeof(NL));
				Zread(tty_fildes, inbuf, _POSIX_MAX_INPUT);
			CLEAR_ALARM
		finis
	finis


	assertion(9, BASE);
	start
									/* ~IGNBRK, BRKINT, controlling terminal */
		prep("Clear IGNBRK and set BRKINT.");
		start
			tty_termios_p->c_iflag &= ~IGNBRK;
			tty_termios_p->c_iflag |= BRKINT;
			Ztcsetattr(tty_fildes, TCSAFLUSH, tty_termios_p);
		finis

		testing("Break condition flushes the input and output queues");
		testing("on controlling terminal.");
		start
			SIGNAL(SIGINT, SIG_IGN);

			SET_TIMEOUT
				expecting(Strlen);
							/* Send data to PORT_TTY input queue. */
				Zwrite(loop_fildes, String, Strlen);
				Ztcdrain(loop_fildes);

				if(PCTS_GTI_BUFFERS_OUTPUT) {
						/* Send data to PORT_TTY output queue. */
					Ztcflow(tty_fildes, TCOOFF);
					expecting(Strlen);
					Zwrite(tty_fildes, String, Strlen);
				}

				dt_secs(TIME_ACQUIRE_XMITTED_DATA);
			CLEAR_ALARM

			SET_TIMEOUT
				Ztcsendbreak(loop_fildes, 0);
				Ztcdrain(loop_fildes);
				dt_secs(TIME_ACQUIRE_XMITTED_DATA);
			CLEAR_ALARM

			SET_ALARM(TIMEOUT +TIMEOUT +WAIT_FOR_TIME)
				Ztcflow(tty_fildes, TCOON);
								/* Check queues were flushed. */
				expecting(sizeof(char));
				Zwrite(loop_fildes, (char *)&NL, sizeof(NL));
				Zwrite(tty_fildes, (char *)&NL, sizeof(NL));
				Ztcdrain(loop_fildes);
				Ztcdrain(tty_fildes);
				dt_secs(TIME_ACQUIRE_XMITTED_DATA);

				expecting(sizeof(NL));
				Zread(loop_fildes, inbuf, _POSIX_MAX_INPUT);
				expecting(sizeof(NL));
				Zread(tty_fildes, inbuf, _POSIX_MAX_INPUT);
			CLEAR_ALARM
		finis

		cleanup("Close terminal devices.");
		start
			SIGNAL(SIGHUP, SIG_IGN);
			Zclose(loop_fildes);
			Zclose(tty_fildes);
			SLEEP(GTI_LINE_CLOSE_DELAY)
		finis

								/* ~IGNBRK, BRKINT, non-controlling terminal */
		FORK
			prep("Ensure, this process has no controlling terminal, then");
			prep("open non-controlling terminal ports PORT_TTY and PORT_LOOP.");
			start
				exit_on(ERROR);

				Zsetsid();
				tty_fildes = Zopen(PORT_TTY, O_RDWR | O_NONBLOCK | O_NOCTTY,
																	PERM_CTTY);
				tty_init(tty_fildes, tty_termios_p);
				loop_prep(&loop_fildes, loop_termios_p);
					/* Allow ports to become established before continuing. */
				sleep(1);
				tty_termios_p->c_iflag &= ~IGNBRK;
				tty_termios_p->c_iflag |= BRKINT;
				Ztcsetattr(tty_fildes, TCSAFLUSH, tty_termios_p);
			finis

			testing("Break condition flushes the input and output queues");
			testing("on non-controlling terminal.");
			start
				SIGNAL(SIGINT, SIG_IGN);

				SET_TIMEOUT
					expecting(Strlen);
								/* Send data to PORT_TTY input queue. */
					Zwrite(loop_fildes, String, Strlen);
					Ztcdrain(loop_fildes);
	
					if(PCTS_GTI_BUFFERS_OUTPUT) {
							/* Send data to PORT_TTY output queue. */
						Ztcflow(tty_fildes, TCOOFF);
						expecting(Strlen);
						Zwrite(tty_fildes, String, Strlen);
					}
					dt_secs(TIME_ACQUIRE_XMITTED_DATA);
				CLEAR_ALARM

				SET_TIMEOUT
					Ztcsendbreak(loop_fildes, 0);
					Ztcdrain(loop_fildes);
					dt_secs(TIME_ACQUIRE_XMITTED_DATA);
				CLEAR_ALARM

				SET_ALARM(TIMEOUT +TIMEOUT +WAIT_FOR_TIME)
					Ztcflow(tty_fildes, TCOON);
									/* Check queues were flushed. */
					expecting(sizeof(char));
					Zwrite(loop_fildes, (char *)&NL, sizeof(NL));
					Zwrite(tty_fildes, (char *)&NL, sizeof(NL));
					Ztcdrain(loop_fildes);
					Ztcdrain(tty_fildes);
					dt_secs(TIME_ACQUIRE_XMITTED_DATA);

					expecting(sizeof(NL));
					Zread(loop_fildes, inbuf, _POSIX_MAX_INPUT);
					expecting(sizeof(NL));
					Zread(tty_fildes, inbuf, _POSIX_MAX_INPUT);
				CLEAR_ALARM
			finis

			cleanup("Close terminal devices.");
			start
				SIGNAL(SIGHUP, SIG_IGN);
				Zclose(loop_fildes);
				Zclose(tty_fildes);
				SLEEP(GTI_LINE_CLOSE_DELAY)
			finis
		KROF
	finis

	done();
}
