#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<termios.h>
#include	<pcts_timer.h>

char String[] = "Test THIS";
#define Strlen	(sizeof(String)-1)


int main(void)
{
	int		tty_fildes, loop_fildes;
	struct	termios tty_termios, *tty_termios_p = &tty_termios,
					loop_termios, *loop_termios_p = &loop_termios;
	char	inbuf[_POSIX_MAX_INPUT];
	int 	i,j,k;

	setup(E_SETTABLE);
	funct(E_SETTABLE);

	if(GTI_NOT_PROVIDED) {
		GTI_NOT_PROVIDED_RESULT(11, BASE)
		GTI_NOT_PROVIDED_RESULT(12, BASE)
		GTI_NOT_PROVIDED_RESULT(13, BASE)
		GTI_NOT_PROVIDED_RESULT(14, BASE)
		GTI_NOT_PROVIDED_RESULT(15, BASE)
		GTI_NOT_PROVIDED_RESULT(16, BASE)
		GTI_NOT_PROVIDED_RESULT(17, BASE)
		GTI_NOT_PROVIDED_RESULT(18, BASE)
		GTI_NOT_PROVIDED_RESULT(19, BASE)
		GTI_NOT_PROVIDED_RESULT(20, BASE)
		GTI_NOT_PROVIDED_RESULT(21, BASE)
		done();
	}

									/* IGNBRK, BRKINT, and PARMRK clear */
	assertion(11, BASE);
	start
		prep("Establish PORT_TTY as the control terminal and PORT_LOOP.");
		prep("Set PORT_TTY to non-canonical, MIN=TIME=0.");
		start
			exit_on(ERROR);
			termios_prep(&tty_fildes, tty_termios_p, &loop_fildes,
							loop_termios_p);
			tty_termios_p->c_iflag &= ~(IGNBRK | BRKINT | PARMRK);
			tty_termios_p->c_lflag |= NOFLSH;
			tty_termios_p->c_lflag &= ~ICANON;
					/* Return number of bytes requested or that available. */
			tty_termios_p->c_cc[VMIN] = 0;
			tty_termios_p->c_cc[VTIME] = 0;
			Ztcsetattr(tty_fildes, TCSAFLUSH, tty_termios_p);
		finis

		testing("When IGNBRK, BRKINT and PARMRK are clear, then a break");
		testing("condition is read as a single '\\0'.");
		start
			sig_rcvd = 0;
			SIGNAL(SIGINT, sig_int);
			SET_TIMEOUT
				expecting(sizeof(char));
				Zwrite(loop_fildes, "a", sizeof(char));
				dt_secs(TIME_ACQUIRE_XMITTED_DATA);
				Ztcdrain(loop_fildes);
				Ztcsendbreak(loop_fildes, 0);
				tcdrain(loop_fildes);	/* Allow for unexpected interrupt */
				expecting(sizeof(char));
				Zwrite(loop_fildes, "b", sizeof(char));
				Ztcdrain(loop_fildes);
				dt_secs(TIME_ACQUIRE_XMITTED_DATA);
			CLEAR_ALARM

			SET_TIMEOUT
				expecting(3 * sizeof(char));
				Zread(tty_fildes, inbuf, _POSIX_MAX_INPUT);
			CLEAR_ALARM

			if(sig_rcvd != 0)
				error("Break detected.");

			if(inbuf[1] != '\0')
				error("Expected '\\0' read as %x(Hex)", inbuf[1]);
		finis
	finis

									/* IGNBRK and BRKINT clear, PARMRK set */
	assertion(12, BASE);
	start
		testing("When IGNBRK and BRKINT are clear and PARMRK is set, then");
		testing("a break condition is read as '\\377', '\\0', '\\0'.");
		start
			tty_termios_p->c_iflag &= ~(IGNBRK | BRKINT);
			tty_termios_p->c_iflag |= PARMRK;
			tty_termios_p->c_lflag |= NOFLSH;

			for(i=0; i<2; i++) {
								/* Test for ISTRIP set and ISTRIP clear. */
				if(i==0)
					tty_termios_p->c_iflag |= ISTRIP;
				else
					tty_termios_p->c_iflag &= ~ISTRIP;
				Ztcsetattr(tty_fildes, TCSAFLUSH, tty_termios_p);
				sig_rcvd = 0;
				SIGNAL(SIGINT, sig_int);
				SET_TIMEOUT
					expecting(3*sizeof(char));
					Zwrite(loop_fildes, "abc", 3*sizeof(char));
					Ztcdrain(loop_fildes);
					dt_secs(TIME_ACQUIRE_XMITTED_DATA);
					Ztcsendbreak(loop_fildes, 0);
					tcdrain(loop_fildes);	/* Allow for unexpected interrupt */
					expecting(sizeof(char));
					Zwrite(loop_fildes, "d", sizeof(char));
					Ztcdrain(loop_fildes);
					dt_secs(TIME_ACQUIRE_XMITTED_DATA);
				CLEAR_ALARM

				SET_TIMEOUT
					expecting(4*sizeof(char) +3*sizeof(char));
					Zread(tty_fildes, inbuf, _POSIX_MAX_INPUT);
				CLEAR_ALARM

				if(inbuf[3] != '\377' || inbuf[4] != '\0' || inbuf[5] != '\0')
					error("%s\n%s %o %o %o",
							"Expected: \\377 \\0 \\0",
							"Received:",
							(int)inbuf[3], (int)inbuf[4], (int)inbuf[5]);
				if(sig_rcvd != 0)
					error("Break detected.");
			}
		finis
	finis

	assertion(13, EXTENDED);

									/* PARENB, INPCK, and IGNBRK all set */
	assertion(14, BASE);
	start
		testing("When PARENB, INPCK, and IGNPAR are set, a byte with a");
		testing("parity error is ignored.");
		start
						/* Generate parity by writing ODD and expecting EVEN. */
			loop_termios_p->c_cflag |= (PARENB | PARODD);
			Ztcsetattr(loop_fildes, TCSAFLUSH, loop_termios_p);

			tty_termios_p->c_iflag |= (IGNPAR | INPCK);
			tty_termios_p->c_cflag |= PARENB;
			tty_termios_p->c_cflag &= ~PARODD;
			Ztcsetattr(tty_fildes, TCSAFLUSH, tty_termios_p);

			SET_TIMEOUT
				expecting(3*sizeof(char));
				Zwrite(loop_fildes, "abc", 3*sizeof(char));
				Ztcdrain(loop_fildes);
				dt_secs(TIME_ACQUIRE_XMITTED_DATA);
									/* Parity characters are not passed. */
				expecting(0);
				Zread(tty_fildes, inbuf, _POSIX_MAX_INPUT);
			CLEAR_ALARM
		finis
	finis

	assertion(15, EXTENDED);

		/* PARENB, INPCK, and PARMRK all set and IGNPAR is clear. */
	assertion(16, BASE);
	start
		testing("When PARENB, INPCK, and PARMRK are set and IGNPAR");
		testing("is clear, then a byte with parity error");
		testing("is read as the three-character sequence");
		testing("'\\377', '\\0', 'X'.");
		start
			tty_termios_p->c_cflag |= PARENB;
			tty_termios_p->c_cflag &= ~PARODD;
			tty_termios_p->c_iflag |= (PARMRK | INPCK);
			tty_termios_p->c_iflag &= ~IGNPAR;
			for(k=0; k<2; k++) {
								/* Test for ISTRIP set and ISTRIP clear. */
				if(k==0)
					tty_termios_p->c_iflag |= ISTRIP;
				else
					tty_termios_p->c_iflag &= ~ISTRIP;
				Ztcsetattr(tty_fildes, TCSAFLUSH, tty_termios_p);

				SET_TIMEOUT
					expecting(3*sizeof(char));
					Zwrite(loop_fildes, "abc", 3*sizeof(char));
					Ztcdrain(loop_fildes);
					dt_secs(TIME_ACQUIRE_XMITTED_DATA);
				CLEAR_ALARM

				SET_TIMEOUT
					expecting(3*(3*sizeof(char)));
					Zread(tty_fildes, inbuf, _POSIX_MAX_INPUT);
				CLEAR_ALARM

				for(i=0,j=0; i<9; i+=3,j++) {
					if(		inbuf[i+0] != '\377' ||
							inbuf[i+1] != '\0'   ||
							inbuf[i+2] != 'a'+j    )
						error("%s %o\n%s %o %o %o",
								"Expected: \\377 \\0",
								'a' +j,
								"Received:",
								inbuf[i+0], inbuf[i+1],
								inbuf[i+2]);
				}
			}
		finis
	finis

		/* PARENB and PARMRK set, CSIZE is CS8, IGNPAR and ISTRIP clear */
	assertion(17, BASE);
	start
		testing("When PARENB and PARMRK are set,CSIZE is CS8, and IGNPAR");
		testing("and ISTRIP are clear, a valid character of '\\377' is read");
		testing("as '\\377', '\\377'");
		start
			loop_termios_p->c_cflag &= ~CSIZE;
			loop_termios_p->c_cflag |= (PARENB | CS8);
			loop_termios_p->c_cflag |= PARODD;
			Ztcsetattr(loop_fildes, TCSAFLUSH, loop_termios_p);

			tty_termios_p->c_cflag |= PARENB;
			tty_termios_p->c_iflag |= PARMRK;
			tty_termios_p->c_cflag &= ~CSIZE;
			tty_termios_p->c_cflag |= CS8;
			tty_termios_p->c_iflag &= ~(ISTRIP | IGNPAR);
			tty_termios_p->c_cflag |= PARODD;
			Ztcsetattr(tty_fildes, TCSAFLUSH, tty_termios_p);

			SET_TIMEOUT
				{
					const unsigned char eight_bits = (unsigned char) '\377';

					expecting(sizeof(char));
					Zwrite(loop_fildes, (char *)&eight_bits, sizeof(char));
					Zwrite(loop_fildes, (char *)&eight_bits, sizeof(char));
					Zwrite(loop_fildes, (char *)&eight_bits, sizeof(char));
					Ztcdrain(loop_fildes);
				}
			CLEAR_ALARM

			dt_secs(TIME_ACQUIRE_XMITTED_DATA);

			SET_TIMEOUT
				expecting(3*(2*sizeof(char)));
				Zread(tty_fildes, inbuf, _POSIX_MAX_INPUT);
			CLEAR_ALARM

			for(i=0; i<3; i+=2)
				if(inbuf[i+0] != '\377' || inbuf[i+1] != '\377')
					error("%s\n%s %o %o",
							"Expected: 377 377",
							"Received:",
							inbuf[i+0], inbuf[i+1]);
		finis
	finis

	assertion(18, EXTENDED);

					/* PARENB and INPCK set, IGNPAR and PARMRK clear */
	assertion(19, BASE);
	start
		testing("When PARENB and INPCK are set, IGNPAR and PARMRK are clear,");
		testing("then a parity error is read as a single character '\\0'.");
		start
			tty_termios_p->c_cflag |= PARENB;
			tty_termios_p->c_iflag |= INPCK;
			tty_termios_p->c_iflag &= ~(IGNPAR | PARMRK);
			tty_termios_p->c_cflag &= ~PARODD;
			Ztcsetattr(tty_fildes, TCSAFLUSH, tty_termios_p);

			SET_TIMEOUT
				expecting(Strlen);
				Zwrite(loop_fildes, String, Strlen);
				Ztcdrain(loop_fildes);
				dt_secs(TIME_ACQUIRE_XMITTED_DATA);
			CLEAR_ALARM

			SET_TIMEOUT
				expecting(Strlen);
				Zread(tty_fildes, inbuf, _POSIX_MAX_INPUT);
			CLEAR_ALARM

			for(i=0; i<Strlen; i++)
				if(inbuf[i] != '\0')
					error("%s %d\n%s\n%s %0",
							"Input character",
							i,
							"Expected: \\0",
							"Received:",
							inbuf[i]);
		finis
	finis

						/*	Assertion #21 is a repeat of assertion #19 with
							INPCK clear.  Although output parity is generated,
							which was detected in the test for assertion #19,
							no detection occurs in this test.
						*/
									/* PARENB set , INPCK clear */
	assertion(21, BASE);
	start
		testing("When PARENB is set and INPCK is clear, then input parity");
		testing("checking is disabled but output parity generation occurs.");
		start
			tty_termios_p->c_iflag &= ~INPCK;
			Ztcsetattr(tty_fildes, TCSAFLUSH, tty_termios_p);

			SET_TIMEOUT
				expecting(Strlen);
				Zwrite(loop_fildes, String, Strlen);
				Ztcdrain(loop_fildes);
				dt_secs(TIME_ACQUIRE_XMITTED_DATA);
			CLEAR_ALARM

			SET_TIMEOUT
				expecting(Strlen);
				Zread(tty_fildes, inbuf, _POSIX_MAX_INPUT);
			CLEAR_ALARM

			if(strncmp(String, inbuf, Strlen))
				error("%s\n%s\"%s\"\n%s\"%*s\"",
						"Data sent not the same as data received.",
						"Sent ",
						String,
						"Received: ",
						(int) Strlen,
						inbuf);
		finis
	finis



									/* PARENB and INPCK set */
	assertion(20, BASE);
	start
		testing("When PARENB and INPCK are set, then input parity");
		testing("checking is enabled and characters received with");
		testing("correct parity are as sent and do not generate an error.");
		start
			tty_termios_p->c_cflag |= PARENB;
			tty_termios_p->c_iflag |= INPCK;
			tty_termios_p->c_cflag |= PARODD;
			Ztcsetattr(tty_fildes, TCSAFLUSH, tty_termios_p);

			SET_TIMEOUT
				expecting(Strlen);
				Zwrite(loop_fildes, String, Strlen);
				Ztcdrain(loop_fildes);
				dt_secs(TIME_ACQUIRE_XMITTED_DATA);
			CLEAR_ALARM

			SET_TIMEOUT
				expecting(Strlen);
				Zread(tty_fildes, inbuf, _POSIX_MAX_INPUT);
			CLEAR_ALARM

			if(strncmp(String, inbuf, Strlen))
				error("%s\n%s\"%s\"\n%s\"%*s\"",
						"Data sent not the same as data received.",
						"Sent ",
						String,
						"Received: ",
						(int) Strlen,
						inbuf);
		finis
	finis

	cleanup("Close terminal devices.");
	start
		SIGNAL(SIGHUP, SIG_IGN);
		Zclose(tty_fildes);
		Zclose(loop_fildes);
		SLEEP(GTI_LINE_CLOSE_DELAY)
	finis

	done();
}
