#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<termios.h>
#include	<pcts_timer.h>

unsigned char eight_bit_set[]= {
										(unsigned char) '\377',
										(unsigned char) '\277',
										(unsigned char) '\200',
									 };
#define Strlen	(sizeof(eight_bit_set)-1)


int main(void)
{
	int		tty_fildes, loop_fildes;
	struct	termios tty_termios, *tty_termios_p = &tty_termios,
					loop_termios, *loop_termios_p = &loop_termios;
	char	inbuf[_POSIX_MAX_INPUT];
	int 	i;

	setup(E_SETTABLE);
	funct(E_SETTABLE);

	if(GTI_NOT_PROVIDED) {
		GTI_NOT_PROVIDED_RESULT(22, BASE)
		GTI_NOT_PROVIDED_RESULT(23, BASE)
		done();
	}

									/* ISTRIP */
	assertion(22, BASE);
	start
		prep("Establish PORT_TTY as the control terminal and PORT_LOOP.");
		prep("Set PORT_TTY to non-canonical, MIN=TIME=0.");
		prep("Set ISTRIP flag for PORT_TTY.");
		start
			exit_on(ERROR);
			termios_prep(&tty_fildes, tty_termios_p, &loop_fildes,
							loop_termios_p);
			tty_termios_p->c_lflag &= ~ICANON;
					/* Return number of bytes requested or that available. */
			tty_termios_p->c_cc[VMIN] = 0;
			tty_termios_p->c_cc[VTIME] = 0;
			tty_termios_p->c_iflag |= ISTRIP;
			Ztcsetattr(tty_fildes, TCSAFLUSH, tty_termios_p);
		finis

		testing("When ISTRIP is set, valid input characters are stripped");
		testing("to 7 bits before returning them to the application.");
		start
			SET_TIMEOUT
				expecting(Strlen);
				Zwrite(loop_fildes, eight_bit_set, Strlen);
				Ztcdrain(loop_fildes);
			CLEAR_ALARM

			dt_secs(TIME_ACQUIRE_XMITTED_DATA);

			SET_TIMEOUT
				expecting(Strlen);
				Zread(tty_fildes, inbuf, _POSIX_MAX_INPUT);
			CLEAR_ALARM

			for(i=0; i<Strlen; i++)
				if((eight_bit_set[i]&'\177') != inbuf[i])
					error("%s%c\n%s%c",
							"Expected: ",
							eight_bit_set[i]&'\177',
							"Actual: ",
							inbuf[i]);
		finis
	finis

												/* ~ISTRIP */
	assertion(23, BASE);
	start
		prep("Clear ISTRIP from PORT_TTY.");
		start
			tty_termios_p->c_iflag &= ~ISTRIP;
			Ztcsetattr(tty_fildes, TCSAFLUSH, tty_termios_p);
		finis

		testing("When ISTRIP is clear, all 8 bits of valid input");
		testing("characters are returned to the application.");
		start
			SET_TIMEOUT
				expecting(Strlen);
				Zwrite(loop_fildes, eight_bit_set, Strlen);
				Ztcdrain(loop_fildes);
			CLEAR_ALARM

			dt_secs(TIME_ACQUIRE_XMITTED_DATA);

			SET_TIMEOUT
				expecting(Strlen);
				Zread(tty_fildes, inbuf, _POSIX_MAX_INPUT);
			CLEAR_ALARM

			for(i=0; i<Strlen; i++)
				if(eight_bit_set[i] != (unsigned char) inbuf[i])
					error("%s%c\n%s%c",
							"Expected: ",
							eight_bit_set[i],
							"Actual: ",
						 	(unsigned char) inbuf[i]);
		finis
	finis


	cleanup("Close terminal devices.");
	start
		SIGNAL(SIGHUP, SIG_IGN);
		Zclose(tty_fildes);
		Zclose(loop_fildes);
		SLEEP(GTI_LINE_CLOSE_DELAY)
	finis

	done();
}
