#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<termios.h>
#include	<pcts_timer.h>

char String[] = "And they thwam and they thwam all over the dam!";
const int Strlen = sizeof(String)-1;


int main(void)
{
	int		tty_fildes, loop_fildes;
	struct	termios tty_termios, *tty_termios_p = &tty_termios,
					loop_termios, *loop_termios_p = &loop_termios;
	char	inbuf[_POSIX_MAX_INPUT];
	char	outbuf[_POSIX_MAX_INPUT];
	size_t	max_input;
	char	c;
	int outchars;

	setup(E_SETTABLE);
	funct(E_SETTABLE);

	if(GTI_NOT_PROVIDED) {
		GTI_NOT_PROVIDED_RESULT(29, BASE)
		GTI_NOT_PROVIDED_RESULT(30, BASE)
		GTI_NOT_PROVIDED_RESULT(31, BASE)
		GTI_NOT_PROVIDED_RESULT(32, BASE)
		GTI_NOT_PROVIDED_RESULT(33, BASE)
		GTI_NOT_PROVIDED_RESULT(34, BASE)
		done();
	}

									/* IXON with STOP */
	assertion(29, BASE);
	start
									/* Needed for #32 and #33. */
		max_input = g_max_input(PORT_TTY);

		prep("Establish PORT_TTY as the control terminal and PORT_LOOP.");
		prep("Set PORT_TTY and PORT_LOOP to non-canonical, MIN=TIME=0.");
		prep("Set IXON flag for PORT_TTY.");
		start
			exit_on(ERROR);
			termios_prep(&tty_fildes, tty_termios_p, &loop_fildes,
							loop_termios_p);

			loop_termios_p->c_lflag &= ~ICANON;
					/* Return number of bytes requested or that available. */
			loop_termios_p->c_cc[VMIN] = 0;
			loop_termios_p->c_cc[VTIME] = 0;
			Ztcsetattr(loop_fildes, TCSAFLUSH, loop_termios_p);

			tty_termios_p->c_lflag &= ~ICANON;
					/* Return number of bytes requested or that available. */
			tty_termios_p->c_cc[VMIN] = 0;
			tty_termios_p->c_cc[VTIME] = 0;

			tty_termios_p->c_iflag |= IXON;
			Ztcsetattr(tty_fildes, TCSAFLUSH, tty_termios_p);
		finis

		testing("When IXON is set, a received STOP character");
		testing("suspends output.");
		start
			SET_TIMEOUT
				WRITE_TTY_SCC(loop_fildes, tty_termios_p->c_cc[VSTOP]);
				Ztcdrain(loop_fildes);
				dt_secs(TIME_ACQUIRE_XMITTED_DATA);
			CLEAR_ALARM

			if(PCTS_GTI_BUFFERS_OUTPUT) {
				SET_TIMEOUT
					expecting(Strlen);
					Zwrite(tty_fildes, String, Strlen);
				CLEAR_ALARM
			} else {
				SET_TIMEOUT
					expecting(Strlen);
					Zwrite(tty_fildes, String, Strlen);
				EXPECT_ALARM
			}

					/* Allow data to be erroneously transmitted. */
			dt_secs(5);									/* Wait 1/2 second. */

			SET_TIMEOUT
				expecting(0);
				Zread(loop_fildes, inbuf, _POSIX_MAX_INPUT);
			CLEAR_ALARM
		finis
	finis

									/* IXON with START */
	assertion(30, BASE);
	start
		testing("When IXON is set, received START character restarts output.");
		start
			SET_TIMEOUT
				WRITE_TTY_SCC(loop_fildes, tty_termios_p->c_cc[VSTART]);
				Ztcdrain(loop_fildes);
				dt_secs(TIME_ACQUIRE_XMITTED_DATA);
			CLEAR_ALARM

			if(PCTS_GTI_BUFFERS_OUTPUT == 0) {
				expecting(Strlen);
				Zwrite(tty_fildes, String, Strlen);
			}

			SET_TIMEOUT
				Ztcdrain(tty_fildes);
				dt_secs(TIME_ACQUIRE_XMITTED_DATA);
			CLEAR_ALARM
										/* Read suspended output. */
			SET_TIMEOUT
				expecting(Strlen);
				Zread(loop_fildes, inbuf, Strlen);
			CLEAR_ALARM
		finis
	finis

							/* IXON - start/stop are not read as data. */
	assertion(31, BASE);
	start
		testing("When IXON is set, START and STOP characters are");
		testing("not read as data.");
		start
			Ztcflush(tty_fildes, TCIOFLUSH);
			Ztcflush(loop_fildes, TCIOFLUSH);

			SET_TIMEOUT
				WRITE_TTY_SCC(loop_fildes, tty_termios_p->c_cc[VSTOP]);
				WRITE_TTY_SCC(loop_fildes, tty_termios_p->c_cc[VSTART]);
				expecting(Strlen);
				Zwrite(loop_fildes, String, Strlen);
				WRITE_TTY_SCC(loop_fildes, tty_termios_p->c_cc[VSTOP]);
				WRITE_TTY_SCC(loop_fildes, tty_termios_p->c_cc[VSTART]);
				Ztcdrain(loop_fildes);
				dt_secs(TIME_ACQUIRE_XMITTED_DATA);
			CLEAR_ALARM

			SET_TIMEOUT
				int	n_read;

				for(n_read=0; n_read < Strlen; )
					n_read += read(tty_fildes, &inbuf[n_read], Strlen);
				if(n_read != Strlen)
					error("Expected: %d bytes\n,Received: %d bytes\n",
							Strlen, n_read);
			CLEAR_ALARM

			if(strncmp(String, inbuf, Strlen))
				error("Expected: \"%*s\"\n,Received: \"%*s\"",
						Strlen, String, Strlen, inbuf);
		finis
	finis

							/* ~IXON - start/stop are read as data. */
	assertion(32, BASE);
	start
		testing("When IXON is clear, START and STOP characters are");
		testing("placed in the input queue.");
		start
			tty_termios_p->c_iflag &= ~IXON;
			Ztcsetattr(tty_fildes, TCSAFLUSH, tty_termios_p);
			Ztcflush(loop_fildes, TCIOFLUSH);

			SET_TIMEOUT
				WRITE_TTY_SCC(loop_fildes, tty_termios_p->c_cc[VSTOP]);
				WRITE_TTY_SCC(loop_fildes, tty_termios_p->c_cc[VSTART]);
				expecting(Strlen);
				Zwrite(loop_fildes, String, Strlen);
				WRITE_TTY_SCC(loop_fildes, tty_termios_p->c_cc[VSTOP]);
				WRITE_TTY_SCC(loop_fildes, tty_termios_p->c_cc[VSTART]);
				Ztcdrain(loop_fildes);
				dt_secs(TIME_ACQUIRE_XMITTED_DATA);
			CLEAR_ALARM

			SET_TIMEOUT
				expecting(Strlen +4*sizeof(cc_t));
				Zread(tty_fildes, inbuf, Strlen +4*sizeof(cc_t));
			CLEAR_ALARM

			if(strncmp(String, inbuf +2*sizeof(cc_t), Strlen))
				error("Expected: \"%*s\"\n, Received: \"%*s\"",
						Strlen, String, Strlen, inbuf +2*sizeof(cc_t));
		finis
	finis

						/* IXOFF - Enable start/stop input control. */
	if(max_input <= (size_t) PCTS_MAX_INPUT) {
	  assertion(33, BASE);
	  start
		int	i,j,k;
		int	baud_rate;

		exit_on(ERROR);

		testing("When IXOFF is set, the system transmits STOP characters");
		testing("as needed to prevent the input queue from overflowing.");
		start
			tty_termios_p->c_iflag |= IXOFF;
			Ztcsetattr(tty_fildes, TCSAFLUSH, tty_termios_p);
			Ztcflush(loop_fildes, TCIOFLUSH);

			memset(inbuf, 'a', _POSIX_MAX_INPUT);
			memset(outbuf, 'a', _POSIX_MAX_INPUT);

					/*	POSIX 1003.1 says that "it is intended that IXOFF be
						sent to prevent more than {MAX_INPUT} chars from being
						buffered.  When this happens is implementation defined."
 						The system may not send IXOFF until {MAX_INPUT} has
						been buffered or sometime before or the value of
						{MAX_INPUT} may be invarient.  This test keeps
						outputing until either a STOP is received or
						100*{MAX_INPUT} is output. The varience of {MAX_INPUT}
						tested is up to 100*{MAX_INPUT}.
 					*/

#define	LIMIT_MAX_INPUT	100
			outchars = 0;
			for(k=0; k<LIMIT_MAX_INPUT; k++) {
											/* Write {MAX_INPUT} bytes. */
				for(i=0, j=0; i<max_input; i+=j) {
					if((i +_POSIX_MAX_INPUT) < max_input)
						j = _POSIX_MAX_INPUT;
					else
						j = max_input -i;
					SET_TIMEOUT
						expecting(j);
						Zwrite(loop_fildes, outbuf, j);
						outchars += j;
					CLEAR_ALARM
				}
			
				baud_rate = (int) baud_max();
				SET_ALARM(max_input/baud_value(baud_max())/10)
					tcdrain(loop_fildes);
				IGNORE_ALARM

				if(read(loop_fildes, &c, sizeof(char)) == 1) {
					if(c == tty_termios_p->c_cc[VSTOP])
						break;
					if(unused_time == 0)
						error("Drain of output buffer timed-out.");
				}
			}

			if(k==LIMIT_MAX_INPUT)
				error("STOP character never detected on PORT_LOOP.");
		finis
	  finis
	}
	else
		assertion(33, NOT_TESTABLE);


	if(max_input <= (unsigned) PCTS_MAX_INPUT) {
	  assertion(34, BASE);
	  start
		int	i;

		exit_on(ERROR);

		prep("Flush PORT_LOOP's input queue.");
		start
			dt_secs(TIME_ACQUIRE_XMITTED_DATA);
			Ztcflush(loop_fildes, TCIFLUSH);
		finis

		testing("When IXOFF is set, the system transmits START");
		testing("characters as needed to cause the terminal device");
		testing("to resume transmitting data.");
		start
			for(i=0; i<outchars;) {
				SET_TIMEOUT
					i += Zread(tty_fildes, inbuf, _POSIX_MAX_INPUT);
				CLEAR_ALARM

				Ztcdrain(tty_fildes);
				dt_secs(TIME_ACQUIRE_XMITTED_DATA);

				if(read(loop_fildes, &c, sizeof(char)) == 1)
					if(c == tty_termios_p->c_cc[VSTART])
						break;
			}
			if(c != tty_termios_p->c_cc[VSTART])
				error("START character never detected on PORT_LOOP.");
		finis
	  finis
	}
	else
		assertion(34, NOT_TESTABLE);


	cleanup("Close terminal devices.");
	start
		SIGNAL(SIGHUP, SIG_IGN);
		Zclose(tty_fildes);
		Zclose(loop_fildes);
		SLEEP(GTI_LINE_CLOSE_DELAY)
	finis

	done();
}
