#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<termios.h>
#include	<pcts_timer.h>

char String[] = "And they thwam and they thwam all over the dam.\n";
const int Strlen = sizeof(String)-1;


int main(void)
{
	int		tty_fildes, loop_fildes;
	struct	termios tty_termios, *tty_termios_p = &tty_termios,
					loop_termios, *loop_termios_p = &loop_termios;
	char	inbuf[_POSIX_MAX_INPUT];
	pid_t	pid;

	setup(E_SETTABLE);
	funct(E_SETTABLE);

	assertion(53, UNUSED);     		/*  Assertion text is identical to that
										of interface[69].
									*/

	if(GTI_NOT_PROVIDED) {
		GTI_NOT_PROVIDED_RESULT(54, BASE)
		GTI_NOT_PROVIDED_RESULT(55, BASE)
		done();
	}

	SIGNAL(SIGHUP, SIG_IGN);

														/* CLOCAL */
	assertion(55, BASE);
	start
		ENABLE_PSYNC

		prep("Fork process.");
		start
			sv_flush();
			pid = Zfork();
		finis

		if(pid == (pid_t)0) {
			exit_on(ERROR);
			prep("Open PORT_LOOP, set HUPCL and CLOCAL flag.");
			prep("Write out two blocks of data to PORT_LOOP.");
			start
				loop_fildes = Zopen(PORT_LOOP, O_RDWR);
				loop_init(loop_fildes, loop_termios_p);
				loop_termios_p->c_cflag |= (HUPCL | CLOCAL);
				Ztcsetattr(loop_fildes, TCSAFLUSH, loop_termios_p);
	
				SET_TIMEOUT
					WAIT_PSYNCA;		/* Parent completes initialization. */
				CLEAR_ALARM
	
				expecting(Strlen);
				Zwrite(loop_fildes, String, Strlen);
				expecting(Strlen);
				Zwrite(loop_fildes, String, Strlen);
				Ztcdrain(loop_fildes);
				SEND_PSYNC
			finis
	
			SET_TIMEOUT
				WAIT_PSYNCA;			/* Parent performs successful read */
			CLEAR_ALARM
	
			prep("Child process terminates.");
			start
				sv_flush();
			finis
	
			done();
		}
		prep("Open PORT_TTY, set HUPCL and CLOCAL flag.");
		prep("Catch SIGHUP.");
		start
			tty_fildes = Zopen(PORT_TTY, O_RDWR);
			tty_init(tty_fildes, tty_termios_p);

			tty_termios_p->c_cflag |= (HUPCL | CLOCAL);
			Ztcsetattr(tty_fildes, TCSAFLUSH, tty_termios_p);

			sig_rcvd = 0;
			SIGNAL(SIGHUP, sig_int);

			SEND_PSYNCA
		finis

		prep("Read a block of data.");
		start
			SET_TIMEOUT
				WAIT_PSYNC;		/* Child completed write of two data blocks. */
			CLEAR_ALARM

			dt_secs(TIME_ACQUIRE_XMITTED_DATA);

			SET_TIMEOUT
				expecting(Strlen);
				Zread(tty_fildes, inbuf, Strlen);
			CLEAR_ALARM
		finis

		SEND_PSYNCA
		WAIT_FOR_PID(pid);
		SLEEP(GTI_LINE_CLOSE_DELAY);

		testing("Modem disconnect not detected when last process with the");
		testing("port open terminates.");
		start
			SET_TIMEOUT
				expecting(Strlen);
				Zread(tty_fildes, inbuf, _POSIX_MAX_INPUT);
			CLEAR_ALARM

			SET_ALARM(WAIT_FOR_TIME)
				read(tty_fildes, inbuf, _POSIX_MAX_INPUT);
			EXPECT_ALARM
		finis

		testing("SIGHUP signal not received.");
		start
			if(sig_rcvd != 0)
				error("SIGHUP signal received.");
		finis

		cleanup("Close PORT_TTY.");
		start
			Zclose(tty_fildes);
			SLEEP(GTI_LINE_CLOSE_DELAY)
		finis

		DISABLE_PSYNC
	finis

	if(GTI_MODEM_CONTROL == 0) {
		assertion(54, BASE);
		start
			not_implemented("modem control");
		finis

		done();
	}

								/* ~HUPCL and ~CLOCAL */
	assertion(54, BASE);
	start
		ENABLE_PSYNC
									/* Test when last process closes port. */
		prep("Fork process.");
		start
			sv_flush();
			pid = Zfork();
		finis

		if(pid == (pid_t)0) {
			exit_on(ERROR);
			prep("Open PORT_LOOP, clear HUPCL, and clear CLOCAL flag.");
			prep("Write out two blocks of data to PORT_LOOP.");
			start
				loop_fildes = Zopen(PORT_LOOP, O_RDWR);
				loop_init(loop_fildes, loop_termios_p);
				loop_termios_p->c_cflag &= ~HUPCL;
				loop_termios_p->c_cflag &= ~CLOCAL;
				Ztcsetattr(loop_fildes, TCSAFLUSH, loop_termios_p);
	
				SET_TIMEOUT
					WAIT_PSYNCA		/* Parent completed initialization. */
				CLEAR_ALARM
	
				expecting(Strlen);
				Zwrite(loop_fildes, String, Strlen);
				expecting(Strlen);
				Zwrite(loop_fildes, String, Strlen);
				Ztcdrain(loop_fildes);
				SEND_PSYNC
			finis
	
			SET_TIMEOUT
				WAIT_PSYNCA;		/* Parent performs successful read */
			CLEAR_ALARM
	
			prep("Close PORT_LOOP.");
			start
				sv_flush();
	
				Zclose(loop_fildes);
				SLEEP(GTI_LINE_CLOSE_DELAY)
	
				SEND_PSYNC;			/* Inform parent port has been closed. */
			finis
			SET_TIMEOUT
				WAIT_PSYNCA;		/* Wait for parent to complete test. */
			CLEAR_ALARM
	
			done();
		}
		prep("Open PORT_TTY, clear HUPCL, and clear CLOCAL flag.");
		start
			tty_fildes = Zopen(PORT_TTY, O_RDWR);
			tty_init(tty_fildes, tty_termios_p);

			tty_termios_p->c_cflag &= ~HUPCL;
									/* Monitor modem status lines */
			tty_termios_p->c_cflag &= ~CLOCAL;
			Ztcsetattr(tty_fildes, TCSAFLUSH, tty_termios_p);

			SEND_PSYNCA
		finis

		prep("Read a block of data.");
		start
			SET_TIMEOUT
				WAIT_PSYNC;		/* Child completed write of two data blocks. */
			CLEAR_ALARM

			dt_secs(TIME_ACQUIRE_XMITTED_DATA);

			SET_TIMEOUT
				expecting(Strlen);
				Zread(tty_fildes, inbuf, Strlen);
			CLEAR_ALARM
		finis

		SEND_PSYNCA

		SET_TIMEOUT
			WAIT_PSYNC;			/* Child closed port. */
		CLEAR_ALARM

		testing("Modem disconnect does not occur when last process with the");
		testing("port open closed the port.");
		start
			SET_TIMEOUT
							/*	POSIX.1, 7.1.1.11,
								"The last process to close a terminal device
								file shall cause any output to be sent to
								the device" ... .
							*/
				expecting(Strlen);
				Zread(tty_fildes, inbuf, _POSIX_MAX_INPUT);
			CLEAR_ALARM

			SET_ALARM(WAIT_FOR_TIME)
				read(tty_fildes, inbuf, _POSIX_MAX_INPUT);
			EXPECT_ALARM
		finis

		cleanup("Close PORT_TTY.");
		start
			SEND_PSYNCA
			Zclose(tty_fildes);
			SLEEP(GTI_LINE_CLOSE_DELAY)
		finis

		WAIT_FOR_PID(pid);


								/* Test for termination of child process. */
		prep("Fork process.");
		start
			sv_flush();
			pid = Zfork();
		finis

		if(pid == (pid_t)0) {
			exit_on(ERROR);
			prep("Open PORT_LOOP, clear HUPCL, and clear CLOCAL flag.");
			prep("Write out two blocks of data to PORT_LOOP.");
			start
				loop_fildes = Zopen(PORT_LOOP, O_RDWR);
				loop_init(loop_fildes, loop_termios_p);
				loop_termios_p->c_cflag &= ~HUPCL;
				loop_termios_p->c_cflag &= ~CLOCAL;
				Ztcsetattr(loop_fildes, TCSAFLUSH, loop_termios_p);
	
				SET_TIMEOUT
					WAIT_PSYNCA;	 /* Parent completes initialization. */
				CLEAR_ALARM
	
				expecting(Strlen);
				Zwrite(loop_fildes, String, Strlen);
				expecting(Strlen);
				Zwrite(loop_fildes, String, Strlen);
				Ztcdrain(loop_fildes);
				SEND_PSYNC
			finis
	
			SET_TIMEOUT
				WAIT_PSYNCA;		/* Parent performs successful read */
			CLEAR_ALARM
	
			prep("Child process terminates.");
			start
				sv_flush();
			finis
	
			done();
		}
		prep("Open PORT_TTY, clear HUPCL, and clear CLOCAL flag.");
		start
			tty_fildes = Zopen(PORT_TTY, O_RDWR);
			tty_init(tty_fildes, tty_termios_p);

			tty_termios_p->c_cflag &= ~HUPCL;
									/* Monitor modem status lines */
			tty_termios_p->c_cflag &= ~CLOCAL;
			Ztcsetattr(tty_fildes, TCSAFLUSH, tty_termios_p);

			SEND_PSYNCA
		finis

		prep("Read a block of data.");
		start
			SET_TIMEOUT
				WAIT_PSYNC;		/* Child completed write of two data blocks. */
			CLEAR_ALARM

			dt_secs(TIME_ACQUIRE_XMITTED_DATA);

			SET_TIMEOUT
				expecting(Strlen);
				Zread(tty_fildes, inbuf, Strlen);
			CLEAR_ALARM
		finis

		SEND_PSYNCA
		WAIT_FOR_PID(pid);
		SLEEP(GTI_LINE_CLOSE_DELAY);

		testing("Modem disconnect does not occur when last process with the");
		testing("port open terminates.");
		start
			SET_TIMEOUT
				expecting(Strlen);
				Zread(tty_fildes, inbuf, _POSIX_MAX_INPUT);
			CLEAR_ALARM

			SET_ALARM(WAIT_FOR_TIME)
				read(tty_fildes, inbuf, _POSIX_MAX_INPUT);
			EXPECT_ALARM
		finis

		cleanup("Close PORT_TTY and disconnect modem.");
		start
			tty_termios_p->c_cflag |= HUPCL;
			tty_termios_p->c_cflag &= ~CLOCAL;
			Ztcsetattr(tty_fildes, TCSAFLUSH, tty_termios_p);

			Zclose(tty_fildes);
			SLEEP(GTI_LINE_CLOSE_DELAY)
		finis

		DISABLE_PSYNC
	finis


	done();
}
