#include	<pcts_ass.h>

#include	<termios.h>
#include	<sv_env.h>

struct	sp_val	{
					const char	*name;
					const unsigned long value;
				} sp_vals1[] =	{
									"VERASE",	VERASE,
									"VINTR",	VINTR,
									"VKILL",	VKILL,
									"VQUIT",	VQUIT,
									"VSUSP",	VSUSP,
									"VSTART",	VSTART,
									"VSTOP",	VSTOP,
									"VMIN",		VMIN,
									"VTIME",	VTIME,
								},
#define	NUM_ENTRIES1 (sizeof(sp_vals1)/sizeof(sp_vals1[0]))

				  sp_vals2[] =	{
									"VERASE",	VERASE,
									"VINTR",	VINTR,
									"VKILL",	VKILL,
									"VQUIT",	VQUIT,
									"VSUSP",	VSUSP,
									"VSTART",	VSTART,
									"VSTOP",	VSTOP,
									"VEOF",		VEOF,
									"VEOL",		VEOL,
							};
#define	NUM_ENTRIES2 (sizeof(sp_vals2)/sizeof(sp_vals2[0]))


int	main(void)
{
	setup(E_SETTABLE);
	funct(E_SETTABLE);

	assertion(69, BASE);
	start
		testing("The subscripts VEOF, VEOL, VERASE, VINTR, VKILL, VMIN,");
		testing("VQUIT, VSUSP, VTIME, VSTART, and VSTOP  are defined in");
		testing("<termios.h>.");
		start
			/* Compiler test since these parameters are used in the global
			   area of this module.
			*/
		finis
	finis

	assertion(70, BASE);
	start
		testing("The subscripts VERASE, VINTR, VKILL, VQUIT, VSUSP, VSTART,");
		testing("and VSTOP are all distinct NCCS subscripts.  VMIN and VEOF");
		testing("are distinct from all the above and are less than NCCS.");
		testing("VTIME and VEOL are distinct from all the above but not");
		testing("necessarily from each other and are less than NCCS.");
		start
			int	i;

			UNIQUE_VALUES(sp_vals1, NUM_ENTRIES1);
			UNIQUE_VALUES(sp_vals2, NUM_ENTRIES2);

			if(VEOF == VTIME)
				error("Value of VEOF same as VTIME.");
			if(VEOL == VMIN)
				error("Value of VEOL same as VMIN.");
		
			for(i=0; i<NUM_ENTRIES1; i++)
				if(sp_vals1[i].value >= NCCS)
					error("%s has value %lu, NCCS has value %lu",
							sp_vals1[i].name,
							(unsigned long) sp_vals1[i].value,
							(unsigned long) NCCS);

			for(i=0; i<NUM_ENTRIES2; i++)
				if(sp_vals2[i].value >= NCCS)
					error("%s has value %lu, NCCS has value %lu",
							sp_vals2[i].name,
							(unsigned long) sp_vals2[i].value,
							(unsigned long) NCCS);
						
		finis
	finis

	done();
}
