#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<termios.h>
#include	<pcts_timer.h>

char String[] = "Four score and seven years ago";
#define	 Strlen	(sizeof(String)-1)

int main(void)
{
	int		tty_fildes, loop_fildes;
	struct	termios tty_termios, *tty_termios_p = &tty_termios,
					loop_termios, *loop_termios_p = &loop_termios;
	char	inbuf[_POSIX_MAX_INPUT];

	setup(E_SETTABLE);
	funct(E_SETTABLE);

	assertion(71, BASE);
	start
		GTI_NOT_PROVIDED_EXIT

		prep("Establish PORT_TTY as the control terminal and PORT_LOOP.");
		prep("Set PORT_TTY and PORT_LOOP to non-canonical, MIN=TIME=0.");
		prep("Set IXON flag for PORT_TTY.");
		start
			exit_on(ERROR);
			termios_prep(&tty_fildes, tty_termios_p, &loop_fildes,
							loop_termios_p);

			loop_termios_p->c_lflag &= ~ICANON;
					/* Return number of bytes requested or that available. */
			loop_termios_p->c_cc[VMIN] = 0;
			loop_termios_p->c_cc[VTIME] = 0;
			Ztcsetattr(loop_fildes, TCSAFLUSH, loop_termios_p);

			tty_termios_p->c_lflag &= ~ICANON;
					/* Return number of bytes requested or that available. */
			tty_termios_p->c_cc[VMIN] = 0;
			tty_termios_p->c_cc[VTIME] = 0;

			tty_termios_p->c_iflag |= IXON;
			Ztcsetattr(tty_fildes, TCSAFLUSH, tty_termios_p);
		finis

		testing("The STOP character obtained from the termios structure");
		testing("returned by tcgetattr() suspends output.");
		start
			Ztcgetattr(tty_fildes, tty_termios_p);
			SET_TIMEOUT
				WRITE_TTY_SCC(loop_fildes, tty_termios_p->c_cc[VSTOP]);
				Ztcdrain(loop_fildes);
				dt_secs(TIME_ACQUIRE_XMITTED_DATA);
			CLEAR_ALARM

			if(PCTS_GTI_BUFFERS_OUTPUT) {
				SET_TIMEOUT
					expecting(Strlen);
					Zwrite(tty_fildes, String, Strlen);
				CLEAR_ALARM
			} else {
				SET_TIMEOUT
					expecting(Strlen);
					Zwrite(tty_fildes, String, Strlen);
				EXPECT_ALARM
			}

					/* Allow data to be erroneously transmitted. */
			dt_secs(5);						/* 1/2 second delay. */

			SET_TIMEOUT
				expecting(0);
				Zread(loop_fildes, inbuf, _POSIX_MAX_INPUT);
			CLEAR_ALARM
		finis

		testing("The START character obtained from the termios structure");
		testing("returned by tcgetattr() restarts output.");
		start
			SET_TIMEOUT
				WRITE_TTY_SCC(loop_fildes, tty_termios_p->c_cc[VSTART]);
				Ztcdrain(loop_fildes);
			CLEAR_ALARM

			if(PCTS_GTI_BUFFERS_OUTPUT == 0) {
				expecting(Strlen);
				Zwrite(tty_fildes, String, Strlen);
			}

			SET_TIMEOUT
				Ztcdrain(tty_fildes);
				dt_secs(TIME_ACQUIRE_XMITTED_DATA);
			CLEAR_ALARM

										/* Read suspended output. */
			SET_TIMEOUT
				expecting(Strlen);
				Zread(loop_fildes, inbuf, Strlen);
			CLEAR_ALARM
		finis
	finis

	cleanup("Close terminal devices.");
	start
		SIGNAL(SIGHUP, SIG_IGN);
		Zclose(tty_fildes);
		Zclose(loop_fildes);
		SLEEP(GTI_LINE_CLOSE_DELAY)
	finis

	done();
}
