#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zfcntl.h>
#include	<sys/Ztimes.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<termios.h>
#include	<pcts_timer.h>

char String[] = "How now, brown cow?";
#define	Strlen	(sizeof(String) -1)

int main(void)
{
	int		tty_fildes, loop_fildes;
	struct	termios tty_termios, *tty_termios_p = &tty_termios,
					loop_termios, *loop_termios_p = &loop_termios;
	char	inbuf[_POSIX_MAX_INPUT];
	pid_t	pid;
	int		i;
	sigset_t	set;

	setup(E_TCFLOW);
	funct(E_TCFLOW);

	SIGNAL(SIGHUP, SIG_IGN);

	assertion(9, BASE);
	start
		GTI_NOT_PROVIDED_EXIT

		prep("Establish PORT_TTY as the control terminal and PORT_LOOP.");
		start
			exit_on(ERROR);
			termios_prep(&tty_fildes, tty_termios_p, &loop_fildes,
							loop_termios_p);
			tty_termios_p->c_iflag |= IXON;
			Ztcsetattr(tty_fildes, TCSANOW, tty_termios_p);
		finis

		for(i=0; i<2; i++) {
			if(i == 0) 
				prep("Set TOSTOP flag.");
			else
				prep("Clear TOSTOP flag.");
			start
				if(i == 0) 
					tty_termios_p->c_lflag |= TOSTOP;
				else
					tty_termios_p->c_lflag &= ~TOSTOP;
				Ztcsetattr(tty_fildes, TCSAFLUSH, tty_termios_p);
				Ztcsetattr(loop_fildes, TCSAFLUSH, loop_termios_p);
			finis
	
			if(PCTS_GTI_BUFFERS_OUTPUT) {
				prep("Write to control terminal (PORT_TTY).");
				start
					Ztcflow(tty_fildes, TCOOFF);
					expecting(Strlen);
					Zwrite(tty_fildes, String, Strlen);
				finis
			}
	
			FORK
				prep("Establish background process group with two processes.");
				start
					Zsetpgid((pid_t)0, (pid_t)0);
					SIGNAL(SIGTTOU, sig_int);
					sig_rcvd = 0;
				finis
	
				prep("Fork a child process.");
				start
					sv_flush();
					pid = Zfork();
				finis
	
				if(pid == (pid_t)0) {
					testing("Child process in background process group");
					testing("received SIGTTOU signal.");
					start
						sleep(WAIT_FOR_TIME);
						if(sig_rcvd == 0)
							error("Child process did not receive SIGTTOU.");
					finis
	
					done();
				}
		
				testing("Call to tcflow(), on the controlling terminal");
				testing("of the process, from a member of background");
				testing("process group that is not blocking nor ignoring");
				testing("the SIGTTOU signal when TOSTOP");
				if(i == 0) 
					testing("is set is unsuccessful.");
				else
					testing("is clear is unsuccessful.");
				start
					SIGUNBLOCK(set, SIGTTOU);
					SET_TIMEOUT
						expecting(FAILURE);
						Ztcflow(tty_fildes, TCOON);
					CLEAR_ALARM
				finis
	
				testing("SIGTTOU signal is sent to calling process.");
				start
					dt_secs(TIME_ACQUIRE_XMITTED_DATA);
					if(sig_rcvd == 0)
						error("Calling process did not receive SIGTTOU.");
				finis
	
				WAIT_FOR_PID(pid);
			KROF
	
			testing("Flow control blocked on output queue.");
			start
				size_t	n_read;
				SLEEP(2);		/* Do not timeout, avoid hanging tcdrain() */
				expecting(0);
				Zread(loop_fildes, inbuf, _POSIX_MAX_INPUT);
	
				SET_TIMEOUT
					Ztcflow(tty_fildes, TCOON);
					Ztcdrain(tty_fildes);
					for(n_read=0; n_read != Strlen;)
						n_read += Zread(loop_fildes, inbuf, _POSIX_MAX_INPUT);
				CLEAR_ALARM
			finis
		finis
	}

	cleanup("Close terminal devices.");
	start
		SIGNAL(SIGHUP, SIG_IGN);
		Zclose(loop_fildes);
		Zclose(tty_fildes);
		SLEEP(GTI_LINE_CLOSE_DELAY)
	finis
	
	done();
}
