#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zfcntl.h>
#include	<sys/Ztimes.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<termios.h>
#include	<pcts_timer.h>


int main(void)
{
	int		notty_fildes;
	int		tty_fildes, loop_fildes;
	struct	termios tty_termios, *tty_termios_p = &tty_termios,
					loop_termios, *loop_termios_p = &loop_termios;

	setup(E_TCFLUSH);
	funct(E_TCFLUSH);

	SIGNAL(SIGHUP, SIG_IGN);		/* Ignore hangups on PORTs. */

	assertion(12, BASE);
	start
		testing("Call tcflush() with an invalid file descriptor.");
		testing("Expect return value of -1 and errno set to [EBADF].");
		start
			expecting(-1);
			expecting(EBADF);
			Ztcflush(-1, TCIOFLUSH);
		finis
	finis


	if(GTI_NOT_PROVIDED) {
		GTI_NOT_PROVIDED_RESULT(13, BASE)
	}
	else {
		assertion(13, BASE);
		start
			testing("Call to tcflush() with an improper queue selector value.");
			testing("Expect a return value of -1 and errno set to [EINVAL].");
			start
				termios_prep(&tty_fildes, tty_termios_p, &loop_fildes,
									loop_termios_p);
				expecting(-1);
				expecting(EINVAL);
				Ztcflush(tty_fildes, -1);
			finis

			cleanup("Close terminal devices.");
			start
				SIGNAL(SIGHUP, SIG_IGN);
				Zclose(loop_fildes);
				Zclose(tty_fildes);
				SLEEP(GTI_LINE_CLOSE_DELAY)
			finis
		finis
	}

	assertion(14, BASE);
	start
		testing("Call to tcflush() when fildes is not a tty.");
		testing("Expect a return value of -1 and errno set to [ENOTTY].");
		start
			notty_fildes = temp_open("notspec", O_RDWR | O_CREAT, PERM_CTTY);
			expecting(-1);
			expecting(ENOTTY);
			Ztcflush(notty_fildes, TCIOFLUSH);
		finis
	finis

	done();
}
