#include	<pcts.h>

#include	<Zunistd.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<termios.h>
#include	<pcts_timer.h>


int main(void)
{
	int		tty_fildes, loop_fildes;
	struct	termios tty_termios, *tty_termios_p = &tty_termios,
					loop_termios, *loop_termios_p = &loop_termios;
	pid_t	xx_pgrp, pid;

	setup(E_TCGETPGRP);
	funct(E_TCGETPGRP);

	if(GTI_NOT_PROVIDED) {
		GTI_NOT_PROVIDED_RESULT(5, BASE)
		done();
	}

	assertion(5, BASE);
	start
		ENABLE_PSYNC
		FORK
			prep("Establish PORT_TTY as the control terminal and PORT_LOOP.");
			start
					/*	Establish a new session and a controlling terminal. */
				termios_prep(&tty_fildes, tty_termios_p, &loop_fildes,
								loop_termios_p);
				tty_termios_p->c_lflag &= ~TOSTOP;
				Ztcsetattr(tty_fildes, TCSANOW, tty_termios_p);
			finis

			prep("Fork a child.");
			start
				sv_flush();
				pid = Zfork();
			finis

			if(pid == (pid_t)0) {
				testing("When a call to tcgetpgrp() is made from a process");
				testing("that is a member of a session which has no");
				testing("foreground process group, then tcgetpgrp() returns");
				testing("a value greater than 1 that does not match the");
				testing("process group of any existing process.");
				start
					exit_on(ERROR);
					Zsetpgid((pid_t)0, (pid_t)0);
					message(
						"Current pgrp_ID of foreground process group is %ld.\n",
						(long) Ztcgetpgrp(tty_fildes));

					SEND_PSYNC

					SET_TIMEOUT
						WAIT_PSYNCA;
								/* Child process is foreground process. */
						message(
						"Updated pgrp_ID of foreground process group is %ld.\n",
						(long) Ztcgetpgrp(tty_fildes));
					CLEAR_ALARM
				finis

				done();
			}
			SET_TIMEOUT
				WAIT_PSYNC
			CLEAR_ALARM

							/*	Parent process becomes background process. */
			Ztcsetpgrp(tty_fildes, pid);
			SEND_PSYNCA
			WAIT_FOR_PID(pid);	/*	Wait for foreground process to exit. */

			xx_pgrp = Ztcgetpgrp(tty_fildes);
			if(xx_pgrp <= 1)
				error("Value returned by tcgetpgrp() was %ld.", (long) xx_pgrp);
			if(xx_pgrp == getpgrp())
				error(
				"Value returned by tcgetpgrp() was process's process group.");
		KROF

		DISABLE_PSYNC

		SLEEP(GTI_LINE_CLOSE_DELAY);
	finis

	done();
}
