#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zfcntl.h>
#include	<sys/Ztimes.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<termios.h>
#include	<pcts_timer.h>


char String[] = "How now, brown cow?\n";
#define	Strlen	(sizeof(String) -1)

int main(void)
{
	int		tty_fildes, loop_fildes;
	struct	termios tty_termios, *tty_termios_p = &tty_termios,
					loop_termios, *loop_termios_p = &loop_termios;
	char	inbuf[_POSIX_MAX_INPUT];
	pid_t	pid;
	sigset_t	set;

	setup(E_TCSETATTR);
	funct(E_TCSETATTR);

	if(GTI_NOT_PROVIDED) {
		GTI_NOT_PROVIDED_RESULT(14, BASE)
		GTI_NOT_PROVIDED_RESULT(15, BASE)
		done();
	}


	SIGNAL(SIGHUP, SIG_IGN);		/* Ignore hangups on PORTs. */

	assertion(14, BASE);
	start
		prep("Establish PORT_TTY as the control terminal and PORT_LOOP.");
		start
			exit_on(ERROR);

			termios_prep(&tty_fildes, tty_termios_p, &loop_fildes,
							loop_termios_p);
							/* Set TOSTOP before becoming background process. */
			tty_termios_p->c_lflag |= TOSTOP;
			Ztcsetattr(tty_fildes, TCSAFLUSH, tty_termios_p);
		finis

		prep("Write to PORT_LOOP.");
		start
			expecting(Strlen);
			Zwrite(loop_fildes, String, Strlen);
			Ztcdrain(loop_fildes);
		finis

		FORK
			prep("Establish background process group with two processes.");
			start
				Zsetpgid((pid_t)0, (pid_t)0);
				SIGNAL(SIGTTOU, sig_int);
				sig_rcvd = 0;
			finis

			prep("Fork a child process.");
			start
				sv_flush();
				pid = Zfork();
			finis

			if(pid == (pid_t)0) {
				testing("Child process in background process group");
				testing("did not receive SIGTTOU signal.");
				start
					SLEEP(WAIT_FOR_TIME);
					if(sig_rcvd != 0)
						error("Child process received SIGTTOU.");
				finis

				done();
			}
	
			testing("Call to tcsetattr(), on the controlling terminal of");
			testing("the process, from a member of a background");
			testing("process group that is blocking the SIGTTOU signal");
			testing("when TOSTOP is set is successful.");
			start
				SIGBLOCK(set, SIGTTOU);
				SET_TIMEOUT
					expecting(Strlen);
					Zwrite(loop_fildes, String, Strlen);
					Ztcdrain(loop_fildes);

					tty_termios_p->c_oflag |= OPOST;
					Ztcsetattr(tty_fildes, TCSAFLUSH, tty_termios_p);
				CLEAR_ALARM
			finis

			testing("SIGTTOU signal not sent to calling process.");
			start
				dt_secs(1);
				if(sig_rcvd != 0)
					error("Calling process received SIGTTOU.");
			finis

			testing("Terminal attribute is changed.");
			start
				Ztcgetattr(tty_fildes, tty_termios_p);
				if((tty_termios_p->c_oflag & OPOST) != OPOST)
					error("Terminal attribute was not set.");
			finis

			WAIT_FOR_PID(pid);
		KROF

									/* Repeat for TOSTOP flag clear. */
		prep("Clear TOSTOP flag.");
		start
						/* Clear TOSTOP before becoming background process. */
			Ztcgetattr(loop_fildes, loop_termios_p);
			loop_termios_p->c_lflag &= ~TOSTOP;
			Ztcsetattr(loop_fildes, TCSAFLUSH, loop_termios_p);
		finis

		FORK
			prep("Establish background process group with two processes.");
			start
				Zsetpgid((pid_t)0, (pid_t)0);
				SIGNAL(SIGTTOU, sig_int);
				sig_rcvd = 0;
			finis

			prep("Fork a child process.");
			start
				sv_flush();
				pid = Zfork();
			finis

			if(pid == (pid_t)0) {
				testing("Child process in background process group");
				testing("did not receive SIGTTOU signal.");
				start
					SLEEP(WAIT_FOR_TIME);
					if(sig_rcvd != 0)
						error("Child process received SIGTTOU.");
				finis

				done();
			}
	
			testing("Call to tcsetattr(), on the controlling terminal of");
			testing("the process, from a member of a background");
			testing("process group that is blocking the SIGTTOU signal");
			testing("when TOSTOP is clear is successful.");
			start
				SIGBLOCK(set, SIGTTOU);
				SET_TIMEOUT
					tty_termios_p->c_oflag |= OPOST;
					Ztcsetattr(tty_fildes, TCSAFLUSH, tty_termios_p);
				CLEAR_ALARM
			finis

			testing("SIGTTOU signal not sent to calling process.");
			start
				dt_secs(1);
				if(sig_rcvd != 0)
					error("Calling process received SIGTTOU.");
			finis

			testing("Terminal attribute is changed.");
			start
				Ztcgetattr(tty_fildes, tty_termios_p);
				if((tty_termios_p->c_oflag & OPOST) != OPOST)
					error("Terminal attribute was not set.");
			finis
	
			WAIT_FOR_PID(pid);
		KROF

		prep("Write 'NL' to PORT_LOOP.");
		start
			expecting(sizeof(char));
			Zwrite(loop_fildes, "\n", sizeof(char));
			Ztcdrain(loop_fildes);
		finis

		testing("PORT_TTY queue was flushed.");
		start
			SET_TIMEOUT
				expecting(1);
				Zread(tty_fildes, inbuf, _POSIX_MAX_INPUT);
			CLEAR_ALARM
		finis
	finis

	assertion(15, BASE);
	start
		prep("Set TOSTOP flag.");
		start
			Ztcgetattr(tty_fildes, tty_termios_p);
			tty_termios_p->c_lflag |= TOSTOP;
			Ztcsetattr(tty_fildes, TCSAFLUSH, tty_termios_p);
		finis

		prep("Write to PORT_LOOP.");
		start
			expecting(Strlen);
			Zwrite(loop_fildes, String, Strlen);
			Ztcdrain(loop_fildes);
		finis

		FORK
			prep("Establish background process group with two processes.");
			start
				Zsetpgid((pid_t)0, (pid_t)0);
				SIGNAL(SIGTTOU, sig_int);
				sig_rcvd = 0;
			finis

			prep("Fork a child process.");
			start
				sv_flush();
				pid = Zfork();
			finis

			if(pid == (pid_t)0) {
				testing("Child process in background process group");
				testing("did not receive SIGTTOU signal.");
				start
					SLEEP(WAIT_FOR_TIME);
					if(sig_rcvd != 0)
						error("Child process received SIGTTOU.");
				finis

				done();
			}
	
			testing("Call to tcsetattr(), on the controlling terminal of");
			testing("the process, from a member of a background");
			testing("process group that is ignoring the SIGTTOU signal");
			testing("when TOSTOP is set is successful.");
			start
				SIGNAL(SIGTTOU, SIG_IGN);
				SET_TIMEOUT
					expecting(Strlen);
					Zwrite(loop_fildes, String, Strlen);
					Ztcdrain(loop_fildes);

					tty_termios_p->c_oflag |= OPOST;
					Ztcsetattr(tty_fildes, TCSAFLUSH, tty_termios_p);
				CLEAR_ALARM
			finis

			testing("SIGTTOU signal not sent to calling process.");
			start
				dt_secs(1);
				if(sig_rcvd != 0)
					error("Calling process received SIGTTOU.");
			finis

			testing("Terminal attribute is changed.");
			start
				Ztcgetattr(tty_fildes, tty_termios_p);
				if((tty_termios_p->c_oflag & OPOST) != OPOST)
					error("Terminal attribute was not set.");
			finis

			WAIT_FOR_PID(pid);
		KROF

									/* Repeat for TOSTOP flag clear. */
		prep("Clear TOSTOP flag.");
		start
						/* Clear TOSTOP before becoming background process. */
			Ztcgetattr(loop_fildes, loop_termios_p);
			loop_termios_p->c_lflag &= ~TOSTOP;
			Ztcsetattr(loop_fildes, TCSAFLUSH, loop_termios_p);
		finis

		FORK
			prep("Establish background process group with two processes.");
			start
				Zsetpgid((pid_t)0, (pid_t)0);
				SIGNAL(SIGTTOU, sig_int);
				sig_rcvd = 0;
			finis

			prep("Fork a child process.");
			start
				sv_flush();
				pid = Zfork();
			finis

			if(pid == (pid_t)0) {
				testing("Child process in background process group");
				testing("did not receive SIGTTOU signal.");
				start
					SLEEP(WAIT_FOR_TIME);
					if(sig_rcvd != 0)
						error("Child process received SIGTTOU.");
				finis

				done();
			}
	
			testing("Call to tcsetattr(), on the controlling terminal of");
			testing("the process, from a member of a background");
			testing("process group that is ignoring the SIGTTOU signal");
			testing("when TOSTOP is clear is successful.");
			start
				SIGNAL(SIGTTOU, SIG_IGN);
				SET_TIMEOUT
					tty_termios_p->c_oflag |= OPOST;
					Ztcsetattr(tty_fildes, TCSAFLUSH, tty_termios_p);
				CLEAR_ALARM
			finis

			testing("SIGTTOU signal not sent to calling process.");
			start
				dt_secs(1);
				if(sig_rcvd != 0)
					error("Calling process received SIGTTOU.");
			finis

			testing("Terminal attribute is changed.");
			start
				Ztcgetattr(tty_fildes, tty_termios_p);
				if((tty_termios_p->c_oflag & OPOST) != OPOST)
					error("Terminal attribute was not set.");
			finis
	
			WAIT_FOR_PID(pid);
		KROF

		prep("Write 'NL' to PORT_LOOP.");
		start
			expecting(sizeof(char));
			Zwrite(loop_fildes, "\n", sizeof(char));
			Ztcdrain(loop_fildes);
		finis

		testing("PORT_TTY queue was flushed.");
		start
			SET_TIMEOUT
				expecting(1);
				Zread(tty_fildes, inbuf, _POSIX_MAX_INPUT);
			CLEAR_ALARM
		finis
	finis

	cleanup("Close terminal devices.");
	start
		SIGNAL(SIGHUP, SIG_IGN);
		Zclose(loop_fildes);
		Zclose(tty_fildes);
		SLEEP(GTI_LINE_CLOSE_DELAY)
	finis

	done();
}
