#include	<pcts_ass.h>
#include	<FIPS151.h>

#include	<stdio.h>

#include	<sv_env.h>

#undef	ARG_MAX
#undef	CHILD_MAX
#undef	OPEN_MAX
#undef	_SSIZE_MAX
#undef	STREAM_MAX
#undef	TZNAME_MAX
#include	<limits.h>

int	main(void)
{
    setup(E_NUM_LMTS);
    funct(E_NUM_LMTS);

	assertion(4, BASE);
	start
#ifdef	ARG_MAX
		testing("When <limits.h> is included and ARG_MAX is defined,");
		testing("then {ARG_MAX} is not less than {_POSIX_ARG_MAX}.");
		start
			if(ARG_MAX < _POSIX_ARG_MAX)
				error("%s\n%s%ld\n%s%ld\n",
					"{ARG_MAX} less than minimum value.",
					"Minimum expected:	",
					(long)_POSIX_ARG_MAX,
					"Actual:	",
					(long)ARG_MAX);
		finis
#else
		not_implemented("ARG_MAX in <limits.h>");
#endif
	finis

	assertion(5, BASE);
	start
#ifdef	CHILD_MAX
		testing("When <limits.h> is included and CHILD_MAX is defined,");
		testing("then {CHILD_MAX} is not less than {_POSIX_CHILD_MAX}.");
		start
			if(CHILD_MAX < _POSIX_CHILD_MAX)
				error("%s\n%s%ld\n%s%ld\n",
					"{CHILD_MAX} less than minimum value.",
					"Minimum expected:	",
					(long)_POSIX_CHILD_MAX,
					"Actual:	",
					(long)CHILD_MAX);
		finis

		testing("When <limits.h> is included and CHILD_MAX is defined,");
		testing("its value is not less than FIPS 151-2 required");
		testing("minimum which is %d.", FIPS151_CHILD_MAX);
		start
			if(CHILD_MAX < FIPS151_CHILD_MAX)
				error("%s\n%s%ld\n%s%ld\n",
					"{CHILD_MAX} less than minimum value.",
					"Minimum expected:	",
					(long)FIPS151_CHILD_MAX,
					"Actual:	",
					(long)CHILD_MAX);
		finis
#else
		not_implemented("CHILD_MAX in <limits.h>");
#endif
	finis

	assertion(6, BASE);
	start
#ifdef	OPEN_MAX
		testing("When <limits.h> is included and OPEN_MAX is defined,");
		testing("then {OPEN_MAX} is not less than {_POSIX_OPEN_MAX}.");
		start
			if(OPEN_MAX < _POSIX_OPEN_MAX)
				error("%s\n%s%ld\n%s%ld\n",
					"{OPEN_MAX} less than minimum value.",
					"Minimum expected:	",
					(long)_POSIX_OPEN_MAX,
					"Actual:	",
					(long)OPEN_MAX);
		finis

		testing("When <limits.h> is included and OPEN_MAX is defined,");
		testing("its value is not less than FIPS 151-2 required");
		testing("minimum which is %d.", FIPS151_OPEN_MAX);
		start
			if(OPEN_MAX < FIPS151_OPEN_MAX)
				error("%s\n%s%ld\n%s%ld\n",
					"{OPEN_MAX} less than minimum value.",
					"Minimum expected:	",
					(long)FIPS151_OPEN_MAX,
					"Actual:	",
					(long)OPEN_MAX);
		finis
#else
		not_implemented("OPEN_MAX in <limits.h>");
#endif
	finis

	assertion(7, BASE);
	start
#ifdef	STREAM_MAX
		testing("When <limits.h> is included and STREAM_MAX is defined,");
		testing("then {STREAM_MAX} is not less than {_POSIX_STREAM_MAX}.");
		start
			if(STREAM_MAX < _POSIX_STREAM_MAX)
				error("%s\n%s%ld\n%s%ld\n",
					"{STREAM_MAX} less than minimum value.",
					"Minimum expected:	",
					(long)_POSIX_STREAM_MAX,
					"Actual:	",
					(long)STREAM_MAX);
		finis
#else
		not_implemented("STREAM_MAX in <limits.h>");
#endif
	finis

	assertion(8, BASE);
	start
#ifdef	STREAM_MAX
		testing("When <limits.h> is included and STREAM_MAX is defined,");
		testing("then {STREAM_MAX} is equal to {FOPEN_MAX} as defined");
		testing("in the header <stdio.h>.");
		start
			if(STREAM_MAX != FOPEN_MAX)
				error("%s\n%s%ld\n%s%ld\n",
					"{STREAM_MAX} not equal to {FOPEN_MAX}.",
					"{STREAM_MAX} value is	",
					(long)STREAM_MAX,
					"{FOPEN_MAX} value is	",
					(long)FOPEN_MAX);
		finis
#else
		not_implemented("STREAM_MAX in <limits.h>");
#endif
	finis

	assertion(9, BASE);
	start
#ifdef	TZNAME_MAX
		testing("When <limits.h> is included and TZNAME_MAX is defined,");
		testing("then {TZNAME_MAX} is not less than {_POSIX_TZNAME_MAX}.");
		start
			if(TZNAME_MAX < _POSIX_TZNAME_MAX)
				error("%s\n%s%ld\n%s%ld\n",
					"{TZNAME_MAX} less than minimum value.",
					"Minimum expected:	",
					(long)_POSIX_TZNAME_MAX,
					"Actual:	",
					(long)TZNAME_MAX);
		finis
#else
		not_implemented("TZNAME_MAX in <limits.h>");
#endif
	finis

    done();
}
