#include	<pcts_ass.h>

#include	<unistd.h>

#include	<sv_env.h>


int	main(void)
{
    setup(E_SYM_CONST);
    funct(E_SYM_CONST);

	/*	Note assertions 6-8:
		{_POSIX_CHOWN_RESTRICTED}, {_POSIX_NO_TRUNC}, and {_POSIX_VDISABLE}
		are required to be supported for implementations that conform to
		FIPS 151-2.  If any of these constants are defined in <unistd.h>,
		then when their value is -1 FIPS 151-2 respective requirement is
		not met.  When their value is other than -1, additional information
		must be provided to ascertain if the respective FIPS 151-2 requirement
		is met.  This additional information is the required documentation
		assertions  of 2.9.4 D05 thru D07.
		
		These assertions have been changed to correlate to the requirements
		of FIPS 151-2.

	06(C) If {_POSIX_CHOWN_RESTRICTED} is defined when <unistd.h> is included:
             The value of {_POSIX_CHOWN_RESTRICTED} is other than -1.
	07(C) If {_POSIX_NO_TRUNC} is defined when <unistd.h> is included:
			  The value of {_POSIX_NO_TRUNC} is other than -1.
	08(C) If {_POSIX_VDISABLE} is defined when <unistd.h> is included:
			 The value of {_POSIX_VDISABLE} is other than -1.
			*/

	assertion(6, BASE);
    start
		prep("{_POSIX_CHOWN_RESTRICTED} defined in <unistd.h>?");
		start
		finis

#ifndef _POSIX_CHOWN_RESTRICTED
		yes_implemented("{_POSIX_CHOWN_RESTRICTED}");
#else
		testing("{_POSIX_CHOWN_RESTRICTED} is supported.");
		start
#if	_POSIX_CHOWN_RESTRICTED == -1
			error("{_POSIX_CHOWN_RESTRICTED} is defined as -1 in <unistd.h>.");
#endif
		finis
#endif
	finis


	assertion(7, BASE);
    start
		prep("{_POSIX_NO_TRUNC} defined in <unistd.h>?");
		start
		finis

#ifndef _POSIX_NO_TRUNC
		yes_implemented("{_POSIX_NO_TRUNC}");
#else
		testing("{_POSIX_NO_TRUNC} is supported.");
		start
#if	_POSIX_NO_TRUNC == -1
			error("{_POSIX_NO_TRUNC} is defined as -1 in <unistd.h>.");
#endif
		finis
#endif
	finis


	assertion(8, BASE);
    start
		prep("{_POSIX_VDISABLE} defined in <unistd.h>?");
		start
		finis

#ifndef _POSIX_VDISABLE
		yes_implemented("{_POSIX_VDISABLE}");
#else
		testing("{_POSIX_VDISABLE} is supported.");
		start
#if	_POSIX_VDISABLE == -1
			error("{_POSIX_VDISABLE} is defined as -1 in <unistd.h>.");
#endif
		finis
#endif
	finis

    done();
}
