#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<iso646_natv.h>

static	void cnv_natv(void);

#define	DEBUG

#define Root_uid	((uid_t **) (&sv_params[1].value))
#define Root_gid	((gid_t **) (&sv_params[2].value))
#define Bin_uid		((uid_t **) (&sv_params[3].value))
#define Bin_gid		((gid_t **) (&sv_params[4].value))
#define Uid			((uid_t **) (&sv_params[5].value))
#define Gid			((gid_t **) (&sv_params[6].value))
#define	MTIME_VALUE	"05321155400" 		/* UCT of Jan 1, 1993 */

#define	C_MAGIC	"070707"
struct	f_entries {
    char	*c_name;
    char	*c_dev;
    char	*c_ino;
    char	*c_mode;
	uid_t     **c_uid;
	gid_t     **c_gid;
    char	*c_nlink;
    char	*c_rdev;
    char	*c_mtime;
    char	*c_namesize;
    char	*c_filesize;
	} f_entry[] = {
		{				/* Entry 0	*/
		  "type_link_1",			/* c_name	*/
		  "000000",				/* c_dev	*/
		  "000000",				/* c_ino	*/
		  "100644",				/* c_mode	*/
		  Uid,					/* c_uid	*/
		  Gid,					/* c_gid	*/
		  "000002",				/* c_nlink	*/
		  "000000",				/* c_rdev	*/
		  MTIME_VALUE,			/* c_mtime	*/
		  "000014",				/* c_namesize	*/
		  "00000000001",		/* c_filesize	*/
		},
		{				/* Entry 1	*/
		  "type.d",				/* c_name	*/
		  "000000",				/* c_dev	*/
		  "000000",				/* c_ino	*/
		  "040700",				/* c_mode	*/
		  Uid,					/* c_uid	*/
		  Gid,					/* c_gid	*/
		  "000004",				/* c_nlink	*/
		  "000000",				/* c_rdev	*/
		  "",					/* c_mtime	*/
		  "000007",				/* c_namesize	*/
		  "00000000000",		/* c_filesize	*/
		},
		{				/* Entry 2	*/
		  "type.d/type_reg_L0",	/* c_name	*/
		  "000000",				/* c_dev	*/
		  "000000",				/* c_ino	*/
		  "100644",				/* c_mode	*/
		  Uid,					/* c_uid	*/
		  Gid,					/* c_gid	*/
		  "000001",				/* c_nlink	*/
		  "000000",				/* c_rdev	*/
		  MTIME_VALUE,			/* c_mtime	*/
		  "000023",				/* c_namesize	*/
		  "00000000000",		/* c_filesize	*/
		},
		{				/* Entry 3	*/
		  "type.d/type_reg_L8000",	/* c_name	*/
		  "000000",				/* c_dev	*/
		  "000000",				/* c_ino	*/
		  "100644",				/* c_mode	*/
		  Uid,					/* c_uid	*/
		  Gid,					/* c_gid	*/
		  "000001",				/* c_nlink	*/
		  "000000",				/* c_rdev	*/
		  MTIME_VALUE,			/* c_mtime	*/
		  "000026",				/* c_namesize	*/
		  "00000017500",		/* c_filesize	*/
		},
		{				/* Entry 4	*/
		  "type.d/type_reg_L4000",	/* c_name	*/
		  "000000",				/* c_dev	*/
		  "000000",				/* c_ino	*/
		  "100644",				/* c_mode	*/
		  Uid,					/* c_uid	*/
		  Gid,					/* c_gid	*/
		  "000001",				/* c_nlink	*/
		  "000000",				/* c_rdev	*/
		  MTIME_VALUE,			/* c_mtime	*/
		  "000026",				/* c_namesize	*/
		  "00000007640",		/* c_filesize	*/
		},
		{				/* Entry 5	*/
		  "type.d/type_link_2",	/* c_name	*/
		  "000000",				/* c_dev	*/
		  "000000",				/* c_ino	*/
		  "100644",				/* c_mode	*/
		  Uid,					/* c_uid	*/
		  Gid,					/* c_gid	*/
		  "000002",				/* c_nlink	*/
		  "000000",				/* c_rdev	*/
		  MTIME_VALUE,			/* c_mtime	*/
		  "000023",				/* c_namesize	*/
		  "00000000001",		/* c_filesize	*/
		},
		{				/* Entry 6	*/
		  "type.d/type_subdir.d",	/* c_name	*/
		  "000000",				/* c_dev	*/
		  "000000",				/* c_ino	*/
		  "040755",				/* c_mode	*/
		  Uid,					/* c_uid	*/
		  Gid,					/* c_gid	*/
		  "000002",				/* c_nlink	*/
		  "000000",				/* c_rdev	*/
		  "",					/* c_mtime	*/
		  "000025",				/* c_namesize	*/
		  "00000000000",		/* c_filesize	*/
		},
		{				/* Entry 7	*/
		  "type.d/type_subdir.d/type_reg_L0",
		  "000000",				/* c_dev	*/
		  "000000",				/* c_ino	*/
		  "100644",				/* c_mode	*/
		  Uid,					/* c_uid	*/
		  Gid,					/* c_gid	*/
		  "000001",				/* c_nlink	*/
		  "000000",				/* c_rdev	*/
		  MTIME_VALUE,			/* c_mtime	*/
		  "000041",				/* c_namesize	*/
		  "00000000000",		/* c_filesize	*/
		},
		{				/* Entry 8	*/
		  "type.d/mode_cks.d",
		  "000000",				/* c_dev	*/
		  "000000",				/* c_ino	*/
		  "040755",				/* c_mode	*/
		  Uid,					/* c_uid	*/
		  Gid,					/* c_gid	*/
		  "000002",				/* c_nlink	*/
		  "000000",				/* c_rdev	*/
		  "",					/* c_mtime	*/
		  "000022",				/* c_namesize	*/
		  "00000000000",		/* c_filesize	*/
		},
		{				/* Entry 9	*/
		  "type.d/mode_cks.d/S_IRUSR",
		  "000000",				/* c_dev	*/
		  "000000",				/* c_ino	*/
		  "100400",				/* c_mode	*/
		  Uid,					/* c_uid	*/
		  Gid,					/* c_gid	*/
		  "000001",				/* c_nlink	*/
		  "000000",				/* c_rdev	*/
		  MTIME_VALUE,			/* c_mtime	*/
		  "000032",				/* c_namesize	*/
		  "00000000000",		/* c_filesize	*/
		},
		{				/* Entry 10	*/
		  "type.d/mode_cks.d/S_IWUSR",
		  "000000",				/* c_dev	*/
		  "000000",				/* c_ino	*/
		  "100600",				/* c_mode	*/
		  Uid,					/* c_uid	*/
		  Gid,					/* c_gid	*/
		  "000001",				/* c_nlink	*/
		  "000000",				/* c_rdev	*/
		  MTIME_VALUE,			/* c_mtime	*/
		  "000032",				/* c_namesize	*/
		  "00000000000",		/* c_filesize	*/
		},
		{				/* Entry 11	*/
		  "type.d/mode_cks.d/S_IXUSR",
		  "000000",				/* c_dev	*/
		  "000000",				/* c_ino	*/
		  "100500",				/* c_mode	*/
		  Uid,					/* c_uid	*/
		  Gid,					/* c_gid	*/
		  "000001",				/* c_nlink	*/
		  "000000",				/* c_rdev	*/
		  MTIME_VALUE,			/* c_mtime	*/
		  "000032",				/* c_namesize	*/
		  "00000000000",		/* c_filesize	*/
		},
		{				/* Entry 12	*/
		  "type.d/mode_cks.d/S_IRGRP",
		  "000000",				/* c_dev	*/
		  "000000",				/* c_ino	*/
		  "100440",				/* c_mode	*/
		  Uid,					/* c_uid	*/
		  Gid,					/* c_gid	*/
		  "000001",				/* c_nlink	*/
		  "000000",				/* c_rdev	*/
		  MTIME_VALUE,			/* c_mtime	*/
		  "000032",				/* c_namesize	*/
		  "00000000000",		/* c_filesize	*/
		},
		{				/* Entry 13	*/
		  "type.d/mode_cks.d/S_IWGRP",
		  "000000",				/* c_dev	*/
		  "000000",				/* c_ino	*/
		  "100420",				/* c_mode	*/
		  Uid,					/* c_uid	*/
		  Gid,					/* c_gid	*/
		  "000001",				/* c_nlink	*/
		  "000000",				/* c_rdev	*/
		  MTIME_VALUE,			/* c_mtime	*/
		  "000032",				/* c_namesize	*/
		  "00000000000",		/* c_filesize	*/
		},
		{				/* Entry 14	*/
		  "type.d/mode_cks.d/S_IXGRP",
		  "000000",				/* c_dev	*/
		  "000000",				/* c_ino	*/
		  "100410",				/* c_mode	*/
		  Uid,					/* c_uid	*/
		  Gid,					/* c_gid	*/
		  "000001",				/* c_nlink	*/
		  "000000",				/* c_rdev	*/
		  MTIME_VALUE,			/* c_mtime	*/
		  "000032",				/* c_namesize	*/
		  "00000000000",		/* c_filesize	*/
		},
		{				/* Entry 15	*/
		  "type.d/mode_cks.d/all_perm_modes",
		  "000000",				/* c_dev	*/
		  "000000",				/* c_ino	*/
		  "100777",				/* c_mode	*/
		  Uid,					/* c_uid	*/
		  Gid,					/* c_gid	*/
		  "000001",				/* c_nlink	*/
		  "000000",				/* c_rdev	*/
		  MTIME_VALUE,			/* c_mtime	*/
		  "000041",				/* c_namesize	*/
		  "00000000000",		/* c_filesize	*/
		},
		{				/* Entry 16	*/
		  "type.d/mode_cks.d/S_IROTH",
		  "000000",				/* c_dev	*/
		  "000000",				/* c_ino	*/
		  "100404",				/* c_mode	*/
		  Uid,					/* c_uid	*/
		  Gid,					/* c_gid	*/
		  "000001",				/* c_nlink	*/
		  "000000",				/* c_rdev	*/
		  MTIME_VALUE,			/* c_mtime	*/
		  "000032",				/* c_namesize	*/
		  "00000000000",		/* c_filesize	*/
		},
		{				/* Entry 17	*/
		  "type.d/mode_cks.d/S_IWOTH",
		  "000000",				/* c_dev	*/
		  "000000",				/* c_ino	*/
		  "100402",				/* c_mode	*/
		  Uid,					/* c_uid	*/
		  Gid,					/* c_gid	*/
		  "000001",				/* c_nlink	*/
		  "000000",				/* c_rdev	*/
		  MTIME_VALUE,			/* c_mtime	*/
		  "000032",				/* c_namesize	*/
		  "00000000000",		/* c_filesize	*/
		},
		{				/* Entry 18	*/
		  "type.d/mode_cks.d/S_IXOTH",
		  "000000",				/* c_dev	*/
		  "000000",				/* c_ino	*/
		  "100401",				/* c_mode	*/
		  Uid,					/* c_uid	*/
		  Gid,					/* c_gid	*/
		  "000001",				/* c_nlink	*/
		  "000000",				/* c_rdev	*/
		  MTIME_VALUE,			/* c_mtime	*/
		  "000032",				/* c_namesize	*/
		  "00000000000",		/* c_filesize	*/
		},
		{				/* Entry 19	*/
		  "type.d/mode_cks.d/S_ISUID",
		  "000000",				/* c_dev	*/
		  "000000",				/* c_ino	*/
		  "104540",				/* c_mode	*/
		  Bin_uid,				/* c_uid	*/
		  Gid,					/* c_gid	*/
		  "000001",				/* c_nlink	*/
		  "000000",				/* c_rdev	*/
		  MTIME_VALUE,			/* c_mtime	*/
		  "000032",				/* c_namesize	*/
		  "00000000000",		/* c_filesize	*/
		},
		{				/* Entry 20	*/
		  "type.d/mode_cks.d/S_ISGID",
		  "000000",				/* c_dev	*/
		  "000000",				/* c_ino	*/
		  "102410",				/* c_mode	*/
		  Uid,					/* c_uid	*/
		  Bin_gid,				/* c_gid	*/
		  "000001",				/* c_nlink	*/
		  "000000",				/* c_rdev	*/
		  MTIME_VALUE,			/* c_mtime	*/
		  "000032",				/* c_namesize	*/
		  "00000000000",		/* c_filesize	*/
		},
		{				/* Entry 21	*/
		  "type.d/mode_cks.d/S_ISFIFO",
		  "000000",				/* c_dev	*/
		  "000000",				/* c_ino	*/
		  "010644",				/* c_mode	*/
		  Uid,					/* c_uid	*/
		  Gid,					/* c_gid	*/
		  "000001",				/* c_nlink	*/
		  "000000",				/* c_rdev	*/
		  "",					/* c_mtime	*/
		  "000033",				/* c_namesize	*/
		  "00000000000",		/* c_filesize	*/
		},
		{				/* Entry 22	*/
		  "fnames.d",
		  "000000",				/* c_dev	*/
		  "000000",				/* c_ino	*/
		  "040700",				/* c_mode	*/
		  Uid,					/* c_uid	*/
		  Gid,					/* c_gid	*/
		  "000001",				/* c_nlink	*/
		  "000000",				/* c_rdev	*/
		  MTIME_VALUE,			/* c_mtime	*/
		  "000011",				/* c_namesize	*/
		  "00000000000",		/* c_filesize	*/
		},
		{				/* Entry 23	*/
		  "fnames.d/ABCDEFGHIJLKM",
		  "000000",				/* c_dev	*/
		  "000000",				/* c_ino	*/
		  "100400",				/* c_mode	*/
		  Uid,					/* c_uid	*/
		  Gid,					/* c_gid	*/
		  "000001",				/* c_nlink	*/
		  "000000",				/* c_rdev	*/
		  MTIME_VALUE,			/* c_mtime	*/
		  "000027",				/* c_namesize	*/
		  "00000000000",		/* c_filesize	*/
		},
		{				/* Entry 24	*/
		  "fnames.d/NOPQRSTUVWXYZ",
		  "000000",				/* c_dev	*/
		  "000000",				/* c_ino	*/
		  "100400",				/* c_mode	*/
		  Uid,					/* c_uid	*/
		  Gid,					/* c_gid	*/
		  "000001",				/* c_nlink	*/
		  "000000",				/* c_rdev	*/
		  MTIME_VALUE,			/* c_mtime	*/
		  "000027",				/* c_namesize	*/
		  "00000000000",		/* c_filesize	*/
		},
		{				/* 	Entry 25	*/
		  "fnames.d/abcdefghijlkm",
		  "000000",					/* c_dev	*/
		  "000000",					/* c_ino	*/
		  "100400",					/* c_mode	*/
		  Uid,						/* c_uid	*/
		  Gid,						/* c_gid	*/
		  "000001",					/* c_nlink	*/
		  "000000",					/* c_rdev	*/
		  MTIME_VALUE,				/* c_mtime	*/
		  "000027",					/* c_namesize	*/
		  "00000000000",			/* c_filesize	*/
		},
		{				/* Entry 26	*/
		  "fnames.d/nopqrstuvwxyz",
		  "000000",				/* c_dev	*/
		  "000000",				/* c_ino	*/
		  "100400",				/* c_mode	*/
		  Uid,					/* c_uid	*/
		  Gid,					/* c_gid	*/
		  "000001",				/* c_nlink	*/
		  "000000",				/* c_rdev	*/
		  MTIME_VALUE,			/* c_mtime	*/
		  "000027",				/* c_namesize	*/
		  "00000000000",		/* c_filesize	*/
		},
		{				/* Entry 27	*/
		  "fnames.d/0123456789._-",
		  "000000",				/* c_dev	*/
		  "000000",				/* c_ino	*/
		  "100400",				/* c_mode	*/
		  Uid,					/* c_uid	*/
		  Gid,					/* c_gid	*/
		  "000001",				/* c_nlink	*/
		  "000000",				/* c_rdev	*/
		  MTIME_VALUE,			/* c_mtime	*/
		  "000027",				/* c_namesize	*/
		  "00000000000",		/* c_filesize	*/
		},

					/*	Section 10.1.12.5, "C_ISDIR, C_ISFIFO, and C_ISREG
						shall be supported ... .  Additional file types may
						be supported; however, such files should not be
						written on archives intended for transport to
						portable systems.

						Deleted entries for block and character special files.
					*/
						
								
		{				/* Trailor Entry */
		  "TRAILER!!!",
		  "000000",				/* c_dev	*/
		  "000000",				/* c_ino	*/
		  "100644",				/* c_mode	*/
		  0,					/* c_uid	*/
		  0,					/* c_gid	*/
		  "000001",				/* c_nlink	*/
		  "000000",				/* c_rdev	*/
		  "",					/* c_mtime	*/
		  "000013",				/* c_namesize	*/
		  "00000000000",		/* c_filesize	*/
		},
	};
#define	NUM_ENTRIES	(sizeof(f_entry)/sizeof(struct f_entries))

#define	C_MAGIC_LEN		6
#define	C_DEV_LEN		6
#define	C_INO_LEN		6
#define	C_MODE_LEN		6
#define	C_TYPE_LEN		2
#define	C_ISFIFO		01
#define	C_ISCHR			02
#define	C_ISDIR			04
#define	C_ISBLK			06
#define	C_ISREG			010
#define	C_UID_LEN		6
#define	C_GID_LEN		6
#define	C_NLINK_LEN		6
#define	C_RDEV_LEN		6
#define	C_MTIME_LEN		11
#define	C_NAMESIZE_LEN		6
#define	C_FILESIZE_LEN		11

#define	C_MAGIC_OFSET		0
#define	C_DEV_OFSET		6
#define	C_INO_OFSET		12
#define	C_MODE_OFSET		18
#define	C_UID_OFSET		24
#define	C_GID_OFSET		30
#define	C_NLINK_OFSET		36
#define	C_RDEV_OFSET		42
#define	C_MTIME_OFSET		48
#define	C_NAMESIZ_OFSET		59
#define	C_FILESIZE_OFSET	65

#define	CPIO_TYPE_OFFSET	0
#define	CPIO_TYPE_LEN		2
#define	CPIO_ISDIR		4
#define	CPIO_ISFIFO		1
#define	CPIO_ISREG		010
#define	CPIO_ISBLK		6
#define	CPIO_ISCHR		2

#define	CPIO_MODE_OFFSET	3
#define	CPIO_MODE_LEN		3
#define	CPIO_IRUSR		0400
#define	CPIO_IWUSR		0200
#define	CPIO_IXUSR		0100
#define	CPIO_IRGRP		040
#define	CPIO_IWGRP		020
#define	CPIO_IXGRP		010
#define	CPIO_IROTH		04
#define	CPIO_IWOTH		02
#define	CPIO_IXOTH		01

#define	CPIO_SETUID_OFFSET	2
#define	CPIO_SETUID_LEN		1
#define	CPIO_ISUID		4
#define	CPIO_ISGID		2

#define	S_ISDIR_ENTRY	1
#define	S_ISREG_ENTRY	3
#define	S_ISFIFO_ENTRY	21
#define	S_ISBLK_ENTRY	22
#define	S_ISCHR_ENTRY	23
#define	S_IRUSR_ENTRY	9
#define	S_IWUSR_ENTRY	10
#define	S_IXUSR_ENTRY	11
#define	S_IRGRP_ENTRY	12
#define	S_IWGRP_ENTRY	13
#define	S_IXGRP_ENTRY	14
#define	S_IROTH_ENTRY	16
#define	S_IWOTH_ENTRY	17
#define	S_IXOTH_ENTRY	18
#define	S_ISUID_ENTRY	19
#define	S_ISGID_ENTRY	20

struct	hdr_ent {
		char	c_magic[C_MAGIC_LEN];
		char	c_dev[C_DEV_LEN];
		char	c_ino[C_INO_LEN];
		char	c_mode[C_MODE_LEN];
		char	c_uid[C_UID_LEN];
		char	c_gid[C_GID_LEN];
		char	c_nlink[C_NLINK_LEN];
		char	c_rdev[C_RDEV_LEN];
		char	c_mtime[C_MTIME_LEN];
		char	c_namesize[C_NAMESIZE_LEN];
		char	c_filesize[C_FILESIZE_LEN];
	} *hdr;
#define	HDR_SIZE	(sizeof(struct hdr_ent))

static	char fn_hdr[512];
static	char data_buf[10000];

static	int	fd, i;

static	int atoo(char *, int);
static	void is_num(char *, int, char *);



int	main(void)
{
	setup(E_CPIO);
	funct(E_CPIO);

	assertion(1, BASE);
	start
		exit_on(ERROR);
		prep("Allocate required storage area.");
		start
			if((hdr = (struct hdr_ent *) calloc(NUM_ENTRIES, HDR_SIZE)) == NULL)
				error("Couldn't calloc() hdr.\n");
		finis

			/*	The CPIO archive format contains a header for each file.
				The contents of the header is in the order specified below.
					c_magic		6 bytes
					c_dev		6 bytes
					c_ino		6 bytes
					c_mode		6 bytes
					c_uid		6 bytes
					c_gid		6 bytes
					c_nlink		6 bytes
					c_rdev		6 bytes
					c_mtime		11 bytes
					c_namesize	6 bytes
					c_filesize	11 bytes
			*/

		cnv_natv();

		testing("Read header files for all file entries in archive.");
		start
			int	cnt;
			int	f_type;

			exit_on(ERROR);
			for(i=0; i<NUM_ENTRIES; i++)  {
				read(fd, hdr[i].c_magic, C_MAGIC_LEN);
				read(fd, hdr[i].c_dev, C_DEV_LEN);
				read(fd, hdr[i].c_ino, C_INO_LEN);
				read(fd, hdr[i].c_mode, C_MODE_LEN);
				read(fd, hdr[i].c_uid, C_UID_LEN);
				read(fd, hdr[i].c_gid, C_GID_LEN);
				read(fd, hdr[i].c_nlink, C_NLINK_LEN);
				read(fd, hdr[i].c_rdev, C_RDEV_LEN);
				read(fd, hdr[i].c_mtime, C_MTIME_LEN);
				read(fd, hdr[i].c_namesize, C_NAMESIZE_LEN);
				read(fd, hdr[i].c_filesize, C_FILESIZE_LEN);

#ifdef	DEBUG
testing("Data read for Entry %d:\n", i);
testing("\tc_magic %6.6s\n", hdr[i].c_magic);
sv_flush();
testing("\tc_dev %6.6s\n", hdr[i].c_dev);
sv_flush();
testing("\tc_ino %6.6s\n", hdr[i].c_ino);
sv_flush();
testing("\tc_mode %6.6s\n", hdr[i].c_mode);
sv_flush();
testing("\tc_uid %6.6s\n", hdr[i].c_uid);
sv_flush();
testing("\tc_gid %6.6s\n", hdr[i].c_gid);
sv_flush();
testing("\tc_nlink %6.6s\n", hdr[i].c_nlink);
sv_flush();
testing("\tc_rdev %6.6s\n", hdr[i].c_rdev);
sv_flush();
testing("\tc_mtime %11.11s\n", hdr[i].c_mtime);
sv_flush();
testing("\tc_namesize %6.6s\n", hdr[i].c_namesize);
sv_flush();
testing("\tc_filesize %11.11s\n", hdr[i].c_filesize);
sv_flush();
#endif

				continue_on(ERROR);
				if(strncmp(f_entry[i].c_namesize, hdr[i].c_namesize,
															C_NAMESIZE_LEN) )
					error("Entry %d.\n%s\n%s%6.6s\n%s%6.6s\n",
							i,
							"Incorrect value for c_namesize detected.",
							"Expected the bytes: ",
							f_entry[i].c_namesize,
							"Actual bytes are: ",
							hdr[i].c_namesize);

				cnt = atoo(f_entry[i].c_namesize, C_NAMESIZE_LEN);
				expecting(cnt);
				Zread(fd, fn_hdr, cnt);		/* Assertion test #14 */

#ifdef	DEBUG
testing("\tc_name %*s\n", cnt, fn_hdr);
sv_flush();
#endif

				if(strncmp(f_entry[i].c_name, fn_hdr, cnt))
					error("Entry %d.\n%s\n%s%6.6s\n%s%6.6s\n",
							i,
							"Incorrect pathname for c_name.",
							"Expected the path: ",
							f_entry[i].c_name,
							"Actual path is: ",
							fn_hdr);
	
				exit_on(ERROR);
				/*	Don't check filesize on Block and Character special files.
					See Section 10.1.2.4, POSIX Standard, size is
					implementation defined.
				*/
				f_type = atoo(f_entry[i].c_mode, C_TYPE_LEN);
				if(!( (f_type == C_ISBLK) || (f_type == C_ISCHR) )) {
					if(strncmp(f_entry[i].c_filesize, hdr[i].c_filesize,
															C_FILESIZE_LEN) )
						error("Entry %d, File name \"%s\"\n%s\n%s%11.11s\n%s%11.11s.\n",
							i,
							f_entry[i].c_name,
							"Incorrect value for c_filesize detected.",
							"Expected the bytes ",
							f_entry[i].c_filesize,
							"Actual bytes are ",
							hdr[i].c_filesize);
				}

				cnt = atoo(hdr[i].c_filesize, C_FILESIZE_LEN);
				expecting(cnt);
				Zread(fd, data_buf, cnt);		/* Assertion test #15 */
			}
		finis
	finis

	assertion(2, BASE);
	start
		testing("Tested in cpio[1].");
		start
		finis
	finis

	assertion(3, BASE);
	start
		testing("The c_magic field contains the magic bytes \"070707\".");
		start
			for(i=0; i<NUM_ENTRIES; i++) {
				continue_on(ERROR);
				if(strncmp(hdr[i].c_magic, C_MAGIC, C_MAGIC_LEN))
				error("Entry %d.\n%s\n%s\n%s%6.6s.\n",
					i,
					"Incorrect c_magic.",
					"Expected the bytes \"070707\"",
					"Actual bytes are ",
					hdr[i].c_magic);
			}
		finis
	finis

	assertion(4, BASE);
	start
		testing("In the archive created, the c_dev and c_ino pair contains");
		testing("values which uniquely identify the file within the archive");
		testing("unless they are links to the same file.");
		start
			int	j;

			/*	NOTE: Entries 0 & 5 are linked together, Any other links
				  are directory entries.
			*/
			for(i=0; i<NUM_ENTRIES -1; i++) {/* Don't process TRAILER header */
				for(j=i+1; j< NUM_ENTRIES -2; j++) {
					if(i==0 && j==5) {
						if(strncmp(hdr[i].c_dev, hdr[j].c_dev, C_DEV_LEN)) 
							error("Entries %d and %d %s\n%s\n",
									i,
									j,
									"contain links to the same file.",
									"The c_dev fields are not the same.");
						if(strncmp(hdr[i].c_ino, hdr[j].c_ino, C_INO_LEN)) 
							error("Entries %d and %d %s\n%s\n",
									i,
									j,
									"contain links to the same file.",
									"The c_ino fields are not the same.");
					} else {
						if((atoo(hdr[S_ISDIR_ENTRY].c_mode+CPIO_TYPE_OFFSET,
								CPIO_MODE_LEN) & CPIO_ISDIR) != CPIO_ISDIR)
							if(!(strncmp(hdr[i].c_dev, hdr[j].c_dev,
															C_DEV_LEN)) ){
				  				if(!(strncmp(hdr[i].c_ino, hdr[j].c_ino,
																C_INO_LEN)))
									error("Entries %d and %d %s\n%s\n",
										i,
										j,
										"do not contain links to the same file.",
										"The c_ino & c_dev fields are the same.");
							}
					}
				}
			}
		finis
	finis

	assertion(5, BASE);
	start
		testing("The c_mode field in the archived file");
		testing("contains values for file type and access permissions.");
		start
			int		f_type;

					/* Don't process TRAILER header */
			for(i=0; i<NUM_ENTRIES -1; i++) {
				is_num(hdr[i].c_mode, C_MODE_LEN, "c_mode");
				if(strncmp(f_entry[i].c_mode, hdr[i].c_mode,
								C_TYPE_LEN))
				error("Entry %d.\n%s\n%s%2.2s\n%s%2.2s.\n",
						i,
						"Incorrect file type in c_mode.",
						"Expected the bytes ",
						f_entry[i].c_mode,
						"Actual bytes are ",
						hdr[i].c_mode);

				/* Don't check special files and FIFO 
				   These were created by the tester at installation
				   time and the proper mode is unknown.
				*/
				f_type = atoo(f_entry[i].c_mode, C_TYPE_LEN);
				if( (f_type == C_ISFIFO) || (f_type == C_ISBLK) ||
													(f_type == C_ISCHR) )
					continue;

						/* Skip checks of C_ISUID & C_ISGID if directory entry.
						   These bits not defined for directory entries.
						*/
				if(f_type != C_ISDIR)
					if(*(f_entry[i].c_mode +2) != *(hdr[i].c_mode +2))
						error("Entry %d.\n%s\n%s%c\n%s%c.\n",
							i,
							"Incorrect value C_ISUID or C_ISGID byte.",
							"Expected the byte ",
							*(f_entry[i].c_mode +2),
							"Actual byte is ",
							*(hdr[i].c_mode +2) );

				if(strncmp(f_entry[i].c_mode +3, hdr[i].c_mode +3,
														C_MODE_LEN -3))
					error("Entry %d.\n%s\n%s%3.3s\n%s%3.3s.\n",
							i,
							"Incorrect value for right three bytes of c_mode.",
							"Expected the bytes ",
							f_entry[i].c_mode +3,
							"Actual bytes are ",
							hdr[i].c_mode +3);
			}
		finis
	finis

	assertion(6, BASE);
	start
		testing("The c_uid field in the archive");
		testing("contains the user ID of the owner of the file.");
		start
					/* Don't process TRAILER header */
			for(i=0; i<NUM_ENTRIES -1; i++) {
				if(**f_entry[i].c_uid !=
						atoo(hdr[i].c_uid, C_UID_LEN))
				error("Entry %d.\n%s\n%s%d\n%s%6.6s.\n",
						i,
						"Incorrect value for c_uid.",
						"Expected user-ID ",
						**f_entry[i].c_uid,
						"Actual bytes are ",
						hdr[i].c_uid);
			}
		finis
	finis

	assertion(7, BASE);
	start
		testing("The c_gid field in the archive");
		testing("contains the group ID of the owner of the file.");
		start
					/* Don't process TRAILER header */
			for(i=0; i<NUM_ENTRIES -1; i++) {
				if(**f_entry[i].c_gid != atoo(hdr[i].c_gid, C_GID_LEN))
					error("Entry %d.\n%s\n%s%d\n%s%6.6s.\n",
							i,
							"Incorrect value for c_gid.",
							"Expected group-ID value ",
							**f_entry[i].c_gid,
							"Actual bytes are ",
							hdr[i].c_gid);
			}
		finis
	finis

	assertion(8, BASE);
	start
		testing("The c_nlink field in the archive");
		testing("contains the number of links referencing the file at");
		testing("the time the archive was created.");
		start
			char	p_tmp[_POSIX_PATH_MAX +1];
			struct	stat st_buf;
			unsigned long	n_lnks;

			for(i=0; i<NUM_ENTRIES -1; i++) {
				is_num(hdr[i].c_nlink, C_NLINK_LEN, "c_nlink");

										/* Links at time of archive. */
				sprintf(p_tmp, "../data/dif.d/%s", f_entry[i].c_name);
				Zstat(p_tmp, &st_buf);
										/* Link valued archived */
				n_lnks = atoo(hdr[i].c_nlink, C_NLINK_LEN);
				if((unsigned long) st_buf.st_nlink != n_lnks)
					error("Entry %d.\n%s\n%s%lu\n%s%lu.\n",
						i,
						"Incorrect value for c_nlink.",
						"Expected value: ",
						(unsigned long) st_buf.st_nlink,
						"Actual value: ",
						n_lnks);
			}
		finis
	finis

	assertion(9, EXTENDED);

	assertion(10, BASE);
	start
		testing("The c_mtime field in the archive");
		testing("contains the last modification time of the file.");
		start
			for(i=0; i<NUM_ENTRIES -1; i++) {
				/* Only check Regular files for proper mtime value*/
				if(C_ISREG != atoo(hdr[i].c_mode, C_TYPE_LEN))
					continue;
				is_num(hdr[i].c_mtime, C_MTIME_LEN, "c_mtime");
				if(strncmp(f_entry[i].c_mtime, hdr[i].c_mtime, C_MTIME_LEN))
					error("Entry %d.\n%s\n%s%11.11s\n%s%11.11s.\n",
							i,
							"Incorrect value for c_mtime.",
							"Expected the bytes ",
							f_entry[i].c_mtime,
							"Actual bytes are ",
							hdr[i].c_mtime);
			}
		finis
	finis

	assertion(11, BASE);
	start
		testing("The c_namesize field right justified and zero filled");
		testing("contains the length of the pathname, including the");
		testing("terminating null byte.");
		testing("Tested in cpio[1].");
		start
		finis
	finis

	assertion(12, BASE);
	start
		testing("The c_filesize field right justified and zero filled");
		testing("contains the length of the data in the file.");
		testing("Tested in cpio[1].");
		start
		finis
	finis

	assertion(13, BASE);
	start
		testing("The c_name field contains the pathname of the file.");
		testing("Tested in cpio[1].");
		start
		finis
	finis

	assertion(14, BASE);
	start
		testing("Support for file names with characters of [a-zA-Z0-9.-_]");
		testing("are tested in the other assertions of this element.");
		testing("(See Entries 22-27 in f_entry structure.)");
		start
		finis
	finis

	assertion(15, BASE);
	start
		testing("Support for upper and lower case letters");
		testing("are tested in the other assertions of this element.");
		testing("(See Entries 22-27 in f_entry structure.)");
		start
		finis
	finis

	assertion(16, EXTENDED);

	assertion(17, BASE);
	start
		testing("The c_filesize element is zero for FIFO special files.");
		start
			continue_on(ERROR);
			for(i=0; i<NUM_ENTRIES; i++) {
				if(atoo(hdr[i].c_mode +CPIO_TYPE_OFFSET, CPIO_TYPE_LEN)
																== CPIO_ISFIFO)
					if(atoo(hdr[i].c_filesize, C_FILESIZE_LEN) != 0)
						error("Entry %d\n%s%s.\n",
								i,
								"Special file length has a size of ",
								f_entry[i].c_filesize);
			}
		finis
	finis

	assertion(18, BASE);
	start
		testing("The c_filesize element is zero for directories.");
		start
			continue_on(ERROR);
			for(i=0; i<NUM_ENTRIES; i++) {
				if(atoo(hdr[i].c_mode +CPIO_TYPE_OFFSET, CPIO_TYPE_LEN)
																== CPIO_ISDIR)
					if(atoo(hdr[i].c_filesize, C_FILESIZE_LEN) != 0)
						error("Entry %d\n%s%s.\n",
								i,
								"Directory length has a size of ",
								f_entry[i].c_filesize);
			}
		finis
	finis

	assertion(19, BASE);
	start
		testing("The c_filesize element is zero for the trailer entry.");
		start
			if(atoo(hdr[NUM_ENTRIES -1].c_filesize, C_FILESIZE_LEN) != 0)
				error("Entry %d\n%s\n%s%d.\n",
						NUM_ENTRIES -1,
						"Expected trailer entry c_filesize length 0.",
						"Actual length is ",
						atoo(hdr[NUM_ENTRIES -1].c_filesize, C_FILESIZE_LEN));
		finis
	finis

	assertion(20, BASE);
	start
		testing("The header with the file name string of TRAILER!!!");
		testing("indicates the end of the archive.");
		start
			if(strncmp(fn_hdr, f_entry[NUM_ENTRIES -1].c_name, 10) != 0)
				error("Entry %d\n%s11.11s.\n%s%11.11s.\n",
						NUM_ENTRIES -1,
						"Expected trailer entry c_name of",
						f_entry[NUM_ENTRIES -1].c_name,
						"Actual name is ",
						fn_hdr);
		finis
	finis

	assertion(21, BASE);
	start
		testing("Support for store/extract directories, FIFOs, and regular");
		testing("files on/from a medium is tested by ./bin/dif_script and");
		testing("the other assertion tests in this module.");
		start
		finis
	finis

	assertion(22, EXTENDED);

						/*	The undefined text "user selection criteria is
							applicable to tests associated with a POSIX.1
							PCTS not a POSIX.1 PCTS since the selection
							criteria is outside the scope of POSIX.1.

							This should be an extended assertion.
						*/
	assertion(23, EXTENDED);

						/*	The conditionals for Assertion #24 require one or
							documentation assertions to specify how the test
							is to be performed and what is the expected outcome.

							Since these documentation assertions would be
							conditional on "documentation being provided",
							this assertion cannot be portably tested.
						*/
	assertion(24, EXTENDED);

	assertion(25, EXTENDED);

	cleanup("Free allocated storage.");
	start
		if(hdr != NULL)
		Zfree(hdr);
	finis

	done();
}


/*	Convert an ASCII string containing octal values to an INT	*/

static	int atoo(char *str, int len)
{
	int	value;
	int	j;

	value = 0;
	for(j=0; j<len; j++)
		value = value*8 + *str++ - '0';
	return(value);
}

/*	Check that string passed has only numeric characters.	*/
/*	Cannot test for zero filled since contents of string not known.	*/

static	void is_num(char *str, int len_str, char *name)
{
	int	j;

	for (j=0; j<len_str; j++, str++) {
		if((*str < '0') || (*str > '9')) {
			continue_on(ERROR);
			error("Entry %d.\nBad character \"%c\", element \"%s\"",
					j,
					*str,
					name);
		}
	}
}

#define	BUF_LENGTH	512
static	void cnv_natv()
{
	char	path[_POSIX_PATH_MAX +1];
	char	path_d[_POSIX_PATH_MAX +1];
	char	data_buf[BUF_LENGTH];
	int		fd_in;
	ssize_t	n_read;

	prep("Convert IUT's created cpio extended format archived to the local");
	prep("code set.");
	start
										/*	Open IUT's created archive file. */
		Zstrcpy(path, data_path());
		Zstrcat(path, "cpio_dif");
		fd_in = Zopen(path, O_RDONLY);

										/*	Open file for converted data. */
		Zstrcpy(path_d, temp_path());
		Zstrcat(path_d, "cpio_dif_natv");
		fd = Zopen(path_d, O_RDWR | O_CREAT | O_TRUNC, PROT_ALL);

		while((n_read = read(fd_in, data_buf, BUF_LENGTH)) > (ssize_t)0) {
			for(i=0; i<n_read; i++)
				data_buf[i] = cs_trans[data_buf[i]].native;
			Zwrite(fd, data_buf, n_read);
		}

		Zclose(fd_in);
		Zlseek(fd, (off_t)0, SEEK_SET);
	finis
}
