#include	<pcts.h>

#include	<Zunistd.h>

#include	<sv_env.h>
#include	<sv_errno.h>

/* This module has the S_ISUID mode set to ROOT. */

int main(void)
{
	char	path[_POSIX_PATH_MAX +1];
	char	*pathm;
	pid_t	pid;

	setup(E_ACCESS);
	funct(E_ACCESS);

	if( ! PCD_READ_ONLY_FILE_SYSTEM) {
		assertion(35, BASE);
		start
			not_implemented("read-only file systems");
		finis

		done();
	}
	assertion(35, BASE);
	start
		pathm = fs_mount(MOUNT_RO, ROFS_REG_FILE);

		abstract("Ensure mounted file system gets unmounted.");
		start
			break_on(ERROR);

			preparation("Establish path to implementation provided ROFS_TESTFILE");
			start
				Zstrcpy(path, pathm);
				Zstrcat(path, "/");
				Zstrcat(path, ROFS_TESTFILE);
			finis

			testing("Appropriate privilege process for write access on a file");
			testing("on a read-only file system.");
			start
				expecting(EROFS);
				Zaccess(path, W_OK);
			finis
	
			FORK
				prep("Set effective user ID to real user ID.");
				start
					Zsetuid(getuid());
				finis

				testing("Ordinary user for write access on a file");
				testing("on a read-only file system.");
				start
					expecting(EROFS);
					Zaccess(path, W_OK);
				finis
			KROF
		finis

		fs_umount(ROFS_REG_FILE);
	finis

	done();
}
