#include	<pcts.h>

#include	<Zunistd.h>
#include	<sys/Zstat.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>

/*	This module has S_ISUID mode set to ROOT. */

#define	DIRNAME_1	"5.6.4_acc.d1"
#define	DIRNAME_2	"5.6.4_acc.d2"


int main(void)
{
	char	path[_POSIX_PATH_MAX +1], path2[_POSIX_PATH_MAX +1];
	pid_t	pid;

	setup(E_CHMOD);
	funct(E_CHMOD);

	assertion(18, BASE);
	start
		prep("Establish strings to be used as paths.");
		start
			Zstrcpy(path2, temp_path());
			Zstrcat(path2, DIRNAME_1);
			sprintf(path, "%s/%s", path2, DIRNAME_2);
		finis

		FORK
			prep("Establish process's real user ID as effective user ID.");
			start
				Zsetuid(getuid());
			finis

			prep("Establish path to a directory such that search access");
			prep("exists on path prefix and on directory.");
			start
				Zmkdir(path2, PROT_ALL);
				Zmkdir(path, S_IXUSR);		/* Search access on directory */
				Zchmod(path2, S_IXUSR);		/* Search access on path prefix */
			finis
				
			testing("For owner of file, chmod() is successful.");
			start
				expecting(SUCCESS);
				Zchmod(path, PROT_ALL);
			finis

			cleanup("Reset permissions on path prefix.");
			start
				Zchmod(path2, PROT_ALL);
			finis
		KROF
							/* Note: Access tests for chmod() are limited
									 to the owner of the file.
							*/

		cleanup("Remove test directories.");
		start
			rmdir(path);
			rmdir(path2);
		finis
	finis
	
	done();
}
