#include	<pcts.h>

#include	<Zfcntl.h>
#include	<sys/Zstat.h>
#include	<Zdirent.h>

#include	<sv_env.h>
#include	<sv_errno.h>

#define	FILENAME "5.1.2d_04"

int main(void)
{
	DIR		*dirp;
	struct	dirent	*dirent;
	char	path[_POSIX_PATH_MAX +1];

	setup(E_CLOSEDIR);
	funct(E_CLOSEDIR);

	assertion(4, BASE);
	start
		break_on(ERROR);
		prep("Open a directory stream.");
		start
			Zstrcpy(path, temp_path());
			dirp = Zopendir(path);
		finis

		testing("A closedir() call returns a value of zero.");
		start
			expecting((int)0);
			Zclosedir(dirp);
		finis

		testing("Accessibility to readdir().");
		start
			expecting(EBADF);
			dirent = Zreaddir(dirp);
		finis
	finis

	assertion(5, BASE);
	start
		int	fd1, fd2, fd3;
	
		if(PCD_DIR_TYPE == TRUE) {
			break_on(ERROR);
			prep("Determine next file descriptor value available.");
			start
				Zstrcpy(path, temp_path());
				Zstrcat(path, FILENAME);
				fd1 = Zcreat(path, PROT_ALL);
			finis
	
			prep("Open a directory stream, then determine value of next file");
			prep("descriptor available.");
			start
				dirp = Zopendir(temp_path());
	
				fd3 = Zcreat(path, PROT_ALL);
			finis

			testing("Call to closedir() closes referenced file descriptor.");
			start
				expecting((int) 0);
				Zclosedir(dirp);

				fd2 = Zcreat(path, PROT_ALL);

				if((fd1 +2 != fd3) || (fd1 +1 != fd2))
					error("%s\n%s%d  %s%d  %s%d",
							"Values for file descriptors not as expected.",
							"fd1 = ",
							fd1,
							"fd2 = ",
							fd2,
							"fd3 = ",
							fd3);
		    finis
		}
		else
			not_implemented("{PCD_DIR_TYPE} of TRUE");
	finis

	done();
}
