#include	<pcts.h>

#include	<Zunistd.h>
#include	<sys/Zstat.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>

/*	Module is set user-ID to ROOT */

#define	FILENAME	"5.3.2_acc"
#define	DIRNAME		"5.3.2_acc.d"

int main(void)
{
	pid_t	pid;
	char	path[_POSIX_PATH_MAX +1], path_dir[_POSIX_PATH_MAX +1];

	setup(E_CREAT);
	funct(E_CREAT);

	assertion(18, BASE);
	start
		prep("Establish strings to be used as paths.");
		start
			Zstrcpy(path_dir, temp_path());
			Zstrcat(path_dir, DIRNAME);
			sprintf(path, "%s/%s", path_dir, FILENAME);
		finis

		FORK
			prep("Establish process's real user-ID as effective user-ID.");
			start
				Zsetuid(getuid());
			finis

			prep("Establish path to an existing file such that search access");
			prep("exists on path prefix and write access exists on file.");
			start
				Zmkdir(path_dir, PROT_ALL);
				Zclose(Zcreat(path, S_IWUSR));	/* Write access on file. */
				Zchmod(path_dir, S_IXUSR);	/* Search access on path prefix. */
			finis
				
			testing("For owner of file, open() is successful.");
			start
				expecting(SUCCESS);
				Zcreat(path, PROT_ALL);
			finis
		KROF

		FORK
			prep("Change owner of test file.");
			prep("Change mode of existing file such that search access");
			prep("exists on path prefix for group owner only and write access");
			prep("exists on file for group owner only.");
			start
				Zchown(path_dir, BIN_UID, GID);
				Zchown(path, BIN_UID, GID);
				Zchmod(path_dir, S_IXGRP);	/* Search access on path prefix */
				Zchmod(path, S_IWGRP);		/* Write access on file */
			finis

			prep("Establish process's real user-ID as effective user-ID.");
			start
				Zsetuid(getuid());
			finis
				
			testing("For group owner of file, open() is successful.");
			start
				expecting(SUCCESS);
				Zcreat(path, PROT_ALL);
			finis
		KROF

		FORK
			prep("Change owner of test file and its path prefix.");
			prep("Change mode of existing file such that search access");
			prep("exists on path prefix for others only and write access");
			prep("exists on file for others only.");
			start
				Zchown(path_dir, BIN_UID, BIN_GID);
				Zchown(path, BIN_UID, BIN_GID);
				Zchmod(path_dir, S_IXOTH);	/* Search access on path prefix */
				Zchmod(path, S_IWOTH);		/* Write access on file */
			finis

			prep("Establish process's real user-ID as effective user-ID.");
			start
				Zsetuid(getuid());
			finis
				
			testing("For others, open() is successful.");
			start
				expecting(SUCCESS);
				Zcreat(path, PROT_ALL);
			finis
		KROF

		cleanup("Remove test file and  directory.");
		start
			Zunlink(path);
			Zrmdir(path_dir);
		finis
	finis

	assertion(19, BASE);
	start
		FORK
			prep("Establish process's real user-ID as effective user-ID.");
			start
				Zsetuid(getuid());
			finis

			prep("Establish path to a non-existent such that write and search");
			prep("access exists on path prefix.");
			start
				Zmkdir(path_dir, PROT_ALL);
								/* Write and search access on path prefix */
				Zchmod(path_dir, S_IWUSR | S_IXUSR);
			finis
				
			testing("For owner of path prefix, creat() is successful.");
			start
				expecting(SUCCESS);
				Zcreat(path, PROT_ALL);
				Zunlink(path);
			finis
		KROF

		FORK
			prep("Change owner such that write and search");
			prep("access exists on path prefix for group owner only.");
			start
				Zchown(path_dir, BIN_UID, GID);
								/* Write and search access on path prefix */
				Zchmod(path_dir, S_IWGRP | S_IXGRP);
			finis
				
			prep("Establish process's real user-ID as effective user-ID.");
			start
				Zsetuid(getuid());
			finis
				
			testing("For group owner of file, open() is successful.");
			start
				expecting(SUCCESS);
				Zcreat(path, PROT_ALL);
				Zunlink(path);
			finis
		KROF

		FORK
			prep("Change owner such that write and search");
			prep("access exists on path prefix for others only.");
			start
				Zchown(path_dir, BIN_UID, BIN_GID);
								/* Write and search access on path prefix */
				Zchmod(path_dir, S_IWOTH | S_IXOTH);
			finis

			prep("Establish process's real user-ID as effective user-ID.");
			start
				Zsetuid(getuid());
			finis
				
			testing("For others, open() is successful.");
			start
				expecting(SUCCESS);
				Zcreat(path, PROT_ALL);
				Zunlink(path);
			finis
		KROF

		cleanup("Remove test directory.");
		start
			Zrmdir(path_dir);
		finis
	finis

	done();
}
