#include	<pcts.h>

#include	<Zunistd.h>
#include	<sys/Zstat.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>

/*	This module is set user ID to ROOT. */

#define	DIRNAME		"5.3.4_09.d"
#define	DIRNAME_NEW	"5.3.4_09.dir"


int main(void)
{
	struct	stat st_bf1, st_bf2;
	char	path_cwd[_POSIX_PATH_MAX +1], path_ref[_POSIX_PATH_MAX +1];

	setup(E_LINK);
	funct(E_LINK);

	assertion(9, BASE);
	start
		if(PCD_LINK_TO_DIRECTORY == TRUE) {
			prep("Change current working directory to \"../tmp/%s.d\".",
									element[(int) E_LINK].e_name);
			prep("Create known directory in working directory.");
			start
				exit_on(ERROR);
				Zstrcpy(path_cwd, temp_path());
				path_cwd[strlen(path_cwd) -1] = '\000';/* delete trailing '/' */
				Zchdir(path_cwd);
				Zgetcwd(path_cwd, _POSIX_PATH_MAX +1);
				Zmkdir(DIRNAME, PROT_ALL);
										/*
												   Working_Directory
												          |
												          |
											            DIRNAME
										*/
			finis

			testing("Existing argument points to the string \"F1/\" and");
			testing("F1 is a directory.");
			start
				Zstat(DIRNAME, &st_bf1);
				sprintf(path_ref, "%s/", DIRNAME);
				Zlink(path_ref, DIRNAME_NEW);
				Zstat(DIRNAME_NEW, &st_bf2);
				if(st_bf1.st_ino != st_bf2.st_ino) 
					error("%s\n%s%lu.\n%s%lu.\n",
							"File inode not expected inode.",
							"Expected inode of file to be: ",
							(unsigned long) st_bf1.st_ino,
							"Actual inode of file is: ",
							(unsigned long) st_bf2.st_ino);
				Zunlink(DIRNAME_NEW);
			finis
		}
		else
			not_implemented("{PCD_LINK_TO_DIRECTORY} of TRUE");
	finis

	assertion(10, BASE);
	start
		if(PCD_LINK_TO_DIRECTORY == TRUE) {
			testing("Existing argument points to the string \"F1//\" and");
			testing("F1 is a directory.");
			start
				Zstat(DIRNAME, &st_bf1);
				sprintf(path_ref, "%s//", DIRNAME);
				Zlink(path_ref, DIRNAME_NEW);
				Zstat(DIRNAME_NEW, &st_bf2);
				if(st_bf1.st_ino != st_bf2.st_ino) 
					error("%s\n%s%lu.\n%s%lu.\n",
							"File inode not expected inode.",
							"Expected inode of file to be: ",
							(unsigned long) st_bf1.st_ino,
							"Actual inode of file is: ",
							(unsigned long) st_bf2.st_ino);
				Zunlink(DIRNAME_NEW);
			finis
		}
		else
			not_implemented("{PCD_LINK_TO_DIRECTORY} of TRUE");
	finis

	if(PCD_LINK_TO_DIRECTORY == TRUE) {
		cleanup("Remove test directory.");
		start
			Zrmdir(DIRNAME);
		finis
	}

	done();
}
