#include	<pcts.h>

#include	<Zunistd.h>
#include	<sys/Zstat.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>

#define	FILENAME		"5.3.4_33"
#define	FILENAME_NEW	"5.3.4_33_n"
#define	String			"DaTa for link testing"
#define	Strlen			(sizeof(String) -1)


int main(void)
{
	struct	stat st_buf1, st_buf2;
	char	path_ex[_POSIX_PATH_MAX +1], path_new[_POSIX_PATH_MAX +1];
	char	inbuf[Strlen +1];
	int		fd;

	setup(E_LINK);
	funct(E_LINK);

	assertion(33, BASE);
	start
		break_on(ERROR);
		prep("Create a data file with known data.");
		start
			Zstrcpy(path_ex, temp_path());
			Zstrcat(path_ex, FILENAME);
			fd = Zcreat(path_ex, PROT_ALL);
			expecting(Strlen);
			Zwrite(fd, String, Strlen);
			Zclose(fd);

			sprintf(path_new, "%s%s", temp_path(), FILENAME_NEW);
		finis

		testing("Link file contains the data of file linked to.");
		start
			expecting(0);
			Zlink(path_ex, path_new);
			fd = Zopen(path_new, O_RDONLY);

			expecting(Strlen);
			Zread(fd, inbuf, Strlen);

			if(strncmp(inbuf, String, Strlen))
				error("%s\n%s%s\n%s%*s",
					"Data read from link file in error.",
					"Expected: ",
					String,
					"Actual: ",
					Strlen,
					inbuf);
		finis
	finis

	assertion(34, BASE);
	start
		testing("Successful call to link() increments the link count by one.");
		start
			Zstat(path_ex, &st_buf1);
			if(st_buf1.st_nlink  != (nlink_t)2)
				error("%s\n%s\n%s\"%lu\"\n",
					"Link count for existing is incorrect.",
					"Expected: 2",
					"Actual: ",
					(unsigned long) st_buf1.st_nlink);
		finis
	finis

	assertion(35, EXTENDED);

	assertion(36, BASE);
	start
		testing("Permission flags match.");
		start
			Zstat(path_ex, &st_buf1);
			Zstat(path_new, &st_buf2);
			if(st_buf1.st_mode  != st_buf2.st_mode)
				error("%s\n%s\"%o\"/n%s\"%o\"\n",
					"Permission flags differ.",
					"Expected: ",
					st_buf1.st_mode,
					"Actual: ",
					st_buf2.st_mode);
		finis

		testing("UID and GID owners match.");
		start
			if(st_buf1.st_uid  != st_buf2.st_uid)
				error("%s\n%s\"%o\"/n%s\"%o\"\n",
					"UIDs don't match.",
					"Expected: ",
					st_buf1.st_uid,
					"Actual: ",
					st_buf2.st_uid);

			if(st_buf1.st_gid  != st_buf2.st_gid)
				error("%s\n%s\"%o\"/n%s\"%o\"\n",
					"GIDs don't match.",
					"Expected: ",
					st_buf1.st_gid,
					"Actual: ",
					st_buf2.st_gid);
		finis
	finis

	assertion(39, BASE);
	start
		time_t	s_time;

		prep("Obtain a starting time, then call link().");
		start
			unlink(path_new);			/*	Ensure new file does not exist. */

			Ztime(&s_time);				/* Obtain minimum reference time. */
			dt_secs(TRF_DELAY);			/* Delay a fixed interval.			*/

			Zlink(path_ex, path_new);
		finis
	
		testing("Time related element \"st_ctime\" of file is marked");
		testing("for update.");
		start
			trf_ck(CHK_CTIME, TRUE, s_time, NO_FILDES, path_new);
		finis

		testing("Time related elements \"st_ctime\" and \"st_mtime\"");
		testing("of parent directory are marked for update.");
		start
			trf_ck(CHK_CTIME, TRUE, s_time, NO_FILDES, temp_path());
			trf_ck(CHK_MTIME, TRUE, s_time, NO_FILDES, temp_path());
		finis
	finis

	done();
}
