#include	<pcts.h>

#include	<Zunistd.h>
#include	<sys/Zstat.h>
#include	<Zfcntl.h>

#include	<sv_env.h>

/*	This module has the S_ISUID mode set to ROOT. */

#define	DIRNAME		"5.4.1_21.d"
#define	FILENAME	"5.4.1_21_d"


int main(void)
{
	struct	stat st_buf;
	char	path_dir[_POSIX_PATH_MAX +1], path[_POSIX_PATH_MAX +1];

	setup(E_MKDIR);
	funct(E_MKDIR);

	assertion(21, BASE);
	start
		prep("Create a test directory.");
		start
			Zstrcpy(path_dir, temp_path());
			Zstrcat(path_dir, DIRNAME);
			Zmkdir(path_dir, PROT_ALL);
		finis

		prep("Set group owner of test directory to BIN.");
		start
			Zchown(path_dir, UID, BIN_GID);
		finis

		if(GROUP_ID_OF_PARENT_DIR == 1) {
			prep("PCTS installation file <config>, states implementation");
			prep("requires S_ISGID mode bit set on directory to enable");
			prep("FIPS 151-2 required feature (\"l\").");
			start
				Zchmod(path_dir, S_IRWXU | S_IRWXG | S_ISGID);
			finis
		}

		prep("Set effective user ID to UID and create test directory.");
		start
			Zsetuid(UID);

			sprintf(path, "%s%s%s", path_dir, "/", FILENAME);
			Zmkdir(path, PROT_ALL);
		finis

		testing("Group ID of a newly created file is set to the group ID");
		testing("of the directory in which the file is created.");
		testing("FIPS 151-2 required feature, Item \"l\".");
		start
			Zstat(path, &st_buf);
			if(st_buf.st_gid != BIN_GID)
				error("%s\n%s%lu\n%s%lu\n",
				  		"Call to stat() reported unexpected group ID.",
					  	"Expected:	",
					  	(unsigned long) BIN_GID,
					  	"Actual:	",
					  	(unsigned long) st_buf.st_gid);
		finis
	finis

	done();
}
