#include	<pcts.h>

#include	<Zunistd.h>
#include	<sys/Zstat.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>

#define	FILENAME	"5.4.2_23"
#define	FIFONAME	"5.4.2_23_f"
#define	DIRNAME		"5.4.2_23.d"


int main(void)
{
	char	path[_POSIX_PATH_MAX +1];

	setup(E_MKFIFO);
	funct(E_MKFIFO);

	assertion(23, BASE);
	start
		testing("Search permission for path component is denied.");
		start
			Zstrcpy(path, data_path());
			Zstrcat(path, "no_srch.d");
			Zstrcat(path, "/mkfifo_tryme");

			expecting(-1);
			expecting(EACCES);
			Zmkfifo(path, PROT_ALL);
		finis
	finis

	assertion(24, BASE);
	start
		testing("Write permission for parent directory is denied.");
		start
			Zstrcpy(path, data_path());
			Zstrcat(path, "no_write.d");
			Zstrcat(path, "/mkfifo_tryme");

			expecting(-1);
			expecting(EACCES);
			Zmkfifo(path, PROT_ALL);
		finis
	finis

	assertion(25, BASE);
	start
		testing("Call to mkfifo() in a directory which contains a file of");
		testing("the same name.");
		start
			Zstrcpy(path, temp_path());
			Zstrcat(path, DIRNAME);
			Zmkdir(path, PROT_ALL);

			expecting(-1);
			expecting(EEXIST);
			Zmkfifo(path, PROT_ALL);
		finis
	finis

	if(tc_name_max()) {
		assertion(26, BASE);
		start
			e_NO_TRUNC(E_MKFIFO);
		finis
	}
	else
		assertion(26, NOT_TESTABLE);

	if(!tc_name_max()) {
		assertion(27, BASE);
		start
			e_NO_TRUNC(E_MKFIFO);
		finis
	}
	else
		assertion(27, NOT_TESTABLE);

	assertion(28, BASE);
	start
		e_ENAMETOOLONG(E_MKFIFO);
	finis


	assertion(29, BASE);
	start
		testing("Call mkfifo() for a path that does not exist.");
		start
			Zstrcpy(path, temp_path());
			Zstrcat(path, "_mkdir/_mkfifo");

			expecting(-1);
			expecting(ENOENT);
			Zmkfifo(path, PROT_ALL);
		finis
	finis

	assertion(30, BASE);
	start
		testing("Call mkfifo() with an empty string for path.");
		start
			expecting(-1);
			expecting(ENOENT);
			Zmkfifo("", PROT_ALL);
		finis
	finis

	assertion(31, EXTENDED);

	assertion(32, BASE);
	start
		testing("Call mkfifo() when path component is not a directory.");
		start
			Zstrcpy(path, temp_path());
			Zstrcat(path, FILENAME);
			Zclose(Zcreat(path, PROT_ALL));
			Zstrcat(path, "/");
			Zstrcat(path, FIFONAME);

			expecting(-1);
			expecting(ENOTDIR);
			Zmkfifo(path, PROT_ALL);
		finis
	finis

	done();
}
