#include	<pcts.h>

#include	<Zunistd.h>
#include	<sys/Zstat.h>
#include	<Zfcntl.h>
#include	<Zdirent.h>

#include	<sv_env.h>
#include	<sv_errno.h>

/*	This module is set user-ID to ROOT */

#define	FILENAME	"5.1.2a_acc"
#define	DIRNAME		"/5.1.2a_acc.d"


int main(void)
{
	pid_t	pid;
	DIR		*dirp;
	char	path[_POSIX_PATH_MAX +1], path1[_POSIX_PATH_MAX +1];

	setup(E_OPENDIR);
	funct(E_OPENDIR);

	assertion(19, BASE);
	start
		prep("Establish strings to be used as paths.");
		start
			Zstrcpy(path1, temp_path());
			Zstrcat(path1, FILENAME);
			Zstrcpy(path, path1);
			Zstrcat(path, DIRNAME);
		finis

		FORK
			prep("Establish process's real user-ID as effective user-ID.");
			start
				Zsetuid(getuid());
			finis

			prep("Establish path to a directory such that search access");
			prep("exists on path prefix and read access exists on directory.");
			start
				Zmkdir(path1, PROT_ALL);
				Zmkdir(path, S_IRUSR);		/* Read access on directory */
				Zchmod(path1, S_IXUSR);		/* Search access on path prefix */
			finis
				
			testing("For owner of file, opendir() is successful.");
			start
				dirp = Zopendir(path);
			finis
		KROF

		FORK
			prep("Change owner of test directory.");
			prep("Change mode of test directory such that search access");
			prep("exists on path prefix for group owner only and read access");
			prep("exists on directory for group owner only.");
			start
				Zchown(path1, BIN_UID, GID);
				Zchown(path, BIN_UID, GID);
				Zchmod(path1, S_IXGRP);		/* Search access on path prefix */
				Zchmod(path, S_IRGRP);		/* Read access on directory */
			finis

			prep("Establish process's real user-ID as effective user-ID.");
			start
				Zsetuid(getuid());
			finis
				
			testing("For group owner of file, opendir() is successful.");
			start
				expecting(SUCCESS);
				dirp = Zopendir(path);
			finis
		KROF

		FORK
			prep("Change owner of test directory and its path prefix.");
			prep("Change mode of test directory such that search access");
			prep("exists on path prefix for others only and read access");
			prep("exists on directory for others only.");
			start
				Zchown(path1, BIN_UID, BIN_GID);
				Zchown(path, BIN_UID, BIN_GID);
				Zchmod(path1, S_IXOTH);		/* Search access on path prefix */
				Zchmod(path, S_IROTH);		/* Read access on directory */
			finis

			prep("Establish process's real user-ID as effective user-ID.");
			start
				Zsetuid(getuid());
			finis
				
			testing("For others, opendir() is successful.");
			start
				dirp = Zopendir(path);
			finis
		KROF

		cleanup("Remove test directories.");
		start
			Zrmdir(path);
			Zrmdir(path1);
		finis
	finis
	
	done();
}
