#include	<pcts.h>

#include	<Zunistd.h>
#include	<sys/Zstat.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>

/*	Module has S_ISUID mode set to ROOT. */

#define	DIRNAME		"5.7.1a_acc.d"
#define	FILENAME	"5.7.1a_acc"


int main(void)
{
	char	path[_POSIX_PATH_MAX +1], path_dir[_POSIX_PATH_MAX +1];
	pid_t	pid;

	setup(E_PATHCONF);
	funct(E_PATHCONF);

	assertion(18, BASE);
	start
		prep("Establish strings to be used as paths.");
		start
			Zstrcpy(path_dir, temp_path());
			Zstrcat(path_dir, DIRNAME);
			sprintf(path, "%s/%s", path_dir, FILENAME);
		finis

		FORK
			prep("Establish process's real user-ID as effective user-ID.");
			start
				Zsetuid(getuid());
			finis

			prep("Establish mode to test file such that search access");
			prep("exists on path prefix.");
			start
				Zmkdir(path_dir, PROT_ALL);
				Zmkdir(path, PROT_ALL);
				Zchmod(path_dir, S_IXUSR);
			finis
				
			testing("For owner of file, pathconf() is successful.");
			start
				Zpathconf(path, _PC_NAME_MAX);
			finis
		KROF

		FORK
			prep("Change owner of path prefix.");
			prep("Change mode of path prefix such that search access");
			prep("exists for group owner only.");
			start
				Zchown(path_dir, BIN_UID, GID);
				Zchmod(path_dir, S_IXGRP);
			finis

			prep("Establish process's real user-ID as effective user-ID.");
			start
				Zsetuid(getuid());
			finis
				
			testing("For group owner of file, pathconf() is successful.");
			start
				Zpathconf(path, _PC_NAME_MAX);
			finis
		KROF

		FORK
			prep("Change owner of path prefix.");
			prep("Change mode of path prefix such that search access");
			prep("exists for others only.");
			start
				Zchown(path_dir, BIN_UID, BIN_GID);
				Zchmod(path_dir, S_IXOTH);
			finis

			prep("Establish process's real user-ID as effective user-ID.");
			start
				Zsetuid(getuid());
			finis
				
			testing("For others, pathconf() is successful.");
			start
				Zpathconf(path, _PC_NAME_MAX);
			finis
		KROF

		cleanup("Remove test directories.");
		start
			rmdir(path);
			rmdir(path_dir);
		finis
	finis
	
	done();
}
