#include	<pcts.h>

#include	<Zunistd.h>
#include	<sys/Zstat.h>
#include	<Zdirent.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<pcts_timer.h>

DIR		*dirp,	*dirp2;
struct	dirent	*dirent, *dirent2;
#define	FILENAME "5.1.2b_04.d"


int main(void)
{
	char	path[_POSIX_PATH_MAX +1];
	pid_t	pid;
	char	*n_buf, *pn_buf, *path_ref, *p_ent[3];
	long	name_max;
	int		i, j;


	setup(E_READDIR);
	funct(E_READDIR);

	assertion(4, BASE);
	start
		prep("Establish test directory and file entries of length {NAME_MAX},");
		prep("1, and another.");
		start
			Zstrcpy(path, temp_path());
			Zstrcat(path, FILENAME);
			Zmkdir(path, PROT_ALL);

							/*	Entry of {NAME_MAX} bytes. */
							/* Count does not include terminating null. */
			name_max = Zpathconf(path, _PC_NAME_MAX);
			n_buf = (char *) Zmalloc((size_t)(name_max +2));
			path_ref = (char *) Zmalloc((size_t)(name_max +2 +_POSIX_PATH_MAX));
			for(pn_buf=n_buf; pn_buf < n_buf + name_max;) 
				*pn_buf++ = 'A';
			*pn_buf = '\000';
			sprintf(path_ref, "%s/%s", path, n_buf);
			Zcreat(path_ref, PROT_ALL);
			p_ent[0] = n_buf;

							/*	Entry of 1 byte. */
			p_ent[1] = "A";
			sprintf(path_ref, "%s/%s", path, p_ent[1]);
			Zcreat(path_ref, PROT_ALL);

							/*	Entry of 5 bytes. */
			p_ent[2] = "12345";
			sprintf(path_ref, "%s/%s", path, p_ent[2]);
			Zcreat(path_ref, PROT_ALL);
		finis

		testing("Read of directory returns proper entries.");
		start
			int	fnd_ent[] = {FALSE, FALSE, FALSE};

			dirp = Zopendir(path);
			for(i=0, j=0; i<3; i++) {
				while(dirent = Zreaddir(dirp)) {
					if(*(dirent->d_name) != '.')
						break;
				}
				for(j=0; j<3; j++) {
					if(strcmp(dirent->d_name, p_ent[j])) {
						if(j==2)
							error("Entry \"%s\" cannot be found.",
								p_ent[j]);
					}
					else {
						if(fnd_ent[j] == TRUE)
							error("%s\n%s\"%s\".",
									"Call to readdir() returned prior entry.",
									"Entry returned was ",
									p_ent[j]);
						else {
							fnd_ent[j] = TRUE;
							break;
						}
					}
				}
			}
		finis
	finis

	assertion(5, BASE);
	start
		testing("Test for advancing to next directory entry is contained");
		testing("within the testing of assertion #4.");
		start
		finis
	finis

#define	DEFAULT_ERRNO	-100
	assertion(6, BASE);
	start
		testing("NULL pointer returned upon reaching end of directory");
		testing("stream and errno is not changed.");
		start
			errno = DEFAULT_ERRNO;
			if(readdir(dirp) != NULL)
				error("Call to readdir() did not return NULL.");

			if(errno != DEFAULT_ERRNO)
				error("The value of errno was changed from %d to %d.",
						DEFAULT_ERRNO, errno);
			Zclosedir(dirp);
		finis
	finis

	assertion(7, EXTENDED);

	assertion(8, BASE);
	start
		prep("Setup to read two directories concurrently.");
		start
			dirp = Zopendir(path);
			dirp2 = Zopendir(path);
		finis

		testing("Reading each directory does not affect the other.");
		start
			int	fnd_ent[] = {FALSE, FALSE, FALSE};

			for(i=0; i<3; i++) {
				while(dirent = Zreaddir(dirp)) {
					dirent2 = Zreaddir(dirp2);
					if(*(dirent->d_name) != '.')
						break;
				}
				for(j=0; j<3; j++) {
					if(strcmp(dirent->d_name, p_ent[j])) {
						if(j==2)
							error("Entry \"%s\" cannot be found.",
								p_ent[j]);
					}
					else {
						if(fnd_ent[j] == TRUE)
							error("%s\n%s\"%s\".",
									"Call to readdir() returned prior entry.",
									"Entry returned was ",
									p_ent[j]);
						else {
							fnd_ent[j] = TRUE;
							if(strcmp(dirent2->d_name, p_ent[j]))
								error("%s\"%s\"\n%s\"%s\"",
									"Expected:	",
									dirent->d_name,
									"Actual:	",
									dirent2->d_name);
							break;
						}
					}
				}
			}
		finis

		cleanup("Close directory streams.");
		start
			Zclosedir(dirp2);
			Zclosedir(dirp);
		finis
	finis

	assertion(9, BASE);
	start
		time_t	s_time;

		testing("Time related field \"st_atime\" is marked for update.");
		start
			dirp = Zopendir(path);
			Ztime(&s_time);				/* Obtain minimum reference time. */
			dt_secs(TRF_DELAY);			/* Delay a fixed interval.			*/
			(void) Zreaddir(dirp);
			trf_ck(CHK_ATIME, TRUE, s_time, NO_FILDES, path);
		finis
	finis


	assertion(10, BASE);
	start
		ENABLE_PSYNC
			prep("Open directory stream.");
			start
				dirp = Zopendir(path);
			finis

			prep("Fork a child.");
			start
				sv_flush();
				pid = Zfork();
			finis

			if(pid == (pid_t) 0) {
				for(i=0; i<3; i++)
					dirent = Zreaddir(dirp);
				SEND_PSYNCA
				WAIT_PSYNC
				done();
			}

			WAIT_PSYNCA

			testing("Parent process using readdir() and rewinddir().");
			start
				int	fnd_ent[] = {FALSE, FALSE, FALSE};

				Zrewinddir(dirp);
				dirp = Zopendir(path);
				for(i=0; i<3; i++) {
					while(dirent = Zreaddir(dirp)) {
						if(*(dirent->d_name) != '.')
							break;
					}
					for(j=0; j<3; j++) {
						if(strcmp(dirent->d_name, p_ent[j])) {
							if(j==2)
								error("Entry \"%s\" cannot be found.",
									p_ent[j]);
						}
						else {
							if(fnd_ent[j] == TRUE)
								error("%s\n%s\"%s\".",
									"Call to readdir() returned prior entry.",
									"Entry returned was ",
									p_ent[j]);
							else {
								fnd_ent[j] = TRUE;
								break;
							}
						}
					}
				}
				Zclosedir(dirp);
			finis

			SEND_PSYNC
			WAIT_FOR_PID(pid);
		DISABLE_PSYNC
	finis

	assertion(11, BASE);
	start
		prep("Open directory stream.");
		start
			dirp = Zopendir(path);
		finis

		FORK
			testing("Child process using readdir() and rewinddir().");
			start
				int	fnd_ent[] = {FALSE, FALSE, FALSE};

				Zrewinddir(dirp);
				dirp = Zopendir(path);
				for(i=0; i<3; i++) {
					while(dirent = Zreaddir(dirp)) {
						if(*(dirent->d_name) != '.')
							break;
					}
					for(j=0; j<3; j++) {
						if(strcmp(dirent->d_name, p_ent[j])) {
							if(j==2)
								error("Entry \"%s\" cannot be found.",
									p_ent[j]);
						}
						else {
							if(fnd_ent[j] == TRUE)
								error("%s\n%s\"%s\".",
									"Call to readdir() returned prior entry.",
									"Entry returned was ",
									p_ent[j]);
							else {
								fnd_ent[j] = TRUE;
								break;
							}
						}
					}
				}
				Zclosedir(dirp);
			finis
		KROF
	finis

	done();
}
