#include	<pcts.h>

#include	<Zunistd.h>
#include	<sys/Zstat.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<pcts_timer.h>

#define	DIRNAME			"5.5.3_44.d"
#define	DIRNAME_NEW		"5.5.3_44.dn"
#define	DIRNAME_OLD		"5.5.3_44.do"
#define	FILENAME		"5.5.3_44"
#define	FILENAME_NEW	"5.5.3_44_n"
#define	String	"This is a test!!!"
#define	Strlen	(sizeof(String) -1)

void el_NO_TRUNC(int);
void el_ENAMETOOLONG(int);

int main(void)
{
	char	path_old[_POSIX_PATH_MAX +1], path_new[_POSIX_PATH_MAX +1];
	char	path[_POSIX_PATH_MAX +1];
	struct	stat st_buf1, st_buf2;

	setup(E_RENAME);
	funct(E_RENAME);

	assertion(44, BASE);
	start
		testing("Call to rename() when search permission is denied for");
		testing("component of the path prefix of old or new.");
		start
			Zstrcpy(path_old, data_path());
			Zstrcat(path_old, "no_srch.d");
			Zstrcat(path_old, "/_tryme_");

			Zstrcpy(path_new, temp_path());
			Zstrcat(path_new, FILENAME_NEW);
			Zclose(Zcreat(path_new, PROT_ALL));
			Zstat(path_new, &st_buf1);

			expecting(-1);
			expecting(EACCES);
			Zrename(path_old, path_new);

			expecting(-1);
			expecting(EACCES);
			Zrename(path_new, path_old);
		finis

		testing("Named files are not changed.");
		start
			Zstat(path_new, &st_buf2);
			if(st_buf1.st_ino != st_buf2.st_ino) 
				error("%s\n%s%lu.\n%s%lu.\n",
						"File inode not expected inode.",
						"Expected inode of file to be: ",
						(unsigned long) st_buf1.st_ino,
						"Actual inode of file is: ",
						(unsigned long) st_buf2.st_ino);
		finis
	finis

	assertion(45, BASE);
	start
		prep("Initialize path names.");
		start
			Zstrcpy(path_old, data_path());
			Zstrcat(path_old, "no_write.d");
			Zstrcat(path_old, "/_tryme_");

			Zstrcpy(path_new, temp_path());
			Zstrcat(path_new, FILENAME_NEW);
			close(creat(path_new, PROT_ALL));
			Zstat(path_new, &st_buf1);
		finis

		testing("Call to rename() when write permission for directory of new");
		testing("or old is denied.");
		start
			expecting(-1);
			expecting(EACCES);
			Zrename(path_old, path_new);

			expecting(-1);
			expecting(EACCES);
			Zrename(path_new, path_old);
			Zstat(path_new, &st_buf1);
		finis

		testing("Named files are not changed.");
		start
			Zstat(path_new, &st_buf2);
			if(st_buf1.st_ino != st_buf2.st_ino) 
				error("%s\n%s%lu.\n%s%lu.\n",
						"File inode not expected inode.",
						"Expected inode of file to be: ",
						(unsigned long) st_buf1.st_ino,
						"Actual inode of file is: ",
						(unsigned long) st_buf2.st_ino);
		finis
	finis

	assertion(46, BASE);
	start
		if(PCD_WRITE_PERM_TO_RENAME == TRUE) {
			testing("When write permission is denied for a directory pointed");
			testing("to by the old or new.");
			start
				Zstrcpy(path_old, temp_path());
				Zstrcat(path_old, DIRNAME_OLD);
				Zmkdir(path_old, S_IRUSR | S_IXUSR);

				Zstrcpy(path_new, temp_path());
				Zstrcat(path_new, DIRNAME_NEW);
				Zmkdir(path_new, PROT_ALL);
				Zstat(path_new, &st_buf1);

				expecting(-1);
				expecting(EACCES);
				Zrename(path_old, path_new);

				expecting(-1);
				expecting(EACCES);
				Zrename(path_new, path_old);
			finis

			testing("Named files are not changed.");
			start
				Zstat(path_new, &st_buf2);
				if(st_buf1.st_ino != st_buf2.st_ino) 
					error("%s\n%s%lu.\n%s%lu.\n",
							"File inode not expected inode.",
							"Expected inode of file to be: ",
							(unsigned long) st_buf1.st_ino,
							"Actual inode of file is: ",
							(unsigned long) st_buf2.st_ino);
			finis

			cleanup("Remove generated test files.");
			start
				Zrmdir(path_old);
				Zrmdir(path_new);
			finis
		}
		else
			not_implemented("{PCD_WRITE_PERM_TO_RENAME} of TRUE");
	finis

	assertion(47, NOT_APPLICABLE);

	assertion(48, EXTENDED);

	assertion(49, BASE);
	start
		prep("Generate test files.");
		start
			Zstrcpy(path_old, temp_path());
			Zstrcat(path_old, DIRNAME_OLD);
			Zmkdir(path_old, PROT_ALL);

			Zstrcpy(path_new, temp_path());
			Zstrcat(path_new, DIRNAME_NEW);
			Zmkdir(path_new, PROT_ALL);
			Zstat(path_new, &st_buf1);

			sprintf(path, "%s/%s", path_new, FILENAME);
			Zmkdir(path, PROT_ALL);
		finis

		testing("Rename() when new is a non-empty directory.");
		start
			expecting(-1);
			expecting(FAILURE);
			Zrename(path_old, path_new);
			if(! ((errno == EEXIST) || (errno == ENOTEMPTY)))
				error("%s\n%s%s",
					"Expected errno of EEXIST or ENOTEMPTY",
					"Actual errno is ",
					err_lookup(errno));
		finis

		testing("Named files are not changed.");
		start
			Zaccess(path_old, F_OK);

			Zstat(path_new, &st_buf2);
			if(st_buf1.st_ino != st_buf2.st_ino) 
				error("%s\n%s%lu.\n%s%lu.\n",
						"File inode not expected inode.",
						"Expected inode of file to be: ",
						(unsigned long) st_buf1.st_ino,
						"Actual inode of file is: ",
						(unsigned long) st_buf2.st_ino);
		finis

	finis

	assertion(50, BASE);
	start
		testing("The new directory is a descendant of the old directory.");
		start
			expecting(-1);
			expecting(EINVAL);
			Zrename(path_new, path);
		finis

		testing("Named files are not changed.");
		start
			expecting(SUCCESS);
			Zaccess(path, F_OK);

			Zstat(path_new, &st_buf2);
			if(st_buf1.st_ino != st_buf2.st_ino) 
				error("%s\n%s%lu.\n%s%lu.\n",
						"File inode not expected inode.",
						"Expected inode of file to be: ",
						(unsigned long) st_buf1.st_ino,
						"Actual inode of file is: ",
						(unsigned long) st_buf2.st_ino);
		finis
		
		cleanup("Remove generated test directory.");
		start
			Zrmdir(path);
		finis
	finis

	assertion(51, BASE);
	start
		testing("When new is a directory and old is a regular file.");
		start
			Zstrcpy(path_old, temp_path());
			Zstrcat(path_old, FILENAME);
			Zclose(Zcreat(path_old, PROT_ALL));

			expecting(EISDIR);
			Zrename(path_old, path_new);
		finis

		testing("Named files are not changed.");
		start
			Zaccess(path_old, F_OK);

			Zstat(path_new, &st_buf2);
			if(st_buf1.st_ino != st_buf2.st_ino) 
				error("%s\n%s%lu.\n%s%lu.\n",
						"File inode not expected inode.",
						"Expected inode of file to be: ",
						(unsigned long) st_buf1.st_ino,
						"Actual inode of file is: ",
						(unsigned long) st_buf2.st_ino);
		finis

		cleanup("Remove generated test files.");
		start
			Zrmdir(path_new);
			Zunlink(path_old);
		finis
	finis

	if(tc_name_max()) {
		assertion(52, BASE);
		start
			el_NO_TRUNC(TRUE);
		finis
	}
	else
		assertion(52, NOT_TESTABLE);

	if(!tc_name_max()) {
		assertion(53, BASE);
		start
			e_NO_TRUNC(TRUE);
		finis
	}
	else
		assertion(53, NOT_TESTABLE);

	if(tc_name_max()) {
		assertion(54, BASE);
		start
			el_NO_TRUNC(FALSE);
		finis
	}
	else
		assertion(54, NOT_TESTABLE);

	if(!tc_name_max()) {
		assertion(55, BASE);
		start
			e_NO_TRUNC(FALSE);
		finis
	}
	else
		assertion(55, NOT_TESTABLE);

	assertion(56, BASE);
	start
		el_ENAMETOOLONG(TRUE);
	finis

	assertion(57, BASE);
	start
		el_ENAMETOOLONG(FALSE);
	finis

	assertion(58, BASE);
	start
		prep("Initialize a path name.");
		start
			Zstrcpy(path_old, temp_path());
			Zstrcat(path_old, "no_rename_dir/_rename");

			Zstrcpy(path_new, temp_path());
			Zstrcat(path_new, FILENAME);
			Zclose(Zcreat(path_new, PROT_ALL));
		finis

		testing("Call to rename() when component of path prefix of old");
		testing("or new does not exist.");
		start
			expecting(-1);
			expecting(ENOENT);
			Zrename(path_old, path_new);

			expecting(-1);
			expecting(ENOENT);
			Zrename(path_new, path_old);

			expecting(SUCCESS);
			Zaccess(path_new, F_OK);					/* old not changed */
		finis
	finis

	assertion(59, BASE);
	start
		testing("Call to rename() when old argument does not exist.");
		start
			Zstrcpy(path_old, temp_path());
			Zstrcat(path_old, "_not_here");

			expecting(-1);
			expecting(ENOENT);
			Zrename(path_old, path_new);
		finis
	finis

	assertion(60, BASE);
	start
		testing("Call to rename() when old or new points to an empty string.");
		start
			expecting(-1);
			expecting(ENOENT);
			Zrename("", path_new);

			expecting(-1);
			expecting(ENOENT);
			Zrename(path_new, "");

			expecting(SUCCESS);
			Zaccess(path_new, F_OK);					/* old not changed */
		finis
	finis

	{								/* Assertion 61 and 62. */
		int	link_cnt, i;

		Zstrcpy(path, temp_path());
		Zstrcat(path, DIRNAME);
		Zmkdir(path, PROT_ALL);

		Zstrcpy(path_old, temp_path());
		Zstrcat(path_old, "link_target");
		Zclose(Zcreat(path_old, PROT_ALL));

		link_cnt = pathconf(path, _PC_LINK_MAX);
		if((link_cnt > PCTS_LINK_MAX) || (link_cnt == -1)) {
			link_cnt = PCTS_LINK_MAX;

			assertion(61, NOT_TESTABLE);
			assertion(62, NOT_TESTABLE);
		}
		else {
			assertion(61, BASE);
			start
				if(PCD_CREAT_LINK_COUNT == TRUE) {
					testing("Errno [EMLINK] is detected.");
					start
						for(i = 1; i < link_cnt; i++){
							sprintf(path_new, "%s%s/%d",temp_path(),DIRNAME,i);
							Zclose(Zcreat(path_new, PROT_ALL));
						}
			
						Zstat(path_old, &st_buf1);
						sprintf(path_new, "%s%s/%d", temp_path(), DIRNAME, i);
						expecting(EMLINK);
						Zrename(path_old, path_new);
					finis
			
					cleanup("Unlink temp files.");
					start
						unlink(path_new);
						for(i = 1; i < link_cnt; i++){
							sprintf(path_new, "%s%s/%d",temp_path(),DIRNAME,i);
							Zunlink(path_new);
						}
					finis
				}
				else
					not_implemented("{PCD_CREAT_LINK_COUNT} of TRUE");
			finis

			assertion(62, BASE);
			start
				if(PCD_CREAT_LINK_COUNT == FALSE) {
					testing("{LINK_MAX} +1 (%lu) links can be created.",
							(unsigned long) (link_cnt +1));
					start
						for(i = 1; i < link_cnt; i++){
							sprintf(path_new, "%s%s/%d",temp_path(),DIRNAME,i);
							Zclose(Zcreat(path_new, PROT_ALL));
						}
			
						Zstat(path_old, &st_buf1);
						sprintf(path_new, "%s%s/%d", temp_path(), DIRNAME, i);
						expecting(SUCCESS);
						Zrename(path_old, path_new);
					finis

					cleanup("Unlink temp files.");
					start
						unlink(path_new);
						for(i = 1; i < link_cnt; i++){
							sprintf(path_new, "%s%s/%d",temp_path(),DIRNAME,i);
							Zunlink(path_new);
						}
					finis
				}
				else
					not_implemented("{PCD_CREAT_LINK_COUNT} of FALSE");
			finis
		}
		Zrmdir(path);
	}

	assertion(63, NOT_APPLICABLE);
	assertion(64, EXTENDED);

	assertion(65, BASE);
	start
		prep("Initialize a path name.");
		start
			sprintf(path_old, "%s%s", temp_path(), FILENAME);
			Zclose(Zcreat(path_old, PROT_ALL));
			sprintf(path_old, "%s%s/%s", temp_path(), FILENAME, "dummy");

			Zstrcpy(path_new, temp_path());
			Zstrcat(path_new, FILENAME_NEW);
			Zclose(Zcreat(path_new, PROT_ALL));
		finis

		testing("Call to rename() when component of path prefix is not");
		testing("a directory.");
		start
			expecting(-1);
			expecting(ENOTDIR);
			Zrename(path_old, path_new);

			expecting(-1);
			expecting(ENOTDIR);
			Zrename(path_new, path_old);

			expecting(SUCCESS);
			Zaccess(path_new, F_OK);					/* old not changed */
		finis
	finis

	assertion(66, BASE);
	start
		testing("Call to rename() when old names a directory and new");
		testing("names a non-directory.");
		start
			Zstrcpy(path_old, temp_path());
			Zstrcat(path_old, DIRNAME);
			Zmkdir(path_old, PROT_ALL);

			Zstrcpy(path_new, temp_path());
			Zstrcat(path_new, FILENAME);
			Zstat(path_new, &st_buf1);

			expecting(-1);
			expecting(ENOTDIR);
			Zrename(path_old, path_new);
		finis

		testing("Named files are not changed.");
		start
			expecting(SUCCESS);
			Zaccess(path_old, F_OK);

			Zstat(path_new, &st_buf2);
			if(st_buf1.st_ino != st_buf2.st_ino) 
				error("%s\n%s%lu.\n%s%lu.\n",
						"File inode not expected inode.",
						"Expected inode of file to be: ",
						(unsigned long) st_buf1.st_ino,
						"Actual inode of file is: ",
						(unsigned long) st_buf2.st_ino);
		finis
	finis

	done();
}


				/*	Test assertions asociated with {NAME_MAX} for rename().
					When old_path is TRUE, path_old is the path where
					the long name is generated for.
				*/
void el_NO_TRUNC(int old_path)
{
	char	*lpath;
	long	res_p;
	char	path[_POSIX_PATH_MAX +1];
	char	*path_tmp;

	Zstrcpy(path, temp_path());
	res_p = pathconf(path, _PC_NO_TRUNC);
	if(res_p != (long) -1 )  {

		lpath = g_lname();

		prep("Initialize a second pathname.");
		start
			path_tmp = (char *) Zmalloc(_POSIX_PATH_MAX +1);
			Zstrcpy(path_tmp, temp_path());
			Zstrcat(path_tmp, "path_2nd");
			if(!old_path)
				Zclose(Zcreat(path_tmp, PROT_ALL));
		finis

		if(tc_name_max() == TRUE) {
			testing("Path component longer than {NAME_MAX}.");
			start
				if(old_path) {
					expecting(ENAMETOOLONG);
					Zrename(lpath, path_tmp);
				}
				else {
					expecting(ENAMETOOLONG);
					Zrename(path_tmp, lpath);

								/* File pointed to by path_tmp not altered. */
					expecting(SUCCESS);
					Zaccess(path_tmp, F_OK);
				}
			finis
		}
		else {
			testing("Path component equal to {PCTS_NAME_MAX}.");
			start
				if(old_path)
					Zrename(lpath, path_tmp);
				else
					Zrename(path_tmp, lpath);
			finis
		}

		cleanup("Remove buffer space allocated for long path.");
		start
			if(!old_path)
				Zunlink(path_tmp);
			Zfree(lpath);
			Zfree(path_tmp);
		finis
	}
	else
		error("{_POSIX_NO_TRUNC} not supported.");
}


				/*	Test [ENAMETOOLONG] for rename() 
					When old_path is TRUE, path_old is the path where
					the long name is generated for.
				*/
void el_ENAMETOOLONG(int old_path)
{
	char	*lpath, *path_tmp;
	int		test_pm;

	if(test_pm = tc_path_max()) {
		prep("Establish pathname of {PATH_MAX} +2 bytes.");
		start
			lpath = g_lpath();
		finis
	}
	else {
		prep("Establish pathname of {PCTS_PATH_MAX} +2 bytes.");
		start
			char	*ptr, *ptr_end;

					/* Allocate buffer for {PCTS_PATH_MAX} +1 + "/X" */
			lpath = (char *) Zmalloc(PCTS_PATH_MAX +3);

			Zstrcpy(lpath, temp_path());
			Zstrcat(lpath, "ENAMETOOLONG");
			if(access(lpath, F_OK))
				Zmkdir(lpath, PROT_ALL);
			ptr = lpath +Zstrlen(lpath);

			ptr_end = PCTS_PATH_MAX +lpath;
			for( ; ptr +16 < ptr_end; ptr += 16 )
        		(void) strcpy(ptr, "/../ENAMETOOLONG");

			for( ; ptr < ptr_end; ptr += 2 )
        			(void) strcpy(ptr, "/.");

							/* End of path may be "/.//X" "or /./X". */
        	(void) strcpy(ptr_end, "/X");
		finis
	}

	prep("Initialize second pathname.");
	start
		path_tmp = (char *) Zmalloc(_POSIX_PATH_MAX +1);
		Zstrcpy(path_tmp, temp_path());
		Zstrcat(path_tmp, "path_scnd");
		if(!old_path)
			Zclose(Zcreat(path_tmp, PROT_ALL));
	finis

	if(test_pm = tc_path_max()) {
		testing("For path exceeds {PATH_MAX}.");
		start
			expecting(ENAMETOOLONG);
			if(old_path)
				Zrename(lpath, path_tmp);
			else {
				Zrename(path_tmp, lpath);

								/* File pointed to by path_tmp not altered. */
				expecting(SUCCESS);
				Zaccess(path_tmp, F_OK);
			}
		finis
	}
	else {
		testing("For path length of {PCTS_PATH_MAX}.");
		start
			if(old_path)
				Zrename(lpath, path_tmp);
			else
				Zrename(path_tmp, lpath);
		finis
	}

	cleanup("Remove buffer space allocated for long path.");
	start
		if(!old_path)
			Zunlink(path_tmp);
		Zfree( lpath );
		Zfree(path_tmp);
	finis
}
