#include	<pcts.h>

#include	<Zunistd.h>
#include	<sys/Zstat.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>

#define	FILENAME	"5.5.2_25"


int main(void)
{
	char	path[_POSIX_PATH_MAX +1];

	setup(E_RMDIR);
	funct(E_RMDIR);

	assertion(25, BASE);
	start
		testing("Search permission for path component is denied.");
		start
			Zstrcpy(path, data_path());
			Zstrcat(path, "no_srch.d");
			Zstrcat(path, "/rmdir_tryme");

			expecting(-1);
			expecting(EACCES);
			Zrmdir(path);
		finis

		testing("Directory was not removed.");
		start
			Zstrcpy(path, data_path());
			Zstrcat(path, "no_srch.d");
			Zchmod(path, S_IRWXU);
			Zstrcat(path, "/rmdir_tryme");
			Zaccess(path, F_OK);
		finis

		cleanup("Reset data file permisssion changed during testing.");
		start
			Zstrcpy(path, data_path());
			Zstrcat(path, "no_srch.d");
			Zchmod(path, S_IRUSR | S_IWUSR);
		finis
	finis

	assertion(26, BASE);
	start
		testing("Write permission for parent directory is denied.");
		start
			Zstrcpy(path, data_path());
			Zstrcat(path, "no_write.d");
			Zstrcat(path, "/rmdir_tryme");

			expecting(-1);
			expecting(EACCES);
			Zrmdir(path);
		finis

		testing("Directory was not removed.");
		start
			Zstrcpy(path, data_path());
			Zstrcat(path, "no_write.d");
			Zchmod(path, S_IRWXU);
			Zstrcat(path, "/rmdir_tryme");
			Zaccess(path, F_OK);
		finis

		cleanup("Reset data file permisssion changed during testing.");
		start
			Zstrcpy(path, data_path());
			Zstrcat(path, "no_write.d");
			Zchmod(path, S_IRUSR | S_IXUSR);
		finis
	finis

	assertion(27, EXTENDED);

	assertion(28, BASE);
	start
		testing("Removal of directory that is not empty.");
		start
			Zstrcpy(path, data_path());
			Zstrcat(path, "not_empty.d");

			expecting(-1);
			Zrmdir(path);
			if(!((errno == EEXIST) || (errno == ENOTEMPTY)))
				error("Value for errno is %s.", err_lookup(errno));
		finis

		testing("Directory was not removed.");
		start
			expecting(SUCCESS);
			Zaccess(path, F_OK);
		finis
	finis

	if(tc_name_max()) {
		assertion(29, BASE);
		start
			e_NO_TRUNC(E_RMDIR);
		finis
	}
	else
		assertion(29, NOT_TESTABLE);

	if(!tc_name_max()) {
		assertion(30, BASE);
		start
			e_NO_TRUNC(E_RMDIR);
		finis
	}
	else
		assertion(30, NOT_TESTABLE);

	assertion(31, BASE);
	start
		e_ENAMETOOLONG(E_RMDIR);
	finis

	assertion(32, BASE);
	start
		testing("Call to rmdir() when a component of the path prefix does");
		testing("not exist.");
		start
			Zstrcpy(path, temp_path());
			Zstrcat(path, "_rmdir/_rmdir_");

			expecting(-1);
			expecting(ENOENT);
			Zrmdir(path);
		finis
	finis

	assertion(33, BASE);
	start
		testing("Call to rmdir() when path argument names a non-existent");
		testing("directory.");
		start
			Zstrcpy(path, temp_path());
			Zstrcat(path, "_rmdir");

			expecting(-1);
			expecting(ENOENT);
			Zrmdir(path);
		finis
	finis

	assertion(34, BASE);
	start
		testing("Call to rmdir() when path argument points to empty string.");
		start
			expecting(-1);
			expecting(ENOENT);
			Zrmdir("");
		finis
	finis

	assertion(35, BASE);
	start
		testing("Call rmdir() when path component is not a directory.");
		start
			Zstrcpy(path, temp_path());
			Zstrcat(path, FILENAME);
			Zclose(Zcreat(path, PROT_ALL));
			Zstrcat(path, "/");
			Zstrcat(path, FILENAME);

			expecting(-1);
			expecting(ENOTDIR);
			Zrmdir(path);
		finis
	finis

	done();
}
