#include	<pcts.h>

#include	<Zunistd.h>
#include	<sys/Zstat.h>

#include	<sv_env.h>
#include	<sv_errno.h>

/* This module has the S_ISUID mode set to ROOT. */


int main(void)
{
	char	path[_POSIX_PATH_MAX +1];
	char	*pathm;
	pid_t	pid;
	time_t	s_time;

	setup(E_RMDIR);
	funct(E_RMDIR);

	if( ! PCD_READ_ONLY_FILE_SYSTEM) {
		assertion(36, BASE);
		start
			not_implemented("read-only file system");
		finis

		done();
	}
	assertion(36, BASE);
	start
		pathm = fs_mount(MOUNT_RO, ROFS_DIR);

		abstract("Ensure mounted file system gets mounted.");
		start
			break_on(ERROR);
			prep("Establish path to ROFS_TESTDIR and obtain a starting time.");
			start
				Zstrcpy(path, pathm);
				Zstrcat(path, "/" );
				Zstrcat(path, ROFS_TESTDIR);

				Ztime(&s_time);			/* Obtain minimum reference time. */
				dt_secs(TRF_DELAY);		/* Delay a fixed interval.			*/
			finis

			testing("Call to rmdir(), by process with appropriate privileges,");
			testing("to remove a directory from a read-only file system.");
			testing("rmdir(%s)", path);
			start
				expecting(-1);
				expecting(EROFS);
				Zrmdir(path);
			finis

			FORK
				prep("Set effective user ID to real user ID.");
				start
					Zsetuid(getuid());
				finis
	
				testing("Call to rmdir(), by process without appropriate");
				testing("privileges, to remove a directory from  a read-only");
				testing("file system.");
				testing("rmdir(%s)", path);
				start
					expecting(-1);
					expecting(EROFS);
					Zrmdir(path);
				finis
	
				testing("Named directory was  not removed.");
				start
					expecting(SUCCESS);
					Zaccess(path, F_OK);
				finis

				testing("Time related elements \"st_atime\", \"st_ctime\" and");
				testing("\"st_mtime\" of the parent directory are not changed");
				start
					trf_ck(CHK_ATIME, FALSE, s_time, NO_FILDES, pathm);
					trf_ck(CHK_CTIME, FALSE, s_time, NO_FILDES, pathm);
					trf_ck(CHK_MTIME, FALSE, s_time, NO_FILDES, pathm);
				finis
			KROF
		finis
	
		fs_umount(ROFS_DIR);
	finis

	done();
}
