#include	<pcts.h>

#include	<Zunistd.h>
#include	<sys/Zstat.h>
#include	<Zfcntl.h>
#include	<Zdirent.h>

#include	<sv_env.h>
#include	<sv_errno.h>

#define	DIRNAME		"5.5.2_pth.d"
#define	DIRNAME_NEW	"5.5.2_pth_d"

static char	*file_names[] = {
							"ABCDEFGHIJLKM",
							"NOPQRSTUVWXYZ",
							"abcdefghijlkm",
							"nopqrstuvwxyz",
							"0123456789._-"
						   };


#define	INITIAL_PATHNAME_ASS_NUM	4
static	int	err_ass;
int	ck_ul(char *);

int main(void)
{
	int		ass_num = INITIAL_PATHNAME_ASS_NUM;
	char	path_cwd[_POSIX_PATH_MAX +1], path_ref[_POSIX_PATH_MAX +1];

	setup(E_RMDIR);
	funct(E_RMDIR);

	assertion(ass_num, BASE);
	start
		prep("Change current working directory to \"../tmp/%s.d\".",
									element[(int) E_RMDIR].e_name);
		prep("Create known directory entries and files in working directory.");
		start
			exit_on(ERROR);
			Zstrcpy(path_cwd, temp_path());
			path_cwd[strlen(path_cwd) -1] = '\000'; /* delete trailing '/' */
			Zchdir(path_cwd);
			Zgetcwd(path_cwd, _POSIX_PATH_MAX +1);
			Zmkdir(DIRNAME, S_IRWXU);
										/*
												Working_Directory
												       |
											        DIRNAME
												       
										*/
		finis

		testing("When the first filename component of the filename");
		testing("argument is \".\", and the pathname does not begin with");
		testing("a slash, then the pathname is resolved by locating");
		testing("the second filename component in the current working");
		testing("directory.");
		start
			Zmkdir(DIRNAME_NEW, S_IRWXU);
			Zaccess(DIRNAME_NEW, F_OK);

			sprintf(path_ref, "%s/%s", ".", DIRNAME_NEW);
			Zrmdir(path_ref);
			expecting(ENOENT);
			Zaccess(DIRNAME_NEW, F_OK);
		finis
	finis

	assertion(++ass_num, EXTENDED);
	assertion(++ass_num, EXTENDED);

	assertion(++ass_num, BASE);
	start
		testing("Filename argument points to the string beginning");
		testing("with a \"/\".");
		start
			Zmkdir(DIRNAME_NEW, S_IRWXU);
			Zaccess(DIRNAME_NEW, F_OK);

			sprintf(path_ref, "%s/%s", path_cwd, DIRNAME_NEW);
			Zrmdir(path_ref);
			expecting(ENOENT);
			Zaccess(DIRNAME_NEW, F_OK);
		finis

		testing("Filename argument points to the string beginning");
		testing("with a \"///\".");
		start
			Zmkdir(DIRNAME_NEW, S_IRWXU);
			Zaccess(DIRNAME_NEW, F_OK);

			sprintf(path_ref, "//%s/%s", path_cwd, DIRNAME_NEW);
			Zrmdir(path_ref);
			expecting(ENOENT);
			Zaccess(DIRNAME_NEW, F_OK);
		finis
	finis

	assertion(++ass_num, BASE);
	start
		testing("First filename component of the pathname argument is \"..\".");
		start
			Zchdir(DIRNAME);
			Zmkdir(DIRNAME_NEW, S_IRWXU);
			Zaccess(DIRNAME_NEW, F_OK);

			sprintf(path_ref, "../%s/%s", DIRNAME, DIRNAME_NEW);
			Zrmdir(path_ref);
			expecting(ENOENT);
			Zaccess(DIRNAME_NEW, F_OK);

			Zchdir(path_cwd);
		finis
	finis

	assertion(++ass_num, BASE);
	start
		testing("Filename argument points to the string \"F1/\" and");
		testing("F1 is a directory.");
		start
			Zmkdir(DIRNAME_NEW, S_IRWXU);
			Zaccess(DIRNAME_NEW, F_OK);

			sprintf(path_ref, "%s/", DIRNAME_NEW);
			Zrmdir(path_ref);
			expecting(ENOENT);
			Zaccess(DIRNAME_NEW, F_OK);
		finis
	finis

	assertion(++ass_num, BASE);
	start
		testing("Filename argument points to the string \"F1//\" and");
		testing("F1 is a directory.");
		start
			Zmkdir(DIRNAME_NEW, S_IRWXU);
			Zaccess(DIRNAME_NEW, F_OK);

			sprintf(path_ref, "%s//", DIRNAME_NEW);
			Zrmdir(path_ref);
			expecting(ENOENT);
			Zaccess(DIRNAME_NEW, F_OK);
		finis
	finis

	assertion(++ass_num, BASE);
	start
		testing("Filename argument points to the string \"F1/F2\".");
		start
			Zchdir(DIRNAME);
			Zmkdir(DIRNAME_NEW, S_IRWXU);
			Zaccess(DIRNAME_NEW, F_OK);
			Zchdir(path_cwd);

			sprintf(path_ref, "%s/%s", DIRNAME, DIRNAME_NEW);
			Zrmdir(path_ref);

			Zchdir(DIRNAME);
			expecting(ENOENT);
			Zaccess(DIRNAME_NEW, F_OK);
			Zchdir(path_cwd);
		finis
	finis

	assertion(++ass_num, BASE);
	start
		testing("Filename argument points to the string \"F1/./F2\".");
		start
			Zchdir(DIRNAME);
			Zmkdir(DIRNAME_NEW, S_IRWXU);
			Zaccess(DIRNAME_NEW, F_OK);
			Zchdir(path_cwd);

			sprintf(path_ref, "%s/./%s", DIRNAME, DIRNAME_NEW);
			Zrmdir(path_ref);

			Zchdir(DIRNAME);
			expecting(ENOENT);
			Zaccess(DIRNAME_NEW, F_OK);
			Zchdir(path_cwd);
		finis
	finis

	assertion(++ass_num, BASE);
	start
		testing("Filename argument points to the string \"F1/../F1/F2\".");
		start
			Zchdir(DIRNAME);
			Zmkdir(DIRNAME_NEW, S_IRWXU);
			Zaccess(DIRNAME_NEW, F_OK);
			Zchdir(path_cwd);

			sprintf(path_ref, "%s/../%s/%s", DIRNAME, DIRNAME, DIRNAME_NEW);
			Zrmdir(path_ref);

			Zchdir(DIRNAME);
			expecting(ENOENT);
			Zaccess(DIRNAME_NEW, F_OK);
			Zchdir(path_cwd);
		finis
	finis

	assertion(++ass_num, BASE);
	start
		testing("Filename argument points to the string \"F1//F2\".");
		start
			Zchdir(DIRNAME);
			Zmkdir(DIRNAME_NEW, S_IRWXU);
			Zaccess(DIRNAME_NEW, F_OK);
			Zchdir(path_cwd);

			sprintf(path_ref, "%s//%s", DIRNAME, DIRNAME_NEW);
			Zrmdir(path_ref);

			Zchdir(DIRNAME);
			expecting(ENOENT);
			Zaccess(DIRNAME_NEW, F_OK);
			Zchdir(path_cwd);
		finis
	finis

	if(pathconf(DIRNAME, _PC_NO_TRUNC) == (long) -1) {
		assertion(++ass_num, BASE);
		start
			testing("Filename component is a string of more than {NAME_MAX}");
			testing("bytes in a directory for which {_POSIX_NO_TRUNC} is not");
			testing("supported.");
			start
				error("{_POSIX_NO_TRUNC} not supported.");
			finis
		finis
	}
	else
		assertion(++ass_num, NOT_APPLICABLE);

	assertion(++ass_num, BASE);
	start
		int	i;

		for(i=0; i<5; i++) {
			testing("Filename of \"%s\" is supported and", file_names[i]);
			testing("the unique identity of upper and lower case");
			testing("letters are retained.");
			start
				sprintf(path_ref, "%s/%s", DIRNAME, file_names[i]);
				Zmkdir(path_ref, PROT_ALL);
				ck_ul(file_names[i]);
				Zrmdir(path_ref);

				Zchdir(DIRNAME);
				expecting(ENOENT);
				Zaccess(file_names[i], F_OK);
				Zchdir(path_cwd);
			finis
		}
	finis

	assertion(++ass_num, BASE);
	start
		testing("Filename retains the unique identity of its upper and lower");
		testing("case letters.");
		start
			if(err_ass)
				error("See previous assertion for specifics of failure.");
		finis
	finis

	done();
}


		/*	For the Filename tests, check that the upper and lower case
			letters are preserved.  Read the directory and match with 
			the expected names.  This procedure is not performed for
			each element, but each element is covered, if all the filename
			tests are successful.
		*/

int	ck_ul(char *f_name)
{
	DIR		*dirp;
	struct	dirent *dirent;
	int	i;
	
	dirp = Zopendir(DIRNAME);
	dirent = Zreaddir(dirp);
	for(i=0; i<2; i++) {	/* Skip dot and dot-dot entries if they exist */
		if( ! ((dirent->d_name)[0] == '.') )
			break;
		dirent = Zreaddir(dirp);
	}
											/* Compare only filename */
	if(strcmp(dirent->d_name, f_name)) {
		error("%s\n%s\"%s\"\n%s\"%s\"\n",
			"Filename entry obtained not what was expected.",
			"Expected:	",
			f_name,
			"Actual:	",
			dirent->d_name);
		err_ass++;
	}
	Zclosedir(dirp);
}
