#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zfcntl.h>
#include	<sys/Zstat.h>

#include	<sv_env.h>
#include	<sv_errno.h>

#define	FILENAME	"5.6.2a_30"

int main(void)
{
	char	path[_POSIX_PATH_MAX +1];
	struct	stat st_buf;

	setup(E_STAT);
	funct(E_STAT);

	assertion(30, BASE);
	start
		prep("Initialize a path name.");
		start
			Zstrcpy(path, data_path());
			Zstrcat(path, "no_srch.d");
			Zstrcat(path, "/_tryme_");
		finis

		testing("Search permission for path is denied.");
		start
			expecting(-1);
			expecting(EACCES);
			Zstat(path, &st_buf);
		finis
	finis

	if(tc_name_max()) {
		assertion(31, BASE);
		start
			e_NO_TRUNC(E_STAT);
		finis
	}
	else
		assertion(31, NOT_TESTABLE);

	if(!tc_name_max()) {
		assertion(32, BASE);
		start
			e_NO_TRUNC(E_STAT);
		finis
	}
	else
		assertion(32, NOT_TESTABLE);

	assertion(33, BASE);
	start
		e_ENAMETOOLONG(E_STAT);
	finis

	assertion(34, BASE);
	start
		testing("Named file does not exist.");
		start
			Zstrcpy(path, temp_path());
			Zstrcat(path, "_stat_");

			expecting(-1);
			expecting(ENOENT);
			Zstat(path, &st_buf);
		finis
	finis

	assertion(35, BASE);
	start
		testing("Conponent of the path prefix of path does not exist.");
		start
			Zstrcpy(path, temp_path());
			Zstrcat(path, "_stat_/_stat_");

			expecting(-1);
			expecting(ENOENT);
			Zstat(path, &st_buf);
		finis
	finis

	assertion(36, BASE);
	start
		testing("Empty string for path.");
		start
			expecting(-1);
			expecting(ENOENT);
			Zstat("", &st_buf);
		finis
	finis

	assertion(37, BASE);
	start
		testing("Component of path prefix is not a directory.");
		start
			Zstrcpy(path, temp_path());
			Zstrcat(path, FILENAME);
			Zclose(Zcreat(path, PROT_ALL));
			Zstrcat(path, "/_stat_");

			expecting(-1);
			expecting(ENOTDIR);
			Zstat(path, &st_buf);
		finis
	finis

	done();
}
