#include	<pcts.h>

#include	<Zunistd.h>
#include	<sys/Zstat.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>

/*	Module has S_ISUID mode set to ROOT. */

#define	DIRNAME_1	"5.6.2a_acc.d1"
#define	DIRNAME_2	"5.6.2a_acc.d2"


int main(void)
{
	char	path[_POSIX_PATH_MAX +1], path2[_POSIX_PATH_MAX +1];
	struct	stat st_buf;
	pid_t	pid;

	setup(E_STAT);
	funct(E_STAT);

	assertion(27, BASE);
	start
		prep("Establish strings to be used as paths.");
		start
			Zstrcpy(path2, temp_path());
			Zstrcat(path2, DIRNAME_1);
			sprintf(path, "%s/%s", path2, DIRNAME_2);
		finis

		FORK
			prep("Establish process's real user ID as effective user ID.");
			start
				Zsetuid(getuid());
			finis

			prep("Establish path to a directory such that search access");
			prep("exists on path prefix and on directory.");
			start
				Zmkdir(path2, PROT_ALL);
				Zmkdir(path, S_IXUSR);		/* Search access on directory */
				Zchmod(path2, S_IXUSR);		/* Search access on path prefix */
			finis
				
			testing("For owner of file, stat() is successful.");
			start
				expecting(SUCCESS);
				Zstat(path, &st_buf);
			finis
		KROF

		FORK
			prep("Change owner of test directory.");
			prep("Change mode of test directory such that search access");
			prep("exists on path prefix for group owner only and search");
			prep("access exists on directory for group owner only.");
			start
				Zchown(path2, BIN_UID, GID);
				Zchown(path, BIN_UID, GID);
				Zchmod(path2, S_IXGRP);		/* Search access on path prefix */
				Zchmod(path, S_IXGRP);		/* Search access on directory */
			finis

			prep("Establish process's real user ID as effective user ID.");
			start
				Zsetuid(getuid());
			finis
				
			testing("For group owner of file, stat() is successful.");
			start
				expecting(SUCCESS);
				Zstat(path, &st_buf);
			finis
		KROF

		FORK
			prep("Change owner of test directory and its path prefix.");
			prep("Change mode of test directory such that search access");
			prep("exists on path prefix for others only and search access");
			prep("exists on directory for others only.");
			start
				Zchown(path2, BIN_UID, BIN_GID);
				Zchown(path, BIN_UID, BIN_GID);
				Zchmod(path2, S_IXOTH);		/* Search access on path prefix */
				Zchmod(path, S_IXOTH);		/* Search access on directory */
			finis

			prep("Establish process's real user ID as effective user ID.");
			start
				Zsetuid(getuid());
			finis
				
			testing("For others, stat() is successful.");
			start
				expecting(SUCCESS);
				Zstat(path, &st_buf);
			finis
		KROF

		cleanup("Remove test directories.");
		start
			rmdir(path);
			rmdir(path2);
		finis
	finis
	
	done();
}
