#include	<pcts.h>

#include	<Zunistd.h>
#include	<sys/Zstat.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>

#define	FILENAME	"5.5.1_27"


int main(void)
{
	char	path[_POSIX_PATH_MAX +1];

	setup(E_UNLINK);
	funct(E_UNLINK);

	assertion(27, BASE);
	start
		testing("Search permission for path component is denied.");
		start
			Zstrcpy(path, data_path());
			Zstrcat(path, "no_srch.d");
			Zstrcat(path, "/unlink_tryme");

			expecting(-1);
			expecting(EACCES);
			Zunlink(path);
		finis

		testing("Entry is not unlinked.");
		start
			Zstrcpy(path, data_path());
			Zstrcat(path, "no_srch.d");
			Zchmod(path, S_IRWXU);		/* Allow data file to be accessed. */
			Zstrcat(path, "/unlink_tryme");

			expecting(SUCCESS);
			Zaccess(path, F_OK);
		finis

		cleanup("Reset data file permission changed during testing.");
		start
			Zstrcpy(path, data_path());
			Zstrcat(path, "no_srch.d");
			Zchmod(path, S_IRUSR | S_IWUSR);
		finis
	finis

	assertion(28, BASE);
	start
		testing("Write permission for parent directory is denied.");
		start
			Zstrcpy(path, data_path());
			Zstrcat(path, "no_write.d");
			Zstrcat(path, "/unlink_tryme");

			expecting(-1);
			expecting(EACCES);
			Zunlink(path);
		finis

		testing("Entry is not unlinked.");
		start
			expecting(SUCCESS);
			Zaccess(path, F_OK);
		finis
	finis

	assertion(29, EXTENDED);

	if(tc_name_max()) {
		assertion(30, BASE);
		start
			e_NO_TRUNC(E_UNLINK);
		finis
	}
	else
		assertion(30, NOT_TESTABLE);

	if(!tc_name_max()) {
		assertion(31, BASE);
		start
			e_NO_TRUNC(E_UNLINK);
		finis
	}
	else
		assertion(31, NOT_TESTABLE);

	assertion(32, BASE);
	start
		e_ENAMETOOLONG(E_UNLINK);
	finis

	assertion(33, BASE);
	start
		testing("Call unlink() when path component prefix does not exist.");
		start
			Zstrcpy(path, temp_path());
			Zstrcat(path, "_unlink/_unlink");

			expecting(-1);
			expecting(ENOENT);
			Zunlink(path);
		finis
	finis

	assertion(34, BASE);
	start
		testing("Call unlink() when file named by path does not exist.");
		start
			Zstrcpy(path, temp_path());
			Zstrcat(path, "_unlink_");

			expecting(-1);
			expecting(ENOENT);
			Zunlink(path);
		finis
	finis

	assertion(35, BASE);
	start
		testing("Call unlink() when path is an empty string.");
		start
			expecting(-1);
			expecting(ENOENT);
			Zmkdir("", PROT_ALL);
		finis
	finis

	assertion(36, BASE);
	start
		testing("Call unlink() when path component is not a directory.");
		start
			Zstrcpy(path, temp_path());
			Zstrcat(path, FILENAME);
			Zclose(Zcreat(path, PROT_ALL));
			Zstrcat(path, "/");
			Zstrcat(path, FILENAME);

			expecting(-1);
			expecting(ENOTDIR);
			Zunlink(path);
		finis
	finis

	done();
}
