#include	<pcts.h>

#include	<Zunistd.h>
#include	<sys/Zstat.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>

/* This module has the S_ISUID mode set to ROOT. */

#define	DIRNAME		"5.5.1_37.d"
#define	DIRNAME2	"5.5.1_37.d2"


int main(void)
{
	char	path[_POSIX_PATH_MAX +1], path2[_POSIX_PATH_MAX +1];
	char	*pathm;
	pid_t	pid;
	time_t	s_time;

	setup(E_UNLINK);
	funct(E_UNLINK);

	assertion(37, BASE);
	start
		if((PCD_LINK_TO_DIRECTORY == TRUE) && (PCD_UNLINK_DIRECTORY == TRUE)) {
			prep("Have appropriate privilege process link to a directory.");
			start
				Zstrcpy(path, temp_path());
				Zstrcat(path, DIRNAME);
				Zmkdir(path, PROT_ALL);

				Zstrcpy(path2, temp_path());
				Zstrcat(path2, DIRNAME2);
				Zlink(path, path2);
			finis

			FORK
				prep("Set effective user ID to real user ID.");
				start
					Zsetuid(getuid());
				finis

				testing("Ordinary user process removing a link to a directory");
				start
					expecting(-1);
					expecting(EPERM);
					Zunlink(path2);
				finis

				testing("Directory is not unlinked.");
				start
					expecting(SUCCESS);
					Zaccess(path2, F_OK);
				finis
			KROF

			cleanup("Remove test files.");
			start
				Zunlink(path2);
				Zrmdir(path);
			finis

		} else
			not_implemented(
	"{PCD_LINK_TO_DIRECTORY} of TRUE and/or {PCD_UNLINK_DIRECTORY} of TRUE");
	finis

	assertion(38, EXTENDED);

	if( ! PCD_READ_ONLY_FILE_SYSTEM) {
		assertion(39, BASE);
		start
			not_implemented("read-only file systems");
		finis

		done();
	}
	assertion(39, BASE);
	start
		pathm = fs_mount(MOUNT_RO, ROFS_REG_FILE);

		abstract("Ensure mounted file system gets unmounted.");
		start
			break_on(ERROR);

			prep("Establish path to implementation provided ROFS_TESTFILE");
			prep("and a starting time.");
			start
				Zstrcpy(path, pathm);
				Zstrcat(path, "/" );
				Zstrcat(path, ROFS_TESTFILE);

				Ztime(&s_time);			/* Obtain minimum reference time. */
				dt_secs(TRF_DELAY);		/* Delay a fixed interval.			*/
			finis

			testing("Appropriate privilege process unlinking a file");
			testing("on a read-only file system.");
			testing("unlink(%s)", path);
			start
				expecting(-1);
				expecting(EROFS);
				Zunlink(path);
			finis

			FORK
				prep("Set effective user ID to real user ID.");
				start
					Zsetuid(getuid());
				finis

				testing("Call to unlink(), by process without appropriate");
				testing("privileges, to unlink file on read-only file system.");
				start
					expecting(-1);
					expecting(EROFS);
					Zunlink(path);
				finis

				testing("Directory is not unlinked.");
				start
					expecting(SUCCESS);
					Zaccess(path, F_OK);
				finis

				testing("Time related elements \"st_atime\", \"st_ctime\" and");
				testing("\"st_mtime\" of the parent directory are not changed");
				start
					trf_ck(CHK_ATIME, FALSE, s_time, NO_FILDES, pathm);
					trf_ck(CHK_CTIME, FALSE, s_time, NO_FILDES, pathm);
					trf_ck(CHK_MTIME, FALSE, s_time, NO_FILDES, pathm);
				finis
			KROF
		finis

		fs_umount(ROFS_REG_FILE);
	finis

    done();
}
