#include	<pcts.h>

#include	<Zunistd.h>
#include	<sys/Zstat.h>
#include	<Zutime.h>

#include	<sv_env.h>
#include	<sv_errno.h>

#define	FILENAME	"5.6.6_19"
#define	AC_TIME		10
#define	MOD_TIME	100

int main(void)
{
	char	path[_POSIX_PATH_MAX +1];
	time_t	s_time;

	setup(E_UTIME);
	funct(E_UTIME);

	assertion(19, BASE);
	start
		prep("Setup path to test data file.");
		prep("Data file owner matches effective user ID.");
		prep("No write permission on file.");
		start
			Zstrcpy(path, data_path());
			Zstrcat(path, "utime_owner");
		finis

		testing("call to  utime(), when the times argument is NULL,");
		testing("sets the last accessed and modified time to the current");
		testing("time and returns zero.");
		start
			Ztime(&s_time);				/* Obtain minimum reference time. */
			dt_secs(TRF_DELAY);			/* Delay a fixed interval.			*/

			expecting((int)0);
			Zutime(path, (struct utimbuf *)0);

			trf_ck(CHK_ATIME, TRUE, s_time, NO_FILDES, path);
			trf_ck(CHK_MTIME, TRUE, s_time, NO_FILDES, path);
		finis
	finis

	assertion(20, BASE);
	start
		prep("Setup path to test data file.");
		prep("Data file owner does not match effective user-ID.");
		prep("Process has write permission on file.");
		start
			Zstrcpy(path, data_path());
			Zstrcat(path, "utime_write");
		finis

		testing("call to  utime(), when the times argument is NULL,");
		testing("sets the last accessed and modified time to the current");
		testing("time and returns zero.");
		start
			Ztime(&s_time);				/* Obtain minimum reference time. */
			dt_secs(TRF_DELAY);			/* Delay a fixed interval.			*/

			expecting((int)0);
			Zutime(path, (struct utimbuf *)0);

			trf_ck(CHK_ATIME, TRUE, s_time, NO_FILDES, path);
			trf_ck(CHK_MTIME, TRUE, s_time, NO_FILDES, path);
		finis
	finis

	assertion(21, BASE);
	start
		struct	stat st_end;
		struct	utimbuf u_time;

		prep("Setup path to test data file.");
		prep("Data file owner matches effective user ID.");
		prep("No write permission on file.");
		start
			Zstrcpy(path, data_path());
			Zstrcat(path, "utime_owner");
		finis
	
		testing("call to  utime(), when the times argument is not NULL,");
		testing("sets the last accessed and modified time to the current");
		testing("time and returns zero.");
		start
			u_time.actime = AC_TIME;
			u_time.modtime = MOD_TIME;

			utime(path, &u_time);
			stat(path, &st_end);
			if(st_end.st_atime != AC_TIME)
				error("%s\n%s%d.\n%s%ul.",
						"Access time not set properly.",
						"Expected:	",
						AC_TIME,
						"Actual:	",
						(unsigned long)st_end.st_atime);
			if(st_end.st_mtime != MOD_TIME)
				error("%s\n%s%d.\n%s%ul.",
						"Access time not set properly.",
						"Expected:	",
						MOD_TIME,
						"Actual:	",
						(unsigned long)st_end.st_mtime);
		finis
	finis

	assertion(25, BASE);
	start
		testing("Call to utime() marks for update time-related field");
		testing("\"st_ctime\".");
		start
			Zstrcpy(path, temp_path());
			Zstrcat(path, FILENAME);
			Zclose(Zcreat(path, PROT_ALL));
			dt_secs(TRF_DELAY);			/* Delay a fixed interval.			*/

			Ztime(&s_time);				/* Obtain minimum reference time. */
			dt_secs(TRF_DELAY);			/* Delay a fixed interval.			*/

			expecting((int) 0);
			Zutime(path, (struct utimbuf *) 0);

			trf_ck(CHK_CTIME, TRUE, s_time, NO_FILDES, path);
		finis
	finis

	done();
}
