#include	<pcts.h>

#include	<Zunistd.h>
#include	<sys/Zstat.h>
#include	<Zutime.h>

#include	<sv_env.h>
#include	<sv_errno.h>

/* This module has the S_ISUID mode set to ROOT. */

#define	AC_TIME 	100
#define	MOD_TIME	200

int main(void)
{
	char	path[_POSIX_PATH_MAX +1];
	time_t	s_time;


	setup(E_UTIME);
	funct(E_UTIME);

	assertion(22, BASE);
	start
		struct	stat st_end;
		struct	utimbuf	u_time;

		if(APP_UTIME) {
			prep("Setup path such that appropriate privilege process user ID");
			prep("does not match the owner of the file used for testing.");
			start
				Zstrcpy(path, data_path());
				Zstrcat(path, "utime_bin");
			finis
	
			testing("call to  utime(), when the times argument is not NULL,");
			testing("sets the last accessed and modified time to the");
			testing("specified time and returns zero.");
			start
				u_time.actime = AC_TIME;;
				u_time.modtime = MOD_TIME;
	
				expecting(0);
				Zutime(path, &u_time);
				stat(path, &st_end);
				if(st_end.st_atime != AC_TIME)
					error("%s\n%s%d.\n%s%ul.",
							"Access time not set properly.",
							"Expected:	",
							AC_TIME,
							"Actual:	",
							(unsigned long)st_end.st_atime);
				if(st_end.st_mtime != MOD_TIME)
					error("%s\n%s%d.\n%s%ul.",
							"Access time not set properly.",
							"Expected:	",
							MOD_TIME,
							"Actual:	",
							(unsigned long)st_end.st_mtime);
			finis
		}
		else
			not_implemented("mechanism to create process to change file times");
	finis
	
	assertion(23, BASE);
	start
		if(APP_UTIME) {
			prep("Setup path such that appropriate privilege process");
			prep("user ID does not match the owner of the file used for");
			prep("testing.");
			start
				Zstrcpy(path, data_path());
				Zstrcat(path, "utime_bin");
			finis
	
			testing("Call to  utime(), when the times argument is NULL,");
			testing("sets the last accessed and modified time to the current");
			testing("time and returns zero.");
			start
				Ztime(&s_time);				/* Obtain minimum reference time. */
				dt_secs(TRF_DELAY);			/* Delay a fixed interval.		*/
	
				expecting((int) 0);
				Zutime(path, (struct utimbuf *) 0);
	
				trf_ck(CHK_ATIME, TRUE, s_time, NO_FILDES, path);
				trf_ck(CHK_MTIME, TRUE, s_time, NO_FILDES, path);
			finis
		}
		else
			not_implemented("mechanism to create process to change file times");
	finis
	
	done();
}
