#include	<pcts.h>

#include	<Zunistd.h>
#include	<sys/Zstat.h>
#include	<Zutime.h>

#include	<sv_env.h>
#include	<sv_errno.h>

/* This module has S_ISUID mode set to ROOT. */


int main(void)
{
	char	path[_POSIX_PATH_MAX +1];
	time_t	s_time;
	pid_t	pid;
	char	*pathm;

	setup(E_UTIME);
	funct(E_UTIME);

	if( ! PCD_READ_ONLY_FILE_SYSTEM) {
		assertion(36, BASE);
		start
			not_implemented("read-only file systems");
		finis

		done();
	}
	assertion(36, BASE);
	start
		pathm = fs_mount(MOUNT_RO, ROFS_REG_FILE);

		abstract("Ensure mounted file system gets unmounted.");
		start
			break_on(ERROR);
			prep("Establish path to implementation provided ROFS_TESTFILE");
			start
				Zstrcpy(path, pathm);
				Zstrcat(path, "/");
				Zstrcat(path, ROFS_TESTFILE);

				Ztime(&s_time);				/* Obtain minimum reference time. */
				dt_secs(TRF_DELAY);			/* Delay a fixed interval.		*/
			finis
	
			if(APP_UTIME) {
				testing("Call to utime(), by process with appropriate,");
				testing("privileges to change file's times on a read-only");
				testing("file system.");
				testing("Path name is \"%s\".", path);
				start
					expecting(-1);
					expecting(EROFS);
					Zutime(path, (struct utimbuf *) 0);
				finis
			}
	
			prep("Fork a child.");
			start
				sv_flush();
				pid = Zfork();
			finis

			if(pid == (pid_t)0) {
				exit_on(ERROR);
				prep("Set effective user ID to real user ID.");
				start
					Zsetuid(getuid());
				finis
	
				testing("Call to utime(), by process without appropriate");
				testing("privileges, to change file's times on a read-only");
				testing("file system.");
				start
					expecting(-1);
					expecting(EROFS);
					Zutime(path, (struct utimbuf *) 0);
				finis

				testing("File times not affected.");
				start
					trf_ck(CHK_ATIME, FALSE, s_time, NO_FILDES, path);
					trf_ck(CHK_CTIME, FALSE, s_time, NO_FILDES, path);
					trf_ck(CHK_MTIME, FALSE, s_time, NO_FILDES, path);
				finis

				done();
			}
			wait_for(pid, TIME_PCTS_FS_TESTING);
		finis
	
		fs_umount(ROFS_REG_FILE);
	finis
	
	done();
}
