#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zfcntl.h>

#include	<sv_env.h>

#define	String	"Rolling down the river."
#define	Strlen	(sizeof(String) -1)
#define	POS_BEG	((off_t)0)			/* Position to start of file */
#define	POS_END	((off_t) Strlen)	/* Position to end of file */
#define	FILENAME	"6.5.3_04"


int main(void)
{
	char	path[_POSIX_PATH_MAX +1];
	char	inbuf[Strlen];
	int		fd;
	off_t	ret;
	pid_t	pid;

	setup(E_LSEEK);
	funct(E_LSEEK);

	exit_on(ERROR);

	assertion(4, BASE);
	start
		prep("Create a test file and write to it.");
		start
			strcpy(path, temp_path());
			Zstrcat(path, FILENAME);
			fd = Zcreat(path, PROT_ALL);
			expecting(Strlen);
			Zwrite(fd, String, Strlen);
			Zclose(fd);
		finis

		FORK
			testing("Call to lseek(fildes, offset, SEEK_SET) sets the file"); 
			testing("offset offset bytes from the beginning of the file.");
			testing("The resulting offset location, in bytes, is returned.");
			start
				fd = Zopen(path, O_RDWR);
				ret = Zlseek(fd, POS_BEG, SEEK_SET);
				expecting(Strlen);
				Zread(fd, inbuf, Strlen);
	
				if(ret != POS_BEG)
					error("%s\n%s%lu.\n%s%lu.\n",
						"Incorrect return from lseek().",
						"Expected ",
						(unsigned long) POS_BEG,
						"Actual ",
						(unsigned long) ret);
			finis
	
			testing("A call to lseek(fildes, offset, SEEK_SET) sets the file"); 
			testing("offset bytes from the beginning of the file.");
			testing("The resulting offset location, in bytes, is returned.");
			start
				ret = Zlseek(fd, POS_END, SEEK_SET);
				expecting(POS_END -Strlen);
				Zread(fd, inbuf, Strlen);
	
				if(ret != POS_END)
					error("%s\n%s%lu.\n%s%lu.\n",
						"Incorrect return from lseek().",
						"Expected ",
						(unsigned long) POS_END,
						"Actual ",
						(unsigned long) ret);
			finis
		KROF
	finis

	assertion(5, BASE);
	start
		FORK
			testing("Call to lseek(fildes, offset, SEEK_CUR) sets the file"); 
			testing("offset offset bytes from the current position of file.");
			testing("The resulting offset location, in bytes, is returned.");
			start
				fd = Zopen(path, O_RDWR);
				ret = Zlseek(fd, POS_BEG, SEEK_CUR);
				expecting(Strlen);
				Zread(fd, inbuf, Strlen);
	
				if(ret != POS_BEG)
					error("%s\n%s%lu.\n%s%lu.\n",
						"Incorrect return from lseek().",
						"Expected ",
						(unsigned long) POS_BEG,
						"Actual ",
						(unsigned long) ret);
			finis
		KROF

		FORK
			testing("Call to lseek(fildes, offset, SEEK_CUR) sets the file"); 
			testing("offset offset bytes from the beginning of the file.");
			testing("The resulting offset location, in bytes, is returned.");
			start
				fd = Zopen(path, O_RDWR);
				ret = Zlseek(fd, POS_END, SEEK_CUR);
				expecting(POS_END -Strlen);
				Zread(fd, inbuf, Strlen);
	
				if(ret != POS_END)
					error("%s\n%s%lu.\n%s%lu.\n",
						"Incorrect return from lseek().",
						"Expected ",
						(unsigned long) POS_END,
						"Actual ",
						(unsigned long) ret);
			finis
		KROF
	finis

	assertion(6, BASE);
	start
		FORK
			testing("Call to lseek(fildes, offset, SEEK_END) sets the file"); 
			testing("offset to the size of the file plus offset bytes.");
			testing("The resulting offset location, in bytes, is returned.");
			start
				fd = Zopen(path, O_RDWR);
				ret = Zlseek(fd, POS_BEG, SEEK_END);
				expecting(0);
				Zread(fd, inbuf, sizeof(inbuf));
	
				if(ret != POS_END)
					error("%s\n%s%lu.\n%s%lu.\n",
						"Incorrect return from lseek().",
						"Expected ",
						(unsigned long) POS_END,
						"Actual ",
						(unsigned long) ret);
			finis
	
			testing("Call to lseek(fildes, offset, SEEK_END) sets the file"); 
			testing("offset offset bytes from the beginning of the file.");
			testing("The resulting offset location, in bytes, is returned.");
			start
				ret = Zlseek(fd, POS_END, SEEK_END);
				if(ret != POS_END +POS_END)
					error("%s\n%s%lu.\n%s%lu.\n",
						"Incorrect return from lseek().",
						"Expected ",
						(unsigned long) (POS_END +POS_END),
						"Actual ",
						(unsigned long) ret);
			finis
		KROF
	finis

	done();
}
