#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<pcts_timer.h>

#define	String	"abcdefghijklmnopqrstuvwxyz"
#define	String1	"ABCDEFGHIJKLMNOPQRSTUVWXYZ"
#define	Strlen	(sizeof(String) -1)

#define FILENAME "6.4.2_18"


int main(void)
{
	char	path[_POSIX_PATH_MAX +1];
	int 	fd;
	char	inbuf[2 * Strlen];

	setup(E_WRITE);
	funct(E_WRITE);

	exit_on(ERROR);

	assertion(18, BASE);
	start
		prep("Create a regular file for testing.");
		start
			Zstrcpy(path, temp_path());
			Zstrcat(path, FILENAME);
			fd = Zopen(path, O_CREAT | O_TRUNC | O_RDWR, PROT_ALL);
			expecting(Strlen);
			Zwrite(fd, String, Strlen);
		finis

		testing("A call to read from any byte position that was modified");
		testing("by the previous write() returns the data written to that");
		testing("position by the previous write().");
		start
			expecting((off_t)0);
			Zlseek(fd, (off_t)0, SEEK_SET);
			Zread(fd, inbuf, Strlen);
			if(strncmp(String, inbuf, Strlen))
				error("%s\n%s%s\n%s%*s\n",
						"Data read not what was written.",
						"Written string: ",
						String,
						"Read string: ",
						Strlen,
						inbuf);

			expecting((off_t)(Strlen -2));
			Zlseek(fd, (off_t)(Strlen -2), SEEK_SET);
			Zread(fd, inbuf, 2);
			if(strncmp(String +Strlen -2, inbuf, 2))
				error("%s\n%s%2s\n%s%2s\n",
						"Data read not what was written.",
						"Written string: ",
						String +Strlen -2,
						"Read string: ",
						inbuf);
		finis
	finis

	assertion(19, BASE);
	start
		testing("A call to write() overwrites data at position referenced.");
		start
			expecting((off_t)(Strlen/2));
			Zlseek(fd, (off_t)(Strlen/2), SEEK_SET);
			expecting(Strlen);
			Zwrite(fd, String1, Strlen);

			expecting((off_t)0);
			Zlseek(fd, (off_t)0, SEEK_SET);
			expecting(Strlen/2 +Strlen);
			Zread(fd, inbuf, Strlen/2 +Strlen);
			if(strncmp(String1, inbuf +Strlen/2, Strlen))
				error("%s\n%s%s\n%s%*s\n",
						"Data read was not what was written.",
						"Written string: ",
						String1,
						"Read string: ",
						Strlen,
						inbuf +Strlen/2);
		finis
	finis

	done();
}
