#include	<pcts.h>

#include	<Zunistd.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<termios.h>
#include	<pcts_timer.h>

int main(void)
{
	int		tty_fildes, loop_fildes;
	struct	termios tty_termios, *tty_termios_p = &tty_termios,
						loop_termios, *loop_termios_p = &loop_termios;
	pid_t	pid;
	int		i;
	sigset_t	set;

	setup(E_ABORT);
	funct(E_ABORT);

	assertion(12, BASE);
	start
		GTI_NOT_PROVIDED_EXIT
		for(i=0; i<3; i++) {
			prep("Fork a process to test with.");
			start
				sv_flush();
				pid = Zfork();
			finis
	
			if(pid == (pid_t)0) {
				prep("Establish PORT_TTY as control terminal and PORT_LOOP.");
				start
					termios_prep(&tty_fildes, tty_termios_p, &loop_fildes,
									loop_termios_p);
				finis
	
				prep("Fork a child process.");
				start
					sv_flush();
					pid = Zfork();
				finis
		
				if(pid == (pid_t)0) {			/* Child process */
					pid_t	c_ppid, gc_ppid, ggc_ppid;
		
					prep("Have child processes catch SIGHUP.");
					start
						SIGNAL(SIGHUP, sig_int);
						sig_rcvd = 0;
					finis
		
					prep("Fork a grandchild");
					prep("process.");
					start
						sv_flush();
						pid = Zfork();
					finis
		
					if(pid == (pid_t)0) {		/* Grandchild process */
						prep("Fork a great grandchild process.");
						start
							sv_flush();
							pid = Zfork();
						finis
		
						if(pid == (pid_t)0) {
							testing("Great grandchild received SIGHUP signal");
							testing("when controlling process calls abort()");
							testing("while SIGABRT signal is %s.",
								(i==0) ? "being ignored" :
								(i==1) ? "being blocked" :
								"caught and returns");
							start
								ggc_ppid = getppid();
								sleep(WAIT_FOR_TIME+2);/* Interrupt by SIGHUP */
								if( ! sig_rcvd)
									error("SIGHUP not received.");
							finis
		
							done();
						}
		
						testing("Grandchild process received a SIGHUP signal");
						testing("when controlling process calls abort()");
						testing("while SIGABRT signal is %s.",
								(i==0) ? "being ignored" :
								(i==1) ? "being blocked" :
								"caught and returns");
						start
							gc_ppid = getppid();
							sleep(WAIT_FOR_TIME +2);/* Interrupted by SIGHUP */
							if( ! sig_rcvd)
								error("SIGHUP not received.");
						finis
		
						WAIT_FOR_PID(pid);
		
						done();
					}
		
					testing("Child process received a SIGHUP signal");
					testing("when controlling process calls abort()");
					testing("while SIGABRT signal is %s.",
								(i==0) ? "being ignored" :
								(i==1) ? "being blocked" :
								"caught and returns");
					start
						c_ppid = getppid();
						sleep(WAIT_FOR_TIME +2);	/* Interrupted by SIGHUP */
						if( ! sig_rcvd)
							error("SIGHUP not received.");
					finis
		
					testing("Child's parent process ID has changed.");
					start
						if(c_ppid == getppid()) {
									/*	Allow for SIGHUP to be processed before
										the implementation has changed the ppid
										of the children.
									*/
							SLEEP(1);
							if(c_ppid == getppid())
								error("Child's parent process ID not changed.");
						}
					finis
		
					WAIT_FOR_PID(pid);
		
					done();
				}
		
				prep("Parent calls abort().");
				start
					if(i==0) {
						SIGNAL(SIGABRT, SIG_IGN);
					} else {
						if(i==1) {
							SIGBLOCK(set, SIGABRT);
												/* Ignore expected SIGABRT. */
							SIGNAL(SIGABRT, SIG_IGN);
						} else {
							SIGNAL(SIGABRT, sig_int);
						}
					}
						/* Allow time for child processes to be established. */
					SLEEP(WAIT_FOR_TIME +1);
				finis
		
				abort();
				error("Process continued after abort() was called.");
				done();
	
			}
			WAIT_FOR_PID(pid);
			/* Allow time for child processes to complete before continuing. */
			SLEEP(WAIT_FOR_TIME +4);
			SLEEP(GTI_LINE_CLOSE_DELAY);
		}
	finis
	
	done();
}
