#include	<pcts.h>

#include	<Zunistd.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<termios.h>
#include	<pcts_timer.h>

int main(void)
{
	int		tty_fildes, loop_fildes;
	struct	termios tty_termios, *tty_termios_p = &tty_termios,
						loop_termios, *loop_termios_p = &loop_termios;
	pid_t	pid, ct_pgrp;
	int		i;
	sigset_t	set;

	setup(E_ABORT);
	funct(E_ABORT);

	assertion(13, BASE);
	start
		GTI_NOT_PROVIDED_EXIT

		for(i=0; i<3; i++) {
			prep("Fork a process.");
			start
				sv_flush();
				pid = Zfork();
			finis
	
			if(pid == (pid_t)0) {
				prep("Establish PORT_TTY as control terminal and PORT_LOOP.");
				start
					termios_prep(&tty_fildes, tty_termios_p, &loop_fildes,
									loop_termios_p);
	
					SIGNAL(SIGHUP, SIG_IGN);
					ct_pgrp = Ztcgetpgrp(tty_fildes);
				finis

				if(i==0) {
					SIGNAL(SIGABRT, SIG_IGN);
				} else {
					if(i==1) {
						SIGBLOCK(set, SIGABRT);
											/* Ignore expected SIGABRT. */
						SIGNAL(SIGABRT, SIG_IGN);
					} else {
						SIGNAL(SIGABRT, sig_int);
					}
				}
	
				prep("Fork a process.");
				start
					sv_flush();
					pid = Zfork();
				finis
	
				if(pid == (pid_t)0) {
					testing("SIGABRT signal is %s.",
								(i==0) ? "being ignored" :
								(i==1) ? "being blocked" :
								"caught and returns");
					testing("When the controlling parent process calls");
					testing("abort(), the controlling terminal is");
					testing("disassociated from the session.");
					start
											/* Allow time for parent to exit. */
						SLEEP(WAIT_FOR_TIME +1);
						if(tcgetpgrp(tty_fildes) == ct_pgrp)
							error("Controlling terminal not disassociated from session.");
					finis
	
					done();
				}
				abort();
				error("Process continued after abort() was called.");
				done();
			}
			WAIT_FOR_PID(pid);
			SLEEP(WAIT_FOR_TIME +3)
			SLEEP(GTI_LINE_CLOSE_DELAY)
		}
	finis
	
	done();
}
