#include	<pcts.h>

#include	<Zunistd.h>
#include	<sys/Ztimes.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<pcts_timer.h>

#define	BUF_SIZE 512


int	main(void)
{
	int tty_fildes, loop_fildes;
	struct termios	tty_termios, loop_termios, *tty_termios_p = &tty_termios,
							*loop_termios_p = &loop_termios;
	FILE	*sfd;
	char	buffer[BUF_SIZE];
	pid_t	pid;

	setup(E_FFLUSH);
	funct(E_FFLUSH);


								/*	These tests contain code similar to
									those of fclose(). */
	exit_on(ERROR);

				/*	When TOSTOP is set, the process is in an orphaned
					process group, the writing process is not ignoring
					or blocking SIGTTOU, data has been buffered to the
					controlling terminal, then an fflush() sets errno to
					EIO.

	 				parent - new session, new controlling tty
	 			  	  |
	 				  child - new process group
	 			  	    |
	 		  		    great grandchild - created
					    |
					  child - exits
					    |
	 		  		    great grandchild - attempts write to control tty
				*/

	assertion(11, BASE);
	start
		GTI_NOT_PROVIDED_EXIT

		prep("Establish PORT_TTY as the control terminal and PORT_LOOP.");
		prep("Set TOSTOP flag on PORT_TTY.");
		prep("Write some data to buffer.");
		start
			termios_prep(&tty_fildes, tty_termios_p, &loop_fildes,
								loop_termios_p);
			tty_termios_p->c_lflag |= TOSTOP;
			Ztcsetattr(tty_fildes, TCSANOW, tty_termios_p);

			sfd = Zfdopen(tty_fildes, "r+");
											/* Place data in stream buffer. */
			setvbuf(sfd, buffer, _IOFBF, BUF_SIZE);
			expecting(2);
			Zfwrite("T\n", sizeof(char), 2, sfd);
		finis

		FORK
			prep("Setup a new process group and catch SIGTTOU.");
			start
				Zsetpgid((pid_t)0, (pid_t)0);
				SIGNAL(SIGTTOU, sig_int);
			finis

			prep("Fork grandchild.");
			start
				sv_flush();
				pid = Zfork();
			finis

			if(pid == (pid_t)0) {
				prep("Wait while parent process exits.");
				start
					SLEEP(WAIT_FOR_TIME);
				finis

				testing("An fflush() of controlling terminal fails.");
				start
					SET_TIMEOUT
						expecting(EOF);
						expecting(EIO);
						Zfflush(sfd);
					CLEAR_ALARM
				finis

				done();
			}

			prep("Child now exits to obtain orphaned background");
			prep("process group for grandchild.");
			start
			finis
		KROF
		SLEEP(2*WAIT_FOR_TIME);	/* Ensure test completes before continuing. */

		cleanup("Close terminal devices.");
		start
			SIGNAL(SIGHUP, SIG_IGN);
			Zclose(tty_fildes);
			Zclose(loop_fildes);
			SLEEP(GTI_LINE_CLOSE_DELAY);
		finis
	finis

	done();
}
