#include	<pcts.h>

#include	<unistd.h>
#include	<Zfcntl.h>

#include	<sv_env.h>


int	main(void)
{
	int	fd;
	int	ret;

	setup(E_FILENO);
	funct(E_FILENO);

	assertion(4, BASE);
	start
		testing("At entry to main(), stdin can be read, and stdout and stderr");
		testing("can be written.");
		start
			fd = Zfileno(stdin);
			ret = Zfcntl(fd, F_GETFL, 0);
			if( (ret & O_ACCMODE) == O_WRONLY)
				error("Access mode of stdin set to O_WRONLY.");
		
			fd = Zfileno(stdout);
			ret = Zfcntl(fd, F_GETFL, 0);
			if( (ret & O_ACCMODE) == O_RDONLY)
				error("Access mode of stdout set to O_RDONLY.");
		
			fd = Zfileno(stderr);
			ret = Zfcntl(fd, F_GETFL, 0);
			if( (ret & O_ACCMODE) == O_RDONLY)
				error("Access mode of stderr set to O_RDONLY.");
		finis
	finis

	assertion(5, BASE);
	start
		off_t	off_0, off_1, off_2, off_fd;

		testing("At entry to main(), the file position indicators");
		testing("associated with stdin, stdout, and stderr are set to");
		testing("the positions indicated by the file offsets associated");
		testing("with 0, 1, and 2 respectively.");
		start
			fd = Zfileno(stdin);
			off_fd = lseek(fd, (off_t)0, SEEK_CUR);
			off_0 = lseek(0, (off_t)0, SEEK_CUR);
			if(off_fd != off_0)
				error("%s%lu\n%s%lu",
						"File offset for stdin at entry to main() was ",
						(unsigned long) off_fd,
						"File offset for 0 at entry to main() was ",
						(unsigned long) off_0);

			fd = Zfileno(stdout);
			off_fd = lseek(fd, (off_t)0, SEEK_CUR);
			off_1 = lseek(1, (off_t)0, SEEK_CUR);
			if(off_fd != off_1)
				error("%s%lu\n%s%lu",
						"File offset for stdout at entry to main() was ",
						(unsigned long) off_fd,
						"File offset for 1 at entry to main() was ",
						(unsigned long) off_1);

			fd = Zfileno(stderr);
			off_fd = lseek(fd, (off_t)0, SEEK_CUR);
			off_2 = lseek(2, (off_t)0, SEEK_CUR);
			if(off_fd != off_2)
				error("%s%lu\n%s%lu",
						"File offset for stderr at entry to main() was ",
						(unsigned long) off_fd,
						"File offset for 2 at entry to main() was ",
						(unsigned long) off_2);
		finis
	finis

	assertion(6, BASE);
	start
		testing("At entry to main(), the error and end-of-file indicators");
		testing("associated with stdin, stdout, and stderr are clear.");
		start
			if(feof(stdin))
				error("The error indicator for stdin is set.");
			if(ferror(stdin))
				error("The end-of-file indicator for stdin is set.");

			if(feof(stdout))
				error("The error indicator for stdout is set.");
			if(ferror(stdout))
				error("The end-of-file indicator for stdout is set.");

			if(feof(stderr))
				error("The error indicator for stderr is set.");
			if(ferror(stderr))
				error("The end-of-file indicator for stderr is set.");
		finis
	finis

	assertion(7, BASE);
	start
		testing("Integer file descriptor associated with stream is");
		testing("returned on successful completion of fileno().");
		start
			fd = Zfileno(stdout);
			if(fd != 1)
				error("%s\n%s\n%s%d",
						"Invalid value returned from call to fileno().",
						"Expected: 1",
						"Returned: ",
						fd);
		finis
	finis

	assertion(9, BASE);
	start
		testing("STDIN_FILENO is associated with \"stdin\".");
		start
			fd = Zfileno(stdin);
			if(STDIN_FILENO != fd) 
				error("%s\n%s%d\n%s%d",
					"STDIN_FILENO not associated with \"stdin\".",
					"Value for STDIN_FILENO is ",
					STDIN_FILENO,
					"fileno(stdin) returned value of ",
					fd);
		finis

		testing("STDOUT_FILENO is associated with \"stdout\".");
		start
			fd = Zfileno(stdout);
			if(STDOUT_FILENO != fd) 
				error("%s\n%s%d\n%s%d",
					"STDOUT_FILENO not associated with \"stdout\".",
					"Value for STDOUT_FILENO is ",
					STDOUT_FILENO,
					"fileno(stdout) returned value of ",
					fd);
		finis

		testing("STDERR_FILENO is associated with \"stderr\".");
		start
			fd = Zfileno(stderr);
			if(STDERR_FILENO != fd) 
				error("%s\n%s%d\n%s%d",
					"STDERR_FILENO not associated with \"stderr\".",
					"Value for STDERR_FILENO is ",
					STDERR_FILENO,
					"fileno(stderr) returned value of ",
					fd);
		finis
	finis

	assertion(10, EXTENDED);

	done();
}
