#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>

#define	FILENAME	"8.1.14_18"

int	main(void)
{
	FILE	*sfd;
	struct	stat st_buf;
	char	path[_POSIX_PATH_MAX +1];

	setup(E_FOPEN);
	funct(E_FOPEN);

	assertion(18, BASE);
	start
		testing("Call to fopen() allocates a file descriptor.");
		start
			Zstrcpy(path, temp_path());
			Zstrcat(path, FILENAME);

			umask(0);					/* Reset for next assertion test.	*/
			sfd = Zfopen(path, "a");
			if(Zfileno(sfd) == -1)
				error("Call to fopen() did not allocate a file descriptor\n");
			Zfclose(sfd);
		finis
	finis

	assertion(19, BASE);
	start
		testing("Created file has file permission bits set appropriately.");
		start
			Zstat(path, &st_buf);
			if( ! (
				((st_buf.st_mode&(S_IRUSR | S_IWUSR)) == (S_IRUSR | S_IWUSR)) &&
				((st_buf.st_mode&(S_IRGRP | S_IWGRP)) == (S_IRGRP | S_IWGRP)) &&
				((st_buf.st_mode&(S_IROTH | S_IWOTH)) == (S_IROTH | S_IWOTH)) &&
				((st_buf.st_mode&(S_IXUSR | S_IXGRP | S_IXOTH)) == 0)
				  ))
				error("%s\n%s%lo (octal)\n%s%lo (octal)\n",
				  		"Unexpected mode.",
					  	"Expected:	",
					  	(unsigned long) (S_IRUSR | S_IWUSR | S_IRUSR | S_IWUSR
											| S_IROTH | S_IWOTH),
					  	"Actual:	",
					  	(unsigned long) (st_buf.st_mode & PROT_ALL));
		finis
	finis

	done();
}
