#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<pcts_timer.h>

#define FILENAME "8.1.19_07"
#define FIFONAME "8.1.19_07.fifo"
char	String[] = "Hello, world!";
#define	Strlen	(sizeof(String) -1)


int main(void)
{
	char	path[_POSIX_PATH_MAX +1];
	char	fifop[_POSIX_PATH_MAX +1];
	char	inbuf[Strlen];
	pid_t	pid;
	FILE	*sfd;
	int		fd;

	setup(E_FSEEK);
	funct(E_FSEEK);

	assertion(7, BASE);
	start
		prep("Create a test file and write to it.");
		start
			exit_on(ERROR);
			strcpy(path, temp_path());
			Zstrcat(path, FILENAME);
			sfd = Zfopen(path, "w");
			expecting(Strlen);
			Zfwrite(String, sizeof(char), Strlen, sfd);
			fd = fileno(sfd);
			Zclose(fd);
		finis

		FORK
			testing("Call to fseek() when the stream pointer argument");
			testing("addresses a file descriptor that is closed.");
			start
				expecting(EBADF);
				Zfseek(sfd, 0L, SEEK_SET);
			finis
		KROF
	finis

	assertion(8, EXTENDED);
	assertion(9, EXTENDED);
	assertion(10, EXTENDED);

	assertion(11, BASE);
	start
		int 	fildes[2];
		int 	fiford, fifowr;

		FORK
			prep("Create a pipe and write to it.");
			start
				Zpipe(fildes);
				expecting(Strlen);
				Zwrite(fildes[1], String, Strlen);
			finis

			testing("Call to fseek() when the underlying open file");
			testing("description references a pipe.");
			start
				sfd = Zfdopen(fildes[0], "r");
				expecting(ESPIPE);
				Zfseek(sfd, 0L, SEEK_CUR);
				sfd = Zfdopen(fildes[1], "w");
				expecting(ESPIPE);
				Zfseek(sfd, 0L, SEEK_CUR);
			finis

			testing("File pointer is not altered.");
			start
				expecting(Strlen);
				Zread(fildes[0], inbuf, Strlen);
			finis

			prep("Create a FIFO and write to it.");
			start
				strcpy(fifop, temp_path());
				Zstrcat(fifop, FIFONAME);
				Zmkfifo(fifop, PROT_ALL);
				fiford = Zopen(fifop, O_RDONLY | O_NONBLOCK);
				fifowr =  Zopen(fifop, O_WRONLY);
				expecting(Strlen);
				Zwrite(fifowr, String, Strlen);
			finis
	
			testing("Call to fseek() when the underlying open file");
			testing("description references a FIFO.");
			start
				sfd = Zfdopen(fiford, "r");
				expecting(ESPIPE);
				Zfseek(sfd, 0L, SEEK_CUR);
				sfd = Zfdopen(fifowr, "w");
				expecting(ESPIPE);
				Zfseek(sfd, 0L, SEEK_CUR);
			finis

			testing("File pointer is not altered.");
			start
				expecting(Strlen);
				Zread(fiford, inbuf, Strlen);
			finis

			cleanup("Remove FIFO file.");
			start
				Zunlink(fifop);
			finis
		KROF
	finis

	done();
}
