#include	<pcts.h>

#include	<sv_env.h>

extern	char **environ;

#define	SECS_PER_MINUTE		60
#define	SECS_PER_HOUR		(SECS_PER_MINUTE * 60)
#define	SECS_PER_DAY		(SECS_PER_HOUR * 24)
#define	DAYS_PER_YEAR		365
#define	SECS_PER_YEAR		(SECS_PER_DAY * DAYS_PER_YEAR)


int	main(void)
{
	time_t	timer, ret_mktime;
	char	tz_env[100];				/* Contains TZ environment */
	struct	tm tm;

	setup(E_MKTIME);
	funct(E_MKTIME);

	assertion(4, BASE);
	start
		prep("Setup environment for testing.");
		start
							/* Christmas day, 1992, 12:30:10 */
			tm.tm_sec		= 10;
			tm.tm_min		= 30;
			tm.tm_hour		= 12;
			tm.tm_mday		= 25;
			tm.tm_mon		= 11;
			tm.tm_year		= 92;
			tm.tm_wday		= 5;
			tm.tm_yday		= 359;
			tm.tm_isdst	= 0;

			sprintf(tz_env, "TZ=UCT0");
			environ[0] = (char *)0;
			put_env(tz_env);	/* Establish TZ environment.		*/
		finis

		testing("Call to mktime() returns proper results.");
		start
						/* Compute timer value for known inputs. */
			timer = (time_t) (tm.tm_sec +tm.tm_min*SECS_PER_MINUTE
							+tm.tm_hour*SECS_PER_HOUR +tm.tm_yday*SECS_PER_DAY
							+(tm.tm_year -70)*SECS_PER_YEAR
				 			+((tm.tm_year -69)/4)*SECS_PER_DAY);
						/* Compare with results from mktime(). */
			ret_mktime = mktime(&tm);
			if(ret_mktime != timer)
				error("%s\n%s%ld\n%s%ld",
					"Incorrect time returned by call to mktime().",
					"Expected: ",
					(long) timer,
					"Actual:   ",
					(long) ret_mktime);
		finis
	finis

	done();
}
