#include	<pcts.h>

#include	<sv_env.h>
#include	"../ctime/c_locale.h"

int	main(void)
{
	time_t	loc_timer;					/*	Local time	*/
	char	tz_env[100];				/* Contains TZ environment */
	int		hours, minutes, seconds;
					/*	jst_day, jend_day ->  Julian day of the year (1-365)
						st_day, jend_day  ->  Zero based day of the year (0-365)
					*/
	int		jst_day, jend_day, st_day, end_day;
	int		leap;

	setup(E_MKTIME);
	funct(E_MKTIME);

	tm_exp.tm_isdst=-1;

	assertion(9, BASE);
	start
		for(leap=0; leap<2; leap++) {
						/* Test for Jstart_day before and after Feb 28th. */
		  for(jst_day=JLEAP_DAY_MINUS+leap; jst_day<JLEAP_DAY_PLUS+leap;
																jst_day++){
			jend_day=jst_day +2;

			prep("Setup environment for testing.");
			start
				sprintf(tz_env, "TZ=dst0std,J%3.3d,J%3.3d", jst_day, jend_day);
				environ[0] = (char *)0;
				put_env(tz_env);	/* Establish TZ environment.		*/
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("%s year, one second prior to Jstart_day time.",
										(leap==0)?"Non-leap":"Leap");
			start
				ambig_flag = ACCEPT_ONLY_STD_OR_DST;
				loc_timer = c_timer((leap==0)?1991:1992, STday, 1, 59, 59);
				LOC_VS_CUT0_ENV(0)
			finis

			testing("%s year, at ambiguous Jstart_day time.",
											(leap==0)?"Non-leap":"Leap");
			start
				ambig_flag = ACCEPT_BOTH_DST_OR_STD;
				loc_timer = c_timer((leap==0)?1991:1992, STday, 2, 00, 00);
				LOC_VS_CUT0_ENV(-SECS_PER_HOUR)
			finis

			testing("%s year, at ambiguous one second after Jstart_day time.",
										(leap==0)?"Non-leap":"Leap");
			start
				ambig_flag = ACCEPT_BOTH_DST_OR_STD;
				loc_timer = c_timer((leap==0)?1991:1992, STday, 2, 00, 01);
				LOC_VS_CUT0_ENV(-SECS_PER_HOUR)
			finis

			testing("%s year, at one hour after Jstart_day time.",
										(leap==0)?"Non-leap":"Leap");
			start
				ambig_flag = ACCEPT_ONLY_STD_OR_DST;
				loc_timer = c_timer((leap==0)?1991:1992, STday, 3, 00, 00);
				LOC_VS_CUT0_ENV(-SECS_PER_HOUR)
			finis

			testing("%s year, one hour and one second prior to Jend_day time.",
										(leap==0)?"Non-leap":"Leap");
			start
				ambig_flag = ACCEPT_ONLY_STD_OR_DST;
				loc_timer = c_timer((leap==0)?1991:1992, ENDday, 00, 00, 59);
				LOC_VS_CUT0_ENV(-SECS_PER_HOUR)
			finis

			testing("%s year, at ambiguous one second prior to Jend_day time.",
										(leap==0)?"Non-leap":"Leap");
			start
				ambig_flag = ACCEPT_BOTH_DST_OR_STD;
				loc_timer = c_timer((leap==0)?1991:1992, ENDday,
													1, 59, 59);
				LOC_VS_CUT0_ENV(-SECS_PER_HOUR)
			finis

			testing("%s year, at Jend_day time.", (leap==0)?"Non-leap":"Leap");
			start
				ambig_flag = ACCEPT_ONLY_STD_OR_DST;
				loc_timer = c_timer((leap==0)?1991:1992, ENDday,
													2, 00, 00);
				LOC_VS_CUT0_ENV(0)
			finis

			testing("%s year, one second after Jend_day time.",
										(leap==0)?"Non-leap":"Leap");
			start
				ambig_flag = ACCEPT_ONLY_STD_OR_DST;
				loc_timer = c_timer((leap==0)?1991:1992, ENDday,
													2, 00, 01);
				LOC_VS_CUT0_ENV(0)
			finis
		  }
		}
	finis


	assertion(10, BASE);
	start
	  for(leap=0; leap<2; leap++) {
						/* Test for Jstart_day before and after Feb 28th. */
		for(jst_day=JLEAP_DAY_MINUS+leap; jst_day<JLEAP_DAY_PLUS+leap;
																	jst_day++){
		  jend_day = jst_day +2;

	  	  for(hours=0; hours<24; hours += 23) {
			prep("Setup environment for testing.");
			start
				sprintf(tz_env, "TZ=dst0std-%2.2d,J%3.3d,J%3.3d", hours,
															jst_day, jend_day);
				environ[0] = (char *)0;
				put_env(tz_env);	/* Establish TZ environment.		*/
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("%s year, one second prior to Jstart_day time.",
										(leap==0)?"Non-leap":"Leap");
			start
				ambig_flag = ACCEPT_ONLY_STD_OR_DST;
				loc_timer = c_timer((leap==0)?1991:1992, STday, 1, 59, 59);
				LOC_VS_CUT0_ENV(0)
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("%s year, at ambiguous Jstart_day time.",
												(leap==0)?"Non-leap":"Leap");
			start
				ambig_flag = ACCEPT_BOTH_STD_OR_DST;
				loc_timer = c_timer((leap==0)?1991:1992, STday, 2, 00, 00);
				LOC_VS_CUT0_ENV(-hours*SECS_PER_HOUR)
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("%s year, at ambiguous one second after Jstart_day time.",
										(leap==0)?"Non-leap":"Leap");
			start
				if(hours == 0)
					ambig_flag = ACCEPT_ONLY_STD_OR_DST;
				else
					ambig_flag = ACCEPT_BOTH_STD_OR_DST;
				loc_timer = c_timer((leap==0)?1991:1992, STday, 2, 00, 01);
				LOC_VS_CUT0_ENV(-hours*SECS_PER_HOUR)
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("%s year, at %d hours after Jstart_day time.",
										(leap==0)?"Non-leap":"Leap", hours);
			start
				ambig_flag = ACCEPT_ONLY_STD_OR_DST;
				loc_timer = c_timer((leap==0)?1991:1992, STday,
												2 +hours, 00, 00);
				LOC_VS_CUT0_ENV(-hours*SECS_PER_HOUR)
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("%s year, at ambiguous one second prior to Jend_day time.",
										(leap==0)?"Non-leap":"Leap");
			start
				ambig_flag = ACCEPT_BOTH_DST_OR_STD;
				loc_timer = c_timer((leap==0)?1991:1992, ENDday,
												1, 59, 59);
				LOC_VS_CUT0_ENV(-hours*SECS_PER_HOUR)
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("%s year, at Jend_day time.", (leap==0)?"Non-leap":"Leap");
			start
				ambig_flag = ACCEPT_ONLY_STD_OR_DST;
				loc_timer = c_timer((leap==0)?1991:1992, ENDday,
												2, 00, 00);
				LOC_VS_CUT0_ENV(0)
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("%s year, one second after Jend_day time.",
										(leap==0)?"Non-leap":"Leap");
			start
				ambig_flag = ACCEPT_ONLY_STD_OR_DST;
				loc_timer = c_timer((leap==0)?1991:1992, ENDday,
												2, 00, 01);
				LOC_VS_CUT0_ENV(0)
			finis
		  }
		}
	  }
	finis


	assertion(11, BASE);
	start
	  int	hours_end;

	  hours_end = minutes = seconds = 10;

	  for(leap=0; leap<2; leap++) {
						/* Test for Jstart_day before and after Feb 28th. */
		for(jst_day=JLEAP_DAY_MINUS+leap; jst_day<JLEAP_DAY_PLUS+leap;
																	jst_day++){
		  jend_day = jst_day +1;

	  	  for(hours=0; hours<24; hours += 23) {
			prep("Setup environment for testing.");
			start
				sprintf(tz_env,
						"TZ=dst0std,J%3.3d/%2.2d,J%3.3d/%2.2d:%2.2d:%2.2d",
						jst_day, hours, jend_day, hours_end, minutes, seconds);
				environ[0] = (char *)0;
				put_env(tz_env);	/* Establish TZ environment.		*/
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("%s year, one second prior to Jstart_day time.",
										(leap==0)?"Non-leap":"Leap");
			start
				ambig_flag = ACCEPT_ONLY_STD_OR_DST;
				loc_timer = c_timer((leap==0)?1991:1992,
								(hours==0)?STday-1:STday,
								(hours==0)?23:hours-1, 59, 59);
				LOC_VS_CUT0_ENV(0)
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("%s year, at ambiguous Jstart_day time.",
											(leap==0)?"Non-leap":"Leap");
			start
				ambig_flag = ACCEPT_BOTH_STD_OR_DST;
				loc_timer = c_timer((leap==0)?1991:1992, STday, hours, 00, 00);
				LOC_VS_CUT0_ENV(-SECS_PER_HOUR)
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("%s year, at ambiguous one second after Jstart_day time.",
										(leap==0)?"Non-leap":"Leap");
			start
				ambig_flag = ACCEPT_BOTH_STD_OR_DST;
				loc_timer = c_timer((leap==0)?1991:1992, STday, hours, 00, 01);
				LOC_VS_CUT0_ENV(-SECS_PER_HOUR)
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("%s year, at one hour after Jstart_day time.",
										(leap==0)?"Non-leap":"Leap");
			start
				ambig_flag = ACCEPT_ONLY_STD_OR_DST;
				loc_timer = c_timer((leap==0)?1991:1992, STday, hours +1,00,00);
				LOC_VS_CUT0_ENV(-SECS_PER_HOUR)
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("%s year, one second prior to Jend_day time.",
										(leap==0)?"Non-leap":"Leap");
			start
				ambig_flag = ACCEPT_BOTH_STD_OR_DST;
				loc_timer = c_timer((leap==0)?1991:1992, ENDday,
								hours_end, minutes, seconds -1);
				LOC_VS_CUT0_ENV(-SECS_PER_HOUR)
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("%s year, at Jend_day time.", (leap==0)?"Non-leap":"Leap");
			start
				ambig_flag = ACCEPT_ONLY_STD_OR_DST;
				loc_timer = c_timer((leap==0)?1991:1992, ENDday,
								hours_end, minutes, seconds);
				LOC_VS_CUT0_ENV(0)
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("%s year, one second after Jend_day time.",
										(leap==0)?"Non-leap":"Leap");
			start
				ambig_flag = ACCEPT_ONLY_STD_OR_DST;
				loc_timer = c_timer((leap==0)?1991:1992, ENDday,
								hours_end, minutes, seconds +1);
				LOC_VS_CUT0_ENV(0)
			finis
		  }
		}
	  }
	finis


	assertion(12, BASE);			/* Similar to assertion #9. */
	start
		for(leap=0; leap<2; leap++) {
						/* Test for start_day before and after Feb 28th. */
		  for(st_day=LEAP_DAY_MINUS+leap; st_day<LEAP_DAY_PLUS+leap; st_day++){
			end_day = st_day +2;

			prep("Setup environment for testing.");
			start
				sprintf(tz_env, "TZ=dst0std,%3.3d,%3.3d", st_day, end_day);
				environ[0] = (char *)0;
				put_env(tz_env);	/* Establish TZ environment.		*/
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("%s year, one second prior to start_day time.",
										(leap==0)?"Non-leap":"Leap");
			start
				ambig_flag = ACCEPT_ONLY_STD_OR_DST;
				loc_timer = c_timer((leap==0)?1991:1992, st_day, 1, 59, 59);
				LOC_VS_CUT0_ENV(0)
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("%s year, at ambiguous start_day time.",
											(leap==0)?"Non-leap":"Leap");
			start
				ambig_flag = ACCEPT_BOTH_STD_OR_DST;
				loc_timer = c_timer((leap==0)?1991:1992, st_day, 2, 00, 00);
				LOC_VS_CUT0_ENV(-SECS_PER_HOUR)
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("%s year, at ambiguous one second after start_day time.",
										(leap==0)?"Non-leap":"Leap");
			start
				ambig_flag = ACCEPT_BOTH_STD_OR_DST;
				loc_timer = c_timer((leap==0)?1991:1992, st_day, 2, 00, 01);
				LOC_VS_CUT0_ENV(-SECS_PER_HOUR)
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("%s year, at one hour after start_day time.",
										(leap==0)?"Non-leap":"Leap");
			start
				ambig_flag = ACCEPT_ONLY_STD_OR_DST;
				loc_timer = c_timer((leap==0)?1991:1992, st_day, 3, 00, 00);
				LOC_VS_CUT0_ENV(-SECS_PER_HOUR)
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("%s year, one hour and one second prior to end_day time.",
										(leap==0)?"Non-leap":"Leap");
			start
				ambig_flag = ACCEPT_ONLY_STD_OR_DST;
				loc_timer = c_timer((leap==0)?1991:1992, end_day, 00, 00, 59);
				LOC_VS_CUT0_ENV(-SECS_PER_HOUR)
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("%s year, at ambiguous one second prior to end_day time.",
										(leap==0)?"Non-leap":"Leap");
			start
				ambig_flag = ACCEPT_BOTH_STD_OR_DST;
				loc_timer = c_timer((leap==0)?1991:1992, end_day,
												1, 59, 59);
				LOC_VS_CUT0_ENV(-SECS_PER_HOUR)
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("%s year, at end_day time.", (leap==0)?"Non-leap":"Leap");
			start
				ambig_flag = ACCEPT_ONLY_STD_OR_DST;
				loc_timer = c_timer((leap==0)?1991:1992, end_day,
												2, 00, 00);
				LOC_VS_CUT0_ENV(0)
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("%s year, one second after end_day time.",
										(leap==0)?"Non-leap":"Leap");
			start
				ambig_flag = ACCEPT_ONLY_STD_OR_DST;
				loc_timer = c_timer((leap==0)?1991:1992, end_day,
												2, 00, 01);
				LOC_VS_CUT0_ENV(0)
			finis
		  }
		}
	finis


	assertion(13, BASE);			/* Similar to assertion #11. */
	start
	  int	hours_end;

	  hours_end = minutes = seconds = 10;

	  for(leap=0; leap<2; leap++) {
		for(st_day=LEAP_DAY_MINUS+leap; st_day<LEAP_DAY_PLUS+leap; st_day++){
		  end_day = st_day +2;
	  	  for(hours=0; hours<24; hours += 23) {
			prep("Setup environment for testing.");
			start
				sprintf(tz_env,
						"TZ=dst0std,%3.3d/%2.2d,%3.3d/%2.2d:%2.2d:%2.2d",
						st_day, hours, end_day, hours_end, minutes, seconds);
				environ[0] = (char *)0;
				put_env(tz_env);	/* Establish TZ environment.		*/
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("%s year, one second prior to start_day time.",
										(leap==0)?"Non-leap":"Leap");
			start
				ambig_flag = ACCEPT_ONLY_STD_OR_DST;
				loc_timer = c_timer((leap==0)?1991:1992, st_day, hours -1,
																	59, 59);
				LOC_VS_CUT0_ENV(0)
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("%s year, at ambiguous start_day time.",
												(leap==0)?"Non-leap":"Leap");
			start
				ambig_flag = ACCEPT_BOTH_STD_OR_DST;
				loc_timer = c_timer((leap==0)?1991:1992, st_day, hours, 00, 00);
				LOC_VS_CUT0_ENV(-SECS_PER_HOUR)
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("%s year, at ambiguous one second after start_day time.",
										(leap==0)?"Non-leap":"Leap");
			start
				ambig_flag = ACCEPT_BOTH_STD_OR_DST;
				loc_timer = c_timer((leap==0)?1991:1992, st_day, hours, 00, 01);
				LOC_VS_CUT0_ENV(-SECS_PER_HOUR)
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("%s year, at one hour after start_day time.",
										(leap==0)?"Non-leap":"Leap");
			start
				ambig_flag = ACCEPT_ONLY_STD_OR_DST;
				loc_timer = c_timer((leap==0)?1991:1992, st_day,
														hours +1, 00, 00);
				LOC_VS_CUT0_ENV(-SECS_PER_HOUR)
			finis


			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("%s year, one second prior to end_day time.",
										(leap==0)?"Non-leap":"Leap");
			start
				ambig_flag = ACCEPT_BOTH_STD_OR_DST;
				loc_timer = c_timer((leap==0)?1991:1992, end_day,
								hours_end, minutes, seconds -1);
				LOC_VS_CUT0_ENV(-SECS_PER_HOUR)
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("%s year, at end_day time.", (leap==0)?"Non-leap":"Leap");
			start
				ambig_flag = ACCEPT_ONLY_STD_OR_DST;
				loc_timer = c_timer((leap==0)?1991:1992, end_day,
								hours_end, minutes, seconds);
				LOC_VS_CUT0_ENV(0)
			finis

			testing("TZ is of the form: TZ=%s", getenv("TZ"));
			testing("%s year, one second after end_day time.",
										(leap==0)?"Non-leap":"Leap");
			start
				ambig_flag = ACCEPT_ONLY_STD_OR_DST;
				loc_timer = c_timer((leap==0)?1991:1992, end_day,
								hours_end, minutes, seconds +1);
				LOC_VS_CUT0_ENV(0)
			finis
		  }
		}
	  }
	finis

	done();
}
