#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>

#define	FILENAME	"8.1.34_18"
#define	FILENAME_L	"8.1.34_18_lnk"

int	main(void)
{
	char	path[_POSIX_PATH_MAX +1];
	char	path_lnk[_POSIX_PATH_MAX +1];
	time_t	s_time;

	setup(E_REMOVE);
	funct(E_REMOVE);

	assertion(18, BASE);
	start
		testing("Call to remove() marks for update the st_ctime and the");
		testing("st_mtime field of the parent directory of the file.");
		start
			Zstrcpy(path, temp_path());
			Zstrcat(path, FILENAME);
			Zclose(Zcreat(path, S_IRWXU));

			Ztime(&s_time);				/* Obtain minimum reference time. */
			dt_secs(TRF_DELAY);			/* Delay a fixed interval.			*/
			remove(path);

			Zstrcpy(path, temp_path());
			trf_ck(CHK_CTIME, TRUE, s_time, NO_FILDES, path);
			trf_ck(CHK_MTIME, TRUE, s_time, NO_FILDES, path);
		finis
	finis

	assertion(19, BASE);
	start
		testing("When the file's link count is not zero, then a call to");
		testing("remove() marks for update the st_ctime field of the file.");
		start
			Zstrcpy(path, temp_path());
			Zstrcat(path, FILENAME);
			Zclose(Zcreat(path, S_IRWXU));
			Zstrcpy(path_lnk, temp_path());
			Zstrcat(path_lnk, FILENAME_L);
			Zlink(path, path_lnk); 

			Ztime(&s_time);				/* Obtain minimum reference time. */
			dt_secs(TRF_DELAY);			/* Delay a fixed interval.			*/
			remove(path_lnk);

			trf_ck(CHK_CTIME, TRUE, s_time, NO_FILDES, path);
		finis
	finis

	done();
}
