#include	<pcts.h>

#include	<sv_env.h>
#include	"../ctime/c_locale.h"

extern	char **environ;

#define	Strlen	10
static	char	String[Strlen];


int	main(void)
{
	char	tz_env[100];				/* Contains TZ environment */
	time_t	timer;

	setup(E_STRFTIME);
	funct(E_STRFTIME);

	assertion(5, BASE);
	start
		prep("Setup environment for testing.");
		start
			timer = c_timer(1992,0,0,0,0);
			exp_time(timer);				/* Setup "tm" structure. */
			tm_exp.tm_isdst = 0;
			sprintf(tz_env, "TZ=AAA1");
			environ[0] = (char *)0;
			put_env(tz_env);				/* Establish TZ environment.	*/
		finis

		testing("Conversion sequence for %%Z returns string used for TZA.");
		start
			(void) strftime(String, Strlen, "%Z %Z", &tm_exp);
			if(strcmp(String, "AAA AAA"))
				error("%s\n%s%s",
						"Expected: AAA AAA",
						"Received: ",
						String);
		finis
	finis


	assertion(6, BASE);
	start
		prep("Setup environment for testing.");
		start
			tm_exp.tm_isdst = 0;
			sprintf(tz_env, "TZ=BBB1CCC");
			environ[0] = (char *)0;
			put_env(tz_env);				/* Establish TZ environment.	*/
		finis

		testing("Conversion sequence for %%Z returns string used for TZA.");
		start
			(void) strftime(String, Strlen, "%Z %Z", &tm_exp);
			if(strcmp(String, "BBB BBB"))
				error("%s\n%s%s",
						"Expected: BBB BBB",
						"Received: ",
						String);
		finis

		testing("Conversion sequence for %%Z returns string used for TZA.");
		start
			tm_exp.tm_isdst = 1;
			(void) strftime(String, Strlen, "%Z %Z", &tm_exp);
			if(strcmp(String, "CCC CCC"))
				error("%s\n%s%s",
						"Expected: CCC CCC",
						"Received: ",
						String);
		finis
	finis

	done();
}
