#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<pcts_timer.h>

#define	FILENAME	"8.1.41_06"

int	main(void)
{
	char	path[_POSIX_PATH_MAX +1];

	setup(E_TMPFILE);
	funct(E_TMPFILE);

	assertion(6, BASE);
	start
		int		open_max, topen_max, i;

		break_on(ERROR);

		prep("Initialize a path name.");
		start
			Zstrcpy(path, temp_path());
			Zstrcat(path, "fill_up");
		finis

		open_max = g_open_max();	/* Get value for {OPEN_MAX} */
									/* Get testable value for {OPEN_MAX} */
		topen_max = (open_max <= PCTS_OPEN_MAX) ? open_max : PCTS_OPEN_MAX;

		prep("Close all file descriptors except 0, 1 and 2.");
		start
			for(i=3; i<topen_max; i++)
				(void) close(i);
		finis

		if(open_max <= PCTS_OPEN_MAX) {
			prep("{OPEN_MAX} equal to {PCTS_OPEN_MAX}.");
			prep("Consume all available file descriptors.");
			start
				for(i=3; i<open_max; i++)
					(void) Zcreat(path, PROT_ALL);
			finis

			prep("Initialize a path name and create.");
			start
				Zstrcpy(path, temp_path());
				Zstrcat(path, FILENAME);
			finis
	
			testing("Call tmpfile() when {OPEN_MAX} file descriptors in use.");
			start
				expecting(NULL);
				expecting(EMFILE);
				Ztmpfile();
			finis
		}
		else {
			prep("Testing for {PCTS_OPEN_MAX} < {OPEN_MAX}.");
			prep("Consume PCTS_OPEN_MAX -1 file descriptors."); 
			start
				for(i=3; i<(topen_max -1); i++)
					(void) Zcreat(path, PROT_ALL);
			finis

			prep("Initialize a path name.");
			start
				Zstrcpy(path, temp_path());
				Zstrcat(path, FILENAME);
				Zclose(Zcreat(path, PROT_ALL));
			finis
	
			testing("tmpfile() on the {PCTS_OPEN_MAX} -1 file descriptor.");
			start
				Ztmpfile();
			finis
		}

		cleanup("Close all file descriptors except 0, 1 and 2.");
		start
			for(i=3; i<topen_max; i++)
				close(i);
		finis
	finis

	assertion(7, EXTENDED);

	done();
}
