#include	<pcts.h>

#include	<Zunistd.h>

#include	<sv_env.h>

/*	This module has S_ISUID and S_ISGID of ROOT_UID and ROOT_GID respectively.*/

int	main(void)
{
	setup(E_SETGID);
	funct(E_SETGID);

	assertion(4, BASE);
	start
		if(sysconf(_SC_SAVED_IDS) !=(long)-1) {
			prep("Check that the real group ID is GID");
			prep("and effective group ID is ROOT_GID");
			start
				exit_on(ERROR);

				expecting(GID);
				(void) Zgetgid();
	
				expecting(ROOT_GID);
				(void) Zgetegid();
			finis

			testing("Appropriate privilege process calling setgid()");
			testing("with argument set to BIN_GID returns a zero value.");
			start
				expecting(0);
				(void) Zsetgid(BIN_GID);
			finis

			testing("Call to setuid() from a privileged process sets the");
			testing("effective and real group IDs to BIN_GID.");
			start
				expecting(BIN_GID);		/* Real group ID set to BIN_GID. */
				(void) Zgetgid();
	
				expecting(BIN_GID);		/* Effective group ID set to BIN_GID. */
				(void) Zgetegid();
			finis
	
			testing("Call to setgid() from the privileged process also sets");
			testing("the saved set group ID to BIN_GID.");
			testing("If saved set group ID was set to BIN_GID, then");
			testing("trying to set group ID to GID should fail.");
			start
				expecting(FAILURE);
				(void) setgid(GID);
			finis
		}
		else
			un_implemented("POSIX_SAVED_IDS");
	finis

	done();
}
