#include	<pcts.h>

#include	<Zunistd.h>

#include	<sv_env.h>
#include	<sv_errno.h>

int	main(void)
{
	setup(E_SETGID);
	funct(E_SETGID);

	assertion(8, BASE);
	start
		if(INVALID_GID_VALUE) {
			prep("Ensure process's real and effective group ID is GID.");
			start
				expecting(GID);
				Zgetgid();

				expecting(GID);
				Zgetegid();
			finis

			testing("[EINVAL] supported for setgid().");
			start
				expecting(-1);
				expecting(EINVAL);
				Zsetgid((gid_t)INVALID_GID_VALUE);
			finis

			testing("Process's real and effective group ID is still GID.");
			start
				expecting(GID);
				Zgetgid();

				expecting(GID);
				Zgetegid();
			finis
		}
		else {
			prep("Call setgid with \"-1\" as the parameter.");
			start
				expecting(-1);
				expecting(EPERM);
				Zsetgid((gid_t)-1);
			finis

			not_implemented("[EINVAL] is not supported for setgid()");
		}
	finis

	assertion(9, BASE);
	start
		testing("User does not have the appropriate privileges for calling");
		testing("setgid() and the setgid() argument does not match either the");
		testing("real group ID or the saved set-group-ID.");
		start
			expecting(-1);
			expecting(EPERM);
			(void) Zsetgid(ROOT_GID);
		finis

		testing("Process's real and effective group ID is still GID.");
		start
			expecting(GID);
			Zgetgid();

			expecting(GID);
			Zgetegid();
		finis
	finis

	done();
}
