#include	<pcts.h>

#include	<Zunistd.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<pcts_timer.h>


int	main(void)
{
	pid_t	pid;

	setup(E_SETSID);
	funct(E_SETSID);

	assertion(4, BASE); 
	start
		pid_t	ret_setsid, ret_pgrp;

		exit_on(ERROR);			/*	Part of Assertion #5 is tested in
									Assertion #4.  If this assertion
									fails, do not test Assertion #5.
								*/
		FORK
			testing("Call to setsid() returns the process group ID");
			testing("of the calling process.");
			start
				ret_setsid = Zsetsid();
				ret_pgrp = Zgetpgrp();

				if(ret_setsid != ret_pgrp)
					error("%s%ld.\n%s%ld.",
						"Expected process group ID of ",
						(long) ret_setsid,
						"Actual reported process group ID was ",
						(long) ret_pgrp);
			finis

			prep("Setup process to catch a signal.");
			start
				SIGNAL(SIGINT, sig_int);
				sig_rcvd = 0;
			finis

			prep("Fork a child.");
			start
				pid = Zfork();
			finis

			if(pid == (pid_t)0) {
				testing("Value returned by setsid() is the process group ID.");
				start
					Zkill((pid_t)(-1*ret_setsid), SIGINT);
					sleep(WAIT_FOR_TIME);
					if(sig_rcvd == 0)
						error("%s%s",
								"Signal sent to process group not received",
								" by child process.");
				
				finis

				done();
			}

			sleep(WAIT_FOR_TIME);	/* Allow time for signal to be processed. */
			WAIT_FOR_PID(pid);

			testing("Value returned by setsid() is the process group ID.");
			start
				if(sig_rcvd == 0)
					error("%s%s",
							"Signal sent to process group not received",
							"by parent process.");
			finis
		KROF
	finis

						/*	Session leader is the process that
							successfully called setsid().

							If we get here, then Assertion #4 was successful.
							Assertion #5 also requires the tests performed
							in Assertion #4.
						*/
	assertion(5, BASE);
	start
		FORK
			prep("Create a new session.");
			start
				Zsetsid();
			finis

			testing("Calling process is now a session leader.");
			start
				expecting(EPERM);
				Zsetpgid((pid_t)0, (pid_t)0);
			finis
		KROF
	finis

	assertion(7, BASE); 
	start
		pid_t	ret_setsid, ret_pid;
		FORK
			testing("Call to setsid() sets the process group ID to the");
			testing("process ID of the calling process.");
			start
				ret_pid = Zgetpid();
				ret_setsid = Zsetsid();

				if(ret_setsid != ret_pid)
					error("%s%ld.\n%s%ld.",
						"Expected process group ID of ",
						(long) ret_pid,
						"Actual reported process group ID was ",
						(long) ret_setsid);
			finis
		KROF
	finis

	done();
}
