#include	<pcts.h>

#include	<Zunistd.h>
#include	<sv_env.h>

/*	This module has S_ISUID of ROOT_UID.  */

int	main(void)
{
	setup(E_SETUID);
	funct(E_SETUID);

	assertion(4, BASE);
	start
		if(sysconf(_SC_SAVED_IDS) !=(long)-1) {
			prep("Check that the real user-ID is UID");
			prep("and effective user-ID is ROOT_UID.");
			start
				exit_on(ERROR);
				expecting(UID);
				(void) Zgetuid();
	
				expecting(ROOT_UID);
				(void) Zgeteuid();
			finis
	
			testing("Setting the process's user ID to BIN_UID returns zero");
			start
				expecting(0);
				(void) Zsetuid(BIN_UID);
			finis

			testing("Call to setuid() from a privileged process sets the");
			testing("effective and real user IDs to BIN_UID.");
			start
				expecting(BIN_UID);
				(void) Zgetuid();
	
				expecting(BIN_UID);
				(void) Zgeteuid();
			finis
	
			testing("Call to setuid() from the privileged process also set");
			testing("the saved set user ID to BIN_UID.");
			testing("If saved set user ID was set to BIN_UID, then");
			testing("trying to set user ID to UID should fail.");
			start
				expecting(FAILURE);
				(void) Zsetuid(UID);
			finis
		}
		else
			error("Call to sysconf(_SC_SAVED_IDS) returned -1.");
	finis

	done();
}
