#include	<pcts.h>

#include	<Zunistd.h>
#include	<sv_env.h>

/*	This module has S_ISUID of BIN_UID.  */

int	main(void)
{
	ass_nu = 5;
	sv_config();					/* Required for sv_nproc() call.	  */
	sv_nproc();						/* Maintain proper journal ID sequence.*/

	prep("Ensure process's real user ID is UID");
	prep("and effective user ID is BIN_UID.");
	start
		exit_on(ERROR);

		expecting(UID);
		(void) Zgetuid();

		expecting(BIN_UID);
		(void) Zgeteuid();
	finis

	prep("Set process's effective user ID to UID.");
	start
		(void) Zsetuid(UID);		/* Reference #1 */
		expecting(UID);
		(void) Zgetuid();
		expecting(UID);
		(void) Zgeteuid();
	finis

	testing("Process without appropriate privileges and only the saved");
	testing("set-user-ID matches the setuid() calling argument, then a call");
	testing("to setuid() sets the effective user ID.");
	testing("The real user ID and the saved set-user-ID remain unchanged.");
	start
		(void) Zsetuid(BIN_UID);
		expecting(BIN_UID);			/* Effective user ID is set. */
		(void) Zgeteuid();

		expecting(UID);				/* Real user ID remains unchanged. */
		(void) Zgetuid();

									/*	Saved set-user-ID remains unchanged.
										See Reference #1 above, if changed
										then the setuid() call in this block
										would have failed.
									*/
	finis

	testing("Process without appropriate privileges and only the real");
	testing("user ID matches the setuid() calling argument, then a call");
	testing("to setuid() sets the effective user ID.");
	testing("The real user ID and the saved set-user-ID remain unchanged.");
	testing("Set effective user ID to UID.");
	start
									/*	Recapping from above results:
											saved set-user-ID -> BIN_UID
											effective user ID -> BIN_UID
											real user ID      -> UID
									*/
		(void) Zsetuid(UID);

		expecting(UID);				/* Effective user ID is set. */
		(void) Zgeteuid();

		expecting(UID);				/* Real user ID remains unchanged. */
		(void) Zgetuid();

									/*	Recapping at this point:
											saved set-user-ID -> BIN_UID
											effective user ID -> BIN
											real user ID      -> UID

										Saved set-user-ID remains unchanged.
									*/
		expecting(SUCCESS);
		(void) Zsetuid(BIN_UID);
	finis

	done();
}
