#include	<pcts_ass.h>

#include	<sys/types.h>
#include	<unistd.h>

#include	<sv_env.h>

struct	sym_cst	{
					const char	*name;
					const unsigned long value;
				} sym_csts[] =	{
									"_SC_ARG_MAX",		_SC_ARG_MAX,
									"_SC_CHILD_MAX",	_SC_CHILD_MAX,
									"_SC_CLK_TCK",		_SC_CLK_TCK,
									"_SC_NGROUPS_MAX",	_SC_NGROUPS_MAX,
									"_SC_OPEN_MAX",		_SC_OPEN_MAX,
									"_SC_JOB_CONTROL",	_SC_JOB_CONTROL,
									"_SC_SAVED_IDS",	_SC_SAVED_IDS,
									"_SC_VERSION",		_SC_VERSION,
									"_SC_STREAM_MAX",	_SC_STREAM_MAX,
									"_SC_TZNAME_MAX",	_SC_TZNAME_MAX,
								};
#define	NUM_ENTRIES (sizeof(sym_csts)/sizeof(sym_csts[0]))


int	main(void)
{
	setup(E_SYSCONF);
	funct(E_SYSCONF);

	exit_on(ERROR);
	assertion(4, BASE);
	start
		testing("When the header <unistd.h> is included, the symbolic");
		testing("constant _SC_ARG_MAX is defined.");
		start
#ifndef	_SC_ARG_MAX
			error("_SC_ARG_MAX not defined when header <unistd.h> included.");
#endif
		finis

		testing("When the header <unistd.h> is included, the symbolic");
		testing("constant _SC_CHILD_MAX is defined.");
		start
#ifndef	_SC_CHILD_MAX
		error("_SC_CHILD_MAX not defined when header <unistd.h> included.");
#endif
		finis

		testing("When the header <unistd.h> is included, the symbolic");
		testing("constant _SC_CLK_TCK is defined.");
		start
#ifndef	_SC_CLK_TCK
			error("_SC_CLK_TCK not defined when header <unistd.h> included.");
#endif
		finis

		testing("When the header <unistd.h> is included, the symbolic");
		testing("constant _SC_NGROUPS_MAX is defined.");
		start
#ifndef	_SC_NGROUPS_MAX
		error("_SC_NGROUPS_MAX not defined when header <unistd.h> included.");
#endif
		finis

		testing("When the header <unistd.h> is included, the symbolic");
		testing("constant _SC_OPEN_MAX is defined.");
		start
#ifndef	_SC_OPEN_MAX
		error("_SC_OPEN_MAX not defined when header <unistd.h> included.");
#endif
		finis

		testing("When the header <unistd.h> is included, the symbolic");
		testing("constant _SC_JOB_CONTROL is defined.");
		start
#ifndef	_SC_JOB_CONTROL
		error("_SC_JOB_CONTROL not defined when header <unistd.h> included.");
#endif
		finis

		testing("When the header <unistd.h> is included, the symbolic");
		testing("constant _SC_SAVED_IDS is defined.");
		start
#ifndef	_SC_SAVED_IDS
		error("_SC_SAVED_IDS not defined when header <unistd.h> included.");
#endif
		finis

		testing("When the header <unistd.h> is included, the symbolic");
		testing("constant _SC_VERSION is defined.");
		start
#ifndef	_SC_VERSION
		error("_SC_VERSION not defined when header <unistd.h> included.");
#endif
		finis

		testing("When the header <unistd.h> is included, the symbolic");
		testing("constant _SC_STREAM_MAX is defined.");
		start
#ifndef	_SC_STREAM_MAX
		error("_SC_STREAM_MAX not defined when header <unistd.h> included.");
#endif
		finis

		testing("When the header <unistd.h> is included, the symbolic");
		testing("constant _SC_TZNAME_MAX is defined.");
		start
#ifndef	_SC_TZNAME_MAX
		error("_SC_TZNAME_MAX not defined when header <unistd.h> included.");
#endif
		finis

		testing("When the header <unistd.h> is included, the symbolic");
		testing("constants _SC_ARG_MAX, _SC_CHILD_MAX, _SC_CLK_TCK,");
		testing("_SC_NGROUPS_MAX, _SC_OPEN_MAX, _SC_JOB_CONTROL,");
		testing("_SC_SAVED_IDS, _SC_VERSION, _SC_STREAM_MAX, and");
		testing("_SC_TZNAME_MAX are distinct.");
		start
			UNIQUE_VALUES(sym_csts, NUM_ENTRIES);
		finis
	finis

	done();
}
