#include	<pcts.h>

#include	<Zunistd.h>
#include	<sys/Zstat.h>
#include	<Zfcntl.h>
#include	<Ztime.h>
#include	<Zutime.h>

#include	<sv_env.h>

int	main(void)
{
	struct	stat	st_buf;
	time_t	time1, time2, time3;

	setup(E_TIME);
	funct(E_TIME);

			/* Call to time(tloc) when 
					tloc is NULL and when
					tloc is a valid address
				returns the value of time in seconds since  the Epoch
				(00:00:00 January 1, 1970 Coordinated Universal Time).
			*/
	assertion(4, BASE);
	start
		struct	utimbuf	u_time;
		char	path[_POSIX_PATH_MAX +1];

		break_on(ERROR);
		prep("Create a temp file.");
		start
			Zstrcpy(path, temp_path());
			Zstrcat(path, "7.15_4");
			Zclose(Zcreat(path, PROT_ALL));
		finis

		prep("Set temp file time to Universal Coordinated time.");
		start
			u_time.actime =(time_t) 0;
			u_time.modtime =(time_t) 0;
			Zutime(path, &u_time);
		finis

		prep("Ensure time set in temp file corresponds to January 1, 1970.");
		start
			char	ex_atime[26];

			Zstat(path, &st_buf);
			sprintf(ex_atime, "%20.20s", asctime(gmtime(&st_buf.st_atime)) +4);
			continue_on(ERROR);
			if(strcmp(ex_atime, "Jan  1 00:00:00 1970"))
				error("%s\n%s\n%s%s",
					"GMT not set properly -",
					"Expected:	Jan  1  00:00:00 1970",
					"Actual:	",
					ex_atime);
		finis

		prep("Recreate the temp file.");
		start
			Zclose(Zcreat(path, PROT_ALL));
		finis

		prep("Call time() to get the value of time and call fstat()");
		prep("to get the time of creation of the data file.");
		start
			(void) Zstat(path, &st_buf);
			time1 = st_buf.st_ctime;
			time2 = Ztime((time_t *) 0);
		finis

		prep("Ensure the value of time from the function time() is");
		prep("nearly identical to the time of creation of the data file.");
		start
			if((time2 > time1 + WAIT_FOR_TIME)||(time2 < time1 - WAIT_FOR_TIME))
				error("%s\n%s%lu.\n%s%lu.",
					"Incorrect return value from time.",
					"Expected value was approximately ",
					(unsigned long) time1,
					"Actual value was ",
					(unsigned long) time2);
		finis

		prep("Delay awhile.");
		start
			SLEEP(WAIT_FOR_TIME);
		finis

		testing("Value returned from time(tloc) when tloc is NULL");
		testing("address returns the value of time in seconds from the Epoch.");
		start
			time1 = Ztime((time_t *) 0);
			if((time1 <= time2) || ((time2 +(2 * WAIT_FOR_TIME)) < time1))
				error("%s\n%s%lu.\n%s%lu.",
					"Incorrect return value from time.",
					"Expected value was approximately ",
					(unsigned long) (time2 + WAIT_FOR_TIME),
					"Actual value was ",
					(unsigned long) time1);
		finis

		testing("Value returned from time(tloc) when tloc is a valid");
		testing("address returns the value of time in seconds from the Epoch.");
		start
			time1 = Ztime(&time3);
			if((time1 <= time2) || ((time2 +(2 * WAIT_FOR_TIME)) < time1))
				error("%s\n%s%lu.\n%s%lu.",
					"Incorrect return value from time.",
					"Expected value was approximately ",
					(unsigned long) (time2 + WAIT_FOR_TIME),
					"Actual value was ",
					(unsigned long) time1);
		finis
	finis

			/* Time with an argument other than a NULL pointer, stores the  */
			/* value of time in the location pointed to by the argument.	*/
	assertion(5, BASE);
	start
		testing("Call time with a non-NULL argument and check that");
		testing("the correct value is stored there.");
		start
			time1 = Ztime(&time2);
			if (time2 != time1)
				error("%s%s\n%s%lu.\n%s%lu.",
					"Incorrect value stored at location ",
					"pointed to by the argument.",
					"Expected value was ",
					(unsigned long) time1,
					"Actual stored value was ",
					(unsigned long) time2);
		finis
	finis

	assertion(6, EXTENDED);

	done();
}
