#include	<pcts.h>

#include	<Zunistd.h>
#include	<sys/Zstat.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<pcts_timer.h>

#define	String	"Wishing it"
#define	Strlen	(sizeof(String) -1)
#define	FILENAME	"3.2.2_4"

#define	Status	0xFF

int main(void)
{
	int		pipfd[2], fd;
	char	inbuf[Strlen +1];
	int		stat_val;
	pid_t	pid;
	char	path[_POSIX_PATH_MAX +1];
	struct	flock flock;

	setup(E__EXIT);
	funct(E__EXIT);

	assertion(4, BASE);
	start
		prep("Fork a process.");
		start
			sv_flush();
			pid = Zfork();
		finis

		if(pid == (pid_t)0) {
			prep("Have child call _exit().");
			start
			finis

			done();

		}

		SET_ALARM(TIMEOUT)
			waitpid(pid, &stat_val, 0);
		CLEAR_ALARM

		testing("Child process has terminated.");
		start
			if(! WIFEXITED(stat_val))
				error("Child processs did not terminate.");
		finis
	finis

							/*	Open pipe file descriptors in calling
								process are closed.
							*/
	assertion(5, BASE);
	start
		prep("Create a regular file.");
		start
			strcpy(path, temp_path());
			strcat(path, FILENAME);
			fd = Zopen(path, O_CREAT | O_RDWR, PROT_ALL);

			flock.l_type = F_WRLCK;
			flock.l_whence = SEEK_SET;
			flock.l_start = (off_t)0;
			flock.l_len = (off_t)0;
		finis

		prep("Establish a pipe and fork a child process.");
		start
			Zpipe(pipfd);
			sv_flush();
			pid = Zfork();
		finis

	   	if(pid == (pid_t)0) {
			prep("Lock regular file.");
			start
				Zfcntl(fd, F_SETLK, &flock);
			finis

			prep("Have child process delay then exit.");
			start
				SLEEP(2 * WAIT_FOR_TIME);
			finis

			done();
		}

		SLEEP(WAIT_FOR_TIME);

		prep("Test regular file for lock denial.");
		start
			Zfcntl(fd, F_GETLK, &flock);

			if(flock.l_type != F_WRLCK)
				error("Regular file accesible for locking.");
		finis

		prep("Have parent close pipe for reading, write to child");
		prep("then wait till child exits.");
		start
			close(pipfd[0]);

			SET_ALARM(TIMEOUT)
				Zwrite(pipfd[1],  String,  Strlen);
				Zwaitpid(pid, &stat_val, 0);
			CLEAR_ALARM

		finis

		testing("File descriptors for child have been closed on child's");
		testing("call to _exit().");
		testing("Expect [EPIPE] since no process has pipe open for reading.");
		start
			SIGNAL(SIGPIPE, SIG_IGN);		/* Ignore expected SIGPIPE */
			expecting(EPIPE);
			Zwrite(pipfd[1], inbuf,  Strlen);
		finis

		testing("Test regular file for lock access.");
		start
			Zfcntl(fd, F_GETLK, &flock);

			if(flock.l_type != F_UNLCK)
				error("Child's regular file descriptor was not closed.");
		finis

		cleanup("Close and unlink test files.");
		start
			Zclose(pipfd[1]);
			Zclose(fd);
			Zunlink(path);
		finis
	finis

	assertion(6, EXTENDED);

	assertion(7, BASE);
	start
									/* Test with wait() */
		prep("Fork a process.");
		start
			sv_flush();
			pid = Zfork();
		finis

		if(pid == (pid_t)0) {
			prep("Have child call _exit(status), \"status\" is eight bits.");
			start
				sv_flush();
				sv_set_exit_val(Status);
			finis

			done();						/* Call _exit(Status) */
		}

		Zwait(&stat_val);

		testing("When child exits and parent process is executing wait(),");
    	testing("the low order 8 bits of status are made available to parent");
		testing("process.");
		start
			if((WEXITSTATUS(stat_val) & 0xff) != Status)
	    		error("%s\n%s%x.\n%s%x.",
					"Unexpected status value returned from wait().",
					"Expected 0x",
					Status,
					"Received 0x",
					WEXITSTATUS(stat_val) & 0xff );
		finis

									/* Repeat test with waitpid() */
		prep("Fork a process.");
		start
			sv_flush();
			pid = Zfork();
		finis

		if(pid == (pid_t)0) {
			prep("Have child call _exit(status), \"status\" is eight bits.");
			start
				sv_flush();
				sv_set_exit_val(Status);
			finis

			done();						/* Call _exit(Status) */
		}

		Zwaitpid(pid, &stat_val, 0);

		testing("When child exits and parent process is executing waitpid(),");
    	testing("the low order 8 bits of status are made available to parent");
		testing("process.");
		start
			if((WEXITSTATUS(stat_val) & 0xff) != Status)
	    		error("%s\n%s%x.\n%s%x.",
					"Unexpected status value returned from waitpid().",
					"Expected 0x",
					Status,
					"Received 0x",
					WEXITSTATUS(stat_val) & 0xff );
		finis
	finis

	assertion(8, BASE);
	start
									/* Test with wait() */
		prep("Fork a process.");
		start
			sv_flush();
			pid = Zfork();
		finis

		if(pid == (pid_t)0) {
			prep("Have child call _exit(status), \"status\" is eight bits.");
			start
				sv_flush();
				sv_set_exit_val(Status);
			finis

			done();						/* Call _exit(Status) */
		}

		SLEEP(WAIT_FOR_TIME);
		Zwait(&stat_val);

		testing("When the child exits and the parent process is not waiting,");
    	testing("the exit status code is saved for return to the parent");
		testing("process whenever the parent process executes a wait().");
		start
			if((WEXITSTATUS(stat_val) & 0xff) != Status)
	    		error("%s\n%s%x.\n%s%x.",
					"Unexpected status value returned from wait().",
					"Expected 0x",
					Status,
					"Received 0x",
					WEXITSTATUS(stat_val) & 0xff );
		finis

									/* Repeat test with waitpid() */
		prep("Fork a process.");
		start
			sv_flush();
			pid = Zfork();
		finis

		if(pid == (pid_t)0) {
			prep("Have child call _exit(status), \"status\" is eight bits.");
			start
				sv_flush();
				sv_set_exit_val(Status);
			finis

			done();						/* Call _exit(Status) */
		}

		SLEEP(WAIT_FOR_TIME);
		Zwaitpid(pid, &stat_val, 0);

		testing("When the child exits and the parent process is not waiting,");
    	testing("the exit status code is saved for return to the parent");
		testing("process whenever the parent process executes a waitpid().");
		start
			if((WEXITSTATUS(stat_val) & 0xff) != Status)
	    		error("%s\n%s%x.\n%s%x.",
					"Unexpected status value returned from waitpid().",
					"Expected 0x",
					Status,
					"Received 0x",
					WEXITSTATUS(stat_val) & 0xff );
		finis
	finis

	assertion(9, BASE);
	start
		ENABLE_PSYNC
		FORK
			prep("Child forks a grandchild process.");
			start
				sv_flush();
				pid = Zfork();
			finis

			if(pid == (pid_t)0) {
				pid_t	p_pid;

				prep("Have grandchild delay.");
				start
					p_pid = Zgetppid();
					SEND_PSYNC
					SLEEP(WAIT_FOR_TIME);
				finis

				testing("Child is not terminated when parent calls _exit().");
				testing("Child process is assigned a new parent process ID.");
				start
					if(p_pid == Zgetppid())
						error("%s\n%s(%ld) has not changed.",
							"Expecting parent process ID to have changed.",
							"Actual parent process ID ",
							(long) p_pid);
					SEND_PSYNC
				finis

				done();
			}

			prep("Have child exit() while grandchild lives on.");
			start
				SET_TIMEOUT
					WAIT_PSYNC
				CLEAR_ALARM
			finis
		KROF
		SET_TIMEOUT
						/* Wait for grandchild to be ready to exit. */
			WAIT_PSYNC
		CLEAR_ALARM
		SLEEP(WAIT_FOR_TIME)

		DISABLE_PSYNC
	finis

	done();
}
