#include	<pcts.h>

#include	<Zunistd.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<pcts_timer.h>

static	int	sigcont_rcvd;
static	void sig_cont(int i) {sigcont_rcvd++;}


int main(void)
{
	pid_t	pid;
	struct	sigaction act;

	setup(E__EXIT);
	funct(E__EXIT);

	assertion(10, BASE);
	start
		ENABLE_PSYNC
		FORK
			prep("Fork a process.");
			start
				sv_flush();
				pid = Zfork();
			finis

			if(pid == (pid_t)0) {		/* Child calls exit(). */
				SET_TIMEOUT
					WAIT_PSYNC
				CLEAR_ALARM

				done();
			}

			prep("Have parent catch expected SIGCHLD signal.");
			start
				sig_rcvd = 0;
				SIGNAL(SIGCHLD, sig_int);
				SEND_PSYNC
			finis

			testing("SIGCHLD signal is received by parent process when child");
			testing("calls _exit().");
			start
				expecting(FAILURE);		/* Interrupted by SIGCHLD signal */
				WAIT_FOR_PID(pid);
				if(sig_rcvd == 0)
					error("SIGCHLD not received by parent when child exited.");
			finis
		KROF
		DISABLE_PSYNC
	finis

	assertion(13, BASE);
	start
	  ENABLE_PSYNC
		prep("Fork a child process.");
		start
			sv_flush();
			pid = Zfork();
		finis

		if(pid == (pid_t)0) {			/* Child process */
			prep("Establish a new process group, then fork a grandchild");
			prep("process.");
			start
				Zsetpgid((pid_t)0, (pid_t)0);
				sv_flush();
				pid = Zfork();
			finis

			if(pid == (pid_t)0) {		/* Grandchild process */
				prep("Have grandchild process catch SIGHUP and SIGCONT.");
				start
					sig_rcvd = 0;
					SIGNAL(SIGHUP, sig_int);

					sigcont_rcvd = 0;
					Zsigemptyset(&act.sa_mask);
					act.sa_handler = sig_cont;
					act.sa_flags = 0;
					Zsigaction(SIGCONT, &act, (struct sigaction *)0);
				finis

				prep("Fork a great-grandchild process.");
				start
					sv_flush();
					pid = Zfork();
				finis

				if(pid == (pid_t)0) {	/* great-grandchild */
					prep("Have great-grandchild send SIGSTOP signal");
					prep("to itself.");
					start
						SEND_PSYNC
						sv_flush();
						Zkill(getpid(), SIGSTOP);
					finis

					testing("SIGHUP and SIGCONT received by stopped");
					testing("great-grandchild when orphaned.");
					start
						if(sig_rcvd == 0)
							error("SIGHUP not received by great-grandchild.");
						if(sigcont_rcvd == 0)
							error("SIGCONT not received by great-grandchild.");
					finis

					done();
				}

				/* Grandchild process */
				prep("Have grandchild send SIGSTOP signal to itself.");
				start
					sv_flush();
					Zkill(getpid(), SIGSTOP);
				finis

				testing("SIGHUP and SIGCONT received by grandchild.");
				start
					if(sig_rcvd == 0)
						error("SIGHUP not received by grandchild.");
					if(sigcont_rcvd == 0)
						error("SIGCONT not received by grandchild.");
				finis

				done();
			}

			prep("Child process calls _exit().");
			start
							/* Wait till grand-children are setup. */
				SET_ALARM(MAX_TIME_TO_RUN)
					WAIT_PSYNC
				CLEAR_ALARM
				SLEEP(WAIT_FOR_TIME);	/* Allow SIGSTOPs to be processed. */
			finis

		  	done();
		}
		WAIT_FOR_PID(pid);				/* Orphaned process group created. */

		SLEEP(2 * WAIT_FOR_TIME);		/* Allow grandchild processes to exit.*/

	  DISABLE_PSYNC
	finis

	done();
}
