#include	<pcts.h>

#include	<Zunistd.h>

#include	<sv_env.h>

#include	"../execl/3.1.2_05.h"


int	main(int argc, char *argv[])
{
	int	e_index;

	e_index = atoi(*argv);
	setup(e_index);

	ass_nu = 5;

	testing("Argc is the count of the number of arguments passed");
	testing("not including the terminating NULL pointer.");
	start
		if(argc != ARGS_CNT)
			error("%s\n%s %d\n%s %d",
					"Argc value incorrect.",
					"Expected:",
					ARGS_CNT,
					"Received:",
					argc);
	finis

	assertion(6, BASE);
	start
		testing("The argv parameter is a null-terminated array of character");
		testing("pointers to the arguments passed.");
		start
			int	i;

			for(i=1; i<ARGS_CNT; i++)
				if(strcmp(argv[i], (i==1)?ARG1_VAL:ARG2_VAL))
					error("%s\n%s \"%s\"\n%s \"%s\"",
						"Argument not passed correctly.",
						"Expected:",
						(i==1)?ARG1_VAL:ARG2_VAL,
						"Received:",
						argv[i]);
		
			if(argv[ARGS_CNT] != NULL)
				error("%s%s",
						"The argv array not terminated with NULL pointer",
						"as expected.");
		finis
	finis

	assertion(7, BASE);
	start
		switch(e_index) {
			char	*ptr;

			case E_EXECLE: case E_EXECVE:
				testing("Environment is obtained from argument envp.");
				start
					ptr = getenv("PASS1");
					if(strcmp(ptr, strchr(ENV_PASS1, '=') +1))
						error("Environment string \"PASS1\" not found.");

					ptr = getenv("PASS2");
					if(strcmp(ptr, strchr(ENV_PASS2, '=') +1))
						error("Environment string \"PASS2\" not found.");
				finis
				break;

			case E_EXECL: case E_EXECV: case E_EXECLP: case E_EXECVP:
				testing("Environment is obtained from external variable");
				testing("environ in the calling process.");
				start
					ptr = getenv("PS1");
					if(strcmp(ptr, strchr(ENV_PS1, '=') +1))
						error("Environment string \"PS1\" not found.");

					ptr = getenv("PS2");
					if(strcmp(ptr, strchr(ENV_PS2, '=') +1))
						error("Environment string \"PS2\" not found.");
				finis
				break;
			default:
				error("Bad index \"%d\" passed to ex_4().", e_index);
		}
	finis

	assertion(8, BASE);
	start
		testing("Variable extern char **environment is initialized as");
		testing("an array of character pointers to the environmental");
		testing("strings provided by the calling process.");
		start
			switch(e_index) {
				case E_EXECL: case E_EXECV: case E_EXECLP: case E_EXECVP:
					if(strcmp(environ[0], ENV_PS1))
						error("%s%s\n%s%s\n",
							"Expecting:	",
							ENV_PS1,
							"Actual:	",
							environ[0]);

					if(strcmp(environ[1], ENV_PS2))
						error("%s%s\n%s%s\n",
							"Expecting:	",
							ENV_PS2,
							"Actual:	",
							environ[1]);
					break;

				case E_EXECLE: case E_EXECVE:
					if(strcmp(environ[0], ENV_PASS1))
						error("%s%s\n%s%s\n",
							"Expecting:	",
							ENV_PASS1,
							"Actual:	",
							environ[0]);

					if(strcmp(environ[1], ENV_PASS2))
						error("%s%s\n%s%s\n",
							"Expecting:	",
							ENV_PASS2,
							"Actual:	",
							environ[1]);
					break;
				default:
					error("Bad index \"%d\" passed.", e_index);
			}
		finis

		testing("Variable \"extern char **environment\" terminates with");
		testing("a NULL pointer.");
		start
			if(environ[2] != '\000')
				error("%s\n%s%x(Hex)\n",
					"Expecting: NULL",
					"actual:	",
					environ[2]);
		finis
	finis

	done();
}
