#include	<pcts.h>

#include	<Zunistd.h>
#include	<sys/Zstat.h>
#include	<Zfcntl.h>
#include	<Zdirent.h>

#include	<sv_env.h>

#define	DIRNAME		"3.1.2_21.d"
#define	FILENAME	"3.1.2_21x"
static char	*file_names[] = {
							"ABCDEFGHIJLKM",
							"NOPQRSTUVWXYZ",
							"abcdefghijlkm",
							"nopqrstuvwxyz",
							"0123456789._-"
						   };

extern	char	**environ;
extern	char	test_rc;
static	int		e_index;
static	int		err_ass;
static	char	ascii_assn[3];


static	char	*args[] =	{
								"path_tests",
								ascii_assn,
								(char *) 0,
							};
#define	INITIAL_PATHNAME_ASS_NUM	21
static	int		ass_num = INITIAL_PATHNAME_ASS_NUM;
#define	Datalen	1000

void	exec_path(char *);
void	ck_ul(char *);


int	main(int argc, char *argv[])
{
	char	path_cwd[_POSIX_PATH_MAX +1], path_ref[_POSIX_PATH_MAX +1];
	char	path_data[_POSIX_PATH_MAX +1];

	e_index = atoi(*++argv);
	setup(e_index);
	funct(e_index);

	assertion(ass_num, BASE);
	start
		prep("Change current working directory to \"../tmp/%s.d\".",
									element[(int) E_EXECL].e_name);
		prep("Create known directory entries and files in working directory.");
		start
			exit_on(ERROR);

			environ[0] = (char *) 0;			/* Reset environ. */

			Zgetcwd(path_cwd, _POSIX_PATH_MAX +1);
			sprintf(path_data, "%s/%s", path_cwd,  FILENAME);

			Zstrcpy(path_cwd, temp_path());
			path_cwd[strlen(path_cwd) -1] = '\000'; /* delete trailing '/' */
			Zchdir(path_cwd);
			Zgetcwd(path_cwd, _POSIX_PATH_MAX +1);

							/* Link executable file to tmp/exec*.d/FILENAME. */
			Zlink(path_data, FILENAME);
			Zmkdir(DIRNAME, S_IRWXU);
					/* link executable file to tmp/exec*.d/DIRNAME/FILENAME. */
			sprintf(path_ref, "%s/%s", DIRNAME, FILENAME);
			Zlink(path_data, path_ref);

										/*
												Working_Directory
												 |              |
												 |              |
											  DIRNAME        FILENAME
												 |
											  FILENAME
										*/
		finis

		prep("When the first filename component of the filename");
		prep("argument is \".\", and the pathname does not begin with");
		prep("a slash, then the pathname is resolved by locating");
		prep("the second filename component in the current working");
		prep("directory.");
		start
			sprintf(path_ref, "%s/%s", ".", FILENAME);
		finis

		exec_path(path_ref);
	finis

	assertion(++ass_num, EXTENDED);
	assertion(++ass_num, EXTENDED);

	assertion(++ass_num, BASE);
	start
		prep("Filename argument points to the string beginning");
		prep("with a \"/\".");
		start
			sprintf(path_ref, "%s/%s", path_cwd, FILENAME);
		finis

		exec_path(path_ref);


		prep("Filename argument points to the string beginning");
		prep("with \"///\".");
		start
			sprintf(path_ref, "%s///%s", path_cwd, FILENAME);
		finis

		exec_path(path_ref);


		prep("Filename argument points to the string beginning");
		prep("with \"////\".");
		start
			sprintf(path_ref, "%s////%s", path_cwd, FILENAME);
		finis

		exec_path(path_ref);
	finis

	assertion(++ass_num, BASE);
	start
		prep("First filename component of the pathname argument is \"..\".");
		start
			Zchdir(DIRNAME);

			sprintf(path_ref, "../%s/%s", DIRNAME, FILENAME);
		finis

		exec_path(path_ref);
		Zchdir(path_cwd);
	finis

	assertion(++ass_num, EXTENDED);
	assertion(++ass_num, EXTENDED);

	assertion(++ass_num, BASE);
	start
		prep("Filename argument points to the string \"F1/F2\".");
		start
			sprintf(path_ref, "%s/%s", DIRNAME, FILENAME);
		finis

		exec_path(path_ref);
	finis

	assertion(++ass_num, BASE);
	start
		prep("Filename argument points to the string \"F1/./F2\".");
		start
			sprintf(path_ref, "%s/./%s", DIRNAME, FILENAME);
		finis

		exec_path(path_ref);
	finis

	assertion(++ass_num, BASE);
	start
		prep("Filename argument points to the string \"F1/../F1/F2\".");
		start
			sprintf(path_ref, "%s/../%s/%s", DIRNAME, DIRNAME, FILENAME);
		finis

		exec_path(path_ref);
	finis

	assertion(++ass_num, BASE);
	start
		prep("Filename argument points to the string \"F1//F2\".");
		start
			sprintf(path_ref, "%s//%s", DIRNAME, FILENAME);
		finis

		exec_path(path_ref);

		cleanup("Remove test file from test directory.");
		start
			Zunlink(path_ref);
		finis
	finis

	if(pathconf(DIRNAME, _PC_NO_TRUNC) == (long) -1) {
		assertion(++ass_num, BASE);
		start
			testing("Filename component is a string of more than {NAME_MAX}");
			testing("bytes in a directory for which {_POSIX_NO_TRUNC} is not");
			testing("supported.");
			start
				error("{_POSIX_NO_TRUNC} not supported.");
			finis
		finis
	}
	else
		assertion(++ass_num, NOT_APPLICABLE);

	assertion(++ass_num, BASE);
	start
		int	i;

		for(i=0; i<5; i++) {
			prep("Filename of \"%s\" is supported and", file_names[i]);
			prep("the unique identity of upper and lower case");
			prep("letters are retained.");
			start
				sprintf(path_ref, "%s/%s", DIRNAME, file_names[i]);
				Zrename(FILENAME, path_ref);
				ck_ul(file_names[i]);
			finis

			exec_path(path_ref);
			Zrename(path_ref, FILENAME);
		}
	finis

	assertion(++ass_num, BASE);
	start
		testing("Filename retains the unique identity of its upper and lower");
		testing("case letters.");
		start
			if(err_ass)
				error("See previous assertion for specifics of failure.");
		finis
	finis

	done();
}


		/*	For the Filename tests, check that the upper and lower case
			letters are preserved.  Read the directory and match with 
			the expected names.  This procedure is not performed for
			each element, but each element is covered, if all the filename
			tests are successful.
		*/

void ck_ul(char *f_name)
{
	DIR		*dirp;
	struct	dirent *dirent;
	int	i;
	
	dirp = Zopendir(DIRNAME);
	dirent = Zreaddir(dirp);
	for(i=0; i<2; i++) {	/* Skip dot and dot-dot entries if they exist */
		if( ! ((dirent->d_name)[0] == '.') )
			break;
		dirent = Zreaddir(dirp);
	}
											/* Compare only filename */
	if(strcmp(dirent->d_name, f_name)) {
		error("%s\n%s\"%s\"\n%s\"%s\"\n",
			"Filename entry obtained not what was expected.",
			"Expected:	",
			f_name,
			"Actual:	",
			dirent->d_name);
		err_ass++;
	}
	Zclosedir(dirp);
}

void exec_path(char *path_ref)
{
	pid_t	pid;

	sprintf(ascii_assn, "%2.2d", ass_num);
	FORK
		switch(e_index) {
			case E_EXECL:
				Zexecl(path_ref, "path_test", ascii_assn, (char *)0);
				break;
			case E_EXECLE:
				Zexecle(path_ref, "path_test", ascii_assn, (char *)0, environ);
				break;
			case E_EXECV:
    			Zexecv(path_ref, args);
				break;
			case E_EXECVE:
    			Zexecve(path_ref, args, environ);
				break;
			case E_EXECLP:
				Zexeclp(path_ref, "path_test", ascii_assn, (char *)0);
				break;
			case E_EXECVP:
    			Zexecvp(path_ref, args);
				break;
			default:
				error("Bad indx \"%d\" passed.", e_index);
		}
	KROF
}
