#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zfcntl.h>
#include	<Zdirent.h>

#include	<sv_env.h>
#include	<sv_errno.h>

#include	<pcts_timer.h>


void sig_segv(int signo)
{
							/* If entered, UNRESOLVED test result code. */
	message("%s\n%s\n%s\n%s\n",
			"Call to closedir() generated a SIGSEGV.",
			"Possible cause is non-portable code for SUT's DIR.",
			"If SUT is conforming, then APTL_RTC is PCTS_FAILURE and",
			"APTL must provide documentation associated with APTL_RTC.");
	done();
}


int main(int argc, char *argv[])
{
	DIR		v_dirp;
	int		ret, fd;
	int		e_index;
	char	path[_POSIX_PATH_MAX +1];

	exit_on(ERROR);

	e_index = atoi(*argv);
	sv_setup(e_index);
	ass_nu = 38;

	prep("Get directory stream saved in calling process image.");
	start
		Zstrcpy(path, temp_path());
		Zstrcat(path, *++argv);		/* Filename of saved directory stream. */
		fd = Zopen(path, O_RDONLY);
		Zread(fd, (DIR *)&v_dirp, sizeof(DIR));
		Zclose(fd);
	finis

	prep("Call closedir() for stream opened in calling process image.");
	start
		SIGNAL(SIGSEGV, sig_segv)
		errno = 0;
		ret = closedir(&v_dirp);
	finis

	testing("Directory stream is closed in the new process image.");
	start
		if((ret != -1) || (errno != EBADF))
			error("%s\nActual: return value of %d and errno set to %s.",
					"Expect: return value of -1 and errno set to [EBADF].",
					ret,
					err_lookup(errno));
	finis

	done();
}
