#include	<pcts.h>

#include	<Zunistd.h>
#include	<sys/Zstat.h>

#include	<sv_env.h>
#include	<sv_errno.h>

/*	This module has the S_ISUID mode set to ROOT.  */


extern	char	**environ;
static	int		e_index;
static	int		path_tst(char **);
static	char	path_dir[_POSIX_PATH_MAX +1], path[_POSIX_PATH_MAX +1];

static	char	*args[] =		{
								"acc_test",
								(char *) 0,
							};

#define	DIRNAME		"3.1.2_acc.d"
#define	FILENAME	"3.1.2_accx"

int	main(int argc, char *argv[])
{
	pid_t	pid;

	e_index = atoi(*++argv);
	setup(e_index);
	funct(e_index);

	exit_on(ERROR);
	assertion(35, BASE);
	start
		prep("Establish test file and its directory.");
		start
			char path_ref[_POSIX_PATH_MAX +1];

			environ[0] = (char *) 0;			/* Reset "environ". */

			sprintf(path_dir, "%s%s", temp_path(), DIRNAME);
			Zmkdir(path_dir, PROT_ALL);
			sprintf(path, "%s/%s", path_dir, FILENAME);

					/* link executable file to tmp/exec*.d/DIRNAME/FILENAME. */
			sprintf(path_ref, "./%s", FILENAME);
			Zlink(path_ref, path);
		finis

		FORK
			prep("Establish proper owner for test file and its directory.");
			start
				Zchown(path_dir, UID, GID);
				Zchown(path, UID, GID);
			finis

			prep("Setup test files such that execute access is granted");
			prep("to test file and search access exists on path prefix.");
			start
								/* Execute access on test file */
				Zchmod(path, S_IXUSR);
								/* Search access on path prefix */
				Zchmod(path_dir, S_IXUSR);
			finis

			prep("Establish process's real user-ID as effective user-ID.");
			start
				Zsetuid(getuid());
			finis

			prep("For owner of file, exec is successful.");
			start
				path_tst(args);
			finis
		KROF

		FORK
			prep("Change owner of test file and its path prefix.");
			prep("Change modes such that execute access is provided on");
			prep("path and search access is provided on path prefix");
			prep("for group owner only.");
			start
				Zchown(path_dir, BIN_UID, GID);
				Zchown(path, BIN_UID, GID);
								/* Execute access on test file */
				Zchmod(path, S_IXGRP);
								/* Search access on path prefix */
				Zchmod(path_dir, S_IXGRP);
			finis
				
			prep("Establish process's real user-ID as effective user-ID.");
			start
				Zsetuid(getuid());
			finis
				
			prep("For group owner of file, exec is successful.");
			start
				path_tst(args);
			finis
		KROF

		FORK
			prep("Change owner of test file and its path prefix.");
			prep("Change modes such that execute access is provided on");
			prep("path and search access is provided on path prefix");
			prep("for others only.");
			start
				Zchown(path_dir, BIN_UID, BIN_GID);
				Zchown(path, BIN_UID, BIN_GID);
								/* Execute access on test file */
				Zchmod(path, S_IXOTH);
								/* Search access on path prefix */
				Zchmod(path_dir, S_IXOTH);
			finis

			prep("Establish process's real user-ID as effective user-ID.");
			start
				Zsetuid(getuid());
			finis
				
			prep("For others, exec is successful.");
			start
				path_tst(args);
			finis
		KROF

		cleanup("Remove test files created.");
		start
			Zunlink(path);
			Zrmdir(path_dir);
		finis
	finis

	done();
}

static	int	path_tst(char **args)
{
	pid_t	pid;

	sv_flush();
	pid = Zfork();
	if(pid == (pid_t)0) {
		switch(e_index) {
			case E_EXECL:
				Zexecl(path, "acc_test", (char *)0);
				break;
			case E_EXECLE:
				Zexecle(path, "acc_test", (char *)0, environ);
				break;
			case E_EXECV:
    			Zexecv(path, args);
				break;
			case E_EXECVE:
    			Zexecve(path, args, environ);
				break;
			case E_EXECLP:
				Zexeclp(path, "acc_test", (char *)0);
				break;
			case E_EXECVP:
    			Zexecvp(path, args);
				break;
			default:
				error("Bad indx \"%d\" passed.", e_index);
		}
		done();
	}
	wait_for(pid, MAX_TIME_TO_RUN);
}
