#include	<pcts.h>

#include	<Zunistd.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<termios.h>
#include	<pcts_timer.h>

#define CHILDREN	(_POSIX_CHILD_MAX -2)	/* Number of children to fork()	*/


int main(void)
{
	pid_t	pid;
	int		tty_fildes, loop_fildes;
	struct	termios tty_termios, *tty_termios_p = &tty_termios,
					loop_termios, *loop_termios_p = &loop_termios;

	setup(E_FORK);
	funct(E_FORK);

	if(GTI_NOT_PROVIDED) {
		GTI_NOT_PROVIDED_RESULT(20, BASE)
		done();
	}

	assertion(20, BASE);
	start
		int	i;

		FORK
			prep("Establish PORT_TTY as the control terminal and PORT_LOOP.");
			start
				exit_on(ERROR);
				termios_prep(&tty_fildes, tty_termios_p, &loop_fildes,
								loop_termios_p);

							/* Enable SIGNALS */
				Ztcgetattr(loop_fildes, loop_termios_p);
				loop_termios_p->c_lflag |= ISIG;
				Ztcsetattr(loop_fildes, TCSAFLUSH, loop_termios_p);
			finis

			prep("Fork children for termination by SIGINT.");
			start
				exit_on(ERROR);
				for(i=0; i<CHILDREN; ++i) {
					SIGNAL(SIGINT, SIG_DFL);
					if(Zfork() == (pid_t)0) {
						SET_TIMEOUT
							pause();
						CLEAR_ALARM

						done();
					}
				}
			finis

						/* Allow child processes to get established. */
			SLEEP(WAIT_FOR_TIME);

			testing("Controlling terminal for parent is the same as child.");
			testing("INTR sent to PORT_TTY of parent generates SIGINT on");
			testing("child processes.");
			start
				SIGNAL(SIGINT, sig_int);
				sig_rcvd = 0;
				SET_ALARM(WAIT_FOR_TIME)
					WRITE_TTY_SCC(loop_fildes, tty_termios_p->c_cc[VINTR]);
				IGNORE_ALARM
				sleep(WAIT_FOR_TIME);

				if(sig_rcvd == 0)
					error("Process did not receive SIGINT.");
			finis

			testing("Children exit due to SIGINT signal.");
			start
				int stat_val;

				SLEEP(WAIT_FOR_TIME);

				while((pid = wait(&stat_val)) > (pid_t)0) {
					if(WTERMSIG(stat_val) != SIGINT)
						error("%s%ld.\n%s%d\n%s%d",
								"Unexpected return from wait() for process ",
								(long) pid,
								"Expected: ",
								SIGINT,
								"Received: ",
								WTERMSIG(stat_val));
				}
			finis
		KROF
		SLEEP(GTI_LINE_CLOSE_DELAY)
	finis

	done();
}
