#include	<pcts.h>

#include	<Zunistd.h>

#include	<sv_env.h>
#include	<sv_sigs.h>
#include	<pcts_timer.h>

/* This module has S_ISUID set to ROOT.  */


int	main(void)
{
	pid_t	pid;
	int		i;
	char	a_sig[10];

	setup(E_KILL);
	funct(E_KILL);

	assertion(7, BASE);
	start
		for(i=0; i<NSIGS_JC; i++) {
			if(sigs[i].sig == SIGKILL)
				continue;
			sprintf(a_sig, "%d", sigs[i].sig);

			FORK
				prep("Fork a child.");
				start
					sv_flush();
					pid = Zfork();
				finis
	
				if(pid == (pid_t)0) {
					prep("Exec a module which has S_ISUID bit set");
					prep("and owner is BIN_UID.");
					start
						Zexecl("./3.3.2_07xr","3.3.2_07xr", a_sig, (char *)0);
					finis

					done();				/* Just in case */
				}
			
				prep("Exec a module which has S_ISUID bit set");
				prep("and owner is ANOTHER_UID.");
				start
					Zexecl("./3.3.2_07xs","3.3.2_07xs", a_sig, (char *)0);
				finis

				WAIT_FOR_PID(pid); 		/* Just in case of failure. */
			KROF
		}
	finis


	assertion(8, BASE);
	start
		for(i=0; i<NSIGS_JC; i++) {
			if(sigs[i].sig == SIGKILL)
				continue;
			sprintf(a_sig, "%d", sigs[i].sig);

			FORK
				prep("Fork a child.");
				start
					sv_flush();
					pid = Zfork();
				finis
	
				if(pid == (pid_t)0) {
					prep("Set user IDs to UID.");
					start
						Zsetuid(UID);
					finis

					prep("Exec a module which has S_ISUID bit set");
					prep("and owner is ANOTHER_UID.");
					start
						Zexecl("./3.3.2_08xr","3.3.2_08xr", a_sig, (char *)0);
					finis

					done();				/* Just in case */
				}
			
				/* Parent process */
				prep("Set user IDs to BIN_UID.");
				start
					Zsetuid(BIN_UID);
				finis

				prep("Exec a module which has S_ISUID bit set");
				prep("and owner is UID.");
				start
					Zexecl("./3.3.2_08xs","3.3.2_08xs", a_sig, (char *)0);
				finis

				WAIT_FOR_PID(pid);		/* Just in case of failure. */
		KROF
		}
	finis


	assertion(9, BASE);
	start
		for(i=0; i<NSIGS_JC; i++) {
			if(sigs[i].sig == SIGKILL)
				continue;
			sprintf(a_sig, "%d", sigs[i].sig);

			FORK
				prep("Fork a child.");
				start
					sv_flush();
					pid = Zfork();
				finis
	
				if(pid == (pid_t)0) {
					prep("Set user IDs to ANOTHER_UID.");
					start
						Zsetuid(ANOTHER_UID);
					finis

					prep("Exec a module which has S_ISUID bit set");
					prep("and owner is UID.");
					start
						Zexecl("./3.3.2_09xr","3.3.2_09xr", a_sig, (char *)0);
					finis

					done();				/* Just in case */
				}
			
				prep("Set user IDs to UID.");
				start
					Zsetuid(UID);
				finis

				prep("Exec a module which has S_ISUID bit set");
				prep("and owner is BIN_UID.");
				start
					Zexecl("./3.3.2_09xs","3.3.2_09xs", a_sig, (char *)0);
				finis

				WAIT_FOR_PID(pid);		/* Just in case of failure. */
			KROF
		}
	finis


	assertion(10, BASE);
	start
		for(i=0; i<NSIGS_JC; i++) {
			if(sigs[i].sig == SIGKILL)
				continue;
			sprintf(a_sig, "%d", sigs[i].sig);

			FORK
				prep("Fork a child.");
				start
					sv_flush();
					pid = Zfork();
				finis
	
				if(pid == (pid_t)0) {
					prep("Set effective user ID to ANOTHER_UID.");
					start
						Zsetuid(ANOTHER_UID);
					finis

					prep("Exec a module which has S_ISUID bit set");
					prep("and owner is UID.");
					start
						Zexecl("./3.3.2_10xr","3.3.2_10xr", a_sig, (char *)0);
					finis

					done();				/* Just in case */
				}
			
				prep("Set user IDs to BIN_UID.");
				start
					Zsetuid(BIN_UID);
				finis

				prep("Exec a module which has S_ISUID bit set");
				prep("and owner is UID.");
				start
					Zexecl("./3.3.2_10xs","3.3.2_10xs", a_sig, (char *)0);
				finis

				WAIT_FOR_PID(pid);		/* Just in case of failure. */
			KROF
		}
	finis

	done();
}
