#include	<pcts.h>

#include	<Zunistd.h>
#include	<sys/Zstat.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<pcts_timer.h>
#include	"./kill.h"

/* This module has S_ISUID set to UID.  */


int	main(int argc, char *argv[])
{
	pid_t	pid;
	int		sig;

	setup(E_KILL);
	ass_nu = 9;

	exit_on(ERROR);
	prep("Set user ID to ANOTHER_UID.");
	start
		Zsetuid(ANOTHER_UID);
	finis

	prep("Ensure receiving process user IDs are set properly.");
	prep("Real and effective user IDs are ANOTHER_UID.");
	prep("Saved set-user ID is UID.");
	start
		if(getuid() != ANOTHER_UID)
			error("%s\n%s%lu.",
					"Expected real user ID to be ANOTHER_UID.",
					"Actual real user ID is ",
					(unsigned long) getuid());

		if(geteuid() !=  ANOTHER_UID)
			error("%s\n%s%lu.",
					"Expected effective user ID to be ANOTHER_UID.",
					"Actual effective user ID is ",
					(unsigned long) geteuid());
		sig = atoi(*++argv);
	finis

	prep("Establish SIG_DFL for %s signal.", sig_lookup(sig));
	start
		SIGNAL(sig, SIG_DFL);
 		pid = getpid();
	finis

 	prep("Pass receiving process's ID (%ld) to sending process.", (long)pid);
	start
 		char	old[_POSIX_PATH_MAX +1], new[_POSIX_PATH_MAX +1];
		int		fd;

 		Zstrcpy(old, temp_path());
 		Zstrcat(old, "psynch_t");
 		fd = Zcreat(old, PROT_ALL);
 		Zwrite(fd, (char *)&pid, (unsigned)sizeof(pid_t));
 		Zstrcpy(new, temp_path());
 		Zstrcat(new, FILENAME);
		Zclose(fd);
 		Zrename(old, new);
		sv_flush();
	finis

	pause();
	
	done();			/* Just in case */
}
