#include	<pcts.h>

#include	<Zunistd.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<sv_sigs.h>
#include	<pcts_timer.h>

/* This module has S_ISUID set to ROOT.  */

int	main(void)
{
	pid_t	pid;
	int		i;
	sigset_t	set;

	setup(E_KILL);
	funct(E_KILL);

	assertion(17, BASE);
	start
		ENABLE_PSYNC
		for(i=0; i<NSIGS_JC; i++) {
			if(sigs[i].sig == SIGKILL)
				continue;
			FORK
				prep("Fork a child.");
				start
					sv_flush();
					pid = Zfork();
				finis
	
				if(pid == (pid_t)0) {
					prep("Set process user IDs to BIN_UID.");
					start
						Zsetuid(BIN_UID);
					finis

					prep("Establish SIG_DFL for %s signal.", sigs[i].signame);
					start
						sv_flush();
						SIGNAL(sigs[i].sig, SIG_DFL);
						SEND_PSYNC
						SLEEP(WAIT_FOR_TIME);
					finis

					done();
				}

				prep("Set process user IDs to UID.");
				start
					Zsetuid(UID);
				finis

				SET_TIMEOUT
					WAIT_PSYNC
				CLEAR_ALARM

				testing("Call to kill() for signal %s, when", sigs[i].signame);
				testing("receiving process IDs do not match sending process");
				testing("IDs, return -1 and set errno to [EPERM].");
				start
					expecting(-1);
					expecting(EPERM);
					Zkill(pid, sigs[i].sig);
				finis
				WAIT_FOR_PID(pid);
			KROF
		}
		DISABLE_PSYNC
	finis


	assertion(18, BASE);
	start
		ENABLE_PSYNC
		FORK
			prep("Fork a child.");
			start
				sv_flush();
				pid = Zfork();
			finis

			if(pid == (pid_t)0) {
				prep("Set process user IDs to BIN_UID and establish a");
				prep("new session.");
				start
					Zsetuid(BIN_UID);
					Zsetsid();
				finis

				prep("Block SIGCONT signal.");
				start
					SIGNAL(SIGCONT, sig_int);
					SIGBLOCK(set, SIGCONT);
					SEND_PSYNC
					SLEEP(WAIT_FOR_TIME);
				finis

				testing("Signal SIGCONT was not delivered.");
				start
					Zsigpending(&set);
					if(sigismember(&set, SIGCONT) )
						error("SIGCONT signal was delivered.");
				finis

				done();
			}

			prep("Set process user IDs to UID.");
			start
				Zsetuid(UID);
			finis

			SET_TIMEOUT
				WAIT_PSYNC
			CLEAR_ALARM

			testing("Call to kill() when signal is SIGCONT, receiving");
			testing("process IDs do not match sending process IDs and there");
			testing("are no receiving processes in the same session as the");
			testing("sending process , returns -1 and sets errno to [EPERM].");
			start
				expecting(-1);
				expecting(EPERM);
				Zkill(pid, sigs[i].sig);
			finis
			WAIT_FOR_PID(pid);
		KROF
		DISABLE_PSYNC
	finis

	assertion(19, NOT_APPLICABLE);

	done();
}
