#include	<pcts.h>

#include	<Zunistd.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<sv_sigs.h>

int	main(void)
{
	sigset_t	set;

	setup(E_SIGISMEMBER);
	funct(E_SIGISMEMBER);

	assertion(4, BASE);
	start
		int	i, st;

		testing("Call to sigismember() returns a value of 0 when the");
		testing("signal argument is not a member of the set.");
		start
			Zsigemptyset(&set);
			for(i=0; i<NSIGS; i++) {
				st = sigismember(&set, sigs[i].sig);
				if(st != 0)
					error("Signal %s is a member of the initialized set .",
								sigs[i].signame);
			}
		finis

		testing("Call to sigismember() returns a value of 1 when the");
		testing("signal argument is a member of the set.");
		start
			Zsigfillset(&set);
			for(i=0; i<NSIGS; i++) {
				st = sigismember(&set, sigs[i].sig);
				if(st != 1)
					error("Signal %s not included in the initialized set .",
									sigs[i].signame);
			}
		finis
	finis

	if(PCTS_INVALID_SIGNAL == 0) {
		assertion(5, NOT_TESTABLE);
	}
	else {
		assertion(5, BASE);
		start
	    	testing("Call to sigismember() returns a value of -1 and errno");
			testing("is set to [EINVAL] when the signal number is invalid.");
	    	start
	       		expecting(-1);
	       		expecting(EINVAL);
	       		Zsigismember(&set, PCTS_INVALID_SIGNAL_NUMBER);
	    	finis
		finis
	}

	assertion(6, EXTENDED);

    done();
}
