#include	<pcts.h>

#include	<Zunistd.h>
#include	<sys/Zstat.h>
#include	<Zfcntl.h>

#include	<sv_env.h>
#include	<sv_sigs.h>
#include	<pcts_timer.h>

#define	String		"Test"
#define	Strlen		(sizeof(String) -1)
#define	FILENAME	"3.3.1_06"


int main(void)
{
	pid_t 	pid;
	int		stat_val, i;
	int		chk_10 = NOT_TRUE_NOR_FALSE;

					/* Do not catch signals when initializing for testing. */
	for(i=0; i<NSIGS; i++) 
		no_sig(sigs[i].sig);

	setup(E_SIGNAL_CON);
	funct(E_SIGNAL_CON);

	assertion(6, BASE);
	start
		for(i=0; i<NSIGS_JC; i++) {
	    	prep("Fork a child process.");
			start
				sv_flush();
				pid = Zfork();
			finis

			if(pid == (pid_t)0) {
				prep("Have child pause.");
				start
					pause();
				finis

				done();
			}

			SLEEP(WAIT_FOR_TIME);

			testing("Signal %s will abnormally terminate the child process.",
									sigs[i].signame);
			start
				Zkill(pid, sigs[i].sig);
				Zwaitpid(pid, &stat_val, 0);
				if(WTERMSIG(stat_val) != sigs[i].sig)
					error("%s%s\n%s%d",
						"Expected child process to be terminated by ",
						sigs[i].signame,
						"Value returned from macro WTERMSIG is ",
						WTERMSIG(stat_val) );
			finis
		}
	finis
	
	assertion(7, BASE);
	start
		for(i=0; i<NSIGS_JC; i++) {
			if(sigs[i].sig == SIGKILL)
				continue;
	    	prep("Fork a child process.");
	    	start
				sv_flush();
				pid = Zfork();
			finis

			if(pid == (pid_t)0) {
				prep("Child sets action to SIG_DFL for signal %s.",
											sigs[i].signame);
				start
					sv_flush();
					SIGNAL(sigs[i].sig, SIG_DFL);
				finis

				prep("Send %s signal to child process.", sigs[i].signame);
				start
					Zkill(getpid(), sigs[i].sig);

					SET_TIMEOUT
						pause();
						error("Process not terminated.");
					CLEAR_ALARM
				finis

				done();
			}

			waitpid(pid, &stat_val, 0);

			testing("Signal %s terminated child.", sigs[i].signame);
			start
				if(WIFSIGNALED(stat_val)) {
					if(WTERMSIG(stat_val) != sigs[i].sig) {
						chk_10 = FALSE;		/* Error for assertion 10 also. */
						error("%s%s.\n%s%d",
							"Expected child process to be terminated by ",
							sigs[i].signame,
							"Value returned from macro WTERMSIG is ",
							WTERMSIG(stat_val) );
					}
					else {
						if(chk_10 == TRUE || chk_10 == NOT_TRUE_NOR_FALSE)
							chk_10 = TRUE;
					}
				}
				else {
					chk_10 = FALSE;		/* Error for assertion 10 also. */
					error("%s signal did not terminate child process.",
										sigs[i].signame);
				}
			finis
		}
	finis

	assertion(8, BASE);
	start
		int		pipfd[2], fd;
		char	path[_POSIX_PATH_MAX +1];
		struct	flock	flock;

		for(i=0; i<NSIGS_JC; i++) {
			if(sigs[i].sig == SIGKILL)
				continue;
			FORK
				ENABLE_PSYNC
					prep("Create a regular file and pipe for testing.");
					start
						strcpy(path, temp_path());
						strcat(path, FILENAME);
						fd = Zcreat(path, PROT_ALL);
						Zpipe(pipfd);
						
						flock.l_type = F_WRLCK;
						flock.l_whence = SEEK_SET;
						flock.l_start = (off_t)0;
						flock.l_len = (off_t)0;
					finis
						
					prep("Fork a child process.");
					start
						sv_flush();
						pid = Zfork();
					finis
						
					if(pid == (pid_t)0) {
						prep("Child sets action to SIG_DFL for signal %s.",
													sigs[i].signame);
						start
							sv_flush();
							SIGNAL(sigs[i].sig, SIG_DFL);
						finis
		
						prep("Lock regular file.");
						start
							Zfcntl(fd, F_SETLK, &flock);
						finis
		
						SEND_PSYNCA
						SET_TIMEOUT
							WAIT_PSYNC
						CLEAR_ALARM
		
						prep("Send %s signal to child process.", 
													sigs[i].signame);
						start
							Zkill(getpid(), sigs[i].sig);
							sv_flush();
		
							SET_TIMEOUT
								pause();
								error("Process not terminated.");
							CLEAR_ALARM
						finis
		
						done();
					}
		
					SET_TIMEOUT
						WAIT_PSYNCA
					CLEAR_ALARM

					prep("Check regular file for being locked.");
					start
						Zfcntl(fd, F_GETLK, &flock);
						
						if(flock.l_type != F_WRLCK)
							error("Regular file accesible for locking.");
					finis
						
					prep("Test pipe() for writing.");
					start
						close(pipfd[0]);
						
						SET_ALARM(TIMEOUT)
							Zwrite(pipfd[1], String, Strlen);
						CLEAR_ALARM
					finis
		
					SEND_PSYNC
					WAIT_FOR_PID(pid);
		
					testing("Test regular file for lock access.");
					start
						Zfcntl(fd, F_GETLK, &flock);
						if(flock.l_type != F_UNLCK)
							error("Child's regular file was not closed.");
					finis
						
					testing("Expect [EPIPE] on write to pipe.");
					start
						SIGNAL(SIGPIPE, SIG_IGN);	/* Ignore expected SIGPIPE*/
						expecting(EPIPE);
						expecting(FAILURE);
						Zwrite(pipfd[1], String, Strlen);
					finis

				DISABLE_PSYNC
			KROF
		}
	finis

	assertion(9, EXTENDED);

	assertion(10, BASE);
	start
		if(chk_10 != NOT_TRUE_NOR_FALSE) {
				/* If NOT_TRUE_NOR_FALSE, test result code is UNRESOLVED. */
			testing("Tested by assertion test #7.");
			start
				if(chk_10 == FALSE)
					error("See assertion test #7 for details on failure.");
			finis
		}
	finis

	assertion(11, BASE);
	start
										/* Test for wait() */
		for(i=0; i<NSIGS_JC; i++) {
			if(sigs[i].sig == SIGKILL)
				continue;
			prep("Fork a child process.");
			start
				sv_flush();
				pid = Zfork();
			finis

			if(pid == (pid_t)0) {
				prep("Child sets action to SIG_DFL for signal %s.",
											sigs[i].signame);
				start
					SIGNAL(sigs[i].sig, SIG_DFL);
				finis

				prep("Wait for process to be terminated.");
				start
					sv_flush();
					pause();
					error("Process not terminated.");
				finis

				done();
			}

			SLEEP(WAIT_FOR_TIME);

			prep("Send %s signal to child process.", sigs[i].signame);
			prep("Delay till child is assumed to exit.");
			start
				kill(pid, sigs[i].sig);
				SLEEP(WAIT_FOR_TIME +1);
			finis

			testing("When the parent is not waiting, the signal number which");
			testing("caused the termination of child is saved for return to");
			testing("the parent process on a subsequent wait() for this");
			testing("process.");
			start
				SET_TIMEOUT
					Zwait(&stat_val);
				CLEAR_ALARM

				if(WIFSIGNALED(stat_val)) {
					if(WTERMSIG(stat_val) != sigs[i].sig)
						error("%s%s.\n%s%d",
							"Expected child process to be terminated by ",
							sigs[i].signame,
							"Value returned from macro WTERMSIG is ",
							WTERMSIG(stat_val) );
				}
				else
					error("%s signal did not terminate child process.",
										sigs[i].signame);
			finis
		}

										/* Repeat test for waitpid() */
		for(i=0; i<NSIGS_JC; i++) {
			if(sigs[i].sig == SIGKILL)
				continue;
			prep("Fork a child process.");
			start
				sv_flush();
				pid = Zfork();
			finis

			if(pid == (pid_t)0) {
				prep("Child sets action to SIG_DFL for signal %s.",
											sigs[i].signame);
				start
					SIGNAL(sigs[i].sig, SIG_DFL);
				finis

				prep("Wait for process to be terminated.");
				start
					sv_flush();
					pause();
					error("Process not terminated.");
				finis

				done();
			}

			SLEEP(WAIT_FOR_TIME);

			prep("Send %s signal to child process.", sigs[i].signame);
			prep("Delay till child is assumed to exit.");
			start
				kill(pid, sigs[i].sig);
				SLEEP(WAIT_FOR_TIME +1);
			finis

			testing("When the parent is not waiting, the signal number which");
			testing("caused the termination of child is saved for return to");
			testing("the parent process on a subsequent waitpid() for this");
			testing("process.");
			start
				SET_TIMEOUT
					Zwaitpid(pid, &stat_val, 0);
				CLEAR_ALARM

				if(WIFSIGNALED(stat_val)) {
					if(WTERMSIG(stat_val) != sigs[i].sig)
						error("%s%s.\n%s%d",
							"Expected child process to be terminated by ",
							sigs[i].signame,
							"Value returned from macro WTERMSIG is ",
							WTERMSIG(stat_val) );
				}
				else {
					error("%s signal did not terminate child process.",
										sigs[i].signame);
				}
			finis
		}
	finis

	done();
}
