#include	<pcts.h>

#include	<Zunistd.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<sv_sigs.h>
#include	<pcts_timer.h>


static	int	sig_passed = 0;
void sig_arg(int i) {sig_passed=i;}
	
	
int main(void)
{
	pid_t		pid;
	int			i;
	sigset_t	set;
	
	setup(E_SIGNAL_CON);
	funct(E_SIGNAL_CON);

	assertion(38, BASE);
	start
		for(i=0; i<NSIGS; i++) {
			if(	(sigs[i].sig == SIGKILL) ||
				(sigs[i].sig == SIGCONT) ||
				(sigs[i].sig == SIGSTOP) ||
				(sigs[i].sig == SIGTSTP) ||
				(sigs[i].sig == SIGTTIN) ||
				(sigs[i].sig == SIGTTOU) )
					continue;
							/*	Behavior unspecified if action for SIGCHLD set
								to SIG_IGN (1003.1, page 54, lines 509-510). */
			if(sigs[i].sig == SIGCHLD)
					continue;

			FORK
				prep("Generate a pending %s signal.", sigs[i].signame);
				start
					SIGBLOCK(set, sigs[i].sig);
					sig_rcvd = 0;
					SIGNAL(sigs[i].sig, sig_int);
					Zkill(getpid(), sigs[i].sig);

					Zsigpending(&set);
					if( ! sigismember(&set, sigs[i].sig) )
						error("Signal %s not pending.", sigs[i].sig);
				finis

				testing("When the action for the pending signal is set to");
				testing("SIG_IGN, then the pending signal is discarded.");
				start
					SIGNAL(sigs[i].sig, SIG_IGN);

					Zsigpending(&set);
					if(sigismember(&set, sigs[i].sig) )
						error("Signal %s is pending.", sigs[i].sig);
				finis
			KROF
		}
	finis

	assertion(39, EXTENDED);

	assertion(40, BASE);
	start
		for(i=0; i<NSIGS_JC; i++) {
			if(sigs[i].sig == SIGKILL)
				continue;

			FORK
				prep("Set action to catch %s.", sigs[i].signame);
				start
					SIGNAL(sigs[i].sig, sig_arg);
				finis
						
				prep("Send signal %s to child process.", sigs[i].signame); 
				start
					Zkill(getpid(), sigs[i].sig);
					SLEEP(WAIT_FOR_TIME);			/* Process kill() */
				finis
	
				testing("Process executed at address specified when");
				testing("the %s signal occurs.", sigs[i].signame);
				testing("Signal number is passed as first argument.");
				start
					if(sig_passed != sigs[i].sig)
						error("%s\n%s%d\n%s%d",
							"Invalid value passed to signal catching function.",
							"Expected: ",
							sigs[i].sig,
							"Received: ",
							sig_passed);
				finis
			KROF
		}
	finis

	done();
}
