#include	<pcts.h>

#include	<Zunistd.h>

#include	<sv_env.h>
#include	<sv_errno.h>
#include	<sv_sigs.h>
#include	<pcts_timer.h>


static	int	sig_passed = 0;
void sig_arg(int i) {sig_passed=i;}
	
	
int main(void)
{
	pid_t		pid;
	int			i;
	struct		sigaction	act1;
	
	setup(E_SIGNAL_CON);
	funct(E_SIGNAL_CON);

	assertion(41, BASE);
	start
		for(i=NSIGS_JC; i<NSIGS; i++) {
			if(sigs[i].sig == SIGSTOP)
				continue;

			FORK
				prep("Set signal catcher for %s.", sigs[i].signame);
				start
					SIGNAL(sigs[i].sig, sig_arg);
				finis
					
				prep("Send the signal %s to this child process.",
					  				sigs[i].signame); 
				start
					Zkill(getpid(), sigs[i].sig);
					SLEEP(WAIT_FOR_TIME);			/* Processs kill() */
				finis

				testing("Process executed at address specified when");
				testing("the %s signal occured.", sigs[i].signame);
				testing("Signal number is passed as first argument.");
				start
					if(sig_passed != sigs[i].sig)
						error("%s\n%s%d\n%s%d",
							"Invalid value passed to signal catcher.",
							"Expected: ",
							sigs[i].sig,
							"Received: ",
							sig_passed);
				finis
			KROF
		}
	finis


#define ITERATIONS 10
#define A_SIZE 10
	assertion(42, BASE);
	start
		unsigned    a[A_SIZE];
		int	j;

		for(j=0; j<ITERATIONS; j++) {
			FORK
				prep("Catch signal SIGALRM.");
				start
		    		for(i = 0; i < A_SIZE; i++)
		        		a[i] = 0;
					SIGNAL(SIGALRM, sig_int);
				finis
	
				prep("Loop continuously until interrupt processed.");
				start
					sig_rcvd = 0;
					alarm(1);
					while(!sig_rcvd) {
						a[0]++;
						a[1]++;
						a[2]++;
						a[3]++;
						a[4]++;
						a[5]++;
						a[6]++;
						a[7]++;
						a[8]++;
						a[9]++;

						a[0]--;
						a[1]--;
						a[2]--;
						a[3]--;
						a[4]--;
						a[5]--;
						a[6]--;
						a[7]--;
						a[8]--;
						a[9]--;
	   				}
				finis
	
				testing("After returning from the signal catching function,");
	    		testing("the receiving process shall resume execution at");
	    		testing("the point it was interrupted.");
				start
		    		for(i = 0; i < A_SIZE; i++)
		       			if(a[i] != 0)
							error("%s\n%s a[%d] is %d.",
								"Expected all values of array to be 0.",
								"Actual value of",
								i, a[i]);
				finis
			KROF
		}
    finis

	assertion(43, BASE);
	start
		FORK
			testing("Cannot set action to catch SIGKILL.");
			start
				Zsigemptyset(&act1.sa_mask);
				act1.sa_handler = sig_int;
				expecting(FAILURE);
				expecting(EINVAL);
				Zsigaction(SIGKILL, &act1, (struct sigaction *)0);
			finis
		KROF
	finis

	assertion(44, BASE);
	start
		FORK
			testing("Cannot set action to catch SIGSTOP.");
			start
				Zsigemptyset(&act1.sa_mask);
				act1.sa_handler = sig_int;
				expecting(FAILURE);
				expecting(EINVAL);
				Zsigaction(SIGSTOP, &act1, (struct sigaction *)0);
			finis
		KROF
	finis

	done();
}
