#include	<pcts.h>

#include	<Zunistd.h>

#include	<sv_env.h>
#include	<pcts_timer.h>

	/* Testing:  pause() is reentrant with respect to signals. */

static int	catch_sig;
void sig_catch2(int i)
{	
	prep("Entering second signal catching routine.");
	start
		catch_sig++;
	finis
}

void sig_catch(int i)
{	
	prep("Unblock SIGINT in interrupt catcher.");
	start
		sigset_t sigint;

		sigemptyset(&sigint);
		sigaddset(&sigint, SIGINT);
		sigprocmask(SIG_UNBLOCK, &sigint, NULL);
	finis

	prep("Set second signal catcher for SIGINT.");
	start
		expecting(SUCCESS);
		SIGNAL(SIGINT, sig_catch2);
		catch_sig++;
	finis

	prep("Signal catcher calls pause().");
	start
		SET_TIMEOUT
			pause();
			catch_sig++;
		CLEAR_ALARM
	finis
}

int main(void)
{
	pid_t	pid;

	setup(E_SIGNAL_CON);
	ass_nu = 45;
	
 	prep("Fork a child process to test function pause() is reentrant.");
	   start
		sv_flush();
		pid = Zfork();
	finis

	if(pid == (pid_t)0) {
		prep("Set signal catcher for SIGINT, then call pause().");
		start
			SIGNAL(SIGINT, sig_catch);
			catch_sig = 0;
		
			pause();
		finis

		testing("The function pause() is reentrant with respect to signals.");
		start
			if(catch_sig != 3)
				error("The pause() function is not reentrant.");
		finis

		done();
	}


	prep("Issue SIGINT to child.");
	start
		SLEEP(WAIT_FOR_TIME);		/* Allow time for child to call pause() */
		Zkill(pid, SIGINT);
	finis

	prep("Issue a second SIGINT to child to interrupt the interrupt.");
	start
		SLEEP(WAIT_FOR_TIME);	/* Allow time for sig_catch() to call pause() */
		Zkill(pid, SIGINT);
	finis

	WAIT_FOR_PID(pid);

	done();
}
