#include	<pcts.h>

#include	<Zunistd.h>

#include	<sv_env.h>
#include	<pcts_timer.h>

	/* Testing: sigprocmask() is reentrant with respect to signals. */

static	int	catch_sig;

void sig_catch(int i)
{	
	sigset_t mask;

	prep("Interrupt action changes signal process mask.");
	start
		sigemptyset(&mask);
		sigaddset(&mask, SIGUSR2);
		sigprocmask(SIG_SETMASK, &mask, (sigset_t *)0);
		catch_sig++;
	finis

	testing("Interrupt signal process action is to block SIGUSR2.");
	start
		sigprocmask(SIG_SETMASK, (sigset_t *)0, &mask);
		if( ! sigismember(&mask, SIGUSR2) )
			error("SIGUSR2 not set in the current signal process mask.");
	finis
}

int main(void)
{
	pid_t	pid;
	sigset_t mask;
	
	setup(E_SIGNAL_CON);
	ass_nu = 45;
	
	FORK
		prep("Set signal catcher for SIGINT and BLOCK SIGINT signal.");
		start
			SIGNAL(SIGINT, sig_catch);
			Zsigemptyset(&mask);
			Zsigaddset(&mask, SIGINT);
			Zsigprocmask(SIG_SETMASK, &mask, (sigset_t *)0);
		finis
		
		prep("Establish a pending SIGINT signal.");
		start
			Zkill(getpid(), SIGINT);
			SLEEP(WAIT_FOR_TIME);
		finis

		prep("Child calls sigprocmask() to unblock SIGINT .");
		start
			Zsigemptyset(&mask);
			Zsigprocmask(SIG_SETMASK, &mask, (sigset_t *)0);
		finis

		testing("Function sigprocmask() is reentrant with respect to signals.");
		start
									/* Get current process signal mask. */
			Zsigprocmask(SIG_SETMASK, (sigset_t *)0, &mask);
			if(sigismember(&mask, SIGINT))
				error("SIGINT is set in the current signal process mask.");
			if(catch_sig != 1)
				error("The sigprocmask() function is not reentrant.");
		finis
	KROF

	done();
}
