#include	<pcts.h>

#include	<Zunistd.h>

#include	<sv_env.h>
#include	<sv_sigs.h>
#include	<pcts_timer.h>


int main(void)
{
	pid_t 	pid;
	int		stat_val, i;
	
					/* Do not catch signals when initializing for testing. */
	for(i=0; i<NSIGS; i++) 
		no_sig(sigs[i].sig);

	setup(E_SIGNAL_CON);
	funct(E_SIGNAL_CON);

	assertion(49, BASE);
	start
		for(i=0; i<NSIGS_JC; i++) {
			if(sigs[i].sig == SIGKILL)
				continue;

	 		prep("Fork a child process.");
		    start
				sv_flush();
				pid = Zfork();
			finis
	
			if(pid == (pid_t)0) {
				prep("Set signal action for %s to SIG_DFL.", sigs[i].signame);
				start
					SIGNAL(sigs[i].sig, SIG_DFL);
				finis

				prep("Child calls pause().");
				start
					sv_flush();
					pause();

					error("Signal %s caused return after interrupt occurred.",
											sigs[i].signame);
				finis
				
				done();
			}

			SLEEP(WAIT_FOR_TIME);		/* Allow testing to be last message. */

			testing("Interrupted function does not return after delivery");
			testing("of signal %s to process.", sigs[i].signame);
			start
				Zkill(pid, sigs[i].sig);
				SET_TIMEOUT
					Zwaitpid(pid, &stat_val, 0);
					if(WIFSIGNALED(stat_val)) {
						if(WTERMSIG(stat_val) != sigs[i].sig)
							error("%s%s.\n%s%s",
								"Expected child terminated by ",
								sigs[i].signame,
								"Signal returned from macro WTERMSIG is ",
								sig_lookup(WTERMSIG(stat_val)) );
					}
					else
						error("Child not terminated by a signal.");
				CLEAR_ALARM
			finis
		}
	finis

	assertion(50, BASE);
	start
		for(i=NSIGS_STOP; i<NSIGS; i++) {
	 		prep("Fork a child process.");
			start
				sv_flush();
				pid = Zfork();
			finis
	
			if(pid == (pid_t)0) {
				if(sigs[i].sig != SIGSTOP) {
					prep("Set action for %s to SIG_DFL.", sigs[i].signame);
					start
						SIGNAL(sigs[i].sig, SIG_DFL);
					finis
				}

				prep("Issue signal %s to stop the child process.",
									sigs[i].signame);
				start
					Zkill(getpid(), sigs[i].sig);
					SLEEP(WAIT_FOR_TIME);
				finis
	
				done();
			}
	
			testing("Child process stopped by signal %s.", sigs[i].signame);
			start
				SLEEP(WAIT_FOR_TIME);
				Zwaitpid(pid, &stat_val, WUNTRACED | WNOHANG);

				if( ! WIFSTOPPED(stat_val) )
					error("Process not stopped.");
				else
					if(WSTOPSIG(stat_val) != sigs[i].sig) 
						error("%s\n%s%s\n%s%s",
							"WSTOPSIG() result not expected result.",
							"Expected: ",
							sigs[i].signame,
							"Actual: ",
							sig_lookup(WSTOPSIG(stat_val)) );
			finis

			prep("Issue a SIGCONT to continue the process.");
			start
				Zkill(pid, SIGCONT);
			finis

			testing("Child continued.");
			start
				SET_ALARM(TIMEOUT);
					Zwaitpid(pid, &stat_val, 0);
				CLEAR_ALARM		
			finis
		}
	finis

	assertion(51, BASE);
	start
		for(i=NSIGS_STOP; i<NSIGS; i++) {
	 		prep("Fork a child process.");
			start
				sv_flush();
				pid = Zfork();
			finis
	
			if(pid == (pid_t)0) {
				if(sigs[i].sig != SIGSTOP) {
					prep("Set action for %s to SIG_DFL.", sigs[i].signame);
					start
						SIGNAL(sigs[i].sig, SIG_DFL);
					finis
				}
				prep("Issue signal %s to stop the child process.",
									sigs[i].signame);
				start
					Zkill(getpid(), sigs[i].sig);
					SLEEP(WAIT_FOR_TIME);
				finis
	
				done();
			}
	
			testing("Child process stopped by signal %s.", sigs[i].signame);
			start
				SLEEP(WAIT_FOR_TIME);
				Zwaitpid(pid, &stat_val, WUNTRACED | WNOHANG);

				if( ! WIFSTOPPED(stat_val) )
					error("Process not stopped.");
				else
					if(WSTOPSIG(stat_val) != sigs[i].sig) 
						error("%s\n%s%s\n%s%s",
							"WSTOPSIG() result not expected result.",
							"Expected: ",
							sigs[i].signame,
							"Actual: ",
							sig_lookup(WSTOPSIG(stat_val)) );
			finis

			prep("Deliver signal SIGKILL to child process.");
			start
				Zkill(pid, SIGKILL);
			finis

			testing("Child terminated by SIGKILL.");
			start
				SET_ALARM(TIMEOUT);
					Zwaitpid(pid, &stat_val, 0);

					if(WIFSIGNALED(stat_val)) {
						if(WTERMSIG(stat_val) != SIGKILL)
							error("%s\n%s%s",
								"Expected child terminated by SIGKILL.",
								"Actually terminated by signal ",
								sig_lookup(WTERMSIG(stat_val)) );
					}
					else
						error("Child not terminated by SIGKILL signal.");
				CLEAR_ALARM		
			finis
		}
	finis

	done();
}
