#include	<pcts.h>

#include	<Zunistd.h>
#include	<Ztime.h>

#include	<sv_env.h>
#include	<pcts_timer.h>

#define	DELAY_TIME	2


int	main(void)
{
    pid_t	pid;
	int		stat_val;
	time_t	beg_time, end_time;
	unsigned int ret;

    setup(E_SLEEP);
    funct(E_SLEEP);

	assertion(4, BASE);
	start
		testing("Call to sleep() suspends current process from execution");
		testing("until real time seconds have elapsed.");
		start
			Ztime(&beg_time);
			expecting((unsigned)0);
			ret = Zsleep(DELAY_TIME);
			Ztime(&end_time);

			if(end_time -beg_time > DELAY_TIME +1)
				error("%s\n%s%d(seconds.\n%s%d seconds.",
					"Time slept too long.",
					"Expected a maximum sleep time of ",
					DELAY_TIME +1,
					"Actual sleep time was ",
					end_time -beg_time);

			if(end_time -beg_time < DELAY_TIME)
				error("%s\n%s%d seconds.\n%s%d seconds.",
					"Time slept too short.",
					"Expected a minimum sleep time of ",
					DELAY_TIME,
					"Actual sleep time was ",
					end_time -beg_time);
		finis

		testing("Value returned after elapsed time is zero.");
		start
			if(ret != (unsigned)0)
				error("%s\n%s%d.",
					"Expected a return value of 0.",
					"Actual value returned was ",
					ret);
		finis
	finis

	assertion(5, BASE);
	start
		ENABLE_PSYNC
		prep("Fork a child.");
		start
			sv_flush();
			pid = Zfork();
		finis

		if(pid == (pid_t)0) {
			testing("Call sleep() and wait to be interrupted.");
			start
				SIGNAL(SIGINT, sig_int);
				SEND_PSYNC
				ret = sleep(TIMEOUT);
			finis

			testing("Call to sleep() interrupted by a caught signal");
			testing("returns the unslept time in seconds.");
			start
				if(ret > TIMEOUT -DELAY_TIME)
					error("%s\n%s%d seconds.\n%s%d seconds.",
						"Time slept too short.",
						"Expected a maximum unslept time of ",
						TIMEOUT -DELAY_TIME,
						"Actual unslept time was ",
						ret);

				if(ret < TIMEOUT -DELAY_TIME -1)
					error("%s\n%s%d seconds.\n%s%d seconds.",
						"Time slept too long.",
						"Expected a minimum unslept time of ",
						TIMEOUT -DELAY_TIME -1,
						"Actual unslept time was ",
						ret);
			finis

			done();
		}

		prep("Delay, then send a signal to child.");
		start
			SET_TIMEOUT
				WAIT_PSYNC
			CLEAR_ALARM

			del_secs(DELAY_TIME);		/* Delay in seconds. */
			Zkill(pid, SIGINT);
			sv_flush();
		finis

		WAIT_FOR_PID(pid);
		DISABLE_PSYNC
	finis

	assertion(6, BASE);
	start
	    prep("Fork a child process.");
	    start
			sv_flush();
			pid = Zfork();
		finis

		if(pid == (pid_t)0) {
			testing("Call to sleep() interrupted by a signal and action");
			testing("is to terminate the process does not return.");
			start
				SIGNAL(SIGINT, SIG_DFL);
				sleep(TIMEOUT);

				error("Call to sleep() returned.");
			finis

			done();
		}

		SLEEP(WAIT_FOR_TIME);
		Zkill(pid, SIGINT);

		SET_TIMEOUT
			waitpid(pid, &stat_val, 0);

			if(WIFSIGNALED(stat_val)) {
				if(WTERMSIG(stat_val) != SIGINT)
					error("%s\n%s%s",
							"Expected child process terminated by SIGINT.",
							"Actually child terminated by ",
							sig_lookup(WTERMSIG(stat_val)) );
			}
			else
				error("WIFSIGNALED reports no signal terminated child.");
		CLEAR_ALARM
	finis

    done();
}
