#include	<pcts.h>

#include	<Zunistd.h>
#include	<Zpwd.h>

#include	<sv_env.h>


int	main(void)
{
	struct	passwd *pw_ptr;
	char	String[1000];
	char	*tok_ptr, *pwd_nam;
	uid_t	uid_ent;

	setup(E_GETPWNAM);
	funct(E_GETPWNAM);

	assertion(4, BASE);
	start
		testing("Extraction of password database entry for known login name.");
		start
			strcpy(String, PDB_ENTRY);
			pwd_nam = Zstrtok(String, ",");
			if((pw_ptr = getpwnam(pwd_nam)) == (struct passwd *)0)
				error("The getpwnam(%s) call failed {%s}",
						pwd_nam,
						err_lookup(errno));
			if(strcmp(pw_ptr->pw_name, pwd_nam))
				error("%s\n%s%s\n%s%s\n",
						"Login name is not the same.",
						"Expected:	",
						pwd_nam,
						"Actual:	",
						pw_ptr->pw_name);

			tok_ptr = Zstrtok(NULL, ",");
			uid_ent = (uid_t)atol(tok_ptr);
			if(pw_ptr->pw_uid != uid_ent)
				error("%s\n%s%s\n%s%s\n",
						"User ID is not the same.",
						"Expected:	",
						uid_ent,
						"Actual:	",
				   		pw_ptr->pw_uid);

			tok_ptr = Zstrtok(NULL, ",");
			if(pw_ptr->pw_gid != (gid_t) atol(tok_ptr))
				error("%s\n%s%s\n%s%lu\n",
						"Group ID is not the same.",
						"Expected:	",
						tok_ptr,
						"Actual:	",
						(unsigned long) pw_ptr->pw_gid);

			tok_ptr = Zstrtok(NULL, ",");
			if(strcmp(pw_ptr->pw_dir, tok_ptr))
				error("%s\n%s%s\n%s%s\n",
						"Home directory is not the same.",
						"Expected:	",
						tok_ptr,
						"Actual:	",
						pw_ptr->pw_dir);

			tok_ptr = Zstrtok(NULL, ",");
			if(strcmp(pw_ptr->pw_shell, tok_ptr))
				error("%s\n%s%s\n%s%s\n",
						"Default shell is not the same.",
						"Expected:	",
						tok_ptr,
						"Actual:	",
						pw_ptr->pw_shell);
		 finis
	finis

	assertion(5, BASE);
	start
		testing("Call to getpwnam(name) when \"name\" is not in the password");
		testing("database.");
		start
			expecting(FAILURE);
			Zgetpwnam(UNUSED_LOGNAME);
		finis
	finis

	assertion(6, EXTENDED);

	done();
}
