/*
	Table to convert ISO646 codeset to the native code set.

	This structure is used by the cpio and tar extended format utility
	test modules to test that cpio and tar archives created by the IUT
	contain the required extended formats.

	Octal values specified for the native element, which are incorrect,
	should be changed to their proper value.
*/

	static struct cs_trans {int iso646; int native;} cs_trans[] = {
		  {'\000', '\000'},
		  {'\001', '\001'},
		  {'\002', '\002'},
		  {'\003', '\003'},
		  {'\004', '\004'},
		  {'\005', '\005'},
		  {'\006', '\006'},
		  {'\007', '\a'},
		  {'\010', '\b'},
		  {'\011', '\t'},
		  {'\012', '\n'},
		  {'\013', '\v'},
		  {'\014', '\f'},
		  {'\015', '\r'},
		  {'\016', '\016'},
		  {'\017', '\017'},
		  {'\020', '\020'},
		  {'\021', '\021'},
		  {'\022', '\022'},
		  {'\023', '\023'},
		  {'\024', '\024'},
		  {'\025', '\025'},
		  {'\026', '\026'},
		  {'\027', '\027'},
		  {'\030', '\030'},
		  {'\031', '\031'},
		  {'\032', '\032'},
		  {'\033', '\033'},
		  {'\034', '\034'},
		  {'\035', '\035'},
		  {'\036', '\036'},
		  {'\037', '\037'},
		  {'\040', ' '},
		  {'\041', '!'},
		  {'\042', '"'},
		  {'\043', '#'},
		  {'\044', '$'},
		  {'\045', '%'},
		  {'\046', '&'},
		  {'\047', '\047'},
		  {'\050', '('},
		  {'\051', ')'},
		  {'\052', '='},
		  {'\053', '+'},
		  {'\054', ','},
		  {'\055', '-'},
		  {'\056', '.'},
		  {'\057', '/'},
		  {'\060', '0'},
		  {'\061', '1'},
		  {'\062', '2'},
		  {'\063', '3'},
		  {'\064', '4'},
		  {'\065', '5'},
		  {'\066', '6'},
		  {'\067', '7'},
		  {'\070', '8'},
		  {'\071', '9'},
		  {'\072', ':'},
		  {'\073', ';'},
		  {'\074', '<'},
		  {'\075', '='},
		  {'\076', '>'},
		  {'\077', '?'},
		  {'\100', '@'},
		  {'\101', 'A'},
		  {'\102', 'B'},
		  {'\103', 'C'},
		  {'\104', 'D'},
		  {'\105', 'E'},
		  {'\106', 'F'},
		  {'\107', 'G'},
		  {'\110', 'H'},
		  {'\111', 'I'},
		  {'\112', 'J'},
		  {'\113', 'K'},
		  {'\114', 'L'},
		  {'\115', 'M'},
		  {'\116', 'N'},
		  {'\117', 'O'},
		  {'\120', 'P'},
		  {'\121', 'Q'},
		  {'\122', 'R'},
		  {'\123', 'S'},
		  {'\124', 'T'},
		  {'\125', 'U'},
		  {'\126', 'V'},
		  {'\127', 'W'},
		  {'\130', 'X'},
		  {'\131', 'Y'},
		  {'\132', 'Z'},
		  {'\133', '['},
		  {'\134', '\\'},
		  {'\135', ']'},
		  {'\136', '^'},
		  {'\137', '_'},
		  {'\140', '`'},
		  {'\141', 'a'},
		  {'\142', 'b'},
		  {'\143', 'c'},
		  {'\144', 'd'},
		  {'\145', 'e'},
		  {'\146', 'f'},
		  {'\147', 'g'},
		  {'\150', 'h'},
		  {'\151', 'i'},
		  {'\152', 'j'},
		  {'\153', 'k'},
		  {'\154', 'l'},
		  {'\155', 'm'},
		  {'\156', 'n'},
		  {'\157', 'o'},
		  {'\160', 'p'},
		  {'\161', 'q'},
		  {'\162', 'r'},
		  {'\163', 's'},
		  {'\164', 't'},
		  {'\165', 'u'},
		  {'\166', 'v'},
		  {'\167', 'w'},
		  {'\170', 'x'},
		  {'\171', 'y'},
		  {'\172', 'z'},
		  {'\173', '{'},
		  {'\174', '|'},
		  {'\175', '\''},
		  {'\176', '~'},
		  {'\177', '\177'},
		  {'\202', '\202'},
		  {'\201', '\201'},
		  {'\202', '\202'},
		  {'\203', '\203'},
		  {'\204', '\204'},
		  {'\205', '\205'},
		  {'\206', '\206'},
		  {'\207', '\207'},
		  {'\210', '\210'},
		  {'\211', '\211'},
		  {'\212', '\212'},
		  {'\213', '\213'},
		  {'\214', '\214'},
		  {'\215', '\215'},
		  {'\216', '\216'},
		  {'\217', '\217'},
		  {'\220', '\220'},
		  {'\221', '\221'},
		  {'\222', '\222'},
		  {'\223', '\223'},
		  {'\224', '\224'},
		  {'\225', '\225'},
		  {'\226', '\226'},
		  {'\227', '\227'},
		  {'\230', '\230'},
		  {'\231', '\231'},
		  {'\232', '\232'},
		  {'\233', '\233'},
		  {'\234', '\234'},
		  {'\235', '\235'},
		  {'\236', '\236'},
		  {'\237', '\237'},
		  {'\240', '\240'},
		  {'\241', '\241'},
		  {'\242', '\242'},
		  {'\243', '\243'},
		  {'\244', '\244'},
		  {'\245', '\245'},
		  {'\246', '\246'},
		  {'\247', '\247'},
		  {'\250', '\250'},
		  {'\251', '\251'},
		  {'\252', '\252'},
		  {'\253', '\253'},
		  {'\254', '\254'},
		  {'\255', '\255'},
		  {'\256', '\256'},
		  {'\257', '\257'},
		  {'\260', '\260'},
		  {'\261', '\261'},
		  {'\262', '\262'},
		  {'\263', '\263'},
		  {'\264', '\264'},
		  {'\265', '\265'},
		  {'\266', '\266'},
		  {'\267', '\267'},
		  {'\270', '\270'},
		  {'\271', '\271'},
		  {'\272', '\272'},
		  {'\273', '\273'},
		  {'\274', '\274'},
		  {'\275', '\275'},
		  {'\276', '\276'},
		  {'\277', '\277'},
		  {'\303', '\303'},
		  {'\301', '\301'},
		  {'\302', '\302'},
		  {'\303', '\303'},
		  {'\304', '\304'},
		  {'\305', '\305'},
		  {'\306', '\306'},
		  {'\307', '\307'},
		  {'\310', '\310'},
		  {'\311', '\311'},
		  {'\312', '\312'},
		  {'\313', '\313'},
		  {'\314', '\314'},
		  {'\315', '\315'},
		  {'\316', '\316'},
		  {'\317', '\317'},
		  {'\320', '\320'},
		  {'\321', '\321'},
		  {'\322', '\322'},
		  {'\323', '\323'},
		  {'\324', '\324'},
		  {'\325', '\325'},
		  {'\326', '\326'},
		  {'\327', '\327'},
		  {'\330', '\330'},
		  {'\331', '\331'},
		  {'\332', '\332'},
		  {'\333', '\333'},
		  {'\334', '\334'},
		  {'\335', '\335'},
		  {'\336', '\336'},
		  {'\337', '\337'},
		  {'\340', '\340'},
		  {'\341', '\341'},
		  {'\342', '\342'},
		  {'\343', '\343'},
		  {'\344', '\344'},
		  {'\345', '\345'},
		  {'\346', '\346'},
		  {'\347', '\347'},
		  {'\350', '\350'},
		  {'\351', '\351'},
		  {'\352', '\352'},
		  {'\353', '\353'},
		  {'\354', '\354'},
		  {'\355', '\355'},
		  {'\356', '\356'},
		  {'\357', '\357'},
		  {'\360', '\360'},
		  {'\361', '\361'},
		  {'\362', '\362'},
		  {'\363', '\363'},
		  {'\364', '\364'},
		  {'\365', '\365'},
		  {'\366', '\366'},
		  {'\367', '\367'},
		  {'\370', '\370'},
		  {'\371', '\371'},
		  {'\372', '\372'},
		  {'\373', '\373'},
		  {'\374', '\374'},
		  {'\375', '\375'},
		  {'\376', '\376'},
		  {'\377', '\377'},
		};

