/*
 *	sv_errno.h
 *
 *	some magic so that errno values can used as arguments to expecting.
 *	the evaluation function needs a flag to tell it that there is an
 *	actual value set against which it must check, and whether the value
 *	is an expected return value, or an expected errno.  Before the errno
 *	value is passed to the expecting() function, sv_expecting is set to
 *	SV_ERRN, to indicate this is an expected errno.
 */

extern	int	sv_sete(int);

#ifdef	E2BIG
#undef	E2BIG
extern	int	ZE2BIG(void);
#define	E2BIG	sv_sete(ZE2BIG())
#endif

#ifdef	EACCES	
#undef	EACCES	
extern	int	ZEACCES(void);
#define	EACCES	sv_sete(ZEACCES())
#endif

#ifdef	EAGAIN	
#undef	EAGAIN	
extern	int	ZEAGAIN(void);
#define	EAGAIN	sv_sete(ZEAGAIN())
#endif

#ifdef	EBADF	
#undef	EBADF	
extern	int	ZEBADF(void);
#define	EBADF	sv_sete(ZEBADF())
#endif

#ifdef	EBUSY	
#undef	EBUSY	
extern	int	ZEBUSY(void);
#define	EBUSY	sv_sete(ZEBUSY())
#endif

#ifdef	ECHILD	
#undef	ECHILD	
extern	int	ZECHILD(void);
#define	ECHILD	sv_sete(ZECHILD())
#endif

#ifdef	EDEADLK	
#undef	EDEADLK	
extern	int	ZEDEADLK(void);
#define	EDEADLK	sv_sete(ZEDEADLK())
#endif

#ifdef	EDOM	
#undef	EDOM	
extern	int	ZEDOM(void);
#define	EDOM	sv_sete(ZEDOM())
#endif

#ifdef	EEXIST	
#undef	EEXIST	
extern	int	ZEEXIST(void);
#define	EEXIST	sv_sete(ZEEXIST())
#endif

#ifdef	EFAULT	
#undef	EFAULT	
extern	int	ZEFAULT(void);
#define	EFAULT	sv_sete(ZEFAULT())
#endif

#ifdef	EFBIG	
#undef	EFBIG	
extern	int	ZEFBIG(void);
#define	EFBIG	sv_sete(ZEFBIG())
#endif

#ifdef	EIDRM
#undef	EIDRM
extern	int	ZEIDRM(void);
#define	EIDRM	sv_sete(ZEIDRM())
#endif

#ifdef	EINTR	
#undef	EINTR	
extern	int	ZEINTR(void);
#define	EINTR	sv_sete(ZEINTR())
#endif

#ifdef	EINVAL	
#undef	EINVAL	
extern	int	ZEINVAL(void);
#define	EINVAL	sv_sete(ZEINVAL())
#endif

#ifdef	EIO	
#undef	EIO	
extern	int	ZEIO(void);
#define	EIO	sv_sete(ZEIO())
#endif

#ifdef	EISDIR	
#undef	EISDIR	
extern	int	ZEISDIR(void);
#define	EISDIR	sv_sete(ZEISDIR())
#endif

#ifdef ELNRNG
#undef ELNRNG
extern	int	ZELNRNG(void);
#define	ELNRNG	sv_sete(ZELNRNG())
#endif

#ifdef	EMFILE	
#undef	EMFILE	
extern	int	ZEMFILE(void);
#define	EMFILE	sv_sete(ZEMFILE())
#endif

#ifdef	EMLINK	
#undef	EMLINK	
extern	int	ZEMLINK(void);
#define	EMLINK	sv_sete(ZEMLINK())
#endif

#ifdef	ENAMETOOLONG
#undef	ENAMETOOLONG
extern	int	ZENAMETOOLONG(void);
#define	ENAMETOOLONG	sv_sete(ZENAMETOOLONG())
#endif

#ifdef	ENFILE	
#undef	ENFILE	
extern	int	ZENFILE(void);
#define	ENFILE	sv_sete(ZENFILE())
#endif

#ifdef	ENODEV	
#undef	ENODEV	
extern	int	ZENODEV(void);
#define	ENODEV	sv_sete(ZENODEV())
#endif

#ifdef	ENOENT	
#undef	ENOENT	
extern	int	ZENOENT(void);
#define	ENOENT	sv_sete(ZENOENT())
#endif

#ifdef	ENOEXEC	
#undef	ENOEXEC	
extern	int	ZENOEXEC(void);
#define	ENOEXEC	sv_sete(ZENOEXEC())
#endif

#ifdef ENOLCK
#undef ENOLCK
extern	int	ZENOLOCK(void);
#define	ENOLCK	sv_sete(ZENOLCK())
#endif

#ifdef	ENOMEM	
#undef	ENOMEM	
extern	int	ZENOMEM(void);
#define	ENOMEM	sv_sete(ZENOMEM())
#endif

#ifdef ENOMSG
#undef ENOMSG
extern	int	ZENOMSG(void);
#define	ENOMSG	sv_sete(ZENOMSG())
#endif

#ifdef	ENOSPC	
#undef	ENOSPC	
extern	int	ZENOSPC(void);
#define	ENOSPC	sv_sete(ZENOSPC())
#endif

#ifdef	ENOSYS
#undef	ENOSYS
extern	int	ZENOSYS(void);
#define	ENOSYS	sv_sete(ZENOSYS())
#endif

#ifdef	ENOTBLK	
#undef	ENOTBLK	
extern	int	ZENOTBLK(void);
#define	ENOTBLK	sv_sete(ZENOTBLK())
#endif

#ifdef	ENOTDIR	
#undef	ENOTDIR	
extern	int	ZENOTDIR(void);
#define	ENOTDIR	sv_sete(ZENOTDIR())
#endif

#ifdef	ENOTEMPTY
#undef	ENOTEMPTY
extern	int	ZENOTEMPTY(void);
#define	ENOTEMPTY	sv_sete(ZENOTEMPTY())
#endif

#ifdef	ENOTTY	
#undef	ENOTTY	
extern	int	ZENOTTY(void);
#define	ENOTTY	sv_sete(ZENOTTY())
#endif

#ifdef	ENXIO	
#undef	ENXIO	
extern	int	ZENXIO(void);
#define	ENXIO	sv_sete(ZENXIO())
#endif

#ifdef	EPERM	
#undef	EPERM	
extern	int	ZEPERM(void);
#define	EPERM	sv_sete(ZEPERM())
#endif

#ifdef	EPIPE	
#undef	EPIPE	
extern	int	ZEPIPE(void);
#define	EPIPE	sv_sete(ZEPIPE())
#endif

#ifdef	ERANGE	
#undef	ERANGE	
extern	int	ZERANGE(void);
#define	ERANGE	sv_sete(ZERANGE())
#endif

#ifdef	EROFS	
#undef	EROFS	
extern	int	ZEROFS(void);
#define	EROFS	sv_sete(ZEROFS())
#endif

#ifdef	ESPIPE	
#undef	ESPIPE	
extern	int	ZESPIPE(void);
#define	ESPIPE	sv_sete(ZESPIPE())
#endif

#ifdef	ESRCH	
#undef	ESRCH	
extern	int	ZESRCH(void);
#define	ESRCH	sv_sete(ZESRCH())
#endif

#ifdef	ETXTBSY	
#undef	ETXTBSY	
extern	int	ZETXTBSY(void);
#define	ETXTBSY	sv_sete(ZETXTBSY())
#endif

#ifdef	EXDEV	
#undef	EXDEV	
extern	int	ZEXDEV(void);
#define	EXDEV	sv_sete(ZEXDEV())
#endif
