#define	_POSIX_SOURCE

#include	<sys/types.h>
#include	<unistd.h>
#include	<stdio.h>
#include	<sys/stat.h>

#include	<sv_conf.h>

extern void    sv_config(void);

#define Root_uid	((uid_t **) (&sv_params[1].value))
#define Root_gid	((gid_t **) (&sv_params[2].value))
#define Bin_uid		((uid_t **) (&sv_params[3].value))
#define Bin_gid		((gid_t **) (&sv_params[4].value))
#define Uid			((uid_t **) (&sv_params[5].value))
#define Gid			((gid_t **) (&sv_params[6].value))


#define	NORM_MODE	S_IRWXU | S_IRGRP | S_IXGRP | S_IROTH | S_IXOTH
#define	S_NULL		0		/* Needs to be defined in POSIX */

struct	perms {
	mode_t	mode;
	uid_t	**owner;
	gid_t	**group;
	char	*file;
} perms[] = {

	/***************************************************************
	**		     Support Tools		              **
	***************************************************************/


	/***************************************************************
	**		    Definitions		                      **
	***************************************************************/



	/***************************************************************
	**		Process Primitives		              **
	***************************************************************/

	/* fork */
	{ S_IRWXU, Uid, Gid, "STD/PP/bin/3.1.1_17" },
	{ S_IRWXU, Uid, Gid, "STD/PP/bin/3.1.1_26" },

	/* exec */
	{ NORM_MODE, Uid, Gid, "STD/PP/bin/3.1.2_acc" },
	{ NORM_MODE, Uid, Gid, "STD/PP/bin/3.1.2_accx" },
	{ NORM_MODE, Uid, Gid, "STD/PP/bin/3.1.2_44x" },
	{ NORM_MODE, Uid, Gid, "STD/PP/bin/3.1.2_45x" },
	{ NORM_MODE, Uid, Gid, "STD/PP/bin/3.1.2_46x" },

	/* execl */
	{ NORM_MODE, Uid, Gid, "STD/PP/data/execl.d/no_srch.d" },

	/* execv */
	{ NORM_MODE, Uid, Gid, "STD/PP/data/execv.d/no_srch.d" },

	/* execve */
	{ NORM_MODE, Uid, Gid, "STD/PP/data/execve.d/no_srch.d" },

	/* execle */
	{ NORM_MODE, Uid, Gid, "STD/PP/data/execle.d/no_srch.d" },

	/* execvp */
	{ NORM_MODE, Uid, Gid, "STD/PP/data/execvp.d/no_srch.d" },

	/* execlp */
	{ NORM_MODE, Uid, Gid, "STD/PP/data/execlp.d/no_srch.d" },

	/* kill */
	{ S_IRWXU, Uid, Gid, "STD/PP/bin/3.3.2_07" },
	{ S_IRWXU, Uid, Gid, "STD/PP/bin/3.3.2_07xr" },
	{ S_IRWXU, Uid, Gid, "STD/PP/bin/3.3.2_07xs" },
	{ S_IRWXU, Uid, Gid, "STD/PP/bin/3.3.2_08xr" },
	{ S_IRWXU, Uid, Gid, "STD/PP/bin/3.3.2_08xs" },
	{ S_IRWXU, Uid, Gid, "STD/PP/bin/3.3.2_09xr" },
	{ S_IRWXU, Uid, Gid, "STD/PP/bin/3.3.2_09xs" },
	{ S_IRWXU, Uid, Gid, "STD/PP/bin/3.3.2_10xr" },
	{ S_IRWXU, Uid, Gid, "STD/PP/bin/3.3.2_10xs" },
	{ S_IRWXU, Uid, Gid, "STD/PP/bin/3.3.2_11" },
	{ S_IRWXU, Uid, Gid, "STD/PP/bin/3.3.2_15" },
	{ S_IRWXU, Uid, Gid, "STD/PP/bin/3.3.2_17" },

	/***************************************************************
	**		Process Environment		              **
	***************************************************************/

	/* getuid */
	{ S_IRWXU, Uid, Gid, "STD/PE/bin/4.2.1a_04" },

	/* geteuid */
	{ S_IRWXU, Uid, Gid, "STD/PE/bin/4.2.1b_04" },

	/* getgid */
	{ S_IRWXU, Uid, Gid, "STD/PE/bin/4.2.1c_04" },

	/* getegid */
	{ S_IRWXU, Uid, Gid, "STD/PE/bin/4.2.1d_04" },

	/* setuid */
	{ S_IRWXU, Uid, Gid, "STD/PE/bin/4.2.2a_04" },
	{ S_IRWXU, Uid, Gid, "STD/PE/bin/4.2.2a_05x" },

	/* setgid */
	{ S_IRWXU, Uid, Gid, "STD/PE/bin/4.2.2b_04" },
	{ S_IRWXU, Uid, Gid, "STD/PE/bin/4.2.2b_05x" },

	/* getlogin */
	{ S_IRWXU, Uid, Gid, "STD/PE/bin/4.2.4_04" },

	/***************************************************************
	**		Files and Directories		              **
	***************************************************************/

	/* opendir */
	{ NORM_MODE, Uid, Gid, "STD/FD/bin/5.1.2a_acc" },
	{ NORM_MODE, Uid, Gid, "STD/FD/data/opendir.d/no_srch.d" },
	{ NORM_MODE, Uid, Gid, "STD/FD/data/opendir.d/no_read.d" },

	/* chdir */
	{ NORM_MODE, Uid, Gid, "STD/FD/bin/5.2.1_acc" },
	{ NORM_MODE, Uid, Gid, "STD/FD/data/chdir.d/no_perm.d" },

	/* open */
	{ NORM_MODE, Uid, Gid, "STD/FD/bin/5.3.1_acc" },
	{ NORM_MODE, Uid, Gid, "STD/FD/bin/5.3.1_32" },
	{ NORM_MODE, Uid, Gid, "STD/FD/bin/5.3.1_65" },
	{ NORM_MODE, Uid, Gid, "STD/FD/data/open.d/no_perm.d" },
	{ NORM_MODE, Uid, Gid, "STD/FD/data/open.d/no_perms.d/no_read" },
	{ NORM_MODE, Uid, Gid, "STD/FD/data/open.d/no_write.d" },
	{ NORM_MODE, Uid, Gid, "STD/FD/data/open.d/no_write" },
	{ NORM_MODE, Uid, Gid, "STD/FD/data/open.d/ownership" },

	/* creat */
	{ NORM_MODE, Uid, Gid, "STD/FD/bin/5.3.2_acc" },
	{ NORM_MODE, Uid, Gid, "STD/FD/bin/5.3.2_29" },
	{ NORM_MODE, Uid, Gid, "STD/FD/bin/5.3.2_52" },
	{ NORM_MODE, Uid, Gid, "STD/FD/data/creat.d/no_perm.d" },
	{ NORM_MODE, Uid, Gid, "STD/FD/data/creat.d/no_write.d" },
	{ NORM_MODE, Uid, Gid, "STD/FD/data/creat.d/ownership" },

	/* link */
	{ NORM_MODE, Uid, Gid, "STD/FD/bin/5.3.4_acc" },
	{ NORM_MODE, Uid, Gid, "STD/FD/bin/5.3.4_09" },
	{ NORM_MODE, Uid, Gid, "STD/FD/bin/5.3.4_23" },
	{ NORM_MODE, Uid, Gid, "STD/FD/bin/5.3.4_37" },
	{ NORM_MODE, Uid, Gid, "STD/FD/bin/5.3.4_61" },
	{ NORM_MODE, Uid, Gid, "STD/FD/data/link.d/no_srch.d" },
	{ NORM_MODE, Uid, Gid, "STD/FD/data/link.d/no_write.d" },

	/* mkdir */
	{ NORM_MODE, Uid, Gid, "STD/FD/bin/5.4.1_acc" },
	{ NORM_MODE, Uid, Gid, "STD/FD/bin/5.4.1_21" },
	{ NORM_MODE, Uid, Gid, "STD/FD/bin/5.4.1_36" },
	{ NORM_MODE, Uid, Gid, "STD/FD/data/mkdir.d/no_srch.d" },
	{ NORM_MODE, Uid, Gid, "STD/FD/data/mkdir.d/no_write.d" },

	/* mkfifo */
	{ NORM_MODE, Uid, Gid, "STD/FD/bin/5.4.2_acc" },
	{ NORM_MODE, Uid, Gid, "STD/FD/bin/5.4.2_21" },
	{ NORM_MODE, Uid, Gid, "STD/FD/bin/5.4.2_33" },
	{ NORM_MODE, Uid, Gid, "STD/FD/data/mkfifo.d/no_srch.d" },
	{ NORM_MODE, Uid, Gid, "STD/FD/data/mkfifo.d/no_write.d" },

	/* unlink */
	{ NORM_MODE, Uid, Gid, "STD/FD/bin/5.5.1_acc" },
	{ NORM_MODE, Uid, Gid, "STD/FD/bin/5.5.1_09" },
	{ NORM_MODE, Uid, Gid, "STD/FD/bin/5.5.1_23" },
	{ NORM_MODE, Uid, Gid, "STD/FD/bin/5.5.1_37" },
	{ NORM_MODE, Uid, Gid, "STD/FD/data/unlink.d/no_srch.d" },
	{ NORM_MODE, Uid, Gid, "STD/FD/data/unlink.d/no_write.d" },

	/* rmdir */
	{ NORM_MODE, Uid, Gid, "STD/FD/bin/5.5.2_acc" },
	{ NORM_MODE, Uid, Gid, "STD/FD/bin/5.5.2_36" },
	{ NORM_MODE, Uid, Gid, "STD/FD/data/rmdir.d/no_srch.d" },
	{ NORM_MODE, Uid, Gid, "STD/FD/data/rmdir.d/no_write.d" },

	/* rename */
	{ NORM_MODE, Uid, Gid, "STD/FD/bin/5.5.3_acc" },
	{ NORM_MODE, Uid, Gid, "STD/FD/bin/5.5.3_42" },
	{ NORM_MODE, Uid, Gid, "STD/FD/bin/5.5.3_67" },
	{ NORM_MODE, Uid, Gid, "STD/FD/data/rename.d/no_srch.d" },
	{ NORM_MODE, Uid, Gid, "STD/FD/data/rename.d/no_write.d"},

	/* stat.h */
	{ NORM_MODE, Uid, Gid, "STD/FD/bin/5.6.1_09" },
	{ NORM_MODE, Uid, Gid, "STD/FD/bin/5.6.1_09y" },

	/* stat */
	{ NORM_MODE, Uid, Gid, "STD/FD/bin/5.6.2a_acc" },
	{ NORM_MODE, Uid, Gid, "STD/FD/data/stat.d/no_srch.d" },

	/* access */
	{ NORM_MODE, Uid, Gid, "STD/FD/bin/5.6.3_23" },
 	{ NORM_MODE, Uid, Gid, "STD/FD/bin/5.6.3_35" },
 	{ NORM_MODE, Uid, Gid, "STD/FD/data/access.d/no_srch.d" },
 	{ NORM_MODE, Uid, Gid, "STD/FD/data/access.d/perms.d/no_perms" },
 	{ NORM_MODE, Uid, Gid, "STD/FD/data/access.d/perms.d/rd_owner" },
 	{ NORM_MODE, Uid, Gid, "STD/FD/data/access.d/perms.d/wr_owner" },
 	{ NORM_MODE, Uid, Gid, "STD/FD/data/access.d/perms.d/ex_owner" },
 	{ NORM_MODE, Uid, Gid, "STD/FD/data/access.d/perms.d/rd_group" },
 	{ NORM_MODE, Uid, Gid, "STD/FD/data/access.d/perms.d/wr_group" },
 	{ NORM_MODE, Uid, Gid, "STD/FD/data/access.d/perms.d/ex_group" },
 	{ NORM_MODE, Uid, Gid, "STD/FD/data/access.d/perms.d/rd_other" },
	{ NORM_MODE, Uid, Gid, "STD/FD/data/access.d/perms.d/wr_other" },
	{ NORM_MODE, Uid, Gid, "STD/FD/data/access.d/perms.d/ex_other" },
	{ NORM_MODE, Uid, Gid, "STD/FD/data/access.d/perms.d/no_perm.d" },

	/* chmod */
	{ NORM_MODE, Uid, Gid, "STD/FD/bin/5.6.4_19" },
	{ NORM_MODE, Uid, Gid, "STD/FD/bin/5.6.4_34" },
	{ NORM_MODE, Uid, Gid, "STD/FD/data/chmod.d/mode_tests_su" },
	{ NORM_MODE, Uid, Gid, "STD/FD/data/chmod.d/chmod_root" },
	{ NORM_MODE, Uid, Gid, "STD/FD/data/chmod.d/chmod_setgid" },
	{ NORM_MODE, Uid, Gid, "STD/FD/data/chmod.d/no_srch.d" },

	/* chown */
	{ NORM_MODE, Uid, Gid, "STD/FD/bin/5.6.5_19" },
	{ NORM_MODE, Uid, Gid, "STD/FD/bin/5.6.5_35" },
	{ NORM_MODE, Uid, Gid, "STD/FD/data/chown.d/no_srch.d" },
	{ NORM_MODE, Uid, Gid, "STD/FD/data/chown.d/mode_test" },
	{ NORM_MODE, Uid, Gid, "STD/FD/data/chown.d/suid_mode_test" },
	{ NORM_MODE, Uid, Gid, "STD/FD/data/chown.d/t_chown" },
	{ NORM_MODE, Uid, Gid, "STD/FD/data/chown.d/t_chown_bin" },
	{ NORM_MODE, Uid, Gid, "STD/FD/data/chown.d/t_chown_res" },
	{ NORM_MODE, Uid, Gid, "STD/FD/data/chown.d/uid_bin" },
	{ NORM_MODE, Uid, Gid, "STD/FD/data/chown.d/gid_bin" },

	/* utime */
	{ NORM_MODE, Uid, Gid, "STD/FD/bin/5.6.6_22" },
	{ NORM_MODE, Uid, Gid, "STD/FD/bin/5.6.6_36" },
	{ NORM_MODE, Uid, Gid, "STD/FD/data/utime.d/utime_write" },
	{ NORM_MODE, Uid, Gid, "STD/FD/data/utime.d/utime_owner" },
	{ NORM_MODE, Uid, Gid, "STD/FD/data/utime.d/no_srch.d" },

	/* pathconf */
	{ NORM_MODE, Uid, Gid, "STD/FD/bin/5.7.1a_acc" },
	{ NORM_MODE, Uid, Gid, "STD/FD/data/pathconf.d/no_srch.d" },

	/* fpathconf */

	/***************************************************************
	**		     Input and Output		              **
	***************************************************************/

	/* write */
	{ NORM_MODE, Uid, Gid, "STD/IO/bin/6.4.2_11" },
	{ NORM_MODE, Uid, Gid, "STD/IO/bin/6.4.2_41" },


	/***************************************************************
	**		 Device and Class Specific	              **
	***************************************************************/

	/* termios */

	/***************************************************************
	**		     C Language Library		              **
	***************************************************************/

	/* fopen */
	{ S_IRWXU, Uid, Gid, "STD/LS/bin/8.1.14_34" },
	{ NORM_MODE, Uid, Gid, "STD/LS/data/fopen.d/no_perm.d" },
	{ NORM_MODE, Uid, Gid, "STD/LS/data/fopen.d/no_perms.d/no_read" },
	{ NORM_MODE, Uid, Gid, "STD/LS/data/fopen.d/no_write.d" },

	/* freopen */
	{ S_IRWXU, Uid, Gid, "STD/LS/bin/8.1.18_43" },
	{ NORM_MODE, Uid, Gid, "STD/LS/data/freopen.d/no_perm.d" },
	{ NORM_MODE, Uid, Gid, "STD/LS/data/freopen.d/no_write.d" },
	{ NORM_MODE, Uid, Gid, "STD/LS/data/freopen.d/no_perms.d/no_read" },
	{ NORM_MODE, Uid, Gid, "STD/LS/data/freopen.d/no_perms.d/no_write" },

	/***************************************************************
	**		      Passwords		                     **
	***************************************************************/



	/***************************************************************
	**		Data Interchange Format		              **
	***************************************************************/

};


#define	NPERMS	(sizeof(perms)/sizeof(struct perms))

int	main(int argc, char *argv[])
{
	int	i;
	void 	exit();

	sv_config();

	if(geteuid() != ROOT_UID) {
		fprintf(stderr, "%s: must be executed as ROOT.\n", argv[0]);
		exit(1);
	}
	if(chdir(PCTS_PATH)) {
		fprintf(stderr, "%s: can not chdir to %s\n", argv[0], PCTS_PATH);
		exit(1);
	}
	printf("%s: clearing special access modes for '%s'\n", argv[0], PCTS_PATH);
	umask(0);
	for(i=0; i<NPERMS; i++) {
		if(!access(perms[i].file, F_OK)) {
			if(chown(perms[i].file, **perms[i].owner, **perms[i].group)) {
				fprintf(stderr,"%s: Can't chown %s\n", argv[0], perms[i].file);
				exit(1);
			}
			if(chmod(perms[i].file, perms[i].mode)) {
				fprintf(stderr,"%s: Can't chmod %s\n", argv[0], perms[i].file);
				exit(1);
			}
		}
		else
			fprintf(stderr, "%s: Can't access %s\n", argv[0],perms[i].file);
	}
	
	exit(0);
}
