#ifndef	_POSIX_SOURCE
#define	_POSIX_SOURCE
#endif

#include	<pcts.h>

#include	<unistd.h>
#include	<fcntl.h>
#include	<sys/stat.h>

#include	<install.h>
#ifdef		BETA_PCTS
#include	"validate.h"
#endif

#define	VALIDATION_RUN	"IUT"

	/*	Macro to establish any relationship between user and root
		Lint will complain of pointer problems because ROOT_[UG]ID are
		defined as "&(uid_t *)object", while object is declared
		"pointer object".  ("pointer" is a typdef for "char *")
	*/
#define	ANYROOT ((getuid() == ROOT_UID) || (geteuid() == ROOT_UID) || (getgid() == ROOT_GID) || (getegid() == ROOT_GID))

#define LMAX 510	/*	ANSI C, 2.2.4.1, # of characters in a string literal. */
#define SECTION (-2)
#define	TEST	(-1)

#define	SUBTMP	"subtmp"

#define	DEPFMT	"%s/%s/adm/dependency"

int		extest(char *);
void	rootcheck(void);
int		files(void);
int		begjourn(void);
int		begrun(void);
char	*gttst(char *, char *);
int		cmpt_indx(char *);
int		p_system(char *);
int		dotest(void);
int		findtest(char *, char *);
int		get_pje(int);
int		report(void);
extern	int fgetln(int, char *);
extern	char *nxtok(char *, char *);
extern	void rstsect(void);
extern	int setsect(char *, char *, char *);
extern	void sv_config(void);
extern	char *getcmd(char *);

void	wr_all(char *);
void	breakup(char *, char *, char *);
void	sectest(void);
void	rootcheck(void);
void	stsigs(void);
char	*getword(int, int);
void	i_cmd(char *, char *);
void	proc_jes(int);
int		hexc_int(char);

static	struct		sigaction	act0;

static	time_t	runstart;	/*Run start date*/
static	int	vmode;			/* verify by sect or test */

int	dopt	= 0;			/* don't remove temporary files*/
int	keep	= 0;			/* flag for raw journal retention */

/*	Report Parameters	*/
#define	MAX_NUMB_ASSERTIONS	150

/*	Test Result Codes as integers	*/
#define	PASS			4
#define	UNRESOLVED		5
#define	FAIL			6
#define	FAIL_EXTENDED	7

short	t_ass[2][MAX_NUMB_ASSERTIONS +1];	/* Table for assertion index	*/
extern	int	ass_nu;		/* Assertion number */
int	numb_ass;			/* Assertions per function	*/
int	ass_index;			/* Index to assertions output result */
int	lst_ass;			/* Assertion number last processed   */
char	fct_ass[30];
char	*fmt_ass[] = {
			"NOT_INITIATED",	/* 0 */
			"UNUSED",			/* 1 */
			"UNSUPPORTED",
			"UNTESTED",
			"PASS",
			"UNRESOLVED",
			"FAIL",
			"FAIL_EXTENDED",
			"PASS_EXTENDED",	/* 8 */
			"EXTENDED_TESTED",	/* 9 */
			"TO_BE_WRITTEN",	/* 10	Test has not yet been coded.		*/
			"NOT_TESTABLE",		/* 11	Testing Constraint unsupported.		*/
			"NOT_APPLICABLE",	/* 12	Assertion is not congruent with the
										requirements for FIPS 151-2. 		*/
		      };


static	int	jrndesc = -1;	/*File descriptor of journal file*/
static	int	rawdesc = -1;	/*File descriptor of raw journal file*/
static	int	ctldesc = -1;	/*File descriptor of control file*/
static	int	lstrun = 1;		/*The run number of the most journal run*/

static	char	section[100];	/*Name of the section to be tested*/
static	char	intbuff[LMAX];	/*Buffer for intermediate cmd string*/
static	char	control[LMAX];	/*The path to the control file*/
static	char	tmpjourn[LMAX];	/*The path to the temporary file*/
static	char	journal[LMAX];	/*The path to the journal file*/
static	char	tstnam[30];		/*Name of the current test*/
static	char	tstloc[100];	/*Section where current test resides*/
static	char	temp[512];
static	int		fm_index;		/* Process function/macro index. */
static	int		indx_e;			/* "e_str" index to element being processed. */

static	char	*sec_tests[] =	{
									"STD/DEF",
									"STD/PP",
									"STD/PE",
									"STD/FD",
									"STD/IO",
									"STD/DC",
									"STD/LS",
									"STD/PW",
									"STD/DIF",
								};
#define	NUM_SECTS	(sizeof(sec_tests)/sizeof(char *))


int	main(int argc, char *argv[])
{
	char	test[LMAX];
	short	i = 1;
	int		tested = 0;
	char	*p;

#ifdef		BETA_PCTS
	v_date_of_run();				/* Validate date of run for BETA. */
#endif

	stsigs();
	sv_config();
	for(i = 1; i < argc; i++){		/* get the options*/
		if(*(argv[i]) == '-'){
			p = argv[i];
			while (*++p){
				switch (*p){
				case 'd':
					dopt++;
					break;
				case 'k':
					keep = 1;	/* retain raw journals*/
					break;
				case 'K':
					keep = 2;	/* On error keep journ*/
					break;
				default:
					wr_all("Usage: verify [ -[d][k][K] ] section\n");
					wr_all("\t\tOR: verify [ -[d][k][K] ] testnames\n");
					exit(1);
				}
			}
		}
	}

												/* Check for Validation Run. */
	if( ! strcmp(VALIDATION_RUN, argv[argc -1]) ) {
		keep = 1;								/* Retain raw journals. */
		for(i=0; i<NUM_SECTS; i++) {
			rstsect();
			vmode = setsect(section, sec_tests[i], PCTS_PATH);
			while(*section){
				sectest();
				setsect(section, sec_tests[i], PCTS_PATH);
			}
		}
		return(0);
	}

	for(i = 1; i < argc; ++i) {
		rstsect();			/*Reset the setsect flags*/
		if(*(argv[i]) != '-') {
			vmode = setsect(section, argv[i], PCTS_PATH);
			if(vmode == SECTION){		
				while(*section){
					sectest();
					setsect(section, argv[i], PCTS_PATH);
				}
				tested = 1;
			}
			else if(vmode == TEST){
				while (i < argc){
					breakup(section, test, argv[i++]);
					extest(test);
					wr_all("\n");
					tested = 1;
				}
			}
		}
	}
	if(!tested){
		wr_all("Usage: verify [ -[d][k][K] ] section\n");
		wr_all("\t\tOR: verify [ -[d][k][K] ] testnames\n");
		exit(1);
	}
	return(0);
}

void	breakup (char *path, char *tst, char *str)
{
	char	*p,*q;

	q = p = str;
	while(*p){
		if(*p == '/'){
			q = p;
		}
		p++;
	}
	if(q != str){
		*(q++) = 0;
		strcpy(path,str);	/*Don't change path if none was there*/
		strcat(path,"/");
	}
	strcpy(tst,q);
}

/**
 **
 **	invoke() will execute an POSIX-VS test based on the assumption
 **	that the test executable is in the current bin.
 **
 **/

int	invoke(char *tst)
{
	int		stat_val;
	pid_t	pid;

	if(access(tst, X_OK)){
		return(-1);
	}
	if((pid = fork()) == 0) {
		struct	sigaction act1;

		sigemptyset(&act1.sa_mask);
		act1.sa_handler = SIG_DFL;
		act1.sa_flags = 0;
		sigaction(SIGUSR2, &act1, (struct sigaction *)0);

		if(vmode == SECTION) {		/* redirect output ? */
			close(STDOUT_FILENO);
			close(STDERR_FILENO);
			dup(rawdesc);		/* std out */
			dup(rawdesc);		/* std err */
		}
		execl(tst, tst, (char*) 0);
		kill(getpid(), SIGUSR2);
		while(1);	/*Make sure we don't continue from here*/
	}
	while(wait(&stat_val) != pid)
		;
	if(WIFEXITED(stat_val)){		/* Normal Exit*/
		return(0);
	}
	else{				/*Child received a signal*/
		return( (WTERMSIG(stat_val) == SIGUSR2) ? -1 :(-(WTERMSIG(stat_val))) );
	}
}

void	sectest(void)
{
	rootcheck();
	if(files())
		return;
	if(begjourn()){
		return;
	}
	if(begrun()){
		return;
	}
	while(gttst(tstnam, tstloc)){
		size_t	lngth;

		lngth = strlen(tstnam);
		for(indx_e=0; indx_e<E_CPIO; indx_e++) {
			if( ! strcmp(element[indx_e].e_name, tstnam))
				break;
			if(indx_e == E_CPIO)
				sprintf(temp, "ERROR: Entry for %s not located in pcts_ass.h\n",
												tstnam);
		}
		sprintf(temp, "\n%s %.*s(%3.3d)\n", tstnam, 15 -lngth,
									"              ", element[indx_e].tests);
		wr_all(temp);
		dotest();
	}
	close(jrndesc);
	close(ctldesc);
}

void	rootcheck(void)
{
	if(ANYROOT){
		sprintf(temp, "%s\n",
			"Non-superuser must run to prevent PCTS damage.");
		wr_all(temp);
		exit(-1);
	}
}

int	files(void)
{
	sprintf(control,DEPFMT,PCTS_PATH, section);
	if((ctldesc = open(control,O_RDONLY)) < 0) {
		sprintf(temp, "verify: Failed to open %s\n", control);
		wr_all(temp);
		return(-1);
	}
	sprintf(journal,"%s/%s/adm/journal",PCTS_PATH, section);
	if((jrndesc = open(journal,O_RDWR|O_CREAT|O_TRUNC, PERM_CTTY)) < 0) {
		sprintf(temp, "verify: Failed to open or create %s\n", journal);
		wr_all(temp);
		return(-1);
	}
	return(0);
}

int	begjourn(void)
{
	char	*rundate;
	char	s_hdwy[LMAX], s_sn[LMAX], s_vers[LMAX], s_rls[LMAX];

	time(&runstart);
	rundate = ctime(&runstart);
	*(rundate+24) = 0;
	rundate += 4;
	lstrun = 1;
	strcpy(temp, UNAME_INFO);
	strcpy(s_sn, strtok(temp, ","));
	(void) strtok(NULL, ",");
	strcpy(s_rls, strtok(NULL, ","));
	strcpy(s_vers, strtok(NULL, ","));
	strcpy(s_hdwy, strtok(NULL, ","));
	sprintf(temp,"\n%s%s\n%s%s\n%s\n%s%s\n%s%s%s%s%s%s\n%s%s\n",
			"\t\t", NIST_PCTS_NAME,
			"\t\tRelease: ", NIST_PCTS_VERSION,
			"\t\tBased on: IEEE Std 2003.1-1992",
			"\t\tHardware Type: ",
			s_hdwy,
			"\t\tSysname: ",
			s_sn,
			", Release: ",
			s_rls,
			", Version: ",
			s_vers,
			"\t\tDate: ", rundate);
	wr_all(temp);
	return(0);
}

int	begrun(void)
{
	char	*rundate;

	time(&runstart);
	rundate = ctime(&runstart);
	*(rundate+24) = 0;
	rundate += 3;
	return(0);
}


int	dotest(void)
{
	mode_t	old_umask;
	int		st, rep_rslt;

	sprintf(tmpjourn, "%s/%s/adm/.%.*s", PCTS_PATH, section,
				_POSIX_NAME_MAX -2, tstnam);
	if((rawdesc =
			open(tmpjourn, O_RDWR|O_CREAT|O_TRUNC|O_APPEND,  PERM_CTTY)) < 0){
		sprintf(temp, "verify: Failed to create temporary file.\n");
		wr_all(temp);
		exit(-1);
	}
	sprintf(temp,"%s/%s/tmp",PCTS_PATH, tstloc);
	chdir(temp);
	old_umask = umask(0);
	sprintf(intbuff,"!RMV %.*s.d", _POSIX_NAME_MAX -2, tstnam);
	i_cmd(temp, intbuff);
	p_system(temp);
	sprintf(intbuff,"!MDV %.*s.d", _POSIX_NAME_MAX -2, tstnam);
	i_cmd(temp, intbuff);
	p_system(temp);
	sprintf(intbuff,"!RMV %s/tmp/%s", PCTS_PATH, SUBTMP);
	i_cmd(temp, intbuff);
	p_system(temp);
	sprintf(intbuff, "!MDV %s/tmp/%s", PCTS_PATH, SUBTMP);
	i_cmd(temp, intbuff);
	p_system(temp);
	umask(old_umask);
	sprintf(temp, "%s/%s/bin", PCTS_PATH, tstloc);
	chdir(temp);
	st = invoke(tstnam);
	rep_rslt = report();
						/* keep = 0, remove raw journal
							  1, retain raw journals
							  2, retain on error
						*/
	if( (keep == 0) || ((keep == 2) && (rep_rslt != -1)) )
		if(unlink(tmpjourn) < 0) {
			sprintf(temp, "Can't unlink raw journal file: \"%s\"\n", tmpjourn);
			wr_all(temp);
		}
	close(rawdesc);
	if(!dopt){
		sprintf(temp,"%s/%s/tmp",PCTS_PATH, tstloc);
		chdir(temp);
		old_umask = umask(0);
		sprintf(intbuff,"!RMV %.*s.d", _POSIX_NAME_MAX -2, tstnam);
		i_cmd(temp, intbuff);
		p_system(temp);
		sprintf(intbuff,"!MDV %.*s.d", _POSIX_NAME_MAX -2, tstnam);
		i_cmd(temp, intbuff);
		p_system(temp);
		umask(old_umask);
	}
	sprintf(temp,"%s/bin",PCTS_PATH);
	chdir(temp);
	return(st);
}

int	report(void)
{
	int		i;

	lseek(rawdesc, (off_t)0, 0);
	proc_jes(rawdesc);

	if(numb_ass != element[indx_e].tests) {
		sprintf(temp,
				"ERROR_N: Expected %3.3d entries,  Actual %3.3d entries.\n",
									element[indx_e].tests, numb_ass);
		wr_all(temp);

		if( ! numb_ass)		/* No Tests Processed */
			return(0);
	}
		
	if( numb_ass > MAX_NUMB_ASSERTIONS )
		numb_ass = MAX_NUMB_ASSERTIONS;
	for(i=1; i<=numb_ass; i++)  {
		sprintf(temp, "   %3.3d\t%-20.20s",
					i,
					(t_ass[0][i] >= 0) ? fmt_ass[t_ass[0][i]] :
					"UNRESOLVED (PLD)");
									/* PLD -> PREP was last directive */
		wr_all(temp);
		if(fm_index == 1)
			if(t_ass[1][i])
				wr_all(fmt_ass[t_ass[1][i]]);
		wr_all("\n");
	}
	return(0);
}

int	extest(char *tst)
{
	int		i;
	mode_t	old_umask;
	char	sct[100];

	i = 4;
	sprintf(temp, "%s%s\n", section, tst);
	wr_all(temp);
	if(!findtest(tst, sct)){
		sprintf(temp, "verify: %s not tested in section %s.\n", tst, section);
		wr_all(temp);
		sprintf(temp, "%s/bin", PCTS_PATH);
		chdir(temp);
		return(4);
	}
	sprintf(temp, "%s/%s/bin/%s", PCTS_PATH, sct, tst);
	if(!access(temp, 1)){
		sprintf(temp, "%s/%s/tmp", PCTS_PATH, sct);
		chdir(temp);
		sprintf(temp, "rm -rf %.*s.d ; mkdir %.*s.d",
						_POSIX_NAME_MAX -2, tst, _POSIX_NAME_MAX -2, tst);
		old_umask = umask(0);
		sprintf(intbuff, "!RMV %.*s.d", _POSIX_NAME_MAX -2, tst);
		i_cmd(temp, intbuff);
		p_system(temp);
		sprintf(intbuff,"!MDV %.*s.d", _POSIX_NAME_MAX -2, tst);
		i_cmd(temp, intbuff);
		p_system(temp);
		umask(old_umask);
		sprintf(temp,"%s/%s/bin",PCTS_PATH, sct);
		chdir(temp);
		i = invoke(tst);
		if(!dopt){
			sprintf(temp,"%s/%s/tmp",PCTS_PATH, sct);
			chdir(temp);
			old_umask = umask(0);
			sprintf(intbuff,"!RMV %.*s.d", _POSIX_NAME_MAX -2, tst);
			i_cmd(temp, intbuff);
			p_system(temp);
			sprintf(intbuff,"!MDV %.*s.d", _POSIX_NAME_MAX -2, tst);
			i_cmd(temp, intbuff);
			p_system(temp);
			umask(old_umask);
		}
	}
	if(i == 4){
		sprintf(temp, "Verify: %s/%s failed to execute.\n", sct, tst);
		wr_all(temp);
	}
	if(i < 0) {
		sprintf(temp, "%s terminated abnormally due to sig %d\n", tst, -i);
		wr_all(temp);
	}
	sprintf(temp,"%s/bin",PCTS_PATH);
	chdir(temp);
	return(i);
}

/*
** findtest(tst,section)
** char	*tst,*section;
**
** Find a test in the dependency file and set section to the section
** where it is really found.  Return 0 if you don't find it.
**
*/
int	findtest(char *tst, char *sect)
{
	char	*p, token[64];
	int		fd;

	sprintf(temp, "%s/%sadm/dependency", PCTS_PATH, section);
	fd = open(temp, O_RDONLY);
	if(fd < 0){
		return(0);
	}
	while(fgetln(fd, temp)){
		p = nxtok(sect, temp);
		p = nxtok(token, p);
		if(!strcmp(token, tst)){
			return(1);
		}
	}
	return(0);
}



/**
 **	gttst:
 **	Returns the next test name in the control file.
 **/
char	*gttst(char *name, char *location)
{
	char	*fp;

	fp = getword(ctldesc, 1);
	if(fp != NULL){
		strcpy(location, fp);
		fp = getword(ctldesc, 0);
		if(fp != NULL){
			strcpy(name, fp);
		}
		return(fp);
	}
	return(NULL);
}

void	catch(int signo)
{
	sprintf(temp, "\nSignal #%d received.\n", signo);
	wr_all(temp);
	sprintf(temp, "\tSee <signal.h> to obtain symbolic name of signal.\n");
	wr_all(temp);
	wr_all("\tVerify aborted.\n");
	exit(1);
}

int	sigs[] =	{
			/* POSIX Required Signals */
#ifdef	SIGABRT
		SIGABRT,
#endif
#ifdef	SIGALRM
		SIGALRM,
#endif
#ifdef	SIGFPE
		SIGFPE,
#endif
#ifdef	SIGHUP
		SIGHUP,
#endif
#ifdef	SIGILL
		SIGILL,
#endif
#ifdef	SIGINT
		SIGINT,
#endif
#ifdef	SIGPIPE
		SIGPIPE,
#endif
#ifdef	SIGQUIT
		SIGQUIT,
#endif
#ifdef	SIGSEGV
		SIGSEGV,
#endif
#ifdef	SIGTERM
		SIGTERM,
#endif
#ifdef	SIGUSR1
		SIGUSR1,
#endif
#ifdef	SIGUSR2
		SIGUSR2,
#endif

	/* POSIX Required Signals when the IEEE1003job Option is provided */
	/* JOB Control signals bracketed with _POSIX_JOB_CONTROL in case the
	   signal is defined but the functionality has not yet been implemented.
	*/
#ifdef	_POSIX_JOB_CONTROL
#ifdef	SIGCONT
		SIGCONT,
#endif
#ifdef	SIGTSTP
		SIGTSTP,
#endif
#ifdef	SIGTTIN
		SIGTTIN,
#endif
#ifdef	SIGTTOU
		SIGTTOU,
#endif
#endif

	/* Attempt to catch all signals which can occur on a POSIX
	   implementation which may provide additional signals.
	*/
#ifdef	SIGTRAP
		SIGTRAP,
#endif
#ifdef	SIGSYS
		SIGSYS,
#endif
#ifdef	SIGIOT
		SIGIOT,
#endif
#ifdef	SIGEMT
		SIGEMT,
#endif
#ifdef	SIGBUS
		SIGBUS,
#endif
#ifdef	SIGPWR
		SIGPWR,
#endif
		0,			/* Terminate the list */
		};

void	stsigs(void)
{
	int	i;

	sigemptyset(&act0.sa_mask);
	act0.sa_handler = catch;
	act0.sa_flags = 0;
	for(i = 0; sigs[i]; ++i){
		sigaction(sigs[i], &act0, (struct sigaction *)0);
	}
}


/**
 **	getword: returns a string containing
 **	the next word in a given file.
 **	if "whence" is 1, start at a new line,
 **	otherwise, find the next word in the present line.
 **	a NULL string means end of file.
 **/
static	char	linwrd[20];
static	char	linbuf[LMAX];
static	char	*linptr;
static	char	*linmark;

char	*getword(int fd, int whence)
{
	char	*lp;

	if(whence == 1){
		if(!fgetln(fd, linbuf))
			return(NULL);
		linmark = linbuf;
	}
	for(lp=linwrd, linptr=linmark; 1; linmark++){
		switch(*linmark){
		case '\0' :
		case '\n' :
			if((linmark -linptr) <= 1)
				return(NULL);

		case ' ' :
			*lp = '\0';
			linmark++;
			return(&linwrd[0]);

		default :
			*lp++ = *linmark;
		}
	}
}



/*
** i_cmd(out,in)
** This function takes the input string specified in "in" and
** if the first character is a "!", converts the string to a
** syntax consistent with that specified by the corresponding syntax
** in <install/install.h>.
** Rules for conversion are:
**	Copy the corresonding string entry in "struct impcmd" into "out".
**
**	If the string %@% is found copy the remaining arguments in "in"
**	to "out".
**
**	If the string %...% is found, copy the next argument in "in" to
**	"out".
*/

void	i_cmd(char *out, char *in)
{
	char	*h_ptr;			/* Command syntax from header file */
	char	*i_ptr;			/* Svcomp entry			   */
	char	*o_ptr;			/* Revised command syntax	   */

	if(*in != '!') {		/* Command is not to be mapped */
		sprintf(temp,
				"Improper syntax, \"%s\" does not begin with \"!\'\n", in);
		wr_all(temp);
		exit(1);
	}

	o_ptr = out;
	i_ptr = in;
	h_ptr = getcmd(in +1);
	while(*i_ptr++ != ' ')		/*Skip cmd symbol and subsequent space*/
		;
	while(*h_ptr){
		while(*h_ptr && (*h_ptr != '%'))
			*o_ptr++ = *h_ptr++;
		if(*h_ptr){
			++h_ptr;		/* Bump past '%' */

			/* Special case '@', picks up all remaining arguments */
			if(*h_ptr == '@') {
				while(*i_ptr)
					*o_ptr++ = *i_ptr++;
				while(*h_ptr && (*h_ptr != '%'))
					h_ptr++;
				++h_ptr;	/* Bump past '%' */
			}

			else {
				/* Skip name of argument substituted for */
				while(*h_ptr && (*h_ptr != '%')) 
					h_ptr++;
				h_ptr++;	/* Bump past '%' */
						/* Skip space characters */
				while(*i_ptr && (*i_ptr == ' '))
					i_ptr++;
				while(*i_ptr && (*i_ptr != ' ')) 
					/* Get next argument form svcomp entry*/
					*o_ptr++ = *i_ptr++;
			}
		}
	}
	*o_ptr = '\000';
}


/*
** getcmd(in)
** This function determines the command to use for the
** command asymbol given in the input string.  It returns a pointer
** to the command syntax to be used.
*/

char	*getcmd(char *in)
{
	struct	cmd_imp	*ptr;
	char	*in_ptr;
	char	cmd[10], *c_ptr;

	for(in_ptr = in, c_ptr = cmd; *in_ptr != ' ';)
		*c_ptr++ = *in_ptr++;
	*c_ptr = '\000';
	for(ptr = impcmd; *(ptr->symbol); ptr++) {
		if( ! strcmp(cmd, ptr->symbol))
			break;
	}
	if( ! *(ptr->symbol)) {
		sprintf(temp, "%s\n\t%s\"%s\".\n",
			"INSTALLATION CONFIGURATION ERROR:",
			"Cannot find mapping command ",
			cmd);
		wr_all(temp);
		exit(-1);
	}
	return(ptr->cmd);
}

int	p_system(char *cmd)
{
	pid_t	pid, r;
	int		status;

	if ((pid = fork()) == 0) {
		char	*args[32], a_cmd[_POSIX_PATH_MAX +1];
		char	*p_mem, *p_cmd;
		int	i;

		/* Convert command string to format suitable for execvp() */
		p_mem = (char *) malloc(strlen(cmd) +1);
		p_cmd = cmd;
		for(i = 0; *p_cmd; i++) {
			for(args[i] = p_mem; *p_cmd && (*p_cmd != ' '); )
				*p_mem++ = *p_cmd++;

			*p_mem++ = '\000';
			while( *p_cmd == ' ' )	/*Skip multiple spaces*/
				p_cmd++;
		}
		args[i] = NULL;		/* Signify end-of-arguments */

		/* Check if command has been negated */
		if(args[0] == NULL) {
			free(p_mem);
			exit(0);		/* Exit child gracefully */
		}

		/* Setup absolute path name */
		strcpy(a_cmd, PATH_CMD);
		if(a_cmd[0] != '\0') {
			strcat(a_cmd, "/");
			strcat(a_cmd, args[0]);
		}
		else
			strcpy(a_cmd, args[0]);

		execvp(a_cmd, &args[0]);
		wr_all("\tMESSAGE\n");
		sprintf(temp,"\tExecvp() failed on \"%s\"\n", args[0]);
		wr_all(temp);
		free(p_mem);
		exit(1);
	}

	while((r = wait(&status)) != pid && r != (pid_t)-1)
		;
	if(r == (pid_t)-1)
		status = -1;
	return(status);
}

	

/*	Process raw journal entries to determine Test Result Code
	(Use table "fmt_ass" as index to the output report status)
	for each numbered assertion.

	Test Result Codes:

	NOT_INITIATED		0
 	UNUSED				1
 	UNSUPPORTED			2
 	UNTESTED			3
 	BASE				4
						4	PASS
						5	UNRESOLVED
						6	FAIL
 	EXTENDED			8
						4 	PASS
						5 	UNRESOLVED
						7 	FAIL_EXTENDED
	NOT_TESTABLE		9
*/

void	proc_jes(int fd)
{
    int	i, j;

    for(i=0; i<MAX_NUMB_ASSERTIONS; i++)
		for(j=0; j<2; j++)
			t_ass[j][i] = 0;
    lst_ass = 1;
    numb_ass = 0;
	fm_index = 0;						/* Start processing functions. */

    while( get_pje(fd) ) {
		if( ass_nu == 0 )
			continue;
		if( ass_nu > MAX_NUMB_ASSERTIONS ) {
			sprintf(temp,
				"ERROR: Current assertion %d > max, prior assertion was %d.\n",
									ass_nu, lst_ass);
			wr_all(temp);
			continue;
		}

/*
sprintf(temp, "CCC ass_nu %d   lst_ass %d  indx %d   %d\n", ass_nu, lst_ass,
						t_ass[fm_index][ass_nu],  fm_index);
wr_all(temp);
*/
		if(ass_nu != lst_ass) {
			if(t_ass[fm_index][ass_nu]) {
				sprintf(temp,
	"ERROR: Assertion %d processed again, prior assertion was %d.\n",
												ass_nu, lst_ass);
				wr_all(temp);
			}
			t_ass[fm_index][ass_nu] = ass_index;
			lst_ass = ass_nu;
		}
		else {
			if(t_ass[fm_index][ass_nu] == hexc_int(EXTENDED)) {
												/* Save index of last entry */
				t_ass[fm_index][ass_nu] = ass_index;
				continue;
			}
			if( t_ass[fm_index][ass_nu] >= UNRESOLVED )
				continue;		/* Assertion had a failure */
			t_ass[fm_index][ass_nu] = ass_index;  /* Save index of last entry */
		}
    }
}
				
		
/*	Process a single possible journal entry by returning
 *	the assertion number and the index value in 'index';
*/

int	get_pje(int fd)
{
	char	line[LMAX], *l_ptr = line;
	char	*p_entry;
	int	num;

	while( fgetln( fd, line )) {
		switch( *l_ptr ) {
		    case '1':
		    case '2':
		    case '3':
		    case '4':
		    case '5':
		    case '6':
		    case '7':
		    case '8':
		    case '9':
			if((p_entry = strchr(l_ptr, '\t')) == NULL)
				p_entry = strchr(l_ptr, ' ');
			if(p_entry != NULL) {
				p_entry++;
				switch(*p_entry) {
			    	case 'P':
					if( ! (cmpt_indx(p_entry)) )	/* Bad entry */
						continue;
					if(ass_nu)
						ass_index = -ass_index;
					return(TRUE);
			    	case 'T':
					if( ! (cmpt_indx(p_entry)) )	/* Bad entry */
						continue;
					if(ass_nu == 0) {
						sprintf(temp, "ERROR: %s%s%3.3d.\n",
								"\tTesting assertion number is 0 ,",
								"\tprior assertion was ",
								lst_ass);
						wr_all(temp);
						/* An ass_nu = 0 occurs when a process
					   		spawns another process and the
					   		assertion number has not been defined
					   		prior to a "prep" call.  By useing
					   		"lst_ass" for the assertion number
					   		in these instances should resolve
					   		the problem.
						*/
						ass_nu = lst_ass;
					}
					return(TRUE);
			    	case 'F':
					fgetln(fd, line);
					p_entry = strchr(l_ptr, '[');
					*(p_entry -2) = '\000';
					*(p_entry +4) = '\000';
					strcpy(fct_ass, line);
					if((num = atoi(p_entry +1)) != 0)
						numb_ass = num;
					break;
		    	    	default:
					break;
				}
			}
			break;
		    
			case 'S':
		    case 'E':
				if( ass_index < 0 )
					ass_index = UNRESOLVED;
				else
					if( ass_index != hexc_int(TO_BE_WRITTEN) ) {
						if( ass_index == hexc_int(EXTENDED) )
							ass_index = FAIL_EXTENDED;
						else
							ass_index = FAIL;
					}
				return(TRUE);

		    case 'M':
				if( ! strncmp(l_ptr, "MACRO ", 6) )
					fm_index = 1;			/* Process macro test results. */
				break;

		    default:
				break;
		}
	}

	return(0);			/* End-of-File */
}


int	cmpt_indx(char *ptr)
{
	char	*p_ptr;
	char	s_array[4];

	p_ptr = strchr(ptr, '\t');			/* [Ixxx] */
	p_ptr += 3;					/* Ixxx] */
	switch(*(p_ptr)) {
	    case '1':
	    case '2':
	    case '3':
	    case '4':
	    case '8':
	    case '9':
	    case 'a':
	    case 'b':
	    case 'c':
		if((*p_ptr > '9') || (*p_ptr < '0'))
			ass_index = (int)(*p_ptr -'a') +10;
		else
			ass_index = (int)(*p_ptr -'0');
		strncpy(s_array, ++p_ptr, 3);
		s_array[3] = '\000';
		ass_nu = atoi(s_array);
		return(TRUE);
	    default:
		sprintf(temp, "ERROR: %s\"%s\".\n%s%3.3d.\n",
				"\tBad entry - ",
				ptr,
				"Previous assertion was ",
				lst_ass);
		wr_all(temp);
		return(FALSE);
	}
}


void	wr_all(char *data)
{
	if(jrndesc > -1) {
		if(write(jrndesc, data, strlen(data)) != (ssize_t) strlen(data)) {
			sprintf(temp, "ERROR: writing to journal.\n");
			write(STDERR_FILENO, temp, strlen(temp));
			exit(-1);
		}
	}
	if(write(STDERR_FILENO, data, strlen(data)) != (ssize_t) strlen(data)) {
		exit(-1);
	}
}

/*	Convert character representing a hexadecimal value to an integer.	*/
int	hexc_int(char c_value)
{
	char	str[2];

	*str = c_value;
	*(str +1) = '\000';
	return((int)strtol(str, NULL, 16));
}
