#ifndef	_POSIX_SOURCE
#define	_POSIX_SOURCE
#endif

#include <stdarg.h>
#include <string.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>

#include <sv_env.h>
#include <element.h>

extern void sv_prlev(void);

static int outfd = STDOUT_FILENO;
#define	LEN_OUTBUF	2048
static char outbuf[LEN_OUTBUF];
static char *outptr = outbuf;

char	ass_buf[30];		/* Assertion info buffer */
char	test_rc = '4';		/* Test Result Code */
int		ass_nu = 0;			/* Assertion number */

void	sv_vprintf(char *format, va_list ap)
{
	char *too_big = "SEVERR():\n\tError message greater than buffer size.\n"; 
	size_t temp_size; 
	char temp_buf[LEN_OUTBUF];  

	(void) vsprintf(temp_buf, format, ap);
	temp_size = strlen(temp_buf);
	if(temp_size > LEN_OUTBUF) {
		write(outfd, too_big, strlen(too_big));
		exit(SEVERR);
	}
	if(temp_size > (LEN_OUTBUF -(outptr -outbuf))) {
		sv_flush();
	}
	memcpy(outptr, temp_buf, temp_size);
	outptr += temp_size;
}

void sv_flush(void)
{
	if(outptr > outbuf) {
		(void) write(outfd, outbuf, outptr-outbuf);
	}
	outptr = outbuf;
}


void sv_printf(char *format, ...)
{
	va_list ap;

	va_start(ap, format);
	sv_vprintf(format, ap);
	va_end(ap);
}

void sv_set_outfd(int fd)
{
	outfd = fd;
}

int sv_get_outfd(void)
{
	return(outfd);
}

void sv_prntline(char *str)
{
	sv_printf("\n");
	if(sv_xenv->sv_levflg) {
		sv_prlev();
		sv_printf("\t%s\n\t",str);
		sv_xenv->sv_levflg=0;
	}
	else
		sv_printf("\t");
}

void sv_abstract(char *format, ...)
{
	va_list ap;

	va_start(ap, format);
	sv_prntline("Abstract");
	sv_vprintf(format, ap);
	va_end(ap);
}

void sv_preparation(char *format, ...)
{
	va_list ap;

	va_start(ap, format);
 	(void) sprintf(ass_buf, "Preparation		[%c%3.3d]",
 			test_rc, ass_nu);
 	sv_prntline(ass_buf);
	sv_vprintf(format, ap);
	va_end(ap);
}

void sv_testing(char *format, ...)
{
	va_list ap;

	va_start(ap, format);
 	(void) sprintf(ass_buf, "Testing		[%c%3.3d]",
 			test_rc, ass_nu);
 	sv_prntline(ass_buf);
	sv_vprintf(format, ap);
	va_end(ap);
}

void sv_cleanup(char *format, ...)
{
	va_list ap;

	va_start(ap, format);
	sv_prntline("Cleanup");
	sv_vprintf(format, ap);
	va_end(ap);
}

void	sv_funct(int foo)
{
	sv_printf("\n");
	sv_prlev();
	sv_printf("Function:\n\t");
 	sv_printf("%s\t\t[%3.3d]", element[foo].e_name, element[foo].tests);
	sv_printf("\n");
}
