#include	<pcts.h>

#include	<sv_env.h>

extern	int		ass_nu;					/* Assertion number being tested	*/
extern	char	test_rc;				/* Assertion Test Result Code		*/

void assertion(int numb, char type)
{
	char	a_numb[5];

	sprintf(a_numb, "%d", numb);
	abstract(a_numb);
	ass_nu = numb;

	test_rc = type;
	if(type == EXTENDED) {
		start
			test_rc = UNTESTED;
			testing("Extended assertion not tested.");
			start
			finis
		finis
	}

	if(type == NOT_TESTABLE) {
		start
			test_rc = NOT_TESTABLE;
			testing("Testing constraints required for testing not provided.");
			start
			finis
		finis
	}

	if(type == NOT_APPLICABLE) {
		start
			test_rc = NOT_APPLICABLE;
			testing("Testing feature required by assertion is not applicable");
			testing(" to the FIPS 151-2 profile.");
			start
			finis
		finis
	}

	if(type == TO_BE_WRITTEN) {
		start
			test_rc = TO_BE_WRITTEN;
			testing("Test has yet to be written.");
			start
			finis
		finis
	}

	if(type == EXTENDED_TESTED)
		test_rc = EXTENDED;

	if(type == UNUSED) {
		start
			testing("This assertion number is no longer in use.");
			start
			finis
		finis
	}
}

void not_implemented(char *option)
{
		test_rc = UNSUPPORTED;
		testing("Implementation does not support the \"%s\" feature.", option);
		start
		finis
}


void yes_implemented(char *option)
{
		test_rc = UNSUPPORTED;
		testing("Implementation supports the \"%s\" feature.", option);
		start
		finis
}


void un_implemented(char *option)
{
		error("Implementation does not support FIPS 151-2 \"%s\" required feature.", option);
}



void unresolved(char *pcd_req, char *clause)
{
	prep("Requires the following documentation in the PCD:");
	prep("%s", pcd_req);
	prep("This information is contained in Subclause %s of the PCD.",clause);
	prep("");
	prep("If info in PCD, APTL resolved test result code is PCD_DOCUMENTED.");
	start
	finis
}
