/* z_calloc.c */

#include <z_pcts.h>

static int success( void **val )
{
	return( (*val)? 1 : 0 );
}

static int failure( void **val )
{
	return( (*val)? 0 : 1 );
}

static char *format( void **val )
{
	static char buf[STRVAL];

	if( !*val )
		(void) strcpy( buf, "NULL" );
	else if( (pointer)(*val) == NON_NULL )
		(void) strcpy( buf, "NON-NULL" );
	else
		(void) sprintf( buf, "0x%lx", (long)(*val) );
	return( buf );
}

static int compare( void **a, void **b )
{
	if( (pointer)(*b) == NON_NULL )
		return( (*a)? 1 : 0 );
	return( *a == *b );
}

extern pointer *sv_getp(void);

static struct ftable Tcalloc = {
	"calloc",
	"a return value other than NULL",
	"a return value of NULL",
	format,
	compare,
	success,
	failure,
	(pfunctptr)sv_getp,
	0,
};

void * Zcalloc(size_t nelem, size_t elsize)
{
	void *ret_val;

	errno = 0;
	ret_val = calloc(nelem, elsize);
	evaluate(&Tcalloc, (pointer)&ret_val);
	return(ret_val);
}
