/* z_cfgetispeed.c */

#include <z_pcts.h>
#include <termios.h>

#ifdef	PCTS_FUNCT_INTF_CK
#undef	cfgetispeed
#endif

static int success(speed_t *val)
{
	return((*val) == 0);
}

static int failure(speed_t *val)
{
	return((*val) == (-1));
}

static char *format(speed_t *val)
{
	static char buf[STRVAL];

	(void) sprintf(buf, "%lu", (unsigned long) *val);
	return(buf);
}

static int compare(speed_t *a, speed_t *b)
{
	return(*a == *b);
}

extern	speed_t *sv_speed_t(void);

static struct ftable Tcfgetispeed = {
	"cfgetispeed",
	"indeterminate - based on actual expected value",
	"not defined",
	format,
	compare,
	success,
	failure,
	(pfunctptr)sv_speed_t,
	1,
};

speed_t  Zcfgetispeed(const struct termios *t)
{
	speed_t ret_val;

	errno = 0;
	ret_val = cfgetispeed(t);
	evaluate(&Tcfgetispeed, (pointer)&ret_val);
	return(ret_val);
}
