#include <z_pcts.h>

#include <unistd.h>
#include <stdarg.h>

#ifdef	PCTS_FUNCT_INTF_CK
#undef execle
#endif

static int failure(int *val )
{
	return( (*val) == (-1) );
}

static char *format(int *val )
{
	static char buf[STRVAL];

	(void) sprintf( buf, "%d", *val );
	return( buf );
}

static int compare(int *a, int *b )
{
	return( *a == *b );
}

extern int *sv_geti(void);
extern void sv_mproc(void);

static struct ftable Texecle = {
	"execle",
	"no return from the function",
	"a return value of (-1)",
	format,
	compare,
	GONE,
	failure,
	(pfunctptr)sv_geti,
	1,
};

#define nargs	12	/* Max number of args to Zexecle() */

int Zexecle(const char *file, const char *arg0, ...) 
{
	va_list ap;
	char	*a[nargs];
	char	**envp;
	int	ret_val;
	int	i;

	va_start(ap, arg0);
	if(arg0 != (const char *) 0) {
	    for(i = 1; i < nargs && (a[i] = va_arg(ap, char *)) != (char *) 0; i++);
	    }
	else {
	    i= 0;
	    }
	envp= va_arg(ap, char **);
	va_end(ap);

	sv_mproc();

	errno = 0;

	switch (i) {
	case 0:
		ret_val=execle(file,(char *)0,envp);
		break;
	case 1:
		ret_val=execle(file,arg0,(char *)0,envp);
		break;
	case 2:
		ret_val=execle(file,arg0,a[1],(char *)0,envp);
		break;
	case 3:
		ret_val=execle(file,arg0,a[1],a[2],(char *)0,envp);
		break;
	case 4:
		ret_val=execle(file,arg0,a[1],a[2],a[3],(char *)0,envp);
		break;
	case 5:
		ret_val=execle(file,arg0,a[1],a[2],a[3],a[4],(char *)0,envp);
		break;
	case 6:
		ret_val=execle(file,arg0,a[1],a[2],a[3],a[4],a[5],
			(char *)0,envp);
		break;
	case 7:
		ret_val=execle(file,arg0,a[1],a[2],a[3],a[4],a[5],
			a[6],(char *)0,envp);
		break;
	case 8:
		ret_val=execle(file,arg0,a[1],a[2],a[3],a[4],a[5],
			a[6],a[7],(char *)0,envp);
		break;
	case 9:
		ret_val=execle(file,arg0,a[1],a[2],a[3],a[4],a[5],
			a[6],a[7],a[8],(char *)0,envp);
		break;
	case 10:
		ret_val=execle(file,arg0,a[1],a[2],a[3],a[4],a[5],
			a[6],a[7],a[8],a[9],(char *)0,envp);
		break;
	case 11:
		ret_val=execle(file,arg0,a[1],a[2],a[3],a[4],a[5],
			a[6],a[7],a[8],a[9],a[10],(char *)0,envp);
		break;
	default:
		sv_error("Too many arguments (max %d) to execle()\n", nargs);
	}
	evaluate( &Texecle, (pointer)&ret_val );
	return( ret_val );
}
