/* z_execvp.c */

#include <z_pcts.h>
#include <unistd.h>

#ifdef	PCTS_FUNCT_INTF_CK
#undef execvp
#endif

static int failure(int *val)
{
	return((*val) == (-1));
}

static char *format(int *val)
{
	static char buf[STRVAL];

	(void) sprintf(buf, "%d", *val);
	return(buf);
}

static int compare(int *a, int *b)
{
	return(*a == *b);
}

extern int *sv_geti(void);
extern void sv_mproc(void);

static struct ftable Texecvp = {
	"execvp",
	"no return from the function",
	"a return value of (-1)",
	format,
	compare,
	GONE,
	failure,
	(pfunctptr)sv_geti,
	1,
};

int  Zexecvp(const char *file, char *const argv[])
{
	int ret_val;

	sv_mproc();
	errno = 0;
	ret_val = execvp(file, argv);
	evaluate(&Texecvp, (pointer)&ret_val);
	return(ret_val);
}
