/* z_fileno.c */

#include <z_pcts.h>
#include <stdio.h>

#ifdef	PCTS_FUNCT_INTF_CK
#undef fileno
#endif

static int success(int *val)
{
	return((*val) >= 0);
}

static char *format(int *val)
{
	static char buf[STRVAL];

	(void) sprintf(buf, "%d", *val);
	return(buf);
}

static int compare(int *a, int *b)
{
	return(*a == *b);
}

extern	int *sv_geti(void);

static struct ftable Tfileno = {
	"fileno",
	"a return value of at least 0",
	"not defined",
	format,
	compare,
	success,
	(ifunctptr)0,
	(pfunctptr)sv_geti,
	0,
};

int  Zfileno(FILE *stream)
{
	int ret_val;

	errno = 0;
	ret_val = fileno(stream);
	evaluate(&Tfileno, (pointer)&ret_val);
	return(ret_val);
}
