/* z_freopen.c */

#include <z_pcts.h>
#include <stdio.h>

#ifdef	PCTS_FUNCT_INTF_CK
#undef freopen
#endif

static int success(FILE **val)
{
	return((*val) ? 1 : 0);
}

static int failure(FILE **val)
{
	return((*val)? 0 : 1);
}

static char *format(FILE **val)
{
	static char buf[STRVAL];

	if(!*val)
		(void) strcpy(buf, "NULL");
	else if((pointer)(*val) == NON_NULL)
		(void) strcpy(buf, "NON-NULL");
	else
		(void) sprintf(buf, "0x%lx", (long)(*val));
	return(buf);
}

static int compare(FILE **a, FILE **b)
{
	if((pointer)(*b) == NON_NULL)
		return((*a)? 1 : 0);
	return(*a == *b);
}

extern	pointer *sv_getp(void);

static struct ftable Tfreopen = {
	"freopen",
	"a return value other than NULL",
	"a return value of NULL",
	format,
	compare,
	success,
	failure,
	(pfunctptr)sv_getp,
	1,
};

FILE *Zfreopen(char *filename, char *type, FILE *stream)
{
	FILE *ret_val;

	errno = 0;
	ret_val = freopen(filename, type, stream);
	evaluate(&Tfreopen, (pointer)&ret_val);
	return(ret_val);
}
