/* z_fwrite.c */

#include <z_pcts.h>
#include <stdio.h>

#ifdef	PCTS_FUNCT_INTF_CK
#undef fwrite
#endif

static int success(int *val)
{
	return((*val) > 0);
}

static int failure(int *val)
{
	return((*val) ? 0 : 1);
}

static char *format(int *val)
{
	static char buf[STRVAL];

	(void) sprintf(buf, "%d", *val);
	return(buf);
}

static int compare(int *a, int *b)
{
	return(*a == *b);
}

extern	int *sv_geti(void);

static struct ftable Tfwrite = {
	"fwrite",
	"a return value greater than 0",
	"a return value of 0",
	format,
	compare,
	success,
	failure,
	(pfunctptr)sv_geti,
	0,
};

int  Zfwrite(char *ptr, int size, int nitems, FILE *stream)
{
	int ret_val;

	errno = 0;
	ret_val = fwrite(ptr, size, nitems, stream);
	evaluate(&Tfwrite, (pointer)&ret_val);
	return(ret_val);
}
