/* z_getc.c */

#include <z_pcts.h>
#include <stdio.h>

#ifdef	PCTS_FUNCT_INTF_CK
#undef getc
#endif

static int success(int *val)
{
	return((*val) != EOF);
}

static int failure(int *val)
{
	return((*val) == EOF);
}

static char *format(int *val)
{
	static char buf[STRVAL];

	(void) sprintf(buf, "%d", *val);
	return(buf);
}

static int compare(int *a, int *b)
{
	return(*a == *b);
}

extern	int *sv_geti(void);

static struct ftable Tgetc = {
	"getc",
	"a return value other than EOF",
	"a return value of EOF",
	format,
	compare,
	success,
	failure,
	(pfunctptr)sv_geti,
	0,
};

int  Zgetc(FILE *stream)
{
	int ret_val;

	errno = 0;
	ret_val = getc(stream);
	evaluate(&Tgetc, (pointer)&ret_val);
	return(ret_val);
}
