/* z_getegid.c */

#include <z_pcts.h>
#include <unistd.h>

#ifdef	PCTS_FUNCT_INTF_CK
#undef	getegid
#endif

static char *format( gid_t *val )
{
	static char buf[STRVAL];

	(void) sprintf( buf, "%lu", (unsigned long) *val );
	return( buf );
}

static int compare( gid_t *a, gid_t *b )
{
	return( *a == *b );
}

extern gid_t *sv_ggid_t(void);

static struct ftable Tgetegid = {
	"getegid",
	"indeterminate - based upon actual expected value",
	"not defined",
	format,
	compare,
	VALUE,
	(ifunctptr)0,
	(pfunctptr)sv_ggid_t,
	0,
};

gid_t  Zgetegid(void)
{
	gid_t ret_val;

	errno = 0;
	ret_val = getegid();
	evaluate( &Tgetegid, (pointer)&ret_val );
	return( ret_val );
}
