/* z_getenv.c */

#include <z_pcts.h>
#include <unistd.h>

#ifdef	PCTS_FUNCT_INTF_CK
#undef getenv
#endif

static int success(char **val)
{
	return((*val) ? 1 : 0);
}

static int failure(char **val)
{
	return((*val)? 0 : 1);
}

static char *format(char **val)
{
	static char buf[STRVAL];

	if(!*val)
		(void) strcpy(buf, "NULL");
	else if((pointer)(*val) == NON_NULL)
		(void) strcpy(buf, "NON-NULL");
	else
		(void) sprintf(buf, "0x%lx", (long)(*val));
	return(buf);
}

static int compare(char **a, char **b)
{
	if((pointer)(*b) == NON_NULL)
		return((*a)? 1 : 0);
	return(*a == *b);
}

extern	pointer *sv_getp(void);

static struct ftable Tgetenv = {
	"getenv",
	"a return value other than NULL",
	"a return value of NULL",
	format,
	compare,
	success,
	failure,
	(pfunctptr)sv_getp,
	0,
};

char *Zgetenv(const char *name)
{
	char *ret_val;

	errno = 0;
	ret_val = getenv(name);
	evaluate(&Tgetenv, (pointer)&ret_val);
	return(ret_val);
}
