/* z_getgrnam.c */

#include <z_pcts.h>
#include <grp.h>

#ifdef	PCTS_FUNCT_INTF_CK
#undef	getgrnam
#endif

static int success(struct group **val)
{
	return((*val) != (struct group *)0);
}

static int failure(struct group **val)
{
	return((*val) == (struct group *)0);
}


static char *format(struct group **val)
{
	static char buf[STRVAL];

	if(!*val)
		(void) strcpy(buf, "NULL");
	else if((pointer)(*val) == NON_NULL)
		(void) strcpy(buf, "NON-NULL");
	else
		(void) sprintf(buf, "0x%lx", (long)(*val));
	return(buf);
}


static int compare(struct group **a, struct group **b)
{
	return(*a == *b);
}

extern pointer *sv_getp(void);

static struct ftable Tgetgrnam = {
	"getgrnam",
	"a non-NULL return value",
	"a NULL return value",
	format,
	compare,
	success,
	failure,
	(pfunctptr)sv_getp,
	1,
};

struct group * Zgetgrnam(char *name)
{
	struct group *ret_val;

	errno = 0;
	ret_val = getgrnam(name);
	evaluate(&Tgetgrnam, (pointer)&ret_val);
	return(ret_val);
}
