/* z_ismember.c	(z_sigismember.c) */

#include <z_pcts.h>
#include <signal.h>

#ifdef	PCTS_FUNCT_INTF_CK
#undef	sigismember
#endif

static int success(int *val)
{
	return((*val) ? 0 : 1);
}

static int failure(int *val)
{
	return((*val) == (-1));
}

static char *format(int *val)
{
	static char buf[STRVAL];

	(void) sprintf(buf, "%d", *val);
	return(buf);
}

static int compare(int *a, int *b)
{
	return(*a == *b);
}

extern	int *sv_geti(void);

static struct ftable Tsigismember = {
	"sigismember",
	"a return value of 0 or 1",
	"a return value of (-1)",
	format,
	compare,
	success,
	failure,
	(pfunctptr)sv_geti,
	1,
};

int  Zsigismember(const sigset_t *set, int signo)
{
	int ret_val;

	errno = 0;
	ret_val = sigismember(set, signo);
	evaluate(&Tsigismember, (pointer)&ret_val);
	return(ret_val);
}
