/* z_localtime.c */

#include <z_pcts.h>
#include <time.h>

#ifdef	PCTS_FUNCT_INTF_CK
#undef localtime
#endif

static int success(struct tm **val)
{
	return((*val)? 1 : 0);
}

static char *format(struct tm **val)
{
	static char buf[STRVAL];

	if(!*val)
		(void) strcpy(buf, "NULL");
	else if((pointer)(*val) == NON_NULL)
		(void) strcpy(buf, "NON-NULL");
	else
		(void) sprintf(buf, "0x%lx", (long)(*val));
	return(buf);
}

static int compare(struct tm **a, struct tm **b)
{
	if((pointer)(*b) == NON_NULL)
		return((*a)? 1 : 0);
	return(*a == *b);
}

extern	pointer *sv_getp(void);

static struct ftable Tlocaltime = {
	"localtime",
	"a return value other than NULL",
	"not defined",
	format,
	compare,
	success,
	(ifunctptr)0,
	(pfunctptr)sv_getp,
	0,
};

struct tm *Zlocaltime(time_t *clock)
{
	struct tm *ret_val;

	errno = 0;
	ret_val = localtime(clock);
	evaluate(&Tlocaltime, (pointer)&ret_val);
	return(ret_val);
}
