/* z_lseek.c */

#include <z_pcts.h>
#include <unistd.h>

#ifdef	PCTS_FUNCT_INTF_CK
#undef	lseek
#endif

static int success(off_t *val)
{
	return((*val) >= 0);
}

static int failure(off_t *val)
{
	return((*val) == (-1));
}

static char *format(off_t *val)
{
	static char buf[STRVAL];

	(void) sprintf(buf, "%ld", (long)*val);
	return(buf);
}

static int compare(off_t *a, off_t *b)
{
	return(*a == *b);
}

extern	off_t *sv_goff_t(void);

static struct ftable Tlseek = {
	"lseek",
	"a return value of at least 0",
	"a return value of (-1)",
	format,
	compare,
	success,
	failure,
	(pfunctptr)sv_goff_t,
	1,
};

off_t  Zlseek(int fildes, off_t offset, int whence)
{
	off_t ret_val;

	errno = 0;
	ret_val = lseek(fildes, offset, whence);
	evaluate(&Tlseek, (pointer)&ret_val);
	return(ret_val);
}
