#include <z_pcts.h>

#include <fcntl.h>
#include <stdarg.h>

#ifdef	PCTS_FUNCT_INTF_CK
#undef	open
#endif

static int success(int *val)
{
	return((*val) >= 0);
}

static int failure(int *val)
{
	return((*val) == (-1));
}

static char *format(int *val)
{
	static char buf[STRVAL];

	(void) sprintf(buf, "%d", *val);
	return(buf);
}

static int compare(int *a, int *b)
{
	return(*a == *b);
}

extern	int *sv_geti(void);

static struct ftable Topen = {
	"open",
	"a return value of at least 0",
	"a return value of (-1)",
	format,
	compare,
	success,
	failure,
	(pfunctptr)sv_geti,
	1,
};

int  Zopen(const char *path, int oflag, ...)
{
	int ret_val;
	va_list v;
	mode_t mode;

	va_start(v, oflag);
	errno = 0;
	if (oflag & O_CREAT) {
								/* C converts char and short arguments to
								   int before passing to a function.
								*/
		if(sizeof(mode_t) < sizeof(int))
			mode = (mode_t)va_arg(v, int);
		else
			mode = va_arg(v, mode_t);
		ret_val = open(path, oflag, mode);
	}
	else
		ret_val = open(path, oflag);
	va_end(v);
	evaluate(&Topen, (pointer)&ret_val);
	return(ret_val);
}
