/* sv_opendir.c */

#include <z_pcts.h>
#include <fcntl.h>
#include <dirent.h>

#ifdef	PCTS_FUNCT_INTF_CK
#undef	opendir
#endif

static int success(DIR **val)
{
	return((*val) != ((DIR *) 0));
}

static int failure(DIR **val)
{
	return((*val) == ((DIR *) 0));
}

static char *format(DIR **val)
{
	static char buf[STRVAL];

	if(!*val)
		(void) strcpy(buf, "NULL");
	else if((pointer)(*val) == NON_NULL)
		(void) strcpy(buf, "NON-NULL");
	else
		(void) sprintf(buf, "0x%lx", (long)(*val));
	return(buf);
}


static int compare(DIR **a, DIR **b)
{
	return(*a == *b);
}

extern pointer *sv_getp(void);

static struct ftable Topendir = {
	"opendir",
	"a return value of non-NULL",
	"a return value of NULL",
	format,
	compare,
	success,
	failure,
	(pfunctptr)sv_getp,
	1,
};

DIR *Zopendir(const char *path)
{
	DIR	*ret_val;

	errno = 0;
	ret_val = opendir(path);
	evaluate(&Topendir, (pointer)&ret_val);
	return(ret_val);
}
