/* z_pause.c */

#include <z_pcts.h>
#include <unistd.h>

#ifdef	PCTS_FUNCT_INTF_CK
#undef pause
#endif

static int success(int *val)
{
	return((*val) != (-1));
}

static int failure(int *val)
{
	return((*val) == (-1));
}

static char *format(int *val)
{
	static char buf[STRVAL];

	(void) sprintf(buf, "%d", *val);
	return(buf);
}

static int compare(int *a, int *b)
{
	return(*a == *b);
}

extern	int *sv_geti(void);

static struct ftable Tpause = {
	"pause",
	"a return value other than (-1)",
	"a return value of (-1)",
	format,
	compare,
	success,
	failure,
	(pfunctptr)sv_geti,
	1,
};

int  Zpause(void)
{
	int ret_val;

	errno = 0;
	ret_val = pause();
	evaluate(&Tpause, (pointer)&ret_val);
	return(ret_val);
}
