/* z_setpgid.c */

#include <z_pcts.h>
#include <unistd.h>

#ifdef	PCTS_FUNCT_INTF_CK
#undef setpgid
#endif

static int success(int *val)
{
	return((*val) == 0);
}

static int failure(int *val)
{
	return((*val) == (-1));
}

static char *format(int *val)
{
	static char buf[STRVAL];

	(void) sprintf(buf, "%d", *val);
	return(buf);
}

static int compare(int *a, int *b)
{
	return(*a == *b);
}

extern	int *sv_geti(void);

static struct ftable Tsetpgid = {
	"setpgid",
	"a return value of 0",
	"a return value of (-1)",
	format,
	compare,
	success,
	failure,
	(pfunctptr)sv_geti,
	1,
};

int  Zsetpgid(pid_t pid, pid_t pgid)
{
	int ret_val;

	errno = 0;
	ret_val = setpgid(pid, pgid);
	evaluate(&Tsetpgid, (pointer)&ret_val);
	return(ret_val);
}
