/* z_setsid.c */

#include <z_pcts.h>
#include <unistd.h>

#ifdef	PCTS_FUNCT_INTF_CK
#undef setsid
#endif

static int success(pid_t *val)
{
	return((*val) >= 0);
}

static int failure(pid_t *val)
{
	return((*val) == (-1));
}

static char *format(pid_t *val)
{
	static char buf[STRVAL];

	(void) sprintf(buf, "%ld", (long) *val);
	return(buf);
}

static int compare(pid_t *a, pid_t *b)
{
	return(*a == *b);
}


extern pid_t *sv_gpid_t(void);

static struct ftable Tsetsid = {
	"setsid",
	"a return value of at least 0",
	"a return value of (-1)",
	format,
	compare,
	success,
	failure,
	(pfunctptr)sv_gpid_t,
	1,
};

pid_t  Zsetsid(void)
{
	pid_t ret_val;

	errno = 0;
	ret_val = setsid();
	evaluate(&Tsetsid, (pointer)&ret_val);
	return(ret_val);
}
