/* z_setvbuf.c	*/

#include <z_pcts.h>
#include <stdio.h>

#ifdef	PCTS_FUNCT_INTF_CK
#undef	setvbuf
#endif

static int success(int *val)
{
	return((*val) == 0);
}

static int failure(int *val)
{
	return((*val) != 0);
}

static char *format(int *val)
{
	static char buf[STRVAL];

	(void) sprintf(buf, "%d", *val);
	return(buf);
}

static int compare(int *a, int *b)
{
	return(*a == *b);
}

extern	int *sv_geti(void);

static struct ftable Tsetvbuf = {
	"setvbuf",
	"a return value of 0",
	"a return value of nonzero",
	format,
	compare,
	success,
	failure,
	(pfunctptr)sv_geti,
	1,
};

int  Zsetvbuf(FILE *stream, char *buf, int mode, size_t size)
{
	int ret_val;

	errno = 0;
	ret_val = setvbuf(stream, buf, mode, size);
	evaluate(&Tsetvbuf, (pointer)&ret_val);
	return(ret_val);
}
