/* z_sigaction.c */

#include <z_pcts.h>
#include <signal.h>

#ifdef	PCTS_FUNCT_INTF_CK
#undef	sigaction
#endif

static int success(int *val)
{
	return((*val) ? 0 : 1);
}

static int failure(int *val)
{
	return((*val) == (-1));
}

static char *format(int *val)
{
	static char buf[STRVAL];

	(void) sprintf(buf, "%d", *val);
	return(buf);
}

static int compare(int *a, int *b)
{
	return(*a == *b);
}

extern	int *sv_geti(void);

static struct ftable Tsigaction = {
	"sigaction",
	"a return value of 0",
	"a return value of (-1)",
	format,
	compare,
	success,
	failure,
	(pfunctptr)sv_geti,
	1,
};

int  Zsigaction(int sig, const struct sigaction *act, struct sigaction *oact)
{
	int ret_val;

	errno = 0;
	ret_val = sigaction(sig, act, oact);
	evaluate(&Tsigaction, (pointer)&ret_val);
	return(ret_val);
}
