/* z_sigemptyset.c */

#include <z_pcts.h>
#include <signal.h>

#ifdef	PCTS_FUNCT_INTF_CK
#undef	sigemptyset
#endif

static int success(int *val)
{
	return((*val) ? 0 : 1);
}

static int failure(int *val)
{
	return((*val) == (-1));
}

static char *format(int *val)
{
	static char buf[STRVAL];

	(void) sprintf(buf, "%d", *val);
	return(buf);
}

static int compare(int *a, int *b)
{
	return(*a == *b);
}

int *sv_geti();

static struct ftable Tsigemptyset = {
	"sigemptyset",
	"a return value of 0",
	"a return value of (-1)",
	format,
	compare,
	success,
	failure,
	(pfunctptr)sv_geti,
	1,
};

int  Zsigemptyset(sigset_t *set)
{
	int ret_val;

	errno = 0;
	ret_val = sigemptyset(set);
	evaluate(&Tsigemptyset, (pointer)&ret_val);
	return(ret_val);
}
