/* z_time.c */

#include <z_pcts.h>
#include <time.h>

#ifdef	PCTS_FUNCT_INTF_CK
#undef	time
#endif

static int success(time_t *val)
{
	return((*val) != (-1));
}

static int failure(time_t *val)
{
	return((*val) == (-1));
}

static char *format(time_t *val)
{
	static char buf[STRVAL];

	(void) sprintf(buf, "%ld", *val);
	return(buf);
}

static int compare(time_t *a, time_t *b)
{
	return(*a == *b);
}

extern	time_t *sv_getl(void);

static struct ftable Ttime = {
	"time",
	"a return value other than (-1)",
	"a return value of (-1)",
	format,
	compare,
	success,
	failure,
	(pfunctptr)sv_getl,
	0,
};

time_t  Ztime(time_t *tloc)
{
	time_t ret_val;

	errno = 0;
	ret_val = time(tloc);
	evaluate(&Ttime, (pointer)&ret_val);
	return(ret_val);
}
