/* z_tmpnam.c */

#include <z_pcts.h>
#include <stdio.h>

#ifdef PCTS_FUNCT_INTF_CK
#undef	tmpnam
#endif

static int success(char **val)
{
	return((*val)? 1 : 0);
}

static char *format(char **val)
{
	static char buf[STRVAL];

	if(!*val)
		(void) strcpy(buf, "NULL");
	else if((pointer)(*val) == NON_NULL)
		(void) strcpy(buf, "NON-NULL");
	else
		(void) sprintf(buf, "0x%lx", (long)(*val));
	return(buf);
}

static int compare(char **a, char **b)
{
	if((pointer)(*b) == NON_NULL)
		return((*a) ? 1 : 0);
	return(*a == *b);
}

extern	pointer *sv_getp(void);

static struct ftable Ttmpnam = {
	"tmpnam",
	"a return value other than NULL",
	"not defined",
	format,
	compare,
	success,
	(ifunctptr)0,
	(pfunctptr)sv_getp,
	0,
};

char *Ztmpnam(char *s)
{
	char * ret_val;

	errno = 0;
	ret_val = tmpnam(s);
	evaluate(&Ttmpnam, (pointer)&ret_val);
	return(ret_val);
}
