/* z_utime.c */

#include <z_pcts.h>
#include <utime.h>

#ifdef	PCTS_FUNCT_INTF_CK
#undef	utime
#endif

static int success(int *val)
{
	return((*val)? 0 : 1);
}

static int failure(int *val)
{
	return((*val) == (-1));
}

static char *format(int *val)
{
	static char buf[STRVAL];

	(void) sprintf(buf, "%d", *val);
	return(buf);
}

static int compare(int *a, int *b)
{
	return(*a == *b);
}

extern	int *sv_geti(void);

static struct ftable Tutime = {
	"utime",
	"a return value of 0",
	"a return value of (-1)",
	format,
	compare,
	success,
	failure,
	(pfunctptr)sv_geti,
	1,
};

int  Zutime(const char *path, const struct utimbuf *times)
{
	int ret_val;

	errno = 0;
	ret_val = utime(path, times);
	evaluate(&Tutime, (pointer)&ret_val);
	return(ret_val);
}
